'-------------------------------------------------------------------------------
' QTabControl - Horizontal TABs demo
'
'   Add bitmaps to tabs & change Font color. Bitmap "strip" of images for each TAB.
'   Bitmap images will be scaled to fit, however minor problems with transparency.
'
' Limitations for horizontal and vertical TABs:
' Horizontal TABs can have text, and if used, bitmaps fixed on left hand side
' Vertical TABs cannot have text (create each TAB with a single space char) then
'    add the bitmap "strip".
' 
' FreeBasic code generated by RapidFRM v1.80
'-------------------------------------------------------------------------------
#INCLUDE "windows.bi"
#INCLUDE "win/commctrl.bi"
InitCommonControls()

#DEFINE __QTABCONTROL
#INCLUDE "win/RQInclude.bi"

#DEFINE IMG_FILE "Suits.bmp"

'-------------------------------------------------------------------------------
' Global data from Form designer sheet
'-------------------------------------------------------------------------------
DIM SHARED AS QFORM Form1
DIM SHARED AS QFORM PTR lpForm1 = @Form1
DIM SHARED AS QTABCONTROL TabCtrl1
DIM SHARED AS QTABCONTROL PTR lpTabCtrl1 = @TabCtrl1
DIM SHARED AS QBUTTON Butn1
DIM SHARED AS QBUTTON PTR lpButn1 = @Butn1
DIM SHARED AS QBUTTON Butn2
DIM SHARED AS QBUTTON PTR lpButn2 = @Butn2
DIM SHARED AS QLABEL Label1
DIM SHARED AS QLABEL PTR lpLabel1 = @Label1

'-------------------------------------------------------------------------------
' Forward declarations for component events 
'-------------------------------------------------------------------------------
DECLARE SUB TabChange(Sender AS QTABCONTROL)
DECLARE SUB DoTest(Sender AS QBUTTON)
DECLARE SUB Done(Sender AS QBUTTON)

'-------------------------------------------------------------------------------
' Configure components
'-------------------------------------------------------------------------------
SUB ConfigureComponents

    lpForm1->ObjIndex = 0
    lpForm1->Caption = "TABcontrol with bitmaps"

    lpTabCtrl1->ObjIndex = 1
    lpTabCtrl1->Left = 10
    lpTabCtrl1->Top = 10
    lpTabCtrl1->Width = 290
    lpTabCtrl1->Height = 130
    lpTabCtrl1->TabHeight = 20
    lpTabCtrl1->TabWidth = 80
    lpTabCtrl1->MultiLine = True
    lpTabCtrl1->Font.Name = "Times New Roman"
    lpTabCtrl1->Font.Size = 8
    lpTabCtrl1->Font.Color = &hdf0000
'    lpTabCtrl1->BMP = IMG_FILE                         ' Initially set the bmp? - no
    lpTabCtrl1->VerticalTabs = False                    ' Default - horizontal
'    lpTabCtrl1->TabPosition = 1                         ' TABs at bottom (horizontal)
    lpTabCtrl1->OnChange = CAST(ANY PTR, @TabChange)

    lpButn1->ObjIndex = 2
    lpButn1->Left = 30
    lpButn1->Top = 170
    lpButn1->Caption = "Add BMP"
    lpButn1->OnClick = CAST(ANY PTR, @DoTest)

    lpButn2->ObjIndex = 3
    lpButn2->Left = 200
    lpButn2->Top = 170
    lpButn2->Caption = "EXIT"
    lpButn2->OnClick = CAST(ANY PTR, @Done)

    lpLabel1->ObjIndex = 4
    lpLabel1->Left = 110
    lpLabel1->Top = 50
    lpLabel1->Caption = "TAB 1"

END SUB

'-------------------------------------------------------------------------------
' Create components
'-------------------------------------------------------------------------------
SUB CreateMainMenu
END SUB

SUB CreatePopupMenus
END SUB

SUB CreateComponents
DIM AS UINT StdStyle, ExtStyle=0
DIM AS string ObjCaption

    lpForm1->PreSetConfig()
    StdStyle=lpForm1->objStyle
    IF lpForm1->BorderStyle > bsDialog THEN ExtStyle=WS_EX_TOOLWINDOW

    lpForm1->Handle = CreateWindowEx(ExtStyle, "RQClass", lpForm1->Caption, StdStyle, _
                    lpForm1->Left, lpForm1->Top, lpForm1->Width, lpForm1->Height, _
                    0, 0, Application.hInstance, 0)
    Application.hMainForm = lpForm1->Handle
    lpForm1->PostConfig()

    lpTabCtrl1->PreSetConfig()
    ObjCaption=""
    StdStyle=lpTabCtrl1->objStyle
    IF lpTabCtrl1->Visible THEN StdStyle OR= WS_VISIBLE
    ExtStyle=0

    lpTabCtrl1->Handle=CreateWindowEx(ExtStyle,lpTabCtrl1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpTabCtrl1->Left, lpTabCtrl1->Top, lpTabCtrl1->Width, lpTabCtrl1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpTabCtrl1->objIndex), 0, 0)

    lpTabCtrl1->Parent = lpForm1->Handle
    lpTabCtrl1->AddTabs "TAB 1"
    lpTabCtrl1->AddTabs "TAB 2"
    lpTabCtrl1->AddTabs "TAB 3"
    lpTabCtrl1->AddTabs "TAB 4"
    lpTabCtrl1->PostConfig()
    EnableWindow(lpTabCtrl1->Handle, lpTabCtrl1->Enabled)

    lpButn1->PreSetConfig()
    ObjCaption=lpButn1->Caption
    StdStyle=lpButn1->objStyle
    IF lpButn1->Visible THEN StdStyle OR= WS_VISIBLE
    ExtStyle=0

    lpButn1->Handle=CreateWindowEx(ExtStyle,lpButn1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpButn1->Left, lpButn1->Top, lpButn1->Width, lpButn1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpButn1->objIndex), 0, 0)

    lpButn1->Parent = lpForm1->Handle
    lpButn1->PostConfig()
    EnableWindow(lpButn1->Handle, lpButn1->Enabled)

    lpButn2->PreSetConfig()
    ObjCaption=lpButn2->Caption
    StdStyle=lpButn2->objStyle
    IF lpButn2->Visible THEN StdStyle OR= WS_VISIBLE
    ExtStyle=0

    lpButn2->Handle=CreateWindowEx(ExtStyle,lpButn2->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpButn2->Left, lpButn2->Top, lpButn2->Width, lpButn2->Height, _
                    lpForm1->Handle, CAST(HMENU, lpButn2->objIndex), 0, 0)

    lpButn2->Parent = lpForm1->Handle
    lpButn2->PostConfig()
    EnableWindow(lpButn2->Handle, lpButn2->Enabled)

    lpLabel1->PreSetConfig()
    ObjCaption=lpLabel1->Caption
    StdStyle=lpLabel1->objStyle
    IF lpLabel1->Visible THEN StdStyle OR= WS_VISIBLE
    ExtStyle=0

    lpLabel1->Handle=CreateWindowEx(ExtStyle,lpLabel1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpLabel1->Left, lpLabel1->Top, lpLabel1->Width, lpLabel1->Height, _
                    lpTabCtrl1->Handle, CAST(HMENU, lpLabel1->objIndex), 0, 0)

    lpLabel1->Parent = lpTabCtrl1->Handle
    lpLabel1->PostConfig()
    EnableWindow(lpLabel1->Handle, lpLabel1->Enabled)

    CreateMainMenu()
    CreatePopupMenus()
END SUB

'-------------------------------------------------------------------------------
' Remove Timers on Exit
'-------------------------------------------------------------------------------
SUB KillAllTimers
    KillTimer(Application.hMainForm, SYS_TIMER_IDX)
END SUB

'-------------------------------------------------------------------------------
' System timer - Display hints
'-------------------------------------------------------------------------------
SUB SysDisplayHint(Parent AS HWND, HintString AS string)
DIM AS TOOLINFO ti

    ti.cbSize=sizeof(ti)
    ti.uFlags=TTF_SUBCLASS: ti.hwnd=Parent
    ti.hinst=NULL: ti.lpszText=STRPTR(HintString)
    GetClientRect(Parent, @ti.rect)
    SendMessage(Application.hWndTTip, TTM_ADDTOOL, 0, CAST(LPARAM, @ti))	
END SUB

SUB CheckSystemTimers
STATIC AS HWND TT_LastHWND
DIM AS HWND TT_hWnd
DIM AS Point TT_pnt

    TT_pnt.X=Screen.MouseX: TT_pnt.Y=Screen.MouseY
    TT_hWnd=WindowFromPoint(TT_pnt)
    IF TT_LastHWND<>TT_hWnd THEN
        TT_LastHWND=TT_hWnd
        SELECT CASE TT_hWnd
            CASE lpForm1->Handle
                IF lpForm1->ShowHint THEN
                    SysDisplayHint(lpForm1->Handle, lpForm1->Hint)
                END IF
            CASE lpTabCtrl1->Handle
                IF lpTabCtrl1->ShowHint THEN
                    SysDisplayHint(lpTabCtrl1->Handle, lpTabCtrl1->Hint)
                END IF
            CASE lpButn1->Handle
                IF lpButn1->ShowHint THEN
                    SysDisplayHint(lpButn1->Handle, lpButn1->Hint)
                END IF
            CASE lpButn2->Handle
                IF lpButn2->ShowHint THEN
                    SysDisplayHint(lpButn2->Handle, lpButn2->Hint)
                END IF
            CASE lpLabel1->Handle
                IF lpLabel1->ShowHint THEN
                    SysDisplayHint(lpLabel1->Handle, lpLabel1->Hint)
                END IF
        END SELECT
    END IF
END SUB

'-------------------------------------------------------------------------------
' Start of Main WndProc code
'-------------------------------------------------------------------------------

SUB CheckWmTimers(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE wParam
        CASE App_Timer.ObjIndex:  CheckSystemTimers
    END SELECT
END SUB

SUB CheckWmCommandMsg(wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE LOWORD(wParam)
        CASE lpButn1->ObjIndex
            IF lpButn1->OnClick>0 THEN lpButn1->OnClick(lpButn1)
        CASE lpButn2->ObjIndex
            IF lpButn2->OnClick>0 THEN lpButn2->OnClick(lpButn2)
        CASE lpLabel1->ObjIndex
            IF lpLabel1->OnClick>0 THEN lpLabel1->OnClick(lpLabel1)
    END SELECT
END SUB

SUB CheckWmNotifyMsg(wParam AS WPARAM, lParam AS LPARAM)
DIM AS NMHDR PTR lpNmhdr=CAST(NMHDR PTR, lParam)

    SELECT CASE lpNmhdr->hwndFrom
        CASE lpTabCtrl1->Handle
            IF lpNmhdr->Code=TCN_SELCHANGE THEN
                IF lpTabCtrl1->OnChange>0 THEN lpTabCtrl1->OnChange(lpTabCtrl1)
            END IF
    END SELECT
END SUB

SUB CheckWmPaintMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    IF lpForm1->OnPaint>0 THEN lpForm1->OnPaint(lpForm1)
END SUB

FUNCTION CheckBtnColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
' Only for OwnerDraw buttons
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckStaticColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
DIM AS HDC hDC=CAST(HDC, wParam)
DIM AS HWND Handle=CAST(HWND, lParam)

    SELECT CASE Handle
        CASE lpLabel1->Handle
            SetBKMode(hDC, 1)
            SetTextColor(hDC, CAST(COLORREF, lpLabel1->Font.Color))
            hBrush=CreateSolidBrush(CAST(COLORREF, lpLabel1->Color))
    END SELECT
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckEditColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckListBoxColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

SUB CheckWmObjScroll(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckSocketEvent(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

' Hook into the Popup menus for all of your components here
SUB CheckWmContextMenu(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmHitTest(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmDrawItem(wParam AS WPARAM, lParam AS LPARAM)
END SUB

FUNCTION MainWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
STATIC AS integer Sizing
    
    SELECT CASE wMsg
        CASE WM_CREATE
            Sizing=False

        CASE WM_COMMAND
            IF lParam<>0 THEN
                CheckWmCommandMsg(wParam, lParam)
            ELSE
                ' IF HIWORD(wParam)=0 THEN
                '     Menu message code goes here.....
                ' ELSE
                '     Accelerator message code goes here...
                ' END IF
            END IF

        CASE WM_NOTIFY
            CheckWmNotifyMsg(wParam, lParam)

        CASE WM_PAINT
            CheckWmPaintMsg(hWnd, wMsg, wParam, lParam)

        CASE WM_TIMER
            CheckWmTimers(hWnd, wMsg, wParam, lParam)

        CASE WM_NCHITTEST
            CheckWmHitTest(hWnd, wMsg, wParam, lParam)

        CASE WM_HSCROLL, WM_VSCROLL
            IF lParam<>0 THEN CheckWmObjScroll(hWnd, wMsg, wParam, lParam)

        CASE WM_CTLCOLORBTN
            RETURN CheckBtnColor(wParam, lParam)

        CASE WM_CTLCOLOREDIT
            RETURN CheckEditColor(wParam, lParam)

        CASE WM_CTLCOLORSTATIC
            RETURN CheckStaticColor(wParam, lParam)

        CASE WM_CTLCOLORLISTBOX
            RETURN CheckListBoxColor(wParam, lParam)

        CASE WM_DRAWITEM
            CheckWmDrawItem(wParam, lParam)

        CASE WM_CONTEXTMENU
            CheckWmContextMenu(hWnd, wMsg, wParam, lParam)

        CASE WM_SOCK_NOTIFY
            CheckSocketEvent(hWnd, wMsg, wParam, lParam)

        CASE WM_MOUSEMOVE
            IF lpForm1->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpForm1->hCursor)
            END IF
            IF lpForm1->OnMouseMove>0 THEN
                lpForm1->OnMouseMove(LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONDBLCLK
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_LBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_RBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_RBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_KEYDOWN
            IF lpForm1->OnKeyDown>0 THEN lpForm1->OnKeyDown(LOWORD(wParam), 0, lpForm1)

        CASE WM_KEYUP
            IF lpForm1->OnKeyUp>0 THEN lpForm1->OnKeyUp(LOWORD(wParam), 0, lpForm1)

        CASE WM_CHAR
            IF lpForm1->OnKeyPress>0 THEN lpForm1->OnKeyPress(LOBYTE(wParam), lpForm1)

        CASE WM_SYSCOMMAND
            IF (wParam AND &hfff0) = SC_CLOSE THEN
                DIM AS integer Action=1                                      ' Default Action is quit
                IF lpForm1->OnClose>0 THEN lpForm1->OnClose(Action, lpForm1) ' Action passed by reference so
                IF Action=0 THEN RETURN 0                                    ' user can change default action
            END IF

        CASE WM_ENTERSIZEMOVE
            Sizing=True

        CASE WM_EXITSIZEMOVE
            lpForm1->FormReSize()
            Sizing=False
            IF lpForm1->OnResize>0 THEN
                lpForm1->OnResize(lpForm1)
                InvalidateRect(hWnd, NULL, True)
                RETURN 0
            END IF

        CASE WM_SIZE
            IF Sizing THEN RETURN 0
            IF (wParam=SIZE_MAXIMIZED) OR (wParam=SIZE_RESTORED) THEN
                lpForm1->FormReSize()
                IF lpForm1->OnResize>0 THEN
                    lpForm1->OnResize(lpForm1)
                    RETURN 0
                END IF
            END IF

        CASE WM_CLOSE

        CASE WM_DESTROY
            KillAllTimers()
            PostQuitMessage(0)

    END SELECT

    RETURN DefWindowProc(hWnd, wMsg, wParam, lParam)
END FUNCTION

'-------------------------------------------------------------------------------
' Create new window class for project
'-------------------------------------------------------------------------------
FUNCTION CreateWindClass(hInst AS HINSTANCE) AS integer
DIM AS integer Result
DIM AS WNDCLASSEX wc

WITH wc
    .cbSize = SizeOf(WNDCLASSEX)
    .style = CS_HREDRAW OR CS_VREDRAW
    .lpfnWndProc = @MainWndProc
    .hInstance = hInst
    .hIcon = LoadIcon(0, IDI_APPLICATION)
    .hCursor = LoadCursor(0, IDC_ARROW)
    .hbrBackground = GetSysColorBrush(COLOR_BTNFACE)
    .lpszClassName = @"RQClass"
    .hIconSm = .hIcon
END WITH

    Result = RegisterClassEx(@wc)
    IF Result = 0 THEN ShowMessage("Register class error")
    RETURN Result
END FUNCTION

'-------------------------------------------------------------------------------
' Main startup code
'-------------------------------------------------------------------------------
FUNCTION WinMain(hInst AS HINSTANCE, hPrevInstance AS HINSTANCE, _
                            szCmdLine AS string, iCmdShow AS integer) AS integer
DIM AS integer Result=0

    IF CreateWindClass(hInst) = 0 THEN RETURN 0

    ConfigureComponents()
    CreateComponents()
    InitSystemTimers(lpForm1->Handle)
    HookTheMouse()

    lpForm1->Center                         ' You may wish to delete this line

    IF lpForm1->OnShow>0 THEN lpForm1->OnShow(lpForm1)

    Result = lpForm1->ShowModal             ' Show form & call default message handler

    ' You may want to change the above line to lpForm1->Show, and then provide
    ' your own function that, amongst other things, handles all window messages.

    UnHookTheMouse()

    RETURN Result
END FUNCTION

'-------------------------------------------------------------------------------
' *** MAIN ENTRY POINT ***
'-------------------------------------------------------------------------------
END WinMain(Application.hInstance, NULL, Command(0), SW_NORMAL)


'-------------------------------------------------------------------------------
' Code for the component events
'-------------------------------------------------------------------------------
SUB TabChange(Sender AS QTABCONTROL)
    lpLabel1->Caption = "TAB " + STR(Sender.TabIndex + 1)
END SUB

SUB DoTest(Sender AS QBUTTON)
    lpTabCtrl1->BMP = IMG_FILE
'    lpTabCtrl1->TabHeight=32
END SUB

SUB Done(Sender AS QBUTTON)
    Application.Terminate
END SUB

