$TypeCheck On

CONST BMPI_RGB = 0
CONST BMPI_RLE8 = 1
CONST BMPI_RLE4 = 2

TYPE BMPHEADER
    Signature as string*2
    FileSize as integer
    reserved as integer
    DataOffset as integer
    Size as integer
    Width as integer
    Height as integer
    Planes as word
    BitCount as word
    Compression as integer
    ImageSize as integer
    XpixelsPerM as integer
    YpixelsPerM as integer
    ColorsUsed as integer
    ColorsImportant as integer
END TYPE

Dim BMPINFOHEADER as BMPHEADER
Dim BMPFILESTREAM AS QFILESTREAM


Type QBMPINFO extends Qobject
Info as bmpheader
Palette as qpanel
PM as qmemorystream
PColor(255) as qlabel

'______________________________________________________________________________
Sub GeneratePalette

With QBMPINFO.palette
    .width = 160
    .height = 160
    .borderstyle = 0
End with

'Dim PColor(255) as qlabel
Dim px as integer
Dim tmpcol as integer


px = 0
QBMPINFO.PM.position = 0


do
    QBMPINFO.Pcolor(px).parent = QBMPINFO.Palette
    QBMPINFO.Pcolor(px).autosize = 0
    QBMPINFO.Pcolor(px).width = 10
    QBMPINFO.Pcolor(px).height = 10
    QBMPINFO.Pcolor(px).color = 255 * px
    QBMPINFO.Pcolor(px).top = 10 * floor((px / 16))
    QBMPINFO.Pcolor(px).left = 10 * (px mod 16)
    QBMPINFO.Pcolor(px).color = QBMPINFO.PM.readnum(4)
inc(px)
loop until px = 256


End sub
'______________________________________________________________________________
Sub Open (File as string)
If fileexists(File) = 0 then
    Showmessage "File not found"
    Exit sub
End if

BMPFILESTREAM.open (File, 0)
BMPFILESTREAM.position = 0
BMPFILESTREAM.readUDT(QBMPINFO.Info)

If QBMPINFO.Info.Bitcount <= 8 then
    Dim ncolors as integer
    dim rwbyte as byte
    dim rwint as integer
    dim x as integer

    x = 0
    ncolors = 2 ^ QBMPINFO.Info.Bitcount
    ncolors = ncolors * 4

    do
    rwint = 0
    rwbyte = BMPFILESTREAM.readnum(1)
    rwint = rwint + (rwbyte * 65536)
    rwbyte = BMPFILESTREAM.readnum(1)
    rwint = rwint + (rwbyte * 256)
    rwbyte = BMPFILESTREAM.readnum(1)
    rwint = rwint + rwbyte
    rwbyte = BMPFILESTREAM.readnum(1)
    QBMPINFO.PM.writenum(rwint, 4)
    inc(x)
    loop until x = ncolors

end if

BMPFILESTREAM.close


QBMPINFO.GeneratePalette
QBMPINFO.PM.Close

End sub
'______________________________________________________________________________
With QBMPINFO.Info
Function Signature as string        :Result = .signature        : End function
Function FileSize as integer        :Result = .Filesize         : End Function
Function Reserved as integer        :Result = .Reserved         : End Function
Function DataOffset as integer      :Result = .DataOffset       : End Function
Function Size as integer            :Result = .Size             : End Function
Function Width as integer           :Result = .Width            : End Function
Function Height as integer          :Result = .Height           : End Function
Function Planes as Word	            :Result = .Planes	        : End Function
Function BitCount as Word	        :Result = .BitCount	        : End Function
Function Compression as Integer	    :Result = .Compression	    : End Function
Function ImageSize as Integer	    :Result = .ImageSize	    : End Function
Function XpixelsPerM as Integer	    :Result = .XpixelsPerM	    : End Function
Function YpixelsPerM as Integer	    :Result = .YpixelsPerM	    : End Function
Function ColorsUsed as Integer	    :Result = .ColorsUsed	    : End Function
Function ColorsImportant as	Integer	:Result = .ColorsImportant  : End Function
End With
'______________________________________________________________________________
Function Numcolors as integer
Result = 2 ^ QBMPINFO.Info.Bitcount
End Function
'______________________________________________________________________________

End Type
