$include "\rapidq\include\Windows.inc"
$include "\rapidq\include\RapidQ2.inc"
$include <GL\gl.inc>
$include <GL\glwgl.inc>
$include <GL\glu.inc>

'$include <glaux.inc>
$include <glBMP.inc>



Declare Sub Init()
Declare Sub Display()
Declare SUB SizeglScreen(width AS INTEGER, height AS INTEGER)        '// Init GL Window size, also use to adjusts the viewport onResize
DECLARE SUB ChangeToFullScreen()



DIM hDC 			AS LONG			'the windows handle to device context (DC)
DIM	glhDC			AS LONG			'my open GL handle to the DC
DIM hglRC			AS LONG

DIM InitItDone		as integer: InitItDone = 0
DIM fps 			as Integer
DIM FrameTime 		as Integer
DIM Frames 			as Integer
DIM rot_y 			as integer
DIM rot_Speed		as integer: rot_Speed = 3
DIM MainForm 		as QForm
DIM glTimer 		as QDXTimer





Dim glTexture as EGLTEXTUREDATA
	glTexture.Height = 256
	glTexture.Width = 256
	glTexture.bpp = 24
	glTexture.imgSizes = 256
	glTexture.tData(0) = 256


'**************************************************************************************************
'initalize the interface to windows:
' x , y size, bits per pixel colors, fullscreen (on/off) z buffer pixel depth, stencil bit depth,  windows DC handle
'****************************************************************************************************
'
SUB glInitialize(width AS INTEGER, height AS INTEGER, bpp As BYTE, FullScreen AS BYTE, zbuffer As BYTE, stencil As BYTE, BYREF hDC As LONG)
    DIM pf 			AS PIXELFORMATDESCRIPTOR
	DIM Hresult		AS LONG


	hDC = GetDC(MainForm.Handle)										'global DC,don't free this hdc until the end of our program
    pf.nSize = LEN(pf)
    pf.nVersion = 1
    pf.dwFlags = PFD_DRAW_TO_WINDOW OR PFD_SUPPORT_OPENGL OR PFD_DOUBLEBUFFER		'OR PFD_TYPE_RGBA
    pf.iPixelType = PFD_TYPE_RGBA													'RGB and Alpha pixel type
    pf.cColorBits = bpp														'8,16,24,or 32-bit color
    pf.cDepthBits = zbuffer													'Depthbits is ignored for RGBA, but we do it anyway		
    pf.cAccumBits = 0														'No special bitplanes needed
    pf.cStencilBits = stencil
    pf.iLayerType = PFD_MAIN_PLANE

    Hresult = ChoosePixelFormat(hDC, pf)
    IF Hresult = 0 THEN								ShowMessage "ChoosePixelFormat failed":	EXIT SUB
    IF (SetPixelFormat(hDC, Hresult, pf) = 0) THEN	ShowMessage "SetPixelFormat failed": 	EXIT SUB

    hglRC = wglCreateContext(hDC)				'//create a rendering context from our hdc
    wglMakeCurrent hDC, hglRC					'//set up a GDI context for openGL screen
'	glClearDepth 1									'//necessary?
'	glEnable(GL_DEPTH_TEST)							'// Enables Depth Testing
	IF FullScreen THEN ChangeToFullScreen
	'SizeGLScreen(width, height)					'// Setup the screen translations and viewport
	INC InitItDone
END SUB



'initalize the interface to windows, bits/pix , windows DC handle     glStart(16, 16, 0, HDC)
'SUB glInitialize(bpp As BYTE, zbuffer As BYTE, stencil As BYTE, hDC As LONG)
'    DIM pf 			AS PIXELFORMATDESCRIPTOR'
'	DIM Hresult		AS LONG
'
 '   pf.nSize = Len(pf)
'    pf.nVersion = 1							'should always be 1 ??
'    pf.dwFlags = PFD_DRAW_TO_WINDOW OR PFD_SUPPORT_OPENGL Or PFD_DOUBLEBUFFER OR PFD_GENERIC_ACCELERATED OR PFD_STEREO 'last two may not be supported-	
'    pf.iPixelType = PFD_TYPE_RGBA			'32 bit or use PFD_TYPE_COLORINDEX for palette based
'    pf.cColorBits = bpp						'8,16,24, 32
'    pf.cDepthBits = zbuffer					'same for z-buffer
'    pf.cStencilBits = stencil				'depth of the stencil buffer which does pen styles
'   ' pf.iLayerType = PFD_MAIN_PLANE 		'Win claims not supported'

'    Hresult = ChoosePixelFormat(hDC, pf)
 '   IF Hresult = 0 THEN ShowMessage "ChoosePixelFormat failed":	Exit SUB
'		'now let open GL know the pixel format for the render window
'    IF SetPixelFormat(hDC, Hresult, pf) = 0 THEN ShowMessage "SetPixelFormat Failed": EXIT SUB
'    glhDC = wglCreateContext(hDC)			'let open gl know which window device context
''    wglMakeCurrent hDC, glhDC				'set up a GDI handle to the screen for openGL
'	INC InitItDone
'END SUB



'**************************************************************************
' Set the width and height of the OpenGL screen, and set its viewport
'**************************************************************************

SUB SizeglScreen(width AS INTEGER, height AS INTEGER)      '// Init GL Window size, also use to adjusts the viewport onResize
        IF (height=0) THEN height=1                        '// Prevent A Divide By Zero error
        glViewport(0,0,width,height)                '// whole window the viewport but could make the view smaller inside
                                                                                '// The glViewport takes (x, y, width, height) -- our drawing boundries
        glMatrixMode(GL_PROJECTION)                        '// GL_ORTHO = all objects are same size try (GL_PROJECTION) for distant = smaller
        glLoadIdentity                                                '// Reset The Projection Matrix

'// *********   Calculate The Aspect Ratio Of The Window  ****************
'//  The parameters are (view angle, aspect ration of the width to the height,closest camera distance before clipping
'                  // FOV deg in y-direction /Aspect Ratio =FOV in x-direction/ dist to Near clipping plane/ dist to far clipping Plane
'        gluPerspective(45.0, (width/height), 0.5 , 20.0)                                        '//sets up a perspective projection matrix.
END SUB




'**************************************************************************
'   Properly exit from the program and release device context (DC)
'**************************************************************************

SUB glQuit()
'        IF glFullScreen THEN ChangeDisplaySettings(NULL$,0)
        IF hglRC THEN wglMakeCurrent 0, 0: wglDeleteContext hglRC
        IF hDC THEN ReleaseDC(MainForm.Handle, hDC)
END SUB



Public Sub glFlip()
    SwapBuffers hDC
End Sub


'Function auxTexture(texture As EGLTEXTUREDATA) As Long
'    Dim tID As Long
'    
'    glGenTextures 1, tID
'    glBindTexture GL_TEXTURE_2D, tID		'TARGET_TEXTURE_2D, tID
'    
'    glTexParameteri GL_TEXTURE_2D, TEXTURE_MAG_FILTER, FILTER_NEAREST
'    glTexParameteri GL_TEXTURE_2D, TEXTURE_MIN_FILTER, FILTER_NEAREST
'    
'    glTexImage2D GL_TEXTURE_2D, 0, PIXEL_RGB, texture.Width, texture.Height, 0, PIXEL_RGB, PT_UNSIGNED_BYTE, texture.tdata(0)
'    auxTexture = tID
'End Function




'**************************************************************************
'   OpenGL lighting, tons of room to play here
'**************************************************************************

SUB SetLighting(LightType AS DWORD, x AS SINGLE, y AS SINGLE, z AS SINGLE, a AS SINGLE)
        DIM params(3)                AS SINGLE
        '// LightType = GL_AMBIENT, GL_SPECULAR, GL_POSITION, GL_SPOT_DIRECTION, etc
        '// turn on lighting
        glEnable GL_LIGHTING:        glEnable GL_LIGHT0                '//light numbers from 0 to 7
        params(0) = x: params(1) =  y: params(2) = z :params(3) = a         '// light RGBA intensities range from -1.0 to 1.0
                                                                                                                                        '//, integers converted
        glLightfv GL_LIGHT0, LightType, VARPTR(params(0))
END SUB





SUB TimerOver
  IF InitItDone < 2 THEN Init()				'need to re-CALL this initialization for it to run, why???
	Display()
	FrameTime = glTimer.framerate
	MainForm.Caption = "OpenGL Demo -- Frame rate = "+ STR$(FrameTime)
End SUB



SUB Init()
	'glFullScreen = false                        'may not work on all graphics cards
	hDC = GetDC(MainForm.Handle)
'	glInitialize(24, 8, 32, 0, 8, 8, hDC)		'bits/pix, z-buffer bits, stencil bits, form DC
	glInitialize(640, 480, 32, 0, 8, 8, hDC)		'bits/pix, z-buffer bits, stencil bits, form DC
	glEnable(GL_TEXTURE_2D)
	glDisable(GL_DEPTH_TEST)
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)
	glShadeModel(GL_SMOOTH)				'	// Set the shading model

	'glTexture =  auxTexture(glTexture)
	glMatrixMode(GL_PROJECTION)
	glLoadIdentity						'// Set the modelview matrix to be the identity matrix
	LoadTexture("gl.tga")     
'	SizeglScreen(60,60)				'set viewport
	glTimer.Enabled = 1
End Sub




SUB Display()

	glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT)	'clear the RGB and depth back buffer
	glPushMatrix						'store matrix of rotation, scaling, translation
	glTranslatef(-0.5,-0.5,0.5)			'center of view is at x,y,z = 0,0,0
	glRotatef(rot_y, 1.0, 1.0, 0.0)		'rotate the plane

	glBegin(GL_QUADS)
			glTexCoord2i(0, 0)
			glVertex3f(0, 0, 0)
           
			glTexCoord2i(0, 1)
			glVertex3f(0, 1.0, 0.0)

			glTexCoord2i(1,1)
			glVertex3f(1.0, 1.0, 0.0)

			glTexCoord2i(1, 0)
			glVertex3f(1.0, 0, 0.0)
	glEnd
	glPopMatrix							'if you push the matrix then pop it
	INC (rot_y, rot_Speed)
	glFlip()							'bring back buffer to screen
END SUB





'**************************************************************************
'   Set graphics mode to full screen, may need to develop QDXSCREEN instead
'**************************************************************************

SUB ChangeToFullScreen()
        DIM hRESULT AS LONG
        DIM dmSettings AS DEVMODE                                                         '// Device Mode variable in WIN32AP.INC

        memset(dmSettings,0,sizeof(dmSettings))                                '// Makes Sure Memory's Cleared
        '// Get current settings -- makes sure NT and Win98 machines change correctly
'        hRESULT = EnumDisplaySettings(NULL$, ENUM_CURRENT_SETTINGS, dmSettings)                ' Null for current display(or \DisplayX), caches the current settings if 0
'        IF hRESULT = DISP_CHANGE_FAILED THEN
'                ShowMessage "Enum Display Settings failed, program will run in window mode"
'                glFullScreen = False
'                EXIT SUB
'        END IF

        dmSettings.dmSize = sizeof(dmSettings)                                '//must initalize size
        dmSettings.dmPelsWidth        = SCREEN.WIDTH                                '// Selected Screen Width
        dmSettings.dmPelsHeight        = SCREEN.HEIGHT                                '// Selected Screen Height
        dmSettings.dmFields     = DM_PELSWIDTH OR DM_PELSHEIGHT' OR DM_BITSPERPEL

        '// CDS_FULLSCREEN - flag will also gets Rid Of Start Bar.-- always check if function failed
        hRESULT = ChangeDisplaySettings(dmSettings, CDS_FULLSCREEN)
        IF(hRESULT<> DISP_CHANGE_SUCCESSFUL) THEN ShowMessage "Display Mode Not Compatible with Fullscreen"
END SUB


'Main Code



glTimer.Interval = 1
glTimer.Enabled = 0
glTimer.OnTimer = TimerOver 



MainForm.Caption = "OpenGL Demo"
MainForm.Width = 640
MainForm.Height = 480
MainForm.BorderStyle = 6
MainForm.Center
'MainForm.OnShow = Init
Init
MainForm.ShowModal
