'*************************************************************
'* QGrid - component v 1.1
'* 2005 Nastase Eodor
'* Generated by RqWork v 7.0.0 Beta
'* eodor@3x.ro  http://rqwork.3x.ro
'*************************************************************
Const gsDots      = 1
Const gsLines     = 2
Const gsMark      = 3

Const Millimetres = 1
Const Inches      = 2
Type QGrid extends QCanvas
     Private:
     fX        As Double
     fY        As Double
     
     Public :
     Units     As Integer
     StepX     As Double Property Set SetStepX
     StepY     As Double Property Set SetStepY
     Scale     As Double Property Set SetScale
     GridStyle As Integer Property Set SetGridStyle
     GridColor As Integer Property Set SetGridColor
     
     With This
     
     Function ToPixel(Value As Double) As Double
     If .Units = 1 then
        Result = Value / 25.4 * 100 ' MM
     ElseIf .Units = 2 then
        Result = Value * 100         'INCH
     End If
     End Function
     
     Event OnPaint
     Defdbl x,y
     If (.Scale > 1) then Exit Sub

               If .GridStyle = 1 then
                   For y = 0 to .Height step .fY * .Scale
                      For x = 0 to .Width step .fX * .Scale
                          .Pixel(x,y) = .GridColor
                      Next x
                   Next y
               End If
               If .GridStyle = 2 then
                  For y = 0 to .Height step .fY * .Scale
                      For x = 0 to .Width step .fX * .Scale
                          .Line(x,0,x,.Height,.GridColor)
                      Next x
                          .Line(0,y,.Width,y,.GridColor)
                  Next y
               End If
               If .GridStyle = 3 then
                  For y = 0 to .Height step .fY * .Scale
                      For x = 0 to .Width step .fX * .Scale
                         .Line(x,y - .fY/4 * .Scale,x,y + .fY/4 * .Scale,.GridColor)
                         .Line(x - .fX/4 * .Scale,y,x + .fX/4 * .Scale ,y,.GridColor)
                      Next x
                  Next y
               End If

     End Event
     
     Sub Invalidate
     .Repaint
     End Sub
     
     Property Set SetGridStyle(Value As Integer)
     If Value <> .GridStyle then
        .GridStyle = Value
        .Invalidate
     End If
     End Property
     
     Property Set SetGridColor(Value As Integer)
     If Value <> .GridColor then
        .GridColor = Value
        .Invalidate
     End If
     End Property
     
     Property Set SetStepX(Value As Double)
     If Value <> .StepX then
        .StepX = Value
        .fx    = .ToPixel(.StepX)
        .Invalidate
     End If
     End Property
     
     Property Set SetStepY(Value As Double)
     If Value <> .StepY then
        .StepY = Value
        .fy    = .ToPixel(.StepY)
        .Invalidate
     End If
     End Property
     
     Property Set SetScale(Value As Double)
     If Value <> .Scale then
        .Scale = Value
        .Invalidate
     End If
     End Property
     
     End With
     
     Constructor
     Units     = 1
     GridStyle = 1
     Scale     = 1
     GridColor = 0
     StepX     = 2.54
     StepY     = 2.54
     fx        = This.ToPixel(This.StepX)
     fY        = This.ToPixel(This.StepY)
     End Constructor
End Type
