'
' =============================================================================
' QINI   EXTENDED   COMPONENT        November 2001          By Jacques Philippe
' =============================================================================
'
$TypeCheck ON    ' turned off at the end of this INC
$EscapeChars ON  ' turned off at the end of this INC
'
CONST JP_INI_ERROR_FUNCTION_OK = 0
CONST JP_INI_ERROR_FUNCTION_WRITE_FAILURE = 1
CONST JP_INI_ERROR_FUNCTION_READ_FAILURE = 2
CONST JP_INI_ERROR_FUNCTION_READ_DEFAULT_VALUE = 3
CONST JP_INI_ERROR_FUNCTION_READ_SECTION_NAME_EMPTY = 4
CONST JP_INI_ERROR_FUNCTION_READ_KEY_NAME_EMPTY  = 5
'
'API declarations
' ---------------
Declare Function JP_GetPrivateProfileString Lib "Kernel32" Alias "GetPrivateProfileStringA" _
 (ByRef lpApplicationName As String, ByRef lpKeyName As String, _
 ByRef lpDefault As String, ByRef lpReturnedString As String, _
 ByVal nSize As Long, ByRef lpFileName As String) As Long

Declare Function JP_WritePrivateProfileString Lib "Kernel32" Alias "WritePrivateProfileStringA" _
 (ByRef lpApplicationName As String, ByRef lpKeyName As String, _
 ByRef lpString As String, ByRef lpFileName As String) As Long
' =========================================================
Type Qini Extends QObject
' -----------------------
    PUBLIC:
    FileName As String
    Section As String
    Error As Long
    Comments As String

    CONSTRUCTOR
        FileName = (Ucase$(Command$(0)) - ".EXE") + ".INI" ' default values
        Section = ((Ucase$(application.exeName)) - ".EXE") ' default values
    END CONSTRUCTOR

    PUBLIC:
    With QIni
        ' READ information FROM an INI File
        ' ---------------------------------
        Function Read(skeyName As String, skeyDefaultValue as String) As String
            DefStr keyName, keyDefaultValue, resultBuffer
            DefInt lenght
            keyName = skeyName
            keyDefaultValue = skeyDefaultValue
            If keyName = "" Then
                .Comments = "Ini Read Comments : \n   KeyName is an EMPTY STRING " _
                            & "\n   FUNCTION READ FAILURE, NOTHING DONE" 
                .Error = JP_INI_ERROR_FUNCTION_READ_KEY_NAME_EMPTY ' = 5
            ElseIf .section = "" Then
                .Comments = "Ini Read Comments : \n   SectionName is an EMPTY STRING " _
                            & "\n   FUNCTION READ FAILURE, NOTHING DONE" 
                .Error = JP_INI_ERROR_FUNCTION_READ_SECTION_NAME_EMPTY ' = 4
            Else
                resultBuffer = Space$(260) 'Dim a buffer to recieve the result
                lenght = JP_GetPrivateProfileString(.Section, keyName, keyDefaultValue, _
                     resultBuffer, 260, .FileName)
                result = Left$(resultBuffer, lenght)
                .Comments = "Ini Read Comments : \n   Key Name \"" & keyName & "\"\n   In Section \"" & .Section & _
                            "\"\n   In File \"" & .Filename & "\""
                If result = keyDefaultValue Then
                    .Comments = .Comments + "\n   KEY NOT FOUND\n   DEFAULT VALUE \"" & _
                            keyDefaultValue & "\" RETURNED" 
                            .Error = JP_INI_ERROR_FUNCTION_READ_DEFAULT_VALUE ' 3
                ElseIf lenght = 0 Then
                    .Comments = .Comments + "\n   FUNCTION READ KEY FAILURE, NOTHING DONE" 
                    .Error = JP_INI_ERROR_FUNCTION_READ_FAILURE ' 2
                Else
                    .Comments = .Comments + "\n   Key Value Read : \"" & result & "\"\n   OK, KEY READING SUCCESFULL" 
                    .Error = JP_INI_ERROR_FUNCTION_OK ' 0
                End If
            End If 
        End Function

        ' WRITE information IN an INI File
        ' --------------------------------
        Sub Write(skeyName As String, skeyValue As String)
            DefStr keyName, keyValue
            DefInt iTmp
            keyName = skeyName
            keyValue = skeyValue
            iTmp = JP_WritePrivateProfileString (.Section, keyName, keyValue, .filename)
            .Comments = "Ini Write Comments\n   Key \"" & keyName & "\" set to \"" & _
                        keyValue  & "\"\n   In Section \"" & .Section & "\"\n   In File \"" & _
                        .Filename & "\""
            If iTmp = 0 Then
                .Comments = .Comments & "\n   FAILURE, NOTHING DONE"            
                .Error = JP_INI_ERROR_FUNCTION_WRITE_FAILURE ' 1
            Else
                .Comments = .Comments & "\n   OK, KEY WRITING SUCCESSFULL"                           
                .Error = JP_INI_ERROR_FUNCTION_OK ' 0
            End If
        End Sub
    End With
End Type

$EscapeChars OFF
$TypeCheck OFF

' =====END==========================================================
