 // Get the current view matrix:
    D3DMATRIX matView;
    lpDevice->GetTransform(D3DTRANSFORMSTATE_VIEW, &matView);

    D3DVECTOR Pos = Particles[i].Position;
    D3DVECTOR TransPos;     // Transformed position
    // Apply the view matrix to the position vector:
    TransPos.x = Pos.x * matView(0, 0) + Pos.y * matView(1, 0)
        + Pos.z * matView(2, 0) + matView(3, 0);
    TransPos.y = Pos.x * matView(0, 1) + Pos.y * matView(1, 1)
        + Pos.z * matView(2, 1) + matView(3, 1);
    TransPos.z = Pos.x * matView(0, 2) + Pos.y * matView(1, 2)
        + Pos.z * matView(2, 2) + matView(3, 2);

    D3DLVERTEX Shape[4];
    // upper left:
    Shape[0] = D3DLVERTEX(
        TransPos + D3DVECTOR(
            -0.5f*Particles[i].Size, 0.5f*Particles[i].Size, 0.0f),
        ParticleColor, 0xffffffff,      // color (with alpha) and specular color
        0.0f, 0.0f);                    // texture coords
    // upper right:
    Shape[1] = D3DLVERTEX(
        TransPos + D3DVECTOR(
            0.5f*Particles[i].Size, 0.5f*Particles[i].Size, 0.0f),
        ParticleColor, 0xffffffff, 1.0f, 0.0f);
    // lower left:
    Shape[2] = D3DLVERTEX(
        TransPos + D3DVECTOR(
            -0.5f*Particles[i].Size, -0.5f*Particles[i].Size, 0.0f),
        ParticleColor, 0xffffffff, 0.0f, 1.0f);
    // lower right:
    Shape[3] = D3DLVERTEX(
        TransPos + D3DVECTOR(
            0.5f*Particles[i].Size, -0.5f*Particles[i].Size, 0.0f),
        ParticleColor, 0xffffffff, 1.0f, 1.0f);




'second example **************************************




Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "DirectX-Graphics: Lesson 01"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   213
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   312
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'###############################
'
'           Title: DirectX-Graphics Lesson 15
'           Desc: Billboarding for special effects
'           Written by: Jack Hoxley (Proper Billboard Code written by Eric Coleman)
'           Date: 5th May 2001
'           Contact: Jollyjeffers@Greenonions.netscapeonline.co.uk
'
'###############################
Option Explicit

Dim Dx As DirectX8 'The master Object, everything comes from here
Dim D3D As Direct3D8 'This controls all things 3D
Dim D3DDevice As Direct3DDevice8 'This actually represents the hardware doing the rendering
Dim bRunning As Boolean 'Controls whether the program is running or not...

Private Type LitVertex
    P As D3DVECTOR
    C As Long
    T As D3DVECTOR2
End Type

Private Const FVF_LV = (D3DFVF_XYZ Or D3DFVF_DIFFUSE Or D3DFVF_TEX1)

Private Type TLVertex
    P As D3DVECTOR4
    C As Long
    T As D3DVECTOR2
End Type

Private Const FVF_TLV = (D3DFVF_XYZRHW Or D3DFVF_DIFFUSE Or D3DFVF_TEX1)

Private Type BillBoard
    V(0 To 3) As LitVertex
End Type

Dim Exp(0 To 4) As BillBoard
Dim ExpFrame(0 To 4) As Long
Dim ExpSpeed(0 To 4) As Long
Dim ExpLastChange(0 To 4) As Long
Dim ExpTranslate(0 To 4) As D3DVECTOR

'//Billboarding angles
Dim BBphi As Single
Dim BBtheta As Single


Dim LastTimeTexChange As Long
Private Const ChangeTexEvery As Long = 1000 / 10 '10 fps

'//TEXTURING STUFF
Dim D3DX As D3DX8 '//A helper library
Dim TexExplosion As Direct3DTexture8

Dim CanDoBlending As Boolean '//Can we do multiple stage blending?

Private Const PI As Single = 3.14159265358979
Private Const RAD As Single = PI / 180
Private Const DEG As Single = 180 / PI

Private matWorld As D3DMATRIX
Private matView As D3DMATRIX
Private matProj As D3DMATRIX

Private Declare Function GetTickCount Lib "kernel32" () As Long

Dim FPS_LastCheck As Long
Dim FPS_Counter As Long
Dim FPS_Current As Long




'// Initialise : This procedure kick starts the whole process.
'// It'll return true for success, false if there was an error.
Public Function Initialise() As Boolean
On Error GoTo ErrHandler:

Dim DispMode As D3DDISPLAYMODE '//Describes our Display Mode
Dim D3DWindow As D3DPRESENT_PARAMETERS '//Describes our Viewport
Dim ColorKeyVal As Long '//What colour becomes transparent...

Set Dx = New DirectX8  '//Create our Master Object
Set D3D = Dx.Direct3DCreate() '//Make our Master Object create the Direct3D Interface
Set D3DX = New D3DX8 '//Create our helper library...

'//We're going to use Fullscreen mode because I prefer it to windowed mode :)

'DispMode.Format = D3DFMT_X8R8G8B8
DispMode.Format = D3DFMT_R5G6B5 'If this mode doesn't work try the commented one above...
DispMode.Width = 640
DispMode.Height = 480

D3DWindow.SwapEffect = D3DSWAPEFFECT_FLIP
D3DWindow.BackBufferCount = 1 '//1 backbuffer only
D3DWindow.BackBufferFormat = DispMode.Format 'What we specified earlier
D3DWindow.BackBufferHeight = DispMode.Height
D3DWindow.BackBufferWidth = DispMode.Width
D3DWindow.hDeviceWindow = frmMain.hWnd
D3DWindow.AutoDepthStencilFormat = D3DFMT_D16
D3DWindow.EnableAutoDepthStencil = 1

'//This line creates a device that uses a hardware device if possible; software vertex processing and uses the form as it's target
'//See the lesson text for more information on this line...
Set D3DDevice = D3D.CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, frmMain.hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, _
                                                        D3DWindow)

'//Set the vertex shader to use our vertex format
D3DDevice.SetVertexShader FVF_LV

'//Transformed and lit vertices dont need lighting
'   so we disable it...
D3DDevice.SetRenderState D3DRS_LIGHTING, False
D3DDevice.SetRenderState D3DRS_ZENABLE, 1
D3DDevice.SetRenderState D3DRS_CULLMODE, D3DCULL_NONE 'make billboards visible from behind as well...

D3DDevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1

D3DDevice.SetTextureStageState 0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR
D3DDevice.SetTextureStageState 0, D3DTSS_MINFILTER, D3DTEXF_LINEAR


'//We now want to load our texture;
'the following line may well error-out if the hardware/device does not support 32bit textures with alpha.
        'should this be the case, try using:
        'D3DFMT_A4R4G4B4 - 16 bit
        'D3DFMT_A8R3G3B2 - 16 bit
        'D3DFMT_A8R8G8B8 - 32 bit
        'Use this code to enumerate capabilities:
        If D3D.CheckDeviceFormat(0, D3DDEVTYPE_HAL, DispMode.Format, 0, D3DRTYPE_TEXTURE, D3DFMT_A8R8G8B8) = D3D_OK Then
            Set TexExplosion = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\explosion.dds", 256, 256, 1, 0, D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
        ElseIf D3D.CheckDeviceFormat(0, D3DDEVTYPE_HAL, DispMode.Format, 0, D3DRTYPE_TEXTURE, D3DFMT_A4R4G4B4) = D3D_OK Then
            Set TexExplosion = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\explosion.dds", 256, 256, 1, 0, D3DFMT_A4R4G4B4, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
        ElseIf D3D.CheckDeviceFormat(0, D3DDEVTYPE_HAL, DispMode.Format, 0, D3DRTYPE_TEXTURE, D3DFMT_A1R5G5B5) = D3D_OK Then
            Set TexExplosion = D3DX.CreateTextureFromFileEx(D3DDevice, App.Path & "\explosion.dds", 256, 256, 1, 0, D3DFMT_A1R5G5B5, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, 0, ByVal 0, ByVal 0)
        
        Else
            Debug.Print "No valid texture formats could be found, an alpha channel is required."
            Initialise = False
            Exit Function
        End If

D3DXMatrixLookAtLH matView, MV3D(0, 0, 20), MV3D(0, 0, 0), MV3D(0, 0, 1)
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
D3DXMatrixPerspectiveFovLH matProj, PI / 3, 1, 0.1, 100
    D3DDevice.SetTransform D3DTS_PROJECTION, matProj
    
'// Configure 5 billboards - times, speeds, positions etc...
'Start Frames :- offset them all slightly, so they dont look like they're going at the same time..
ExpFrame(0) = 0: ExpFrame(1) = 2: ExpFrame(2) = 4: ExpFrame(3) = 8: ExpFrame(4) = 10
'Speed :- make some render faster than others, again to reduce the illusion that they're all syncronised
ExpSpeed(0) = 1000 / 8: ExpSpeed(1) = 1000 / 12: ExpSpeed(2) = 1000 / 10: ExpSpeed(3) = 1000 / 13: ExpSpeed(4) = 1000 / 6
'Last Change :- For animation purposes
ExpLastChange(0) = GetTickCount(): ExpLastChange(1) = GetTickCount(): ExpLastChange(2) = GetTickCount(): ExpLastChange(3) = GetTickCount(): ExpLastChange(4) = GetTickCount()
'Translation :- the world position of each billboard.
ExpTranslate(0) = MV3D(0, 0, 0)
ExpTranslate(1) = MV3D(3, 0, -4)
ExpTranslate(2) = MV3D(-2, 3, 0)
ExpTranslate(3) = MV3D(0, -1, 3)
ExpTranslate(4) = MV3D(4, -2, 0)
'NB: it will look, on screen, like they are rotating around; this is an illusion created by the camera rotating around
'the actual billboards are completely static.


'//We can only continue if Initialise Geometry succeeds;
'   If it doesn't we'll fail this call as well...
If InitialiseGeometry() = True Then
    Initialise = True '//We succeeded
    Exit Function
End If


ErrHandler:
'//We failed; for now we wont worry about why.
Debug.Print "Error Number Returned: " & Err.Number, Err.Description
Initialise = False
End Function

Public Sub Render(angle As Single)
'//0. Any Variables
    Dim CamPos As D3DVECTOR
    Dim D3DDevVP As D3DVIEWPORT8
    
'//1. We need to clear the render device before we can draw anything
'       This must always happen before you start rendering stuff...
D3DDevice.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1#, 0    '//Clear the screen black


'//2. Rendering the graphics...
    'make the camera rotate around the origin at a distance of 20m
    'Whilst the camera is rotating around quite a lot, you should not notice any movement of
    'the billboards - the fact that they look totally 2D is a sign that they are working :)
    CamPos.X = 20 * Cos(angle * RAD * 2)
    CamPos.Y = 20 * Sin(angle * RAD * 2)
    CamPos.Z = 20 * Cos(angle * RAD)
    
    D3DXMatrixLookAtLH matView, CamPos, MV3D(0, 0, 0), MV3D(0, 0, 1)
        D3DDevice.SetTransform D3DTS_VIEW, matView
        FindAngles CamPos, MV3D(0, 0, 0)    'we must recalculate the angles on each camera-update
    
    D3DDevice.GetViewport D3DDevVP 'cache for second method...
        
    'Comment out one of the two following function calls
    'to see the difference between them both...
D3DDevice.BeginScene
    '###########################
    '## METHOD 1: PROPER BILLBOARDS ##
    '##########################
        RenderProperBillBoards D3DDevVP
    
    '############################
    '## METHOD 2: CHEAP BILLBOARDING ##
    '###########################
        'RenderCheapBillboards D3DDevVP
    

            
D3DDevice.EndScene

'//3. Update the frame to the screen...
D3DDevice.Present ByVal 0, ByVal 0, 0, ByVal 0
End Sub

Private Function Dist(v1 As D3DVECTOR, v2 As D3DVECTOR) As Single
    Dist = Sqr(Abs((v1.X + v2.X) ^ 2 + (v1.Y + v2.Y) ^ 2 + (v1.Z + v2.Z) ^ 2))
End Function

Private Sub Form_Click()
bRunning = False
End Sub

Private Sub Form_Load()
Dim A As Single

Me.Show '//Make sure our window is visible

bRunning = Initialise()
Debug.Print "Device Creation Return Code : ", bRunning 'So you can see what happens...

Do While bRunning
    A = A + 0.1
    If A > 360 Then A = A - 360
    Render A  '//Update the frame...
    DoEvents '//Allow windows time to think; otherwise you'll get into a really tight (and bad) loop...
    
    If GetTickCount - FPS_LastCheck >= 1000 Then
        FPS_LastCheck = GetTickCount
        FPS_Current = FPS_Counter
        FPS_Counter = 0
        Debug.Print FPS_Current & "fps"
        'FYI: I get around 1500fps on my system (at 640x480x16), 700mhz Athlon, 288mb RAM, GeForce 256 DDR...
    End If
    FPS_Counter = FPS_Counter + 1
    
Loop '//Begin the next frame...

'//If we've gotten to this point the loop must have been terminated
'   So we need to clean up after ourselves. This isn't essential, but it'
'   good coding practise.

On Error Resume Next 'If the objects were never created;
'                               (the initialisation failed) we might get an
'                               error when freeing them... which we need to
'                               handle, but as we're closing anyway...
Set D3DDevice = Nothing
Set D3D = Nothing
Set Dx = Nothing
Debug.Print "All Objects Destroyed"

'//Final termination:
Unload Me
End
End Sub



Private Function InitialiseGeometry() As Boolean
    
    
On Error GoTo BailOut: '//Setup our Error handler

Exp(0).V(0) = CreateLV(-3, 3, 0, &HFFFFFF, 0, 0)
Exp(0).V(1) = CreateLV(3, 3, 0, &HFFFFFF, 0, 0)
Exp(0).V(2) = CreateLV(-3, -3, 0, &HFFFFFF, 0, 0)
Exp(0).V(3) = CreateLV(3, -3, 0, &HFFFFFF, 0, 0)

Exp(1).V(0) = Exp(0).V(0)
Exp(1).V(1) = Exp(0).V(1)
Exp(1).V(2) = Exp(0).V(2)
Exp(1).V(3) = Exp(0).V(3)

Exp(2).V(0) = Exp(0).V(0)
Exp(2).V(1) = Exp(0).V(1)
Exp(2).V(2) = Exp(0).V(2)
Exp(2).V(3) = Exp(0).V(3)

Exp(3).V(0) = Exp(0).V(0)
Exp(3).V(1) = Exp(0).V(1)
Exp(3).V(2) = Exp(0).V(2)
Exp(3).V(3) = Exp(0).V(3)

Exp(4).V(0) = Exp(0).V(0)
Exp(4).V(1) = Exp(0).V(1)
Exp(4).V(2) = Exp(0).V(2)
Exp(4).V(3) = Exp(0).V(3)


InitialiseGeometry = True
Exit Function
BailOut:
InitialiseGeometry = False
End Function

Private Function CreateLV(pX As Single, pY As Single, pZ As Single, C As Long, tU As Single, tV As Single) As LitVertex
    CreateLV.P = MV3D(pX, pY, pZ)
    CreateLV.C = C
    CreateLV.T = MV2D(tU, tV)
End Function

Private Function CreateTLV(pX As Single, pY As Single, pZ As Single, RHW As Single, C As Long, tU As Single, tV As Single) As TLVertex
    CreateTLV.P.X = pX
    CreateTLV.P.Y = pY
    CreateTLV.P.Z = pZ
    CreateTLV.P.w = RHW
    CreateTLV.C = C
    CreateTLV.T.X = tU
    CreateTLV.T.Y = tV
End Function

Private Function MV3D(X As Single, Y As Single, Z As Single) As D3DVECTOR
    MV3D.X = X
    MV3D.Y = Y
    MV3D.Z = Z
End Function

Private Function MV2D(X As Single, Y As Single) As D3DVECTOR2
    MV2D.X = X
    MV2D.Y = Y
End Function

Public Sub FindAngles(vFrom As D3DVECTOR, vTo As D3DVECTOR)
'//Finds the angles required to set up the correct
'//billboard rotations. Written by Eric Coleman (thanks!)

Dim vN As D3DVECTOR
Dim R As Single, temp As Single

'//1. Calc. Vector from Cam->BBoard
    vN.X = -vTo.X + vFrom.X
    vN.Y = -vTo.Y + vFrom.Y
    vN.Z = -vTo.Z + vFrom.Z
    
'//2. Convert to spherical Coords
    R = Sqr(vN.X * vN.X + vN.Y * vN.Y + vN.Z * vN.Z)
    
    temp = vN.Z / R
    If temp = 1 Then
      BBphi = 0
    ElseIf temp = -1 Then
      BBphi = PI
    Else
      BBphi = Atn(-temp / Sqr(-temp * temp + 1)) + (PI / 2)
    End If
    
    temp = vN.X / (R * Sin(BBphi))
    If temp = 1 Then
      BBtheta = 0
    ElseIf temp = -1 Then
      BBtheta = PI
    Else
      BBtheta = Atn(-temp / Sqr(Abs(-temp * temp + 1))) + (PI / 2)
    End If
    
    If vN.Y < 0 Then
       BBtheta = -BBtheta
    End If

End Sub

Private Sub GenerateBBMatrix(Index As Long)
Dim tempMatrix As D3DMATRIX
Dim tempMatrix2 As D3DMATRIX

D3DXMatrixIdentity matWorld
D3DXMatrixIdentity tempMatrix

D3DXMatrixRotationY tempMatrix, BBphi
D3DXMatrixRotationZ tempMatrix2, BBtheta

D3DXMatrixMultiply matWorld, tempMatrix, tempMatrix2

matWorld.m41 = ExpTranslate(Index).X
matWorld.m42 = ExpTranslate(Index).Y
matWorld.m43 = ExpTranslate(Index).Z

D3DDevice.SetTransform D3DTS_WORLD, matWorld
End Sub

Private Sub RenderProperBillBoards(vp As D3DVIEWPORT8)
Dim I As Long, X As Long, Y As Long
Dim StoredMatrices(0 To 4) As D3DMATRIX '//we need to cache the matrices...
Dim Depth(0 To 4) As Single, vTmp As D3DVECTOR
Dim Ref(0 To 4) As Long 'pointer to correct value...

    '####################
    '## 1: SETUP THE DEVICE ##
    '###################
    
    D3DDevice.SetVertexShader FVF_LV
    D3DDevice.SetTexture 0, TexExplosion
    D3DDevice.SetRenderState D3DRS_ALPHATESTENABLE, 1 'alpha testing is useful... ;)
    D3DDevice.SetRenderState D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL 'Pixel passes if (pxAlpha>=ALPHAREF)
    D3DDevice.SetRenderState D3DRS_ALPHAREF, 50 'only if the pixels alpha is greater than or equal to 50 will it be rendered (skips lots of rendering!)
    D3DDevice.SetRenderState D3DRS_ZWRITEENABLE, 0 'we dont want to affect the depth buffer

    '###########################
    '## 2: CALCULATE NECESSARY DATA ##
    '##########################
        For I = 0 To 4
            X = ExpFrame(I) Mod 4
            Y = ExpFrame(I) \ 4
            
            '//Set up the correct texture coordinates
            Exp(I).V(0).T.X = X / 4: Exp(I).V(0).T.Y = Y / 4
            Exp(I).V(1).T.X = (X + 1) / 4: Exp(I).V(1).T.Y = Y / 4
            Exp(I).V(2).T.X = X / 4: Exp(I).V(2).T.Y = (Y + 1) / 4
            Exp(I).V(3).T.X = (X + 1) / 4: Exp(I).V(3).T.Y = (Y + 1) / 4
                            
            '//Update the current frame if necessary...
            If GetTickCount - ExpLastChange(I) > ExpSpeed(I) Then
                    ExpLastChange(I) = GetTickCount
                    ExpFrame(I) = ExpFrame(I) + 1
                    If ExpFrame(I) > 11 Then ExpFrame(I) = 0
            End If
            
            '//Calculate the correct rotation/translation matrix for the geometry
            GenerateBBMatrix I
            StoredMatrices(I) = matWorld 'cache this matrix for usage later on. NB: it is the currently set matrix though...
        Next I
    
    '###############################
    '## 3: GATHER PROJECTED DEPTH VALUES  ##
    '##############################
        For I = 0 To 4
            D3DXVec3Project vTmp, ExpTranslate(I), vp, matProj, matView, matWorld
            Ref(I) = I
            Depth(I) = vTmp.Z 'all we want is the Depth-Buffer value.
        Next I
    
    '#####################
    '## 4: SORT DEPTH VALUES ##
    '####################
        Dim Changes As Long, tmp As Single, lTmp As Long
        Changes = 1 'just to get it started...
        Do While Changes > 0
            Changes = 0
            For I = 0 To 3
                If Depth(I + 1) > Depth(I) Then
                     tmp = Depth(I)
                     Depth(I) = Depth(I + 1)
                     Depth(I + 1) = tmp
                     lTmp = Ref(I)
                     Ref(I) = Ref(I + 1)
                     Ref(I + 1) = lTmp
                     Changes = Changes + 1
                End If
            Next I
        Loop
        
    
    '#################################
    '## 5: RENDER DEEPEST FIRST-CLOSEST LAST ##
    '################################
    For I = 0 To 4
        D3DDevice.SetTransform D3DTS_WORLD, StoredMatrices(Ref(I))
        D3DDevice.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, Exp(Ref(I)).V(0), Len(Exp(Ref(I)).V(0))
    Next I
    
    
    '#####################
    '## 6: TIDY UP THE DEVICE ##
    '####################
    D3DDevice.SetRenderState D3DRS_ALPHATESTENABLE, 0
    D3DDevice.SetRenderState D3DRS_ZWRITEENABLE, 1
End Sub

Private Sub RenderCheapBillboards(vp As D3DVIEWPORT8)
'#################
'## 0. DECLARATIONS ##
'################
    Dim I As Long, X As Long, Y As Long
    
    Dim v2D(0 To 4) As D3DVECTOR, Verts(0 To 3) As TLVertex
    Dim Ref(0 To 4) As Long 'sort the depths...
    Dim Depths(0 To 4) As Single
    '   - NB: wont respond to camera roll.
    
    '####################
    '## 1. SETUP THE DEVICE ##
    '##################
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetRenderState D3DRS_ALPHATESTENABLE, 1 'alpha testing is useful... ;)
    D3DDevice.SetRenderState D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL 'Pixel passes if (pxAlpha>=ALPHAREF)
    D3DDevice.SetRenderState D3DRS_ALPHAREF, 50 'only if the pixels alpha is greater than or equal to 50 will it be rendered (skips lots of rendering!)
    D3DDevice.SetRenderState D3DRS_ZWRITEENABLE, 0 'we dont want to affect the depth buffer
    D3DDevice.SetTexture 0, TexExplosion
    D3DDevice.SetVertexShader FVF_TLV
        
    '############################
    '## 2. TRANSFORM TO SCREEN SPACE ##
    '###########################
    For I = 0 To 4
        D3DXVec3Project v2D(I), ExpTranslate(I), vp, matProj, matView, matWorld
        Ref(I) = I
        Depths(I) = v2D(I).Z
    Next I
    
    '################
    '## 3. SORT DEPTHS ##
    '###############
        Dim Changes As Long, tmp As Single, lTmp As Long
        Changes = 1 'just to get it started...
        Do While Changes > 0
            Changes = 0
            For I = 0 To 3
                If Depths(I + 1) > Depths(I) Then
                     tmp = Depths(I)
                     Depths(I) = Depths(I + 1)
                     Depths(I + 1) = tmp
                     lTmp = Ref(I)
                     Ref(I) = Ref(I + 1)
                     Ref(I + 1) = lTmp
                     Changes = Changes + 1
                End If
            Next I
        Loop
    
    '####################
    '## 4. RENDER THE QUADS ##
    '####################
    For I = 0 To 4
            '//Generate the vertices.
            Verts(0) = CreateTLV(v2D(Ref(I)).X - 100, v2D(Ref(I)).Y - 100, v2D(Ref(I)).Z, 1, &HFFFFFF, 0, 0)
            Verts(1) = CreateTLV(v2D(Ref(I)).X + 100, v2D(Ref(I)).Y - 100, v2D(Ref(I)).Z, 1, &HFFFFFF, 1, 0)
            Verts(2) = CreateTLV(v2D(Ref(I)).X - 100, v2D(Ref(I)).Y + 100, v2D(Ref(I)).Z, 1, &HFFFFFF, 0, 1)
            Verts(3) = CreateTLV(v2D(Ref(I)).X + 100, v2D(Ref(I)).Y + 100, v2D(Ref(I)).Z, 1, &HFFFFFF, 1, 1)
            
            X = ExpFrame(Ref(I)) Mod 4
            Y = ExpFrame(Ref(I)) \ 4
            
            '//Set up the correct texture coordinates
            Verts(0).T.X = X / 4: Verts(0).T.Y = Y / 4
            Verts(1).T.X = (X + 1) / 4: Verts(1).T.Y = Y / 4
            Verts(2).T.X = X / 4: Verts(2).T.Y = (Y + 1) / 4
            Verts(3).T.X = (X + 1) / 4: Verts(3).T.Y = (Y + 1) / 4
            
            '//Update the current frame if necessary
            If GetTickCount - ExpLastChange(I) > ExpSpeed(I) Then
                ExpLastChange(I) = GetTickCount
                ExpFrame(I) = ExpFrame(I) + 1
                If ExpFrame(I) > 11 Then ExpFrame(I) = 0
            End If
            
            '//Finally, render the quad
            D3DDevice.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, Verts(0), Len(Verts(0))
    Next I
    
    '######################
    '## 5. CLEAN UP THE DEVICE ##
    '#####################
    D3DDevice.SetRenderState D3DRS_ALPHATESTENABLE, 0
    D3DDevice.SetRenderState D3DRS_ZWRITEENABLE, 1  'we dont want to affect the depth buffer
End Sub
