' -----------------------------------------------------------------------------------
' GET DLL FUNCTIONS    by Jacques Philippe
'
' Creates a file for each scanned DLL with all the included functions and their
' main caracteristics. The array is an NASM BIN CODE called from RapidQ.
' Just as a sample of what RqAsm can do.
'
' First functions for KERNEL32.DLL :
' COUNT HEX_ORD(DEC)  HEX_OFFSET_FCT_(DEC)   HASHNAME   API_FUNCTION_NAME
' 00001 0031(00049)   0003161F(0000202271)   ECFC3453   AddAtomA
' 00002 0075(00117)   0003946D(0000234605)   ECFC3469   AddAtomW
' 00003 007A(00122)   000332E3(0000209635)   D9F868D8   AllocConsole
' 00004 007B(00123)   000235FE(0000144894)   12844C1B   AllocLSCallback
' ...
'     !!! ORDINAL VALUE IS THE ORDINAL VALUE READ IN THE DLL.
'          OTHER SOFTWARES, LIKE DEPENDS, RETURN THE VALUE I READ + 1 !!!   ??????
' HASH FUNCTION USED :
' i32Hash = 0
' For N = 1 To Len(DLLNAME)
'     ROR i32Hash, 13       ' Rotate Right dont exist in RQ :)(bit 0 goes in bit 31)
'     i32Hash = i32Hash + Asc(DLLNAME[N])
' Next N
' ------------------------------------------------------------------------------------
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
' ====================================================================================
DECLARE FUNCTION CallAsmProc LIB "user32" ALIAS "CallWindowProcA" _
            (Proc AS LONG, A1 AS LONG, A2 AS LONG, A3 AS LONG, A4 AS LONG) AS LONG
' ====================================================================================
' ----- ARRAY containing ASM GetDllFunctionsInfos -----
DefByte GetDllFunctionsInfosArray (0 To 620) = _
   {&HB8,&H25,&H02,&H00,&H00,&H68,&H00,&H00,&H00,&H00,&HE9,&H00,&H00,&H00,&H00,&H81, _
    &HC4,&H04,&H00,&H00,&H00,&HE8,&H1C,&H00,&H00,&H00,&H50,&H89,&H80,&H06,&H00,&H00, _
    &H00,&HC7,&H80,&H0B,&H00,&H00,&H00,&H30,&H00,&H00,&H00,&HFE,&H80,&H24,&H02,&H00, _
    &H00,&HE9,&H09,&H00,&H00,&H00,&H8B,&H04,&H24,&H2D,&H1A,&H00,&H00,&H00,&HC3,&H55, _
    &H89,&HE5,&H8B,&H75,&H10,&H55,&H81,&H3E,&H00,&H00,&H00,&H00,&H75,&H55,&H56,&H8B, _
    &H7D,&H04,&H81,&HC7,&H25,&H02,&H00,&H00,&H81,&HC6,&H9C,&H00,&H00,&H00,&H87,&HF7, _
    &H8A,&H06,&H3C,&H00,&H74,&H04,&HFC,&HA4,&HEB,&HF6,&H5E,&H8B,&H44,&H24,&H10,&H89, _
    &H46,&H04,&H8B,&H6C,&H24,&H10,&H8B,&H45,&H3C,&H89,&H46,&H08,&H8B,&H7C,&H05,&H78, _
    &H01,&HEF,&H89,&H7E,&H0C,&H8B,&H4F,&H18,&H89,&H4E,&H10,&H8B,&H5F,&H20,&H01,&HEB, _
    &H89,&H5E,&H14,&H8B,&H5F,&H24,&H01,&HEB,&H89,&H5E,&H18,&H8B,&H5F,&H1C,&H01,&HEB, _
    &H89,&H5E,&H1C,&H8B,&H4E,&H10,&H39,&H0E,&H72,&H0A,&HB8,&H01,&H00,&H00,&H00,&HE9, _
    &H4D,&H00,&H00,&H00,&H8B,&H5E,&H14,&H8B,&H6E,&H04,&H8B,&H0E,&H8B,&H14,&H8B,&H89, _
    &H56,&H20,&H01,&HEA,&H89,&H56,&H24,&H56,&H52,&H89,&HD6,&H31,&HC0,&H31,&HD2,&HFC, _
    &HAC,&H84,&HC0,&H74,&H07,&HC1,&HCA,&H0D,&H01,&HC2,&HEB,&HF4,&H89,&HD0,&H5A,&H5E, _
    &H89,&H46,&H34,&H8B,&H5E,&H18,&H66,&H8B,&H0C,&H4B,&H81,&HE1,&HFF,&HFF,&H00,&H00, _
    &H89,&H4E,&H28,&H8B,&H5E,&H1C,&H8B,&H04,&H8B,&H89,&H46,&H2C,&H01,&HE8,&H89,&H46, _
    &H30,&H5D,&HFF,&H06,&H89,&HF7,&H81,&HC7,&H38,&H00,&H00,&H00,&HB9,&H64,&H00,&H00, _
    &H00,&HC6,&H07,&H20,&H47,&H49,&H75,&HF9,&H89,&HF7,&H81,&HC7,&H38,&H00,&H00,&H00, _
    &H8B,&H16,&HBB,&H10,&H27,&H00,&H00,&HE8,&H97,&H00,&H00,&H00,&H89,&HF7,&H81,&HC7, _
    &H3E,&H00,&H00,&H00,&H8B,&H56,&H28,&HBB,&H04,&H00,&H00,&H00,&HE8,&HAC,&H00,&H00, _
    &H00,&H89,&HF7,&H81,&HC7,&H42,&H00,&H00,&H00,&HC6,&H07,&H28,&H47,&H8B,&H56,&H28, _
    &HBB,&H10,&H27,&H00,&H00,&HE8,&H69,&H00,&H00,&H00,&H47,&HC6,&H07,&H29,&H89,&HF7, _
    &H81,&HC7,&H4C,&H00,&H00,&H00,&H8B,&H56,&H2C,&HBB,&H08,&H00,&H00,&H00,&HE8,&H7A, _
    &H00,&H00,&H00,&H89,&HF7,&H81,&HC7,&H54,&H00,&H00,&H00,&HC6,&H07,&H28,&H47,&H8B, _
    &H56,&H2C,&HBB,&H00,&HCA,&H9A,&H3B,&HE8,&H37,&H00,&H00,&H00,&H47,&HC6,&H07,&H29, _
    &H89,&HF7,&H81,&HC7,&H63,&H00,&H00,&H00,&H8B,&H56,&H34,&HBB,&H08,&H00,&H00,&H00, _
    &HE8,&H48,&H00,&H00,&H00,&H56,&H89,&HF7,&H81,&HC7,&H6E,&H00,&H00,&H00,&H8B,&H76, _
    &H24,&H8A,&H06,&H3C,&H00,&H74,&H06,&H88,&H07,&H46,&H47,&HEB,&HF4,&H5E,&HE9,&H53, _
    &H00,&H00,&H00,&H50,&H89,&HD0,&H31,&HD2,&HF7,&HF3,&H05,&H30,&H00,&H00,&H00,&H88, _
    &H07,&H81,&HFB,&H01,&H00,&H00,&H00,&H75,&H02,&H58,&HC3,&H52,&H89,&HD8,&H31,&HD2, _
    &HBB,&H0A,&H00,&H00,&H00,&HF7,&HF3,&H89,&HC3,&H5A,&H47,&HEB,&HD7,&H01,&HDF,&H4F, _
    &H81,&HFB,&H00,&H00,&H00,&H00,&H74,&H1D,&H89,&HD0,&H25,&H0F,&H00,&H00,&H00,&H3C, _
    &H0A,&H72,&H07,&H04,&H37,&HE9,&H02,&H00,&H00,&H00,&H04,&H30,&H88,&H07,&H4F,&HC1, _
    &HEA,&H04,&H4B,&HEB,&HDB,&HC3,&H89,&HEC,&H5D,&H81,&HC4,&H04,&H00,&H00,&H00,&HC2, _
    &H10,&H00,&H00,&H00,&H00,&H43,&H4F,&H55,&H4E,&H54,&H20,&H48,&H45,&H58,&H5F,&H4F, _
    &H52,&H44,&H28,&H44,&H45,&H43,&H29,&H20,&H20,&H48,&H45,&H58,&H5F,&H4F,&H46,&H46, _
    &H53,&H45,&H54,&H5F,&H46,&H43,&H54,&H5F,&H28,&H44,&H45,&H43,&H29,&H20,&H20,&H20, _
    &H48,&H41,&H53,&H48,&H4E,&H41,&H4D,&H45,&H20,&H20,&H20,&H41,&H50,&H49,&H5F,&H46, _
    &H55,&H4E,&H43,&H54,&H49,&H4F,&H4E,&H5F,&H4E,&H41,&H4D,&H45,&H00}
' ----- POINTER to use In CallAsmProc -----
DefInt ptrGetDllFunctionsInfos = VarPtr (GetDllFunctionsInfosArray(0))
' ----- RQ CALL GetDllFunctionsInfos -----
Function GetDllFunctionsInfos (hLibrary As Long, RQ_Struct As Long) As Long
    Result = CallAsmProc (ptrGetDllFunctionsInfos, hLibrary, RQ_Struct, 0, 0)
End Function
' ====================================================================================
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function GetTickCount Lib "kernel32" Alias "GetTickCount" () As Long
' Struture used by GetDllFunctionInfos
' PE_VMA : Program Executable Virtual Memory Address
Type PE_Infos
    Counter                      As Long         ' +   0
    BaseAddress                  As Long         ' +   4
    PE_VMA                       As Long         ' +   8
    ExportTableVMA               As Long         ' +  12
    NumberOfNames                As Long         ' +  16
    NamesTableVMA                As Long         ' +  20
    OrdinalsTableVMA             As Long         ' +  24
    AddressTableVma              As Long         ' +  28
    CurrentFunctionNameOffset    As Long         ' +  32
    CurrentFunctionNameVMA       As Long         ' +  36
    CurrentFunctionOrdinal       As Long         ' +  40
    CurrentFunctionOffset        As Long         ' +  44
    CurrentFunctionVMA           As Long         ' +  48
    HashApiName                  As Long         ' +  52
    OutputString                 As String * 100 ' +  56
    OutputHeader                 As String * 100 ' + 156
End Type
'
Declare Sub GetDllInfos (Dll As String)
'
DefInt iTotalChrono = GetTickCount
' ------------------------------------------------------------------------------------
'
GetDllInfos ("Kernel32.Dll")
GetDllInfos ("AdvApi32.Dll")
GetDllInfos ("ComCtl32.Dll")
GetDllInfos ("ComDlg32.Dll")
GetDllInfos ("Gdi32.Dll")
GetDllInfos ("Ole32.Dll")
GetDllInfos ("OleAut32.Dll")
GetDllInfos ("Shell32.Dll")
GetDllInfos ("User32.Dll")
GetDllInfos ("WinMM.Dll")
GetDllInfos ("WSock32.Dll")
GetDllInfos ("ShlWapi.Dll")
GetDllInfos ("MsvCrt.Dll")
GetDllInfos ("MLang.Dll")
GetDllInfos ("MPR.Dll")
GetDllInfos ("Version.Dll")
GetDllInfos ("MSI.Dll")
GetDllInfos ("RPCRT4.Dll")
GetDllInfos ("SetUpApi.Dll")
GetDllInfos ("NTDLL.Dll")
GetDllInfos ("LZ32.Dll")
GetDllInfos ("CfgMgr32.Dll")
GetDllInfos ("UrlMon.dll")
GetDllInfos ("Wininet.dll")
GetDllInfos ("Url.dll")
GetDllInfos ("ShlWapi.dll")
' Add your DLLs here
' GetDllInfos("YourDll.Dll") ' must be registered, in system or local directory
'
Print "FINISHED         DONE IN : ";(GetTickCount - iTotalChrono);" ms"
' -------------------------------------------------------------
' EXIT CONSOLE
' ------------
DefStr sExit
Input "\n\n                    CR to QUIT \n\n", sExit
Application.Terminate
End
' -------------------------------------------------------------
Sub GetDllInfos (Dll As String)
    Dim myPE As PE_Infos
    myPE.Counter = 0          ' Initialise GetDllFunctionInfos  a MUST !
    DefStr DLL_Name = Dll
    DefStr sFileName = (Ucase$(DLL_Name) - ".DLL") + "_Fct.Txt"
    DefInt iChrono
    DefInt hDll = LoadLibrary (DLL_Name)
    If hDll = 0 Then
        Print  "\"" & DLL_Name & "\" CANNOT BE FOUND"
        Exit Sub
    End If
    Dim fileOut As QFileStream
    '
    fileOut.Open(sFileName, fmCreate)
    iChrono = GetTickCount
    Do
        GetDllFunctionsInfos(hDll, myPE)
        If myPE.Counter MOD 10 = 1 Then fileOut.WriteLine(RTrim$(myPE.OutputHeader))
        fileOut.WriteLine(RTrim$(myPE.OutputString))
    Loop Until myPE.Counter = myPE.NumberOfNames
    Print sFileName;" : ";Str$(myPE.NumberOfNames);" Functions Scanned in ";(GetTickCount - iChrono);" ms"
fileOut.Close
End Sub
'
