$INCLUDE <RapidQ2.INC>
$INCLUDE <RapidQ_D3D.INC>

DECLARE SUB DXInit(Sender AS QDXScreen)
DECLARE SUB DXInitSurface(Sender AS QDXScreen)
DECLARE SUB DXscreen_MouseMove (MousX AS INTEGER, MousY AS INTEGER)
DECLARE SUB Form_Key_Press(TheKey AS WORD, Shift AS INTEGER)
DECLARE SUB Make3DObjects
DECLARE SUB deleterock (num as integer)
DECLARE SUB deleteshot (num as integer)
DECLARE SUB drawlives (originx as integer)
DECLARE SUB drawrocks (originx as integer, originy as integer, radius as integer, angle as double, color as integer)
DECLARE SUB exitall
DECLARE SUB keydown(key as word, shift as integer)
DECLARE SUB restart
DECLARE SUB start
DECLARE SUB timeout



DIM WorldFrame          AS QD3DFrame        'Master (parent) frame all 3d objects moving together attached to this frame
DIM AmbientLight        AS QD3DLight        'ambient DXscreen light.. make it dark for dark, daylight handles daytime!!
DIM StarLight           AS QD3DLight        'set the properties of the light, this is for ambient daylight
DIM StarLightFrame      AS QD3DFrame        'allow position & orientation of light
DIM Cam                 AS QD3DCAMERA       'custom camera component

DIM TheBall             AS QD3DPrimitive    'Boing ball
DIM FloorObj            AS QD3DPrimitive    'Floor is a reserved keyword
DIM SkyBox              AS QD3DPrimitive    'box around the world frame, texture surround scene on it
DIM wrap                AS QD3DWRAP         'object to hold texture wrapping information
DIM Particles1          AS QD3DCloneMesh    'A clone mesh is a single mesh on many QD3DFrames
DIM GameEndFlag AS INTEGER: GameEndFlag = False




TYPE Ship EXTENDS QOBJECT
    Mesh        AS QD3DMESHBUILDER
    Orient      AS Q3DVECTOR
    originx     AS double
    originy     AS double
    top         AS integer
    left        AS integer
    right       AS integer
    thrust      AS double
    thrusta     AS integer
END TYPE

TYPE Sht EXTENDS QOBJECT
    Mesh        AS QD3DMESHBUILDER' QD3DPrimitive '
    originx     as  integer
    originy     AS integer
    angle       as  integer     
    round       AS integer
END TYPE

TYPE Rck EXTENDS QOBJECT
    Mesh        AS QD3DMESHBUILDER
    originx     as  integer
    originy     as  integer
    radius      AS integer
    rotation    as  integer
    rotationa   as  double
    thrust      as  double
    thrusta     as  integer
END TYPE    

width = Screen.Width
height = Screen.Height


CREATE main AS QForm
    BorderStyle = 0
    Left = 0
    Top = 0
    Width = width
    Height = height
    Color = &H000000
    OnKeyDown = keydown
    CREATE canvas as QDXSCREEN 
        Left = 0
        Top = 0
        Width = width
        Height = height
        Cursor = crNone
        FullScreen = True
        Init(Width, Height)
        BitCount = Screen.GetPixelDepth         'get whatever mode we are in
        Use3D = True                            'load Direct3D Retained mode
        UseHardware = True                      '3D accelerated video cards are cheap, get one!!
        OnInitialize = DXInit                   'load your meshs/faces to the frames, set lights, camera
        OnInitializeSurface = DXInitSurface     'screen is ready to be drawn
        OnMouseMove =   DXscreen_MouseMove      'pass mouse (X%, Y%) 
        OnKeyDown = Form_Key_Press
    END CREATE
END CREATE


CREATE form1 AS QFORM
    Caption = "An Asteroids Like Game"
    Width = 225
    Height = 247
    Center
    CREATE Label1 AS QLABEL
        Caption = "Use the Left and Right Arrow keys"
        Left = 37
        Top = 21
        Width = 168
        Height = 21
    END CREATE
    CREATE Label2 AS QLABEL
        Caption = "To rotate the ship"
        Left = 60
        Top = 40
        Width = 112
    END CREATE
    CREATE Label3 AS QLABEL
        Caption = "Use the Up Arrow Key for Thrust"
        Left = 37
        Top = 75
        Width = 160
    END CREATE
    CREATE Label4 AS QLABEL
        Caption = "Use the space bar to shoot"
        Left = 37
        Top = 100
        Width = 152
    END CREATE
    CREATE Label5 AS QLABEL
        Caption = "Press Enter at anytime to Exit"
        Left = 37
        Top = 128
        Width = 144
    END CREATE
    CREATE Button3 AS QBUTTON
        Caption = "Continue"
        Left = 70
        Top = 165
        TabOrder = 8
      OnClick = start
    END CREATE
END CREATE



CREATE font AS QFont
    Name = "Times New Roman"
    Size = 18
END CREATE

CREATE form2 AS QFORM
    Caption = "Game Over"
    Width = 216
    Height = 200
    Center
    CREATE Label6 AS QLABEL
        Caption = "Game Over"
      Font = font
        Left = 51
        Top = 33
        Width = 112
        Height = 37
    END CREATE
    CREATE Button1 AS QBUTTON
        Caption = "Play Again"
        Left = 8
        Top = 82
        Height = 57
      OnClick = restart
    END CREATE
    CREATE Button2 AS QBUTTON
        Caption = "Exit"
        Left = 115
        Top = 84
        Height = 57
        TabOrder = 1
      OnClick = exitall
    END CREATE
END CREATE


randomize

dim     old      AS Ship
dim     new      as Ship
dim     shot(30) as  Sht
dim     rock(20) as  Rck

        lives = 3
        score = 0
        new.originx = width / 2
        new.originy = height / 2
        new.top = 90
        new.left = 240
        new.right = 300
        new.thrust = 0
        new.thrusta = 90
        old.originx = new.originx
        old.originy = new.originy
        old.top = new.top
        old.left = new.left
        old.right = new.right
        old.thrust = new.thrust
        old.thrusta = new.thrusta
        mode = 1


CREATE tm as QTimer
    OnTimer = timeout
    Interval = 5
END CREATE
mode = 0
main.ShowModal


SUB keydown(key as word, shift as integer)
    select case key
        case    37  'Left
            if new.top < 350 then
                new.top = new.top + 10
            else
                new.top = 0
            end if
            if new.left < 350 then
                new.left = new.left + 10
            else
                new.left = 0
            end if
            if new.right < 350 then
                new.right = new.right + 10
            else
                new.right = 0
            end if
        case    39  'Right
            if new.top > 0 then
                new.top = new.top - 10
            else
                new.top = 350
            end if
            if new.left > 0 then
                new.left = new.left - 10
            else
                new.left = 350
            end if
            if new.right > 0 then
                new.right = new.right - 10
            else
                new.right = 350
            end if
        case    38  'Up
            point1x = new.originx + new.thrust * cos (new.thrusta * (3.1415927/180))
            point1y = new.originy - new.thrust * sin (new.thrusta * (3.1415927/180))
            point2x = point1x + cos (new.top * (3.1415927/180))
            point2y = point1y - sin (new.top * (3.1415927/180))
            new.thrust = sqr(abs((point2x - new.originx)^2) + abs((point2y - new.originy)^2))
            if new.thrust < .5 then new.thrust = 0
            if point2y <= new.originy then
                new.thrusta = int((180/3.1415927)*(acos((point2x - new.originx)/new.thrust)))
            else
                new.thrusta = 360 - int((180/3.1415927)*(acos((point2x - new.originx)/new.thrust )))            
            end if
        case    32  'Space

            for x = 30 to 1 step -1
                if shot(x).originx = 0 then b = x
            next x
            shot(b).originx = new.originx + 10 * cos (new.top * (3.1415927/180))
            shot(b).originy = new.originy - 10 * sin (new.top * (3.1415927/180))
            shot(b).angle = new.top
            shot(b).round = 1

        case    13  'Return
            end
    end select
END SUB

SUB timeout

select case mode
    case 0:

        form1.ShowModal
    
    case 1:

'--------------- Erase Ship

    topx = old.originx + 10 * cos (old.top * (3.1415927/180))
    topy = old.originy - 10 * sin (old.top * (3.1415927/180))
    leftx = old.originx + 10 * cos (old.left * (3.1415927/180))
    lefty = old.originy - 10 * sin (old.left * (3.1415927/180))
    rightx = old.originx + 10 * cos (old.right * (3.1415927/180))
    righty = old.originy - 10 * sin (old.right * (3.1415927/180))

    canvas.Line (leftx, lefty, topx, topy, &H000000)
    canvas.Line (topx, topy, rightx, righty, &H000000)
    canvas.Line (rightx, righty, leftx, lefty, &H000000)

'-------------- Erase Shots

    for x = 1 to 30
        if shot(x).originx <> 0 then
            canvas.Rectangle (shot(x).originx, shot(x).originy, shot(x).originx + 2, shoy(x).originy -2, &H000000)
        end if
    next x


'----------------Erase Rocks

    for x = 1 to 20
        if rock(x).originx <> 0 then drawrocks(rock(x).originx, rock(x).originy, rock(x).radius, rock(x).rotationa, &H000000)
    next x


'----------------Erase Score

    canvas.TextOut(0, 0, "Score = " + str$(score), &H000000, &H000000)

'----------------Test for Crash


    for x = 1 to 20
        if rock(x).originx <> 0 then
            if abs(rock(x).originx - old.originx) < rock(x).radius + 10 then
                if abs(rock(x).originy - old.originy) < rock(x).radius + 10 then
                    tm.Interval = 5000
                    mode = 2
                    playwav "crash.wav", 1
                    goto done
                end if
            end if
        end if
    next x


'----------------Test for Hit and split rock
    for y = 1 to 30
        if shot(y).originx <> 0 then
        for x = 1 to 20
            if rock(x).originx <> 0 then
                if abs(shot(y).originx - rock(x).originx) < rock(x).radius then
                    if abs(shot(y).originy - rock(x).originy) < rock(x).radius then
                        playwav "hit.wav", 1
                        deleteshot(y)
                        angle = rock(x).rotationa
                        thrusta = rock(x).thrusta
                        originx = rock(x).originx
                        originy = rock(x).originy
                        radius = rock(x).radius
                        deleterock(x)
                        score = score + (60 - radius)
                        if radius > 10 then
                        for z = 1 to 2
                            for q = 15 to 1 step -1
                                if rock(q).originx = 0 then d = q
                            next q
                            rock(d).originx = originx
                            rock(d).originy = originy
                            rock(d).rotationa = angle
                            rock(d).radius = radius / 2 
                            rock(d).thrust = int(rnd * 4) + 2
                            d1 = int(rnd * 2)
                            if d1 = 0 then
                                rock(d).thrusta = thrusta - (int(rnd * 90) + 1)
                            else
                                rock(d).thrusta = thrusta _ (int(rnd * 90) + 1)
                            end if
                            r1 = int(rnd * 2)
                            if r1 = 0 then
                                rock(d).rotation = - (int(rnd * 10) + 1) * 2
                            else
                                rock(d).rotation = (int(rnd * 10) + 1) * 2
                            end if
                        next z
                        end if                          
                    end if
                end if
            end if
        next x
        end if
    next y



'-------------- Advance Ship

    new.originx = old.originx + new.thrust * cos (new.thrusta * (3.1415927/180))
    new.originy = old.originy - new.thrust * sin (new.thrusta * (3.1415927/180))
    if new.originx > width - 10 then
        new.originx = 10
    elseif new.originx < 10 then
        new.originx = width -10
    end if
    if new.originy > height - 10 then
        new.originy = 10
    elseif new.originy < 10 then
        new.originy = height - 10
    end if

'-------------- Advance Shots

    for x = 1 to 30
        if shot(x).originx <> 0 then
            shot(x).originx = shot(x).originx + 15 * cos (shot(x).angle * (3.1415927/180))
            shot(x).originy = shot(x).originy - 15 * sin (shot(x).angle * (3.1415927/180))
            if shot(x).round = 2 then
                if shot(x).originx > width - 10 or shot(x).originx < 10 then deleteshot(x)
                if shot(x).originy > height - 10 or shot(x).originy < 10 then deleteshot(x)
            else
                if shot(x).originx > width - 2 then
                    shot(x).originx = 2
                    shot(x).round = 2
                end if
                if shot(x).originx < 2 then
                    shot(x).originx = width - 2
                    shot(x).round = 2
                end if
                if shot(x).originy > height - 2 then
                    shot(x).originy = 2
                    shot(x).round = 2
                end if
                if shot(x).originy < 2 then
                    shot(x).originy = height - 2
                    shot(x).round = 2
                end if
            end if
        end if
    next x
    
'----------------Advance Rocks
    for x = 1 to 20
        if rock(x).originx <> 0 then
            rock(x).originx = rock(x).originx + rock(x).thrust * cos(rock(x).thrusta * (3.1415927/180))
            rock(x).originy = rock(x).originy - rock(x).thrust * sin(rock(x).thrusta * (3.1415927/180))
            if rock(x).originx > width - 4 then
                rock(x).originx = 4
            elseif rock(x).originx < 4 then
                rock(x).originx = width -4
            end if
            if rock(x).originy > height - 4 then
                rock(x).originy = 4
            elseif rock(x).originy < 4 then
                rock(x).originy = height -4
            end if
            rock(x).rotationa = rock(x).rotationa + rock(x).rotation
            if rock(x).rotationa > 360 then rock(x).rotationa = rock(x).rotationa - 360
            if rock(x).rotationa < 0 then rock(x).rotationa = rock(x).rotationa + 360
        end if
    next x
            

'---------------- Create Rocks

    num = 0
    for x = 1 to 20
        if rock(x).originx <> 0 then num = num + 1
    next x
    if num < 5 then
        x = 1
        for y = 5 to num step -1
            while rock(x).originx <> 0
                x = x + 1
            wend
            w1 = int(rnd*2)
            if w1 = 0 then
                rock(x).originx = int(rnd * 100)
            else
                rock(x).originx = width - int(rnd*100)
            end if
            h1 = int(rnd*2)
            if h1 = 0 then
                rock(x).originy = int(rnd * 100)
            else
                rock(x).originy = height - int(rnd * 100)
            end if
            rock(x).radius = (int(rnd * 10) + 1) * 5
            rock(x).thrust = int(rnd * 4) + 2
            rock(x).thrusta = int(rnd * 360)
            rock(x).rotationa = int(rnd * 360)
            r1 = int(rnd * 2)
            if r1 = 0 then
                rock(x).rotation = - (int(rnd * 10) + 1) * 2
            else
                rock(x).rotation = (int(rnd * 10) + 1) * 2
            end if
        next y
    end if

done:

'-------------- Draw Ship

    topx = new.originx + 10 * cos (new.top * (3.1415927/180))
    topy = new.originy - 10 * sin (new.top * (3.1415927/180))
    leftx = new.originx + 10 * cos (new.left * (3.1415927/180))
    lefty = new.originy - 10 * sin (new.left * (3.1415927/180))
    rightx = new.originx + 10 * cos (new.right * (3.1415927/180))
    righty = new.originy - 10 * sin (new.right * (3.1415927/180))

    canvas.Line (leftx, lefty, topx, topy, &HFFFFFF)
    canvas.Line (topx, topy, rightx, righty, &HFFFFFF)
    canvas.Line (rightx, righty, leftx, lefty, &HFFFFFF)



'--------------- Draw Shots

    for x = 1 to 30
        if shot(x).originx <> 0 then
            canvas.Rectangle (shot(x).originx, shot(x).originy, shot(x).originx + 2, shot(x).originy -2, &HFFFFFF)
        end if
    next x

'--------------Draw Rocks

    for x = 1 to 20
        if rock(x).originx <> 0 then drawrocks(rock(x).originx, rock(x).originy, rock(x).radius, rock(x).rotationa, &HFFFFFF)
    next x

'--------------Draw Score

    canvas.TextOut(0, 0, "Score = " + str$(score), &HFFFFFF, &H000000)

'-------------Draw Lives

    for x = 1 to lives
        drawlives ((width - 60) + 15 * x)
    next x

    old.originx = new.originx
    old.originy = new.originy
    old.top = new.top
    old.left = new.left
    old.right = new.right


    case 2:

    if lives > 1 then
        lives = lives - 1
        for x = 1 to 20
            deleterock (x)
        next x
        for x = 1 to 30
            deleteshot (x)
        next x
        new.originx = width / 2
        new.originy = height / 2
        new.top = 90
        new.left = 240
        new.right = 300
        new.thrust = 0
        new.thrusta = 90
        old.originx = new.originx
        old.originy = new.originy
        old.top = new.top
        old.left = new.left
        old.right = new.right
        old.thrust = new.thrust
        old.thrusta = new.thrusta
        canvas.FillRect (0, 0, width, height, &H000000)
        tm.Interval = 50
        mode = 1
    else

        form2.ShowModal
            
    end if
    
Canvas.Flip
end select


END SUB

SUB drawrocks (originx as integer, originy as integer, radius as integer, angle as double, color as integer)
DIM pointX(7)
DIM pointY(7)


        pointX(1) = originx + (radius * cos (angle * (3.1415927 / 180)))
        pointY(1) = originy - (radius * sin (angle * (3.1415927 / 180)))
        IF angle + 60 < 360 THEN
            pointX(2) = originx + (radius * cos ((angle + 60) * (3.1415927 / 180)))
            pointY(2) = originy - (radius * sin ((angle + 60) * (3.1415927 / 180)))
        ELSE
            pointX(2) = originX + (radius * COS ((angle - 300) * (3.1415927/ 180)))
            pointY(2) = originY - (radius * SIN ((angle - 300) * (3.1415927 / 180)))
        END IF

        IF angle + 120 < 360 THEN
            pointX(3) = originX + (radius * COS ((angle + 120) * (3.1415927 / 180)))
            pointY(3) = originY - (radius * SIN ((angle + 120) * (3.1415927 / 180)))
        ELSE
            pointX(3) = originX + (radius * COS ((angle - 240) * (3.1415927 / 180)))
            pointY(3) = originY - (radius * SIN ((angle - 240) * (3.1415927 / 180)))
        END IF

        IF angle + 180 < 360 THEN
            pointX(4) = originX + (radius * COS ((angle + 180) * (3.1415927 / 180)))
            pointY(4) = originY - (radius * SIN ((angle + 180) * (3.1415927 / 180)))
        ELSE
            pointX(4) = originX + (radius * COS ((angle - 180) * (3.1415927 / 180)))
            pointY(4) = originY - (radius * SIN ((angle - 180) * (3.1415927 / 180)))
        END IF

        IF angle + 240 < 360 THEN
            pointX(5) = originX + (radius * COS ((angle + 240) * (3.1415927 / 180)))
            pointY(5) = originY - (radius * SIN ((angle + 240) * (3.1415927 / 180)))
        ELSE
            pointX(5) = originX + (radius * COS ((angle - 120) * (3.1415927 / 180)))
            pointY(5) = originY - (radius * SIN ((angle - 120) * (3.1415927 / 180)))
        END IF

        IF angle + 300 < 360 THEN
            pointX(6) = originX + (radius * COS ((angle + 300) * (3.1415927 / 180)))
            pointY(6) = originY - (radius * SIN ((angle + 300) * (3.1415927 / 180)))
        ELSE
            pointX(6) = originX + (radius * COS ((angle - 60) * (3.1415927 / 180)))
            pointY(6) = originY - (radius * SIN ((angle - 60) * (3.1415927 / 180)))
        END IF

        IF angle + 330 < 360 THEN
            pointX(7) = originX + ((radius / 2) * COS ((angle + 330) * (3.1415927 / 180)))
            pointY(7) = originY - ((radius / 2) * SIN ((angle + 330) * (3.1415927 / 180)))
        ELSE
            pointX(7) = originX + ((radius / 2) * COS ((angle - 30) * (3.1415927 / 180)))
            pointY(7) = originY - ((radius / 2) * SIN ((angle - 30) * (3.1415927 / 180)))
        END IF


    FOR x =1 TO 6
        canvas.line (pointX(x), pointY(x), pointX(x + 1), pointY(x + 1), color)
    NEXT x
        canvas.line (pointX(7), pointY(7), pointX(1), pointY(1), color)

canvas.flip

END SUB

SUB drawlives (originx as integer)
    canvas.line (originx, 0, originx + 5, 15, &HFFFFFF)
    canvas.line (originx + 5, 15, originx - 5, 15, &HFFFFFF)
    canvas.line (originx - 5, 15, originx, 0, &HFFFFFF)
canvas.flip
END SUB

SUB start

        mode = 1
        form1.Close

END SUB

SUB restart
        form2.Close

        lives = 3
        mode = 1
        score = 0
        tm.Interval = 50

        new.originx = width / 2
        new.originy = height / 2
        new.top = 90
        new.left = 240
        new.right = 300
        new.thrust = 0
        new.thrusta = 90
        old.originx = new.originx
        old.originy = new.originy
        old.top = new.top
        old.left = new.left
        old.right = new.right
        old.thrust = new.thrust
        old.thrusta = new.thrusta
        canvas.FillRect (0, 0, width, height, &H000000)

        for x = 1 to 20
            deleterock (x)
        next x
        for x = 1 to 30
            deleteshot (x)
        next x
canvas.flip
END SUB

SUB exitall
    end
END SUB


SUB deleteshot (num as integer)
    shot(num).originx = 0
    shot(num).originy = 0
    shot(num).angle = 0
    shot(num).round = 0
END SUB

SUB deleterock (num as integer)
    rock(num).originx = 0
    rock(num).originy = 0
    rock(num).radius = 0
    rock(num).rotation = 0
    rock(num).rotationa = 0
    rock(num).thrust = 0
    rock(num).thrusta = 0
END SUB




'*******************************************************
'*******************************************************
'****     INITIALIZATION CODE FOR DirectX Screen *******
'*******************************************************
'*******************************************************

SUB DXInitSurface(Sender AS QDXScreen)
    DxScreen.setRenderMode(D3DRMRENDERMODE_BLENDEDTRANSPARENCY OR D3DRMRENDERMODE_SORTEDTRANSPARENCY)
'    Intro
'    RenderLoop
END SUB



SUB DXInit(Sender AS QDXScreen)
    DXScreen.CreateFrame(WorldFrame)    'create the world maxtrix, all other frames will be attached to it in heirarchy
    DXScreen.CreateFrame(StarLightFrame) 

'       *********  First we create the lights  ******************
    DXScreen.CreateLightRGB(D3DRMLIGHT_AMBIENT, 0.2, 0.2, 0.2, AmbientLight)    'ambient is dark for baseline darkness!!
    DXScreen.AddLight(AmbientLight)                                             'this light moves with root frame
    DXScreen.CreateLightRGB(D3DRMLIGHT_SPOT, 0.9, 0.9, 0.9, StarLight)    'point light
    DayLightFrame.AddLight(StarLight)                                            'to a frame so we can remove from scene
    DayLightFrame.SetPosition(0, 8, 0)                                         'x,y,z position, some arbitary value until load a terrain
    DayLightFrame.SetOrientation(0.3, -0.31, 0.3, 0, 1, 0)                             'points straight down
    DXScreen.SetTextureQuality(D3DRMTEXTURE_MIPLINEAR)      'gives a smooth appearance to textures
    WorldFrame.SetPosition(0.0, 0.0, 0.0)
    Make3DObjects
'   DXScreen.SetCameraPosition(0.0, 2.5 * Ceiling, -4 * CourtZ)
'   DXScreen.SetCameraOrientation(0.0,-0.5, 0.7, 0, 1, 0)
    Cam.Pos.x = 0.0
    Cam.Pos.y = 2.5 * Ceiling
    Cam.Pos.z = -4.5 * CourtZ
    Cam.Orient.x = 0.0
    Cam.Orient.y = -0.5
    Cam.Orient.z = 0.7
    Cam.Update(DXscreen)
    DXScreen.Font.Size = 14
    DXScreen.Font.Bold = True
END SUB


SUB Make3DObjects                                   'make the box, floor and paddles    
    Canvas.CreateMeshBuilder(SkyBox.Mesh)         'Reallocate memory
	WITH SkyBox
     .ViewFromOutside = False                   'view from inside, it is a skybox (dome)
     .BoxSides = 4                              'No ceiling
     .MakeBox (Canvas)
	END WITH
    WorldFrame.AddVisual(SkyBox.Mesh)               'this object moves on top of world
END SUB



SUB DXscreen_MouseMove (MousX AS INTEGER, MousY AS INTEGER)
'     player1_z = CourtZ - (MouseX/DXScreen.Height) * CourtZ * 2
'     player1_y = Ceiling - (MouseY/DXScreen.Width * Ceiling)
END SUB


SUB Form_Key_Press(TheKey AS WORD, Shift AS INTEGER)
'     SELECT CASE TheKey
'     'Player One keyboard control (keeps in bounds)--------------------------------------------------------
'     CASE = ASC("q")
'         IF player1_z <CourtZ then player1_z =player1_z +TheSpeed
'     CASE = ASC("a")
'         IF player1_z >-CourtZ then player1_z =player1_z -TheSpeed
'     'Player Two keyboard control (keeps in bounds)--------------------------------------------------------
'     CASE = 38, 107      'up arrow and "+"
'         IF player2_z <2.4 then player2_z =player2_z +TheSpeed
'     CASE = 40, 109          'dn arrow "-"
'         IF player2_z >-3 then player2_z =player2_z -TheSpeed
'     CASE 82 'r
'         IF RotateMe THEN RotateMe = False ELSE RotateMe = True 
'     CASE 27     'esc
'         GameEndFlag = True
'     END SELECT
END SUB
