'-------------------------------------------------------------------------------
' ReBar3.bas Example
' Manually included code for the Rebar component, code commented with #REBAR#
'
' This example consists of 2 toolbar button strips plus 1 combobox.
' Each button strip is 'contained' within its own Panel and made up of
' individual buttons. The panels are auto-sized as the rebar control is resized.
' An additional WndProc is necessary to action any button events.
'
' FreeBasic code generated by RapidFRM v1.80
'-------------------------------------------------------------------------------
#INCLUDE "windows.bi"
#INCLUDE "win/commctrl.bi"
InitCommonControls()

#DEFINE __QBUTTON
#INCLUDE "win/RQInclude.bi"

'-------------------------------------------------------------------------------
' #REBAR# Rebar global data
'-------------------------------------------------------------------------------
#DEFINE NUM_BTN     10

DECLARE SUB BtnClick(idx AS integer)
DECLARE SUB cbChange(Sender AS QCOMBOBOX)

DIM SHARED AS WNDPROC OldWndProc, NewWndProc            ' Hook for the bands

DIM SHARED AS QOBJECT rbRibbon(0 TO 2)                  ' Rebar ribbon bands (3)
DIM SHARED AS QBUTTON rbButn(0 TO NUM_BTN-1)            ' Toolbar btns (10)
DIM SHARED AS QCOMBOBOX rbCombo
DIM SHARED AS QREBAR Rebar
DIM SHARED AS QREBAR PTR lpRebar = @Rebar

'-------------------------------------------------------------------------------
' Global data from Form designer sheet
'-------------------------------------------------------------------------------
DIM SHARED AS QFORM Form1
DIM SHARED AS QFORM PTR lpForm1 = @Form1
DIM SHARED AS QBUTTON Butn1
DIM SHARED AS QBUTTON PTR lpButn1 = @Butn1
DIM SHARED AS QSTATUSBAR Status1
DIM SHARED AS QSTATUSBAR PTR lpStatus1 = @Status1
DIM SHARED AS QLABEL Label1
DIM SHARED AS QLABEL PTR lpLabel1 = @Label1

'-------------------------------------------------------------------------------
' Forward declarations for component events 
'-------------------------------------------------------------------------------
DECLARE SUB Initialise(Sender AS QFORM)
DECLARE SUB Done(Sender AS QBUTTON)

'-------------------------------------------------------------------------------
' Configure components
'-------------------------------------------------------------------------------
SUB ConfigureComponents

    lpForm1->ObjIndex = 0
    lpForm1->Width=500
    lpForm1->Height=250
    lpForm1->Caption = "Main Form"
    lpForm1->OnShow = CAST(ANY PTR, @Initialise)

    lpButn1->ObjIndex = 1
    lpButn1->Left = 200
    lpButn1->Top = 160
    lpButn1->Caption = "EXIT"
    lpButn1->OnClick = CAST(ANY PTR, @Done)

    lpStatus1->ObjIndex = 2
    lpStatus1->SimplePanel = True

    lpLabel1->ObjIndex = 3
    lpLabel1->Left = 10
    lpLabel1->Top = 140
    lpLabel1->Autosize = True
    lpLabel1->Caption = ""

    ' #REBAR#
    lpRebar->ObjIndex = 4
    lpRebar->BMP="suits.bmp"                            ' Add a bitmap image "strip" to Rebar
    lpRebar->BandCount=3                                ' One image in bitmap per band
    lpRebar->BorderStyle=bsNone
    lpRebar->Color=&hffdfdf                             ' Set background color
    lpRebar->Font.Name="Times New Roman"                ' Change Font attributes
    lpRebar->Font.Italic=True                           ' ditto
'    lpRebar->Font.Underline=True                        ' ditto
'    lpRebar->Font.Color=&hbf                            ' Set color

END SUB

'-------------------------------------------------------------------------------
' Create components
'-------------------------------------------------------------------------------
' #REBAR# Create Rebar component
' 3 bands: 2 with toolbar buttons and the third with a combobox
' add text and a bitmap img to each band and color the band and text
'-------------------------------------------------------------------------------
' #REBAR# Additional WndProc
FUNCTION BandWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
    SELECT CASE wMsg
        CASE WM_COMMAND, WM_NOTIFY                              ' Pass these on to the parent
            SendMessage(GetParent(hWnd), wMsg, wParam, lParam)
            RETURN 0
    END SELECT
    RETURN CallWindowProc(OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

' #REBAR# The Rebar control
SUB CreateRebarControl
DIM AS UINT StdStyle
DIM AS QBUTTON PTR lpBtn
DIM AS QOBJECT PTR lpRibn
DIM AS integer i, j

    ' Create the first Rebar ribbon panel with 4 buttons (initially parent is the form)
    lpRibn=@rbRibbon(0)
    lpRibn->ObjIndex=lpRebar->ObjIndex+1
    lpRibn->Left=1 
    lpRibn->Top=1
    lpRibn->Width=4+4*31+3                                  ' 4 Btns width 30
    lpRibn->Height=3+25+3                                   ' Btns height 25
    lpRibn->Caption=""
    StdStyle=SS_NOTIFY OR WS_DLGFRAME OR WS_VISIBLE
    lpRibn->Parent=lpRebar->Handle
    lpRibn->Handle=CreateWindowEx(0, "STATIC", "", WS_CHILD OR StdStyle, _
                                lpRibn->Left, lpRibn->Top, lpRibn->Width, lpRibn->Height, _
                                    lpForm1->Handle, CAST(HMENU,lpRibn->ObjIndex), 0, 0)
    NewWndProc=@BandWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(lpRibn->Handle, GWL_WNDPROC, CAST(long,NewWndProc)))

    FOR i = 0 TO 3
        lpBtn=@rbButn(i)
        lpBtn->objIndex=TOOLBAR_IDX+i                                   ' An incrementing ID value
        lpBtn->Left=i*31+1: lpBtn->Top=1
        lpBtn->Width=30: lpBtn->Height=25
        lpBtn->Caption="A" & i+1                                        ' Button identification
        StdStyle=SS_NOTIFY OR WS_VISIBLE
        lpBtn->Parent=lpRibn->Handle
        lpBtn->Handle=CreateWindowEx(0, "BUTTON", lpBtn->Caption, WS_CHILD OR StdStyle, _
                                        lpBtn->Left, lpBtn->Top, lpBtn->Width, lpBtn->Height, _
                                        lpRibn->Handle, CAST(HMENU,lpBtn->objIndex), 0, 0)
    NEXT i

    ' Create the second Rebar ribbon panel with 6 buttons(initially parent is the form)
    lpRibn=@rbRibbon(1)
    lpRibn->ObjIndex=lpRebar->ObjIndex+2
    lpRibn->Left=1
    lpRibn->Top=1
    lpRibn->Width=4+6*31+3
    lpRibn->Height=3+25+3
    lpRibn->Caption=""
    StdStyle=SS_NOTIFY OR WS_DLGFRAME OR WS_VISIBLE
    lpRibn->Parent=lpRebar->Handle
    lpRibn->Handle=CreateWindowEx(0, "STATIC", "", WS_CHILD OR StdStyle, _
                                lpRibn->Left, lpRibn->Top, lpRibn->Width, lpRibn->Height, _
                                    lpForm1->Handle, CAST(HMENU,lpRibn->ObjIndex), 0, 0)

    SetWindowLong(lpRibn->Handle, GWL_WNDPROC, CAST(long,NewWndProc))

    j=0
    FOR i = i TO NUM_BTN-1                                              ' Continue incrementing 'i'
        lpBtn=@rbButn(i)
        lpBtn->objIndex=TOOLBAR_IDX+i                                   ' An incrementing ID value
        lpBtn->Left=j*31+1: lpBtn->Top=1
        lpBtn->Width=30: lpBtn->Height=25
        lpBtn->Caption="B" & j+1                                        ' Button identification
        j += 1
        lpBtn->Parent=lpRibn->Handle
        StdStyle=WS_VISIBLE OR BS_PUSHBUTTON
        lpBtn->Handle=CreateWindowEx(0, "BUTTON", lpBtn->Caption, WS_CHILD OR StdStyle, _
                                        lpBtn->Left, lpBtn->Top, lpBtn->Width, lpBtn->Height, _
                                        lpRibn->Handle, CAST(HMENU,lpBtn->objIndex), 0, 0)
    NEXT i

    ' Add the third Rebar ribbon panel with a QCombobox(initially parent is the form)
    lpRibn=@rbRibbon(2)
    lpRibn->ObjIndex=lpRebar->ObjIndex+3
    lpRibn->Left=1
    lpRibn->Top=1
    lpRibn->Width=135
    lpRibn->Height=31
    lpRibn->Caption=""
    StdStyle=SS_NOTIFY OR WS_DLGFRAME OR WS_VISIBLE
    lpRibn->Parent=lpRebar->Handle
    lpRibn->Handle=CreateWindowEx(0, "STATIC", "", WS_CHILD OR StdStyle, _
                                lpRibn->Left, lpRibn->Top, lpRibn->Width, lpRibn->Height, _
                                    lpForm1->Handle, CAST(HMENU,lpRibn->ObjIndex), 0, 0)

    SetWindowLong(lpRibn->Handle, GWL_WNDPROC, CAST(long,NewWndProc))

    rbCombo.objIndex=TOOLBAR_IDX+i                                      ' Unique idx
    rbCombo.Left=0: rbCombo.Top=1
    rbCombo.Width=130: rbCombo.Height=150
    rbCombo.Parent=lpRibn->Handle
    StdStyle=rbCombo.ObjStyle OR WS_VISIBLE
    rbCombo.Handle=CreateWindowEx(0, "COMBOBOX", "", WS_CHILD OR StdStyle, _
                            rbCombo.Left, rbCombo.Top, rbCombo.Width, rbCombo.Height, _
                                    lpRibn->Handle, CAST(HMENU,rbCombo.objIndex), 0, 0)

    DIM AS string tstr
    FOR i=1 TO 4                                                       ' Add items to the combobox
        tstr="Color scheme " & i
        SendMessage(rbCombo.Handle, CB_ADDSTRING, 0, CAST(LPARAM, STRPTR(tstr)))
    NEXT i
    rbCombo.OnChange = CAST(ANY PTR, @cbChange)


    ' Create the empty rebar component
    lpRebar->Presetconfig()
    StdStyle=lpRebar->ObjStyle OR WS_VISIBLE
    lpRebar->Handle=CreateWindowEx(WS_EX_TOOLWINDOW, "ReBarWindow32", "", WS_CHILD OR StdStyle, _
                                            0, 0, 0, 0, lpForm1->Handle, CAST(HMENU, 1000), 0, 0)
    lpRebar->PostConfig()

    lpRebar->AddBand(rbRibbon(0).Handle, 0, "A")
    lpRebar->AddBand(rbRibbon(1).Handle, 1, "B")
    lpRebar->AddBand(rbRibbon(2).Handle, -1, "C")                     ' NO image for 3rd band, just text
'    lpRebar->AddBand(rbRibbon(2).Handle, 2, "C")                     ' Image & text
END SUB

SUB CreateMainMenu
END SUB

SUB CreatePopupMenus
END SUB

SUB CreateComponents
DIM AS UINT StdStyle, ExtStyle=0
DIM AS string ObjCaption

    lpForm1->PreSetConfig()
    StdStyle=lpForm1->objStyle
    IF lpForm1->BorderStyle > bsDialog THEN ExtStyle=WS_EX_TOOLWINDOW

    lpForm1->Handle = CreateWindowEx(ExtStyle, "RQClass", lpForm1->Caption, StdStyle, _
                    lpForm1->Left, lpForm1->Top, lpForm1->Width, lpForm1->Height, _
                    0, 0, Application.hInstance, 0)
    Application.hMainForm = lpForm1->Handle
    lpForm1->PostConfig()

    lpButn1->PreSetConfig()
    ObjCaption=lpButn1->Caption
    StdStyle=lpButn1->objStyle
    IF lpButn1->Visible THEN StdStyle OR= WS_VISIBLE
    ExtStyle=0

    lpButn1->Handle=CreateWindowEx(ExtStyle,lpButn1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpButn1->Left, lpButn1->Top, lpButn1->Width, lpButn1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpButn1->objIndex), 0, 0)

    lpButn1->Parent = lpForm1->Handle
    lpButn1->PostConfig()
    EnableWindow(lpButn1->Handle, lpButn1->Enabled)

    lpStatus1->PreSetConfig()
    ObjCaption=""
    StdStyle=lpStatus1->objStyle
    IF lpStatus1->Visible THEN StdStyle OR= WS_VISIBLE
    ExtStyle=0

    lpStatus1->Handle=CreateWindowEx(ExtStyle,lpStatus1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpStatus1->Left, lpStatus1->Top, lpStatus1->Width, lpStatus1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpStatus1->objIndex), 0, 0)

    lpStatus1->Parent = lpForm1->Handle
    lpStatus1->PostConfig()
    EnableWindow(lpStatus1->Handle, lpStatus1->Enabled)

    lpLabel1->PreSetConfig()
    ObjCaption=lpLabel1->Caption
    StdStyle=lpLabel1->objStyle
    IF lpLabel1->Visible THEN StdStyle OR= WS_VISIBLE
    ExtStyle=0

    lpLabel1->Handle=CreateWindowEx(ExtStyle,lpLabel1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpLabel1->Left, lpLabel1->Top, lpLabel1->Width, lpLabel1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpLabel1->objIndex), 0, 0)

    lpLabel1->Parent = lpForm1->Handle
    lpLabel1->PostConfig()
    EnableWindow(lpLabel1->Handle, lpLabel1->Enabled)

' #REBAR# 
    CreateRebarControl()

    CreateMainMenu()
    CreatePopupMenus()
END SUB

'-------------------------------------------------------------------------------
' Remove Timers on Exit
'-------------------------------------------------------------------------------
SUB KillAllTimers
    KillTimer(Application.hMainForm, SYS_TIMER_IDX)
END SUB

'-------------------------------------------------------------------------------
' System timer - Display hints
'-------------------------------------------------------------------------------
SUB SysDisplayHint(Parent AS HWND, HintString AS string)
DIM AS TOOLINFO ti

    ti.cbSize=sizeof(ti)
    ti.uFlags=TTF_SUBCLASS: ti.hwnd=Parent
    ti.hinst=NULL: ti.lpszText=STRPTR(HintString)
    GetClientRect(Parent, @ti.rect)
    SendMessage(Application.hWndTTip, TTM_ADDTOOL, 0, CAST(LPARAM, @ti))	
END SUB

SUB CheckSystemTimers
STATIC AS HWND TT_LastHWND
DIM AS HWND TT_hWnd
DIM AS Point TT_pnt

    TT_pnt.X=Screen.MouseX: TT_pnt.Y=Screen.MouseY
    TT_hWnd=WindowFromPoint(TT_pnt)
    IF TT_LastHWND<>TT_hWnd THEN
        TT_LastHWND=TT_hWnd
        SELECT CASE TT_hWnd
            CASE lpForm1->Handle
                IF lpForm1->ShowHint THEN
                    SysDisplayHint(lpForm1->Handle, lpForm1->Hint)
                END IF
            CASE lpButn1->Handle
                IF lpButn1->ShowHint THEN
                    SysDisplayHint(lpButn1->Handle, lpButn1->Hint)
                END IF
            CASE lpStatus1->Handle
                IF lpStatus1->ShowHint THEN
                    SysDisplayHint(lpStatus1->Handle, lpStatus1->Hint)
                END IF
        END SELECT
    END IF
END SUB

'-------------------------------------------------------------------------------
' Start of Main WndProc code
'-------------------------------------------------------------------------------

SUB CheckWmTimers(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE wParam
        CASE App_Timer.ObjIndex:  CheckSystemTimers
    END SELECT
END SUB

SUB CheckWmCommandMsg(wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE LOWORD(wParam)
        CASE lpButn1->ObjIndex
            IF lpButn1->OnClick>0 THEN lpButn1->OnClick(lpButn1)
        CASE TOOLBAR_IDX TO TOOLBAR_IDX+9
            DIM AS integer i=LOWORD(wParam)-TOOLBAR_IDX+1       ' id: 1 - 10
            BtnClick(i)
        CASE rbCombo.ObjIndex
            IF HIWORD(wParam)=CBN_SELCHANGE THEN rbCombo.OnChange(@rbCombo)

    END SELECT
END SUB

SUB CheckWmNotifyMsg(wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmPaintMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
DIM AS RECT frmRect, objRect
DIM AS integer H, W

    GetClientRect(hWnd, @frmRect)
    W=frmRect.Right-frmRect.Left

    H=lpStatus1->Height
    MoveWindow(lpStatus1->Handle, 0, frmRect.Bottom-H, W, H, 1)
    IF lpStatus1->OnResize>0 THEN lpStatus1->OnResize(lpStatus1)

    IF lpForm1->OnPaint>0 THEN lpForm1->OnPaint(lpForm1)
END SUB

FUNCTION CheckBtnColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
' Only for OwnerDraw buttons
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckStaticColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckEditColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckListBoxColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

SUB CheckWmObjScroll(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckSocketEvent(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

' Hook into the Popup menus for all of your components here
SUB CheckWmContextMenu(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmHitTest(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmDrawItem(wParam AS WPARAM, lParam AS LPARAM)
END SUB

FUNCTION MainWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
STATIC AS integer Sizing
    
    SELECT CASE wMsg
        CASE WM_CREATE
            Sizing=False

        CASE WM_COMMAND
            IF lParam<>0 THEN
                CheckWmCommandMsg(wParam, lParam)
            ELSE
                ' IF HIWORD(wParam)=0 THEN
                '     Menu message code goes here.....
                ' ELSE
                '     Accelerator message code goes here...
                ' END IF
            END IF

        CASE WM_NOTIFY
            CheckWmNotifyMsg(wParam, lParam)

        CASE WM_PAINT
            CheckWmPaintMsg(hWnd, wMsg, wParam, lParam)

        CASE WM_TIMER
            CheckWmTimers(hWnd, wMsg, wParam, lParam)

        CASE WM_NCHITTEST
            CheckWmHitTest(hWnd, wMsg, wParam, lParam)

        CASE WM_HSCROLL, WM_VSCROLL
            IF lParam<>0 THEN CheckWmObjScroll(hWnd, wMsg, wParam, lParam)

        CASE WM_CTLCOLORBTN
            RETURN CheckBtnColor(wParam, lParam)

        CASE WM_CTLCOLOREDIT
            RETURN CheckEditColor(wParam, lParam)

        CASE WM_CTLCOLORSTATIC
            RETURN CheckStaticColor(wParam, lParam)

        CASE WM_CTLCOLORLISTBOX
            RETURN CheckListBoxColor(wParam, lParam)

        CASE WM_DRAWITEM
            CheckWmDrawItem(wParam, lParam)

        CASE WM_CONTEXTMENU
            CheckWmContextMenu(hWnd, wMsg, wParam, lParam)

        CASE WM_SOCK_NOTIFY
            CheckSocketEvent(hWnd, wMsg, wParam, lParam)

        CASE WM_MOUSEMOVE
            IF lpForm1->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpForm1->hCursor)
            END IF
            IF lpForm1->OnMouseMove>0 THEN
                lpForm1->OnMouseMove(LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONDBLCLK
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_LBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_RBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_RBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_KEYDOWN
            IF lpForm1->OnKeyDown>0 THEN lpForm1->OnKeyDown(LOWORD(wParam), 0, lpForm1)

        CASE WM_KEYUP
            IF lpForm1->OnKeyUp>0 THEN lpForm1->OnKeyUp(LOWORD(wParam), 0, lpForm1)

        CASE WM_CHAR
            IF lpForm1->OnKeyPress>0 THEN lpForm1->OnKeyPress(LOBYTE(wParam), lpForm1)

        CASE WM_SYSCOMMAND
            IF (wParam AND &hfff0) = SC_CLOSE THEN
                DIM AS integer Action=1                                      ' Default Action is quit
                IF lpForm1->OnClose>0 THEN lpForm1->OnClose(Action, lpForm1) ' Action passed by reference so
                IF Action=0 THEN RETURN 0                                    ' user can change default action
            END IF

        CASE WM_ENTERSIZEMOVE
            Sizing=True

        CASE WM_EXITSIZEMOVE
            lpForm1->FormReSize()
            Sizing=False
            IF lpForm1->OnResize>0 THEN
                lpForm1->OnResize(lpForm1)
                InvalidateRect(hWnd, NULL, True)
                RETURN 0
            END IF

        CASE WM_SIZE
            IF Sizing THEN RETURN 0
            IF (wParam=SIZE_MAXIMIZED) OR (wParam=SIZE_RESTORED) THEN
                lpForm1->FormReSize()
                IF lpForm1->OnResize>0 THEN
                    lpForm1->OnResize(lpForm1)
                    RETURN 0
                END IF
            END IF

        CASE WM_CLOSE

        CASE WM_DESTROY
            KillAllTimers()
            PostQuitMessage(0)

    END SELECT

    RETURN DefWindowProc(hWnd, wMsg, wParam, lParam)
END FUNCTION

'-------------------------------------------------------------------------------
' Create new window class for project
'-------------------------------------------------------------------------------
FUNCTION CreateWindClass(hInst AS HINSTANCE) AS integer
DIM AS integer Result
DIM AS WNDCLASSEX wc

WITH wc
    .cbSize = SizeOf(WNDCLASSEX)
    .style = CS_HREDRAW OR CS_VREDRAW
    .lpfnWndProc = @MainWndProc
    .hInstance = hInst
    .hIcon = LoadIcon(0, IDI_APPLICATION)
    .hCursor = LoadCursor(0, IDC_ARROW)
    .hbrBackground = GetSysColorBrush(COLOR_BTNFACE)
    .lpszClassName = @"RQClass"
    .hIconSm = .hIcon
END WITH

    Result = RegisterClassEx(@wc)
    IF Result = 0 THEN ShowMessage("Register class error")
    RETURN Result
END FUNCTION

'-------------------------------------------------------------------------------
' Main startup code
'-------------------------------------------------------------------------------
FUNCTION WinMain(hInst AS HINSTANCE, hPrevInstance AS HINSTANCE, _
                            szCmdLine AS string, iCmdShow AS integer) AS integer
DIM AS integer Result=0

    IF CreateWindClass(hInst) = 0 THEN RETURN 0

    ConfigureComponents()
    CreateComponents()
    InitSystemTimers(lpForm1->Handle)
    HookTheMouse()

    lpForm1->Center                         ' You may wish to delete this line

    IF lpForm1->OnShow>0 THEN lpForm1->OnShow(lpForm1)

    Result = lpForm1->ShowModal             ' Show form & call default message handler

    ' You may want to change the above line to lpForm1->Show, and then provide
    ' your own function that, amongst other things, handles all window messages.

    UnHookTheMouse()

    RETURN Result
END FUNCTION

'-------------------------------------------------------------------------------
' *** MAIN ENTRY POINT ***
'-------------------------------------------------------------------------------
END WinMain(Application.hInstance, NULL, Command(0), SW_NORMAL)


'-------------------------------------------------------------------------------
' Code for the component events
'-------------------------------------------------------------------------------
SUB BtnClick(idx AS integer)
DIM AS string tstr

    SELECT CASE idx
        CASE 1
            tstr="Butn A1"
            lpRebar->Color=&h0
            lpRebar->Font.Color=&hffffff
        CASE 2
            tstr="Butn A2"
            lpRebar->Color=&hffff
            lpRebar->Font.Color=&hbf00
        CASE 3
            tstr="Butn A3"
            lpRebar->Color=&hbfbfff
            lpRebar->Font.Color=&hbf
        CASE 4
            tstr="Butn A4"
            lpRebar->Color=&hffefef
            lpRebar->Font.Color=&hbf0000
        CASE 5 TO 10: tstr="Butn B" & (idx-4)
    END SELECT
    lpStatus1->SimpleText=tstr
END SUB

SUB cbChange(Sender AS QCOMBOBOX)
    BtnClick(Sender.ItemIndex+1)                ' Redirect as btn click
END SUB

SUB Initialise(Sender AS QFORM)
    lpLabel1->Caption="Two toolbar ribbons using individual buttons, plus one ribbon with a combobox. Some color 'schemes'"
END SUB

SUB Done(Sender AS QBUTTON)
    Application.Terminate
END SUB

