'-------------------------------------------------------------------------------
' TrayIcon.bas - an animated icon in the tray
' Hooked into the main form WndProc to add the handler for the WM_TRAYICON message
' (could have just added it to the main WndProc but want to keep this consistent).
'
' Only problem I have encountered, is determining the position for the popup menu.
' Currently I have hard-coded this - see FormWndProcEx().
' Manually added code marked with #TRAY# &/or #POPUP# comments
'
' FreeBasic code generated by RapidFRM v1.82
'-------------------------------------------------------------------------------
#INCLUDE "windows.bi"
#INCLUDE "win/commctrl.bi"
InitCommonControls()

#DEFINE __QRICHEDIT
#INCLUDE ONCE "win/richedit.bi"
DyLibLoad("Riched32.dll")

#INCLUDE "win/RQInclude.bi"

'-------------------------------------------------------------------------------
' #TRAY# & #POPUP# Some global data manually added
'-------------------------------------------------------------------------------
#INCLUDE ONCE "win/shellapi.bi"

#DEFINE USE_RESOURCE                                        ' Comment out to use files

DIM SHARED AS NOTIFYICONDATA TrayIcon
DIM SHARED AS WNDPROC OldFormWndProc                        ' Hook into Form WndProc see Initialise()

DECLARE FUNCTION FormWndProcEx(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE SUB HelpAbout()
DECLARE SUB DoPopup(Index AS integer, Sender AS QFORM)

'-------------------------------------------------------------------------------
' Global data from Form designer sheet
'-------------------------------------------------------------------------------
DIM SHARED AS QFORM Form1
DIM SHARED AS QFORM PTR lpForm1 = @Form1
DIM SHARED AS QRICHEDIT RichEd1
DIM SHARED AS QRICHEDIT PTR lpRichEd1 = @RichEd1
DIM SHARED AS QBUTTON Butn1
DIM SHARED AS QBUTTON PTR lpButn1 = @Butn1
DIM SHARED AS QBUTTON Butn2
DIM SHARED AS QBUTTON PTR lpButn2 = @Butn2
DIM SHARED AS QTIMER Timer1
DIM SHARED AS QTIMER PTR lpTimer1 = @Timer1

'-------------------------------------------------------------------------------
' Forward declarations for component events 
'-------------------------------------------------------------------------------
DECLARE SUB Initialise(Sender AS QFORM)
DECLARE SUB DoTimer(Sender AS QTIMER)
DECLARE SUB HideMe(Sender AS QBUTTON)
DECLARE SUB Done(Sender AS QBUTTON)

'-------------------------------------------------------------------------------
' Configure components
'-------------------------------------------------------------------------------
SUB ConfigureComponents

    lpForm1->ObjIndex = 0
    lpForm1->Width = 300
    lpForm1->Height = 150
    lpForm1->Caption = "About"
    lpForm1->ICOHandle = 1
    lpForm1->OnShow = CAST(ANY PTR, @Initialise)

    lpRichEd1->ObjIndex = 1
    lpRichEd1->Left = 10
    lpRichEd1->Top = 10
    lpRichEd1->Width = 275
    lpRichEd1->Height = 70

    lpButn1->ObjIndex = 2
    lpButn1->Left = 30
    lpButn1->Top = 90
    lpButn1->Caption = "Hide"
    lpButn1->OnClick = CAST(ANY PTR, @HideMe)

    lpButn2->ObjIndex = 3
    lpButn2->Left = 180
    lpButn2->Top = 90
    lpButn2->Caption = "EXIT"
    lpButn2->OnClick = CAST(ANY PTR, @Done)

    lpTimer1->ObjIndex = 4
    lpTimer1->Interval = 100
    lpTimer1->OnTimer = CAST(ANY PTR, @DoTimer)

END SUB

'-------------------------------------------------------------------------------
' Create components
'-------------------------------------------------------------------------------
SUB CreateMainMenu
END SUB

' #POPUP#
SUB CreatePopupMenus
    lpForm1->PopupMenu=CreatePopupMenu()                ' Create an empty menu
    AppendMenu(lpForm1->PopupMenu, 0, 1, "About")       ' Option 1
    AppendMenu(lpForm1->PopupMenu, 0, 0, 0)             ' A separator
    AppendMenu(lpForm1->PopupMenu, 0, 2, "Exit")        ' Option 2
    lpForm1->OnPopup = CAST(ANY PTR, @DoPopup)
END SUB

SUB CreateComponents
DIM AS UINT StdStyle, ExtStyle=0
DIM AS string ObjCaption

    lpForm1->PreSetConfig()
    StdStyle=lpForm1->objStyle
    IF lpForm1->BorderStyle > bsDialog THEN ExtStyle=WS_EX_TOOLWINDOW

    lpForm1->Handle = CreateWindowEx(ExtStyle, "RQClass", lpForm1->Caption, StdStyle, _
                    lpForm1->Left, lpForm1->Top, lpForm1->Width, lpForm1->Height, _
                    0, 0, Application.hInstance, 0)
    Application.hMainForm = lpForm1->Handle
    lpForm1->PostConfig()

    lpRichEd1->PreSetConfig()
    ObjCaption=""
    StdStyle=lpRichEd1->objStyle
    IF lpRichEd1->Visible THEN StdStyle OR= WS_VISIBLE
    IF lpRichEd1->BorderStyle=bsNone THEN ExtStyle=0 ELSE ExtStyle=WS_EX_CLIENTEDGE

    lpRichEd1->Handle=CreateWindowEx(ExtStyle,lpRichEd1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpRichEd1->Left, lpRichEd1->Top, lpRichEd1->Width, lpRichEd1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpRichEd1->objIndex), 0, 0)

    lpRichEd1->Parent = lpForm1->Handle
    lpRichEd1->PostConfig()
    EnableWindow(lpRichEd1->Handle, lpRichEd1->Enabled)

    lpButn1->PreSetConfig()
    ObjCaption=lpButn1->Caption
    StdStyle=lpButn1->objStyle
    IF lpButn1->Visible THEN StdStyle OR= WS_VISIBLE
    ExtStyle=0

    lpButn1->Handle=CreateWindowEx(ExtStyle,lpButn1->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpButn1->Left, lpButn1->Top, lpButn1->Width, lpButn1->Height, _
                    lpForm1->Handle, CAST(HMENU, lpButn1->objIndex), 0, 0)

    lpButn1->Parent = lpForm1->Handle
    lpButn1->PostConfig()
    EnableWindow(lpButn1->Handle, lpButn1->Enabled)

    lpButn2->PreSetConfig()
    ObjCaption=lpButn2->Caption
    StdStyle=lpButn2->objStyle
    IF lpButn2->Visible THEN StdStyle OR= WS_VISIBLE
    ExtStyle=0

    lpButn2->Handle=CreateWindowEx(ExtStyle,lpButn2->objClass, ObjCaption, WS_CHILD OR StdStyle, _
                    lpButn2->Left, lpButn2->Top, lpButn2->Width, lpButn2->Height, _
                    lpForm1->Handle, CAST(HMENU, lpButn2->objIndex), 0, 0)

    lpButn2->Parent = lpForm1->Handle
    lpButn2->PostConfig()
    EnableWindow(lpButn2->Handle, lpButn2->Enabled)

    lpTimer1->Parent=lpForm1->Handle
    SetTimer(lpForm1->Handle, lpTimer1->ObjIndex, lpTimer1->Interval, 0)

    CreateMainMenu()
    CreatePopupMenus()
END SUB

'-------------------------------------------------------------------------------
' Remove Timers on Exit
'-------------------------------------------------------------------------------
SUB KillAllTimers
    KillTimer(Application.hMainForm, SYS_TIMER_IDX)
    lpTimer1->Enabled=False
    KillTimer(lpForm1->Handle, lpTimer1->ObjIndex)
END SUB

'-------------------------------------------------------------------------------
' System timer - Display hints
'-------------------------------------------------------------------------------
SUB SysDisplayHint(Parent AS HWND, HintString AS string)
DIM AS TOOLINFO ti

    ti.cbSize=sizeof(ti)
    ti.uFlags=TTF_SUBCLASS: ti.hwnd=Parent
    ti.hinst=NULL: ti.lpszText=STRPTR(HintString)
    GetClientRect(Parent, @ti.rect)
    SendMessage(Application.hWndTTip, TTM_ADDTOOL, 0, CAST(LPARAM, @ti))	
END SUB

SUB CheckSystemTimers
STATIC AS HWND TT_LastHWND
DIM AS HWND TT_hWnd
DIM AS Point TT_pnt

    TT_pnt.X=Screen.MouseX: TT_pnt.Y=Screen.MouseY
    TT_hWnd=WindowFromPoint(TT_pnt)
    IF TT_LastHWND<>TT_hWnd THEN
        TT_LastHWND=TT_hWnd
        SELECT CASE TT_hWnd
            CASE lpForm1->Handle
                IF lpForm1->ShowHint THEN
                    SysDisplayHint(lpForm1->Handle, lpForm1->Hint)
                END IF
            CASE lpRichEd1->Handle
                IF lpRichEd1->ShowHint THEN
                    SysDisplayHint(lpRichEd1->Handle, lpRichEd1->Hint)
                END IF
            CASE lpButn1->Handle
                IF lpButn1->ShowHint THEN
                    SysDisplayHint(lpButn1->Handle, lpButn1->Hint)
                END IF
            CASE lpButn2->Handle
                IF lpButn2->ShowHint THEN
                    SysDisplayHint(lpButn2->Handle, lpButn2->Hint)
                END IF
        END SELECT
    END IF
END SUB

'-------------------------------------------------------------------------------
' Start of Main WndProc code
'-------------------------------------------------------------------------------

SUB CheckWmTimers(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE wParam
        CASE App_Timer.ObjIndex:  CheckSystemTimers
        CASE lpTimer1->ObjIndex
            IF (lpTimer1->Enabled) AND (lpTimer1->OnTimer>0) THEN
                lpTimer1->OnTimer(lpTimer1)
            END IF
    END SELECT
END SUB

SUB CheckWmCommandMsg(wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE LOWORD(wParam)
        CASE lpRichEd1->ObjIndex
            IF lpRichEd1->OnChange>0 THEN lpRichEd1->OnChange(lpRichEd1)
        CASE lpButn1->ObjIndex
            IF lpButn1->OnClick>0 THEN lpButn1->OnClick(lpButn1)
        CASE lpButn2->ObjIndex
            IF lpButn2->OnClick>0 THEN lpButn2->OnClick(lpButn2)
    END SELECT
END SUB

SUB CheckWmNotifyMsg(wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmPaintMsg(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    IF lpForm1->OnPaint>0 THEN lpForm1->OnPaint(lpForm1)
END SUB

FUNCTION CheckBtnColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
' Only for OwnerDraw buttons
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckStaticColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckEditColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

FUNCTION CheckListBoxColor(wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS HBRUSH hBrush=NULL
    RETURN CAST(LRESULT, hBrush)
END FUNCTION

SUB CheckWmObjScroll(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckSocketEvent(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

' Hook into the Popup menus for all of your components here
SUB CheckWmContextMenu(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
    SELECT CASE wParam
        ' #POPUP#
        CASE lpForm1->Handle
            IF lpForm1->OnPopup>0 THEN
                DIM AS UINT popFlags=TPM_RETURNCMD OR TPM_RIGHTBUTTON OR TPM_NOANIMATION
                DIM AS integer Result, x=LOWORD(lParam), y=HIWORD(lParam)
                Result=TrackPopupMenuEx(lpForm1->PopupMenu, popFlags, x, y, lpForm1->Handle, 0)
                IF Result>0 THEN lpForm1->OnPopup(Result, lpForm1)
            END IF
    END SELECT
END SUB

SUB CheckWmHitTest(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM)
END SUB

SUB CheckWmDrawItem(wParam AS WPARAM, lParam AS LPARAM)
END SUB

FUNCTION MainWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
STATIC AS integer Sizing
    
    SELECT CASE wMsg
        CASE WM_CREATE
            Sizing=False

        CASE WM_COMMAND
            IF lParam<>0 THEN
                CheckWmCommandMsg(wParam, lParam)
            ELSE
                ' IF HIWORD(wParam)=0 THEN
                '     Menu message code goes here.....
                ' ELSE
                '     Accelerator message code goes here...
                ' END IF
            END IF

        CASE WM_NOTIFY
            CheckWmNotifyMsg(wParam, lParam)

        CASE WM_PAINT
            CheckWmPaintMsg(hWnd, wMsg, wParam, lParam)

        CASE WM_TIMER
            CheckWmTimers(hWnd, wMsg, wParam, lParam)

        CASE WM_NCHITTEST
            CheckWmHitTest(hWnd, wMsg, wParam, lParam)

        CASE WM_HSCROLL, WM_VSCROLL
            IF lParam<>0 THEN CheckWmObjScroll(hWnd, wMsg, wParam, lParam)

        CASE WM_CTLCOLORBTN
            RETURN CheckBtnColor(wParam, lParam)

        CASE WM_CTLCOLOREDIT
            RETURN CheckEditColor(wParam, lParam)

        CASE WM_CTLCOLORSTATIC
            RETURN CheckStaticColor(wParam, lParam)

        CASE WM_CTLCOLORLISTBOX
            RETURN CheckListBoxColor(wParam, lParam)

        CASE WM_DRAWITEM
            CheckWmDrawItem(wParam, lParam)

        CASE WM_CONTEXTMENU
            CheckWmContextMenu(hWnd, wMsg, wParam, lParam)

        CASE WM_SOCK_NOTIFY
            CheckSocketEvent(hWnd, wMsg, wParam, lParam)

        CASE WM_MOUSEMOVE
            IF lpForm1->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpForm1->hCursor)
            END IF
            IF lpForm1->OnMouseMove>0 THEN
                lpForm1->OnMouseMove(LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONDBLCLK
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_LBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_LBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF
            IF lpForm1->OnClick>0 THEN lpForm1->OnClick(lpForm1)

        CASE WM_RBUTTONDOWN
            IF lpForm1->OnMouseDown>0 THEN
                lpForm1->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_RBUTTONUP
            IF lpForm1->OnMouseUp>0 THEN
                lpForm1->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpForm1)
            END IF

        CASE WM_KEYDOWN
            IF lpForm1->OnKeyDown>0 THEN lpForm1->OnKeyDown(LOWORD(wParam), 0, lpForm1)

        CASE WM_KEYUP
            IF lpForm1->OnKeyUp>0 THEN lpForm1->OnKeyUp(LOWORD(wParam), 0, lpForm1)

        CASE WM_CHAR
            IF lpForm1->OnKeyPress>0 THEN lpForm1->OnKeyPress(LOBYTE(wParam), lpForm1)

        CASE WM_SYSCOMMAND
            IF (wParam AND &hfff0) = SC_CLOSE THEN
                DIM AS integer Action=1                                      ' Default Action is quit
                IF lpForm1->OnClose>0 THEN lpForm1->OnClose(Action, lpForm1) ' Action passed by reference so
                IF Action=0 THEN RETURN 0                                    ' user can change default action
            END IF

        CASE WM_ENTERSIZEMOVE
            Sizing=True

        CASE WM_EXITSIZEMOVE
            lpForm1->FormReSize()
            Sizing=False
            IF lpForm1->OnResize>0 THEN
                lpForm1->OnResize(lpForm1)
                InvalidateRect(hWnd, NULL, True)
                RETURN 0
            END IF

        CASE WM_SIZE
            IF Sizing THEN RETURN 0
            IF (wParam=SIZE_MAXIMIZED) OR (wParam=SIZE_RESTORED) THEN
                IF wParam=SIZE_MAXIMIZED THEN
                    lpForm1->WindowState=wsMaximized
                ELSE
                    lpForm1->WindowState=wsNormal
                END IF
                lpForm1->FormReSize()
                IF lpForm1->OnResize>0 THEN
                    lpForm1->OnResize(lpForm1)
                    RETURN 0
                END IF
            END IF

        CASE WM_CLOSE

        CASE WM_DESTROY
            KillAllTimers()
            PostQuitMessage(0)

    END SELECT

    RETURN DefWindowProc(hWnd, wMsg, wParam, lParam)
END FUNCTION

'-------------------------------------------------------------------------------
' Create new window class for project
'-------------------------------------------------------------------------------
FUNCTION CreateWindClass(hInst AS HINSTANCE) AS integer
DIM AS integer Result
DIM AS WNDCLASSEX wc

WITH wc
    .cbSize = SizeOf(WNDCLASSEX)
    .style = CS_HREDRAW OR CS_VREDRAW
    .lpfnWndProc = @MainWndProc
    .hInstance = hInst
    .hIcon = LoadIcon(0, IDI_APPLICATION)
    .hCursor = LoadCursor(0, IDC_ARROW)
    .hbrBackground = GetSysColorBrush(COLOR_BTNFACE)
    .lpszClassName = @"RQClass"
    .hIconSm = .hIcon
END WITH

    Result = RegisterClassEx(@wc)
    IF Result = 0 THEN ShowMessage("Register class error")
    RETURN Result
END FUNCTION

'-------------------------------------------------------------------------------
' Main startup code
'-------------------------------------------------------------------------------
FUNCTION WinMain(hInst AS HINSTANCE, hPrevInstance AS HINSTANCE, _
                            szCmdLine AS string, iCmdShow AS integer) AS integer
DIM AS integer Result=0

    IF CreateWindClass(hInst) = 0 THEN RETURN 0

    ConfigureComponents()
    CreateComponents()
    InitSystemTimers(lpForm1->Handle)
    HookTheMouse()

    lpForm1->Center                         ' You may wish to delete this line

    IF lpForm1->OnShow>0 THEN lpForm1->OnShow(lpForm1)

    Result = lpForm1->ShowModal             ' Show form & call default message handler

    ' You may want to change the above line to lpForm1->Show, and then provide
    ' your own function that, amongst other things, handles all window messages.

    UnHookTheMouse()

    RETURN Result
END FUNCTION

'-------------------------------------------------------------------------------
' *** MAIN ENTRY POINT ***
'-------------------------------------------------------------------------------
END WinMain(Application.hInstance, NULL, Command(0), SW_NORMAL)


'-------------------------------------------------------------------------------
' Code for the component events
'-------------------------------------------------------------------------------
SUB DoTimer(Sender AS QTIMER)
DIM AS integer i = Sender.Tag

    i += 1: IF i > 4 THEN i = 1                                 ' 1-4 for icons resource
    Sender.Tag = i
#IFDEF USE_RESOURCE
    lpForm1->IcoHandle = i                                      ' Change the form icon
#ELSE
    lpForm1->Icon = "eth" & i & ".ico"
#ENDIF
    ' #TRAY#
    TrayIcon.hIcon = CAST(HICON,lpForm1->hWndIcon)              ' Copy icon handle to Tray struc
    Shell_NotifyIcon(NIM_MODIFY, @TrayIcon)                     ' Update the Tray icon
END SUB

SUB HideMe(Sender AS QBUTTON)
    lpForm1->Visible=False
END SUB

SUB HelpAbout()
    lpRichEd1->Clear
    lpRichEd1->AddStrings "Tray Icon Demo"
    lpRichEd1->AddStrings "Double left click on the Tray icon to view THIS screen" 
    lpRichEd1->AddStrings "or right click to view the popup menu"
    lpRichEd1->AddStrings "Add more icons and/or change the timer to suit"
    lpForm1->Show
END SUB

' #POPUP#
SUB DoPopup(Index AS integer, Sender AS QFORM)
    SELECT CASE Index
        CASE 1: HelpAbout()
        CASE 2: Done(Butn2)
    END SELECT
END SUB

' #TRAY#  NB The Popup msg could be handled here, but keeping some consistency!
FUNCTION FormWndProcEx(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
    IF wMsg = WM_TRAYICON THEN
        SELECT CASE LOWORD(lParam)
            CASE WM_RBUTTONUP                                                                   ' Activate Popup menu
'                DIM AS integer posn = (Screen.MouseY SHL 16) + LOWORD(Screen.MouseX)           ' Doesn't work!
                DIM AS integer posn = (Screen.ClientHeight SHL 16) + LOWORD(Screen.Width)-150   ' BIG fudge with position!
                SendMessage(hWnd, WM_CONTEXTMENU, CAST(WPARAM, hWnd), CAST(LPARAM,posn))        ' Send Popup msg to self

            CASE WM_LBUTTONDBLCLK
                HelpAbout()
        END SELECT
    END IF
    RETURN CallWindowProc(OldFormWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

SUB Initialise(Sender AS QFORM)
' #TRAY#
'   Add WM_TRAYICON message handler to main form
    OldFormWndProc = CAST(WNDPROC,SetWindowLong(Sender.Handle, GWL_WNDPROC, CAST(long,@FormWndProcEx)))

'   Initialise the TrayIcon data structure
    MEMSET(CAST(BYTE PTR, @TrayIcon), 0, SIZEOF(NOTIFYICONDATA))
    TrayIcon.cbSize = SIZEOF(NOTIFYICONDATA)
    TrayIcon.hWnd = lpForm1->Handle
    TrayIcon.uID = CAST(UINT, Application.hInstance)
    TrayIcon.uFlags = NIF_MESSAGE OR NIF_ICON OR NIF_TIP
    TrayIcon.uCallBackMessage = WM_TRAYICON
    TrayIcon.hIcon = CAST(HICON, lpForm1->hWndIcon)
    TrayIcon.szTip = Application.Title+" Demo"

'   Add icon to the Tray area
    Shell_NotifyIcon(NIM_ADD, @TrayIcon)

'   Tidy main form
    Sender.DelBorderIcons(biMinimize)
    Sender.DelBorderIcons(biMaximize)
    lpRichEd1->Clear
    lpRichEd1->AddStrings "Minimize me to the tray using the 'Hide' button"

END SUB

SUB Done(Sender AS QBUTTON)
    lpTimer1->Enabled=False
    Shell_NotifyIcon(NIM_DELETE, @TrayIcon)
    Application.Terminate
END SUB
