'-----------------------------------------------------------------------------------------
' RQInclude.bi Part of the RapidFRM project
' Main include file for FreeBasic windows applications
'
'   Based on RapidQ objects/components
'   Author: d_homans@yahoo.com.au
'   Version 1.84.1
'   Date:   27 Jun 2013
'-----------------------------------------------------------------------------------------
#INCLUDE ONCE "win/commdlg.bi"
#INCLUDE ONCE "crt/stdio.bi"
#INCLUDE ONCE "crt/string.bi"
#INCLUDE ONCE "file.bi"
#INCLUDE ONCE "dir.bi"

#UNDEF FALSE
#UNDEF TRUE
#DEFINE FALSE               0
#DEFINE TRUE                1

#UNDEF Delete                               '|
#UNDEF Min                                  '|
#UNDEF Max                                  '| REMOVED! Dual declaration problems
#UNDEF Transparent                          '|
#UNDEF screen                               '|
#UNDEF Pointer                              '|

#DEFINE WM_TRAYICON         &h8000          ' User msg for tray icon stuff
#DEFINE WM_SOCK_NOTIFY      &h8001          ' User msg - Non-blocking socket Msg
#DEFINE WM_INIT_SCROLLBOX   &h8002          ' User msg - ScrollBox initialisation

#DEFINE EV_LMOUSEDOWN       (1 SHL 16)      '
#DEFINE EV_LMOUSEUP         (2 SHL 16)      ' HIWORD wParam Event notification
#DEFINE EV_RMOUSEDOWN       (4 SHL 16)      '
#DEFINE EV_RMOUSEUP         (8 SHL 16)      '

#DEFINE TOOLBAR_IDX         800             ' Start index Toolbars and buttons (internal)
#DEFINE SYS_TIMER_IDX       900             ' Start index for sys timers (internal)

#DEFINE fbEverything	(fbArchive OR fbDirectory OR fbSystem OR fbHidden OR fbReadOnly)

#DEFINE PBM_SETBKCOLOR      8193            ' ProgressBar msg <=> CCM_SETBKCOLOR
#DEFINE PBM_SETMARQUEE      1034

#IFNDEF TPM_NOANIMATION
#DEFINE TPM_NOANIMATION     &h4000          ' Popup menu flag
#ENDIF
#IFNDEF UDN_DELTAPOS
#DEFINE UDN_DELTAPOS        -722            ' UpDown control
#ENDIF
#IFNDEF PGN_SCROLL
#DEFINE PGN_SCROLL	        (PGN_FIRST-1)   ' PageScroller flag
#ENDIF
#IFNDEF PGN_CALCSIZE
#DEFINE PGN_CALCSIZE	    (PGN_FIRST-2)   ' PageScroller flag
#ENDIF
#IFNDEF RBN_LAYOUTCHANGED
#DEFINE RBN_LAYOUTCHANGED   (RBN_FIRST-2)   ' Rebar msg
#ENDIF

#DEFINE DEG2RAD             (3.14159265/180.0)  ' degree to radians

#DEFINE FORM_COLOR          &hc8d0d4        ' Default color most objects

ENUM HintStyles: hsLabel, hsBalloon: END ENUM
ENUM WindoState: wsNormal, wsMinimized, wsMaximized: END ENUM
ENUM BorderIcons: biSystemMenu, biMinimize, biMaximize, biHelp: END ENUM
ENUM StyleBorder: bsNone, bsSingle, bsSizeable, bsDialog, bsToolWindow, bsSizeToolWin: END ENUM
ENUM ControlAlign: alNone, alTop, alBottom, alLeft, alRight, alClient: END ENUM
ENUM EditCharCase: ecNormal, ecUpperCase, ecLowerCase: END ENUM
ENUM ButnTypes: bkCustom, bkOK, bkCancel, bkHelp, bkYes, bkNo, bkClose, bkAbort, bkRetry, bkIgnore, bkAll: END ENUM
ENUM TextAlign: taLeftJustify, taCenter, taRightJustify: END ENUM
ENUM BevelStyle: bvNone, bvLowered, bvRaised: END ENUM
ENUM LabelStyle: lsNone, lsRaised, lsRecessed: END ENUM
ENUM ComboStyle: csDropDown, csSimple, csDropDownList, csOwnerDrawFixed, csOwnerDrawVariable: END ENUM
ENUM ScrollBarKind: sbHorizontal, sbVertical: END ENUM
ENUM LViewSort: stNone, stData, stText, stBoth: END ENUM
ENUM LViewStyle: vsIcon, vsSmallIcon, vsList, vsReport: END ENUM
ENUM TBarOrientation: tbHorizontal, tbVertical: END ENUM
ENUM TBarTickPos: tmBottomRight, tmTopLeft, tmBoth: END ENUM
ENUM TBarTickStyle: tsNone, tsAuto, tsManual: END ENUM
ENUM GaugeKind: gkText, gkHorizontalBar, gkVerticalBar, gkPie, gkNeedle: END ENUM
ENUM StringDup: dupIgnore, dupAccept, dupError: END ENUM
ENUM FileMode: fmOpenRead, fmOpenWrite, fmOpenReadWrite, fmCreate=65535: END ENUM
ENUM FilePos: soFromBeginning, soFromCurrent, soFromEnd: END ENUM
ENUM VarType: Num_BYTE=1, Num_SHORT, Num_WORD, Num_LONG, Num_DWORD, Num_SINGLE, Num_DOUBLE=8: END ENUM
ENUM ImgType: itImage, itMask: END ENUM
ENUM ImgBack: clNone, clDefault: END ENUM
ENUM ImgDrawStyle: dsFocused, dsSelected, dsNormal, dsTransparent: END ENUM
ENUM ColorChooseStyle: cdNormal, cdFullOpen, cdNoFullOpen: END ENUM
ENUM FontStyles: fsBold, fsItalic, fsUnderline, fsStrikeOut: END ENUM
ENUM BMPFormat: pfDevice, pf1bit, pf4bit, pf8bit, pf15bit, pf16bit, pf24bit, pf32bit: END ENUM
ENUM ColStyle: gcsList, gcsEllipsis, gcsNone: END ENUM
ENUM ScrllBars: ssNone, ssHorizontal, ssVertical, ssBoth: END ENUM
ENUM LBoxHite: lbStandard, lbOwnerDrawFixed, lbOwnerDrawVariable: END ENUM

ENUM SpinOrientation: spVertical, spHorizontal: END ENUM
ENUM ProgBar: pbHorizontal, pbVertical: END ENUM
ENUM ProgStyles: pbsSegment, pbsSmooth, pbsSmoothReverse, pbsMarquee=4: END ENUM
ENUM PagerOrientation: pgHorizontal, pgVertical: END ENUM
ENUM RETextExtend: ST_NEWCHARS=3, ST_UNICODE: END ENUM
ENUM CalcTextSize: tsWidth, tsHeight: END ENUM
ENUM CursorStyles
    crDefault=32512, crArrow=32512, crIBeam, crHourGlass, crCross, crUpArrow
    crSizeNWSE=32642, crSizeNESW, crSizeWE, crSizeNS, crSize, crNone, crNoDrop
    crHandPoint, crAppStart, crHelp, crVSplit, crHSplit
END ENUM

' ALL major objects from RapidQ plus some extras
' The following order kept in sync with RapidFRM
ENUM Q_OBJECTS
    Q_FORM, Q_EDIT, Q_RICHEDIT, Q_LABEL, Q_BUTTON, Q_COOLBTN, Q_OVALBTN, Q_CHECKBOX,
    Q_RADIOBUTTON, Q_PANEL, Q_TABCONTROL, Q_COMBOBOX, Q_LISTBOX, Q_GROUPBOX, Q_SCROLLBOX,
    Q_SCROLLBAR, Q_STRINGGRID, Q_LISTVIEW, Q_DIRTREE, Q_FILELISTBOX, Q_TREEVIEW,
    Q_OUTLINE, Q_GAUGE, Q_TRACKBAR, Q_HEADER, Q_STATUSBAR, Q_CANVAS, Q_IMAGE,
    Q_OLECONTAINER, Q_SPLITTER, Q_BITMAP, Q_IMAGELIST, Q_STRINGLIST, Q_TIMER, Q_SOCKET,
    Q_FILESTREAM, Q_MEMORYSTREAM, Q_FONT, Q_MYSQL, Q_OLEOBJECT, Q_REGISTRY,
    Q_OPENDIALOG, Q_SAVEDIALOG, Q_FONTDIALOG, Q_COLORDIALOG,
    Q_DXTimer, Q_DXSound, Q_DXScreen, Q_DXImageList, Q_D3DFace, Q_D3DMeshBuilder,
    Q_D3DFrame, Q_D3DLight, Q_D3DTexture, Q_D3DVector, Q_D3DWrap,
    Q_PAGESETUPDIALOG, Q_PRINTDIALOG, Q_PROGRESSBAR, Q_CALENDAR, Q_DATEPICKER,
    Q_DRIVELIST, Q_UPDOWN, Q_PAGER, Q_REBAR, Q_TOOLBAR,
    Q_OBJECT=99
END ENUM

'-----------------------------------------------------------------------------------------
' Some macro stuff
'-----------------------------------------------------------------------------------------
#MACRO ShowMessage(Txt)                                                 ' For RapidQ users
    MessageBox(Application.hMainForm, Txt, "FB Information", MB_OK)     ' Use "global" Form handle to capture focus
#ENDMACRO

#MACRO DBG(Txt)
    MessageBox(Application.hMainForm, Txt, "FB Debug", MB_OK)
#ENDMACRO

#MACRO InpFileError(FileName)
    MessageBox(Application.hMainForm, CHR(34)+FileName+CHR(34)+" - does not exist!", "File error", MB_OK)
#ENDMACRO

'-------------------
' Vars for "common" properties (one set for each object, whether they need them or not!)
#MACRO PrivateProperties()
    _Init AS integer=0: OldWndProc AS WNDPROC: NewWndProc AS WNDPROC: _Handle AS HWND: _Parent AS HWND
    _Enabled AS integer=1: _Visible AS integer=1: _Tag AS integer=0: _ShowHint AS integer=0
    _Min AS integer=0: _Max AS integer=100: _Position AS integer=0: _SmallChange AS integer=1
    _LargeChange AS integer=10: _PageSize AS integer=100: _Transparent AS integer=1
    _BorderStyle AS integer=1
    _Caption AS string = "": _Hint AS string = "": _Text AS string = ""
#ENDMACRO

'-------------------
' Read/SetOnce 'ReadOnly' properties (ONE time settable using the _Init variable as flags)
#MACRO DoReadOnlyProperties(ObjName)
    PROPERTY ObjName.Handle() AS HWND: RETURN _Handle: END PROPERTY
    PROPERTY ObjName.Handle(value AS HWND): IF (_Init AND 1)=0 THEN _Init OR= 1: _Handle=value: END IF: END PROPERTY
    PROPERTY ObjName.Parent() AS HWND: RETURN _Parent: END PROPERTY
    PROPERTY ObjName.Parent(value AS HWND): IF (_Init AND 2)=0 THEN _Init OR= 2: _Parent=value: END IF: END PROPERTY
#ENDMACRO

' Read/Set common group of properties
#MACRO DoGeneralProperties(ObjName)
    PROPERTY ObjName.Enabled() AS integer: RETURN _Enabled: END PROPERTY
    PROPERTY ObjName.Enabled(value AS integer)
        _Enabled=value: EnableWindow(Handle, value): InvalidateRect(Handle,NULL,True)
    END PROPERTY
    PROPERTY ObjName.Visible() AS integer: RETURN _Visible: END PROPERTY
    PROPERTY ObjName.Visible(value AS integer)
        _Visible=value: IF value=False THEN ShowWindow(Handle,SW_HIDE) ELSE ShowWindow(Handle,SW_SHOW): END IF
    END PROPERTY
    PROPERTY ObjName.Tag() AS integer: RETURN _Tag: END PROPERTY
    PROPERTY ObjName.Tag(value AS integer): _Tag=value: END PROPERTY
#ENDMACRO

' Read/Set object dynamics
#MACRO DoPositionalProperties(ObjName)
    PROPERTY ObjName.Left() AS integer: RETURN _Left: END PROPERTY
    PROPERTY ObjName.Left(value AS integer): _Left=value: MoveWindow(Handle, Left, Top, Width, Height, True): END PROPERTY
    PROPERTY ObjName.Top() AS integer: RETURN _Top: END PROPERTY
    PROPERTY ObjName.Top(value AS integer): _Top=value: MoveWindow(Handle, Left, Top, Width, Height, True): END PROPERTY
    PROPERTY ObjName.Width() AS integer: RETURN _Width: END PROPERTY
    PROPERTY ObjName.Width(value AS integer): _Width=value: MoveWindow(Handle, Left, Top, Width, Height, True): END PROPERTY
    PROPERTY ObjName.Height() AS integer: RETURN _Height: END PROPERTY
    PROPERTY ObjName.Height(value AS integer): _Height=value: MoveWindow(Handle, Left, Top, Width, Height, True): END PROPERTY
#ENDMACRO

' Read/Set Align property
#MACRO DoAlignProperty(ObjName)
    PROPERTY ObjName.Align() AS integer: RETURN _Align: END PROPERTY
    PROPERTY ObjName.Align(value AS integer): IF (value>=alNone) AND (value<=alClient) THEN: _Align=value: END IF: END PROPERTY
#ENDMACRO

' Read/Set Caption property
#MACRO DoCapProperties(ObjName)
    PROPERTY ObjName.Caption() AS string: RETURN _Caption: END PROPERTY
    PROPERTY ObjName.Caption(value AS string)
        _Caption=value: SetWindowText(Handle, value)
    END PROPERTY
#ENDMACRO

' Read/Set/Show Hint property
#MACRO DoHintProperties(ObjName)
    PROPERTY ObjName.Hint() AS string: RETURN _Hint: END PROPERTY
    PROPERTY ObjName.Hint(value AS string): _Hint=value: END PROPERTY
    PROPERTY ObjName.ShowHint() AS integer: RETURN _ShowHint: END PROPERTY
    PROPERTY ObjName.ShowHint(value AS integer): _ShowHint=value: END PROPERTY
#ENDMACRO

'------------------------------------------------------------------------------------------
' Graphics functions for Form, Canvas, Combobox, Header, Image, Listbox & StringGrid (plus QPanel
' undocumented). QBitmap calls the drawing functions (rqCircle(), rqFillRect()...etc) directly
'------------------------------------------------------------------------------------------
#MACRO ObjectDrawFns(ObjName)
    SUB ObjName.Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
        DIM AS HDC srcDC=GetDC(Handle)
        rqCircle(srcDC, x1, y1, x2, y2, c, fill)
        ReleaseDC(Handle, srcDC)
    END SUB
    SUB ObjName.Pset(x AS integer, y AS integer, c AS integer)
        DIM AS HDC srcDC=GetDC(Handle)
        rqSetPixel(srcDC, x, y, c)
        ReleaseDC(Handle, srcDC)
    END SUB
    SUB ObjName.FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
        DIM AS HDC srcDC=GetDC(Handle)
        rqFillRect(srcDC, x1, y1, x2, y2, c)
        ReleaseDC(Handle, srcDC)
    END SUB
    SUB ObjName.Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
        DIM AS HDC srcDC=GetDC(Handle)
        rqRectangle(srcDC, x1, y1, x2, y2, c)
        ReleaseDC(Handle, srcDC)
    END SUB
    SUB ObjName.Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
        DIM AS HDC srcDC=GetDC(Handle)
        rqLine(srcDC, x1, y1, x2, y2, c)
        ReleaseDC(Handle, srcDC)
    END SUB
    SUB ObjName.RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
        DIM AS HDC srcDC=GetDC(Handle)
        rqRoundRect(srcDC, x1, y1, x2, y2, x3, y3, c)
        ReleaseDC(Handle, srcDC)
    END SUB
    SUB ObjName.Paint(x AS integer, y AS integer, colr AS integer, brdr AS integer)
        DIM AS HDC srcDC=GetDC(Handle)
        rqPaint(srcDC, x, y, colr, brdr)
        ReleaseDC(Handle, srcDC)
    END SUB
    FUNCTION ObjName.Pixel(x AS integer, y AS integer) AS integer
        DIM AS HDC srcDC=GetDC(Handle)
        DIM AS integer Result=rqGetPixel(srcDC, x, y)
        RETURN Result
    END FUNCTION
    SUB ObjName.StretchDraw(lpRect AS RECT PTR, FileName AS string)
        DIM AS HDC dstDC=GetDC(Handle)
        rqStretchDraw(dstDC, lpRect, FileName)
        ReleaseDC(Handle, dstDC)
    END SUB
    SUB ObjName.Draw(x AS integer, y AS integer, FileName AS string)
        DIM AS HDC dstDC=GetDC(Handle)
        rqDraw(dstDC, x, y, FileName)
        ReleaseDC(Handle, dstDC)
    END SUB
    SUB ObjName.CopyRect OVERLOAD (D AS RECT PTR, Image AS HWND, S AS RECT PTR)
        DIM AS HDC dstDC=GetDC(Handle)
        rqCopyRect(dstDC, D, Image, S)
        ReleaseDC(Handle, dstDC)
    END SUB
    SUB ObjName.CopyRect OVERLOAD (D AS RECT PTR, Image AS HDC, S AS RECT PTR)
        DIM AS HDC dstDC=GetDC(Handle)
        rqCopyRect(dstDC, D, Image, S)
        ReleaseDC(Handle, dstDC)
    END SUB
    SUB ObjName.Repaint()
        InvalidateRect(Handle, NULL, True)
    END SUB
    ' x & y can be negative!
    SUB ObjName.TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
        rqTextOut(@Font, x, y, S, fc, bc)
    END SUB
    SUB ObjName.TextRect(lpRct AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
        IF LEN(S)=0 THEN EXIT SUB
        IF (x>0) AND ((lpRct->Left+x)>lpRct->Right) THEN EXIT SUB
        IF (y>0) AND ((lpRct->Top+y)>lpRct->Bottom) THEN EXIT SUB
        rqTextRect(@Font, lpRct, x, y, S, fc, bc)
    END SUB
    FUNCTION ObjName.TextHeight(Txt AS string) AS integer
        RETURN rqGetTextSize(@Font, Txt, tsHeight)
    END FUNCTION
    FUNCTION ObjName.TextWidth(Txt AS string) AS integer
        RETURN rqGetTextSize(@Font, Txt, tsWidth)
    END FUNCTION
    FUNCTION ObjName.SaveToBMP(FileName AS string) AS integer
        RETURN rqCaptureToFile(Handle, FileName)
    END FUNCTION
#ENDMACRO

'-----------------------------------------------------------------------------------------
DECLARE FUNCTION UpDateFont(Handle AS HWND, lpLogFont AS LOGFONTA PTR) AS HFONT

TYPE QFONT
' Properties
    ObjId AS integer        = Q_FONT                        ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = ""                            ' Base class
    ObjStyle AS UINT        = 0                             '

    _Charset AS integer
    _Color AS COLORREF
    _Name AS string*LF_FACESIZE
    _Size AS integer
    _Bold AS integer                                        '|
    _Italic AS integer                                      '| Undocumented in RQ but...
    _Underline AS integer                                   '| ...used here in lieu of AddStylyes() and...
    _Strikeout AS integer                                   '| ... DelStyles() methods

    FontCount AS integer                                    ' count of installed fonts
    FontNameArray AS zString PTR                            ' csv string of installed fonts
    Pitch AS integer                                        ' fpDefault - not used
    Handle AS HFONT

    Owner AS HWND           = 0
    IsBitmap AS integer     = 0                             ' Assists with diffs between BMP & visible objects
    lFontA AS LOGFONTA
    lpFontColor AS SUB(hWnd AS HWND, TxtColor AS COLORREF)  ' Some components need special treatment

    DECLARE PROPERTY Color() AS COLORREF
    DECLARE PROPERTY Color(value AS COLORREF)
    DECLARE PROPERTY Name() AS string
    DECLARE PROPERTY Name(value AS string)
    DECLARE PROPERTY bold() AS integer
    DECLARE PROPERTY bold(value AS integer)
    DECLARE PROPERTY italic() AS integer
    DECLARE PROPERTY italic(value AS integer)
    DECLARE PROPERTY underline() AS integer
    DECLARE PROPERTY underline(value AS integer)
    DECLARE PROPERTY strikeout() AS integer
    DECLARE PROPERTY strikeout(value AS integer)
    DECLARE PROPERTY Size() AS integer
    DECLARE PROPERTY Size(value AS integer)
' Methods
#IF 0
    DECLARE SUB AddStyles(value AS integer)
    DECLARE SUB DelStyles(value AS integer)
#ENDIF
END TYPE

PROPERTY QFONT.Color() AS COLORREF: RETURN _Color: END PROPERTY
PROPERTY QFONT.Color(value AS COLORREF)
    IF _Color=value THEN EXIT PROPERTY
    _Color=value
    IF lpFontColor>0 THEN lpFontColor(Owner, _Color)
    InvalidateRect(Owner,NULL,True)
END PROPERTY
PROPERTY QFONT.Name() AS string: RETURN _Name: END PROPERTY
PROPERTY QFONT.Name(value AS string)
    IF _Name=value THEN EXIT PROPERTY
    _Name=value: lFontA.lfFaceName=value
    Handle=UpDateFont(Owner, @lFontA)
END PROPERTY
PROPERTY QFONT.Bold() AS integer: RETURN _Bold: END PROPERTY
PROPERTY QFONT.Bold(value AS integer)
    IF _Bold=value THEN EXIT PROPERTY
    _Bold=value: IF value THEN lFontA.lfWeight=FW_BOLD ELSE lFontA.lfWeight=FW_NORMAL
    Handle=UpDateFont(Owner, @lFontA)
END PROPERTY
PROPERTY QFONT.Italic() AS integer: RETURN _Italic: END PROPERTY
PROPERTY QFONT.Italic(value AS integer)
    IF _Italic=value THEN EXIT PROPERTY
    _Italic=value: IF value THEN lFontA.lfItalic=1 ELSE lFontA.lfItalic=0
    Handle=UpDateFont(Owner, @lFontA)
END PROPERTY
PROPERTY QFONT.Underline() AS integer: RETURN _Underline: END PROPERTY
PROPERTY QFONT.Underline(value AS integer)
    IF _Underline=value THEN EXIT PROPERTY
    _Underline=value: IF value THEN lFontA.lfUnderline=1 ELSE lFontA.lfUnderline=0
    Handle=UpDateFont(Owner, @lFontA)
END PROPERTY
PROPERTY QFONT.Strikeout() AS integer: RETURN _Strikeout: END PROPERTY
PROPERTY QFONT.Strikeout(value AS integer)
    IF _Strikeout=value THEN EXIT PROPERTY
    _Strikeout=value: IF value THEN lFontA.lfStrikeOut=1 ELSE lFontA.lfStrikeOut=0
    Handle=UpDateFont(Owner, @lFontA)
END PROPERTY
PROPERTY QFONT.Size() AS integer: RETURN _Size: END PROPERTY
PROPERTY QFONT.Size(value AS integer)
    IF value=_Size THEN EXIT PROPERTY
    IF (value<6) OR (value>48) THEN EXIT PROPERTY                   ' 6-48??????
    DIM AS HDC fntDC
    IF IsBitmap THEN fntDC=CAST(HDC,Owner) ELSE fntDC=GetDC(Owner)      ' For BMPs - Owner is a HDC
    lFontA.lfHeight = -MulDiv(value, GetDeviceCaps(fntDC, LOGPIXELSY), 72)
    ReleaseDC(Owner, fntDC): _Size=value
    Handle=UpDateFont(Owner, @lFontA)
END PROPERTY

' (Internal) Component WndProc hooks
DECLARE FUNCTION EditWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION RichEdWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION ButnWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION CanvasWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION ComboWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION DirTreeWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION FileLBoxWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION HeadrWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION ImgWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION LabelWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION ListBoxWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION ListViewWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION ScollBarWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION StatusWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION TreeViewWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION CoolWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION GaugeWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION TrackWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION GrpBoxWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION OvalWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION CheckWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION RadioWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION PanelWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION ScrollBoxWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION StrGridWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION TabCtlWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DECLARE FUNCTION ProgressWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT

' Shared graphics functions
DECLARE SUB rqCircle(srcDC AS HDC, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer, FillColr AS integer)
DECLARE SUB rqSetPixel(srcDC AS HDC, x AS integer, y AS integer, colr AS integer)
DECLARE SUB rqFillRect(srcDC AS HDC, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer)
DECLARE SUB rqRectangle(srcDC AS HDC, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer)
DECLARE SUB rqLine(srcDC AS HDC, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer)
DECLARE SUB rqRoundRect(srcDC AS HDC, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, colr AS integer)
DECLARE SUB rqPaint(srcDC AS HDC, x AS integer, y AS integer, colr AS integer, brdr AS integer)
DECLARE FUNCTION rqGetPixel(srcDC AS HDC, x AS integer, y AS integer) AS integer
DECLARE SUB rqDraw(dstDC AS HDC, x AS integer, y AS integer, FileName AS string)
DECLARE SUB rqStretchDraw(dstDC AS HDC, lpRect AS RECT PTR, FileName AS string)
DECLARE SUB rqCopyRect OVERLOAD (dstDC AS HDC, dstRect AS RECT PTR, srcHandle AS HWND, srcRect AS RECT PTR)
DECLARE SUB rqCopyRect OVERLOAD (dstDC AS HDC, dstRect AS RECT PTR, srcDC AS HDC, srcRect AS RECT PTR)
DECLARE SUB rqTextOut(lpFont AS QFONT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
DECLARE SUB rqTextRect(lpFont AS QFONT PTR, lpRct AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
DECLARE FUNCTION rqGetTextSize(lpFont AS QFONT PTR, Text AS string, DirnFlag AS integer) AS integer

DECLARE FUNCTION rqScreenToBMP(lpRect AS RECT PTR, bmpHandle AS HDC) AS integer                         ' Screen capture to QBITMAP
DECLARE FUNCTION rqScreenToFile(lpRect AS RECT PTR, OutFileName AS string) AS integer                   ' Screen capture to file
DECLARE FUNCTION rqBMPToFile(srcDC AS HDC, Widf AS integer, Height AS integer, FileName AS string) AS integer   ' Save a QBITMAP to a file
DECLARE FUNCTION rqCaptureToFile(hWnd AS HWND, FileName AS string) AS integer                           ' Save object client area to file

' General purpose functions
DECLARE FUNCTION rqTALLY(srcString AS string, srchString AS string) AS integer
DECLARE FUNCTION rqFIELDSTR(srcString AS string, sepField AS string, numField AS integer) AS string
DECLARE FUNCTION rqREPLACESUBSTR(srcString AS string, oldToken AS string, newToken AS string) AS string
DECLARE FUNCTION FillRichEditFromFile(hWnd AS HWND, BYVAL pszFile AS LPCTSTR) AS integer
DECLARE FUNCTION SaveRichEditToFile(hWnd AS HWND, FileName AS string) AS integer
DECLARE FUNCTION GetSysDateFormat() AS string
DECLARE FUNCTION CreateDefaultFont() AS HFONT
DECLARE SUB InitialiseFont(lpFont AS QFONT PTR)
DECLARE SUB rqUpdateStyle(Handle AS HWND, Style AS UINT, AddYesNo AS integer)
DECLARE SUB DoEvents()

'------------------------------
TYPE QSCREEN
' Properties
    Width AS integer
    Height AS integer
    ClientWidth AS integer
    ClientHeight AS integer
    MouseBtns AS integer
    MouseX AS integer
    MouseY AS integer

' Methods
    DECLARE CONSTRUCTOR
    DECLARE FUNCTION CaptureToBMP(lpRect AS RECT PTR, bmpHandle AS HDC) AS integer
    DECLARE FUNCTION CaptureToFile(lpRect AS RECT PTR, OutFileName AS string) AS integer
    DECLARE FUNCTION Pixel(x AS integer, y AS integer) AS long
    DECLARE FUNCTION SetMouseXY(x AS integer, y AS integer) AS integer
#IF 0
    DECLARE FUNCTION EnumResolution(lpListBox AS QLISTBOX PTR) AS long
    DECLARE FUNCTION GetPixelDepth() AS integer
    DECLARE FUNCTION Monitors() AS integer
    DECLARE FUNCTION MouseButtons() AS integer
    DECLARE FUNCTION MousePresent() AS integer
    DECLARE FUNCTION MouseSwap() AS integer
    DECLARE FUNCTION SetResolution(X AS DWORD, Y AS DWORD, bpp AS WORD, Freq AS DWORD) AS long
#ENDIF
END TYPE

CONSTRUCTOR QSCREEN
DIM AS RECT rct
WITH THIS
    .Width = GetSystemMetrics(SM_CXVIRTUALSCREEN)
    .Height = GetSystemMetrics(SM_CYVIRTUALSCREEN)
    SystemParametersInfo(SPI_GETWORKAREA, 0, @rct, 0)
    .ClientWidth = rct.Right - rct.Left
    .ClientHeight = rct.Bottom - rct.Top
END WITH
END CONSTRUCTOR

FUNCTION QSCREEN.CaptureToBMP(lpRect AS RECT PTR, bmpHandle AS HDC) AS integer
    RETURN rqScreenToBMP(lpRect, bmpHandle)
END FUNCTION
FUNCTION QSCREEN.CaptureToFile(lpRect AS RECT PTR, OutFileName AS string) AS integer
    RETURN rqScreenToFile(lpRect, OutFileName)
END FUNCTION
FUNCTION QSCREEN.Pixel(x AS integer, y AS integer) AS long
DIM AS HDC hDC=GetDC(NULL)
DIM AS long Colr=CAST(long, GetPixel(hDC, x, y))
    ReleaseDC(NULL, hDC)
    RETURN Colr
END FUNCTION
FUNCTION QSCREEN.SetMouseXY(x AS integer, y AS integer) AS integer
    RETURN SetCursorPos(x, y)
END FUNCTION

'------------------------------
TYPE APP_TIMER
    ObjIndex AS integer
    Parent AS HWND
    Enabled AS integer
    Interval AS integer
    AS SUB() OnTimer
END TYPE

'------------------------------
TYPE OBJ_INFO
    Handle AS HWND                      ' Cross reference generated object handles to...
    ObjPtr AS ANY PTR                   ' ...the object structures. Used in all WndProcs
END TYPE

'------------------------------
TYPE QAPPLICATION
    hInstance AS HINSTANCE
    _ExeName AS string                                  ' exe name only
    _Path AS string                                     ' Full path
    _Title AS string                                    ' ExeName minus the '.exe' extension

    _HintStyle AS integer       = hsLabel               ' Default - edit label style
    _HintColor AS integer       = &he1ffff
    _HintTextColor AS integer   = 0
    _HintHidePause AS integer   = 2500                  ' Time in mSecs hint displayed
    HintPause AS integer        = 250                   ' Delay B4 hint shown (HintHidePause/10)
    HintShortPause AS integer   = 50                    ' HintPause/5

    Cursor AS integer           = crDefault             ' crDefault = crArrow FIXED
    Font AS QFONT                                       ' FIXED font struc
    HelpFile AS string          = ""
    IcoHandle AS integer        = 0                     '| ONLY via a resource file!!
    Icon AS string              = ""                    '|
    ShowHint AS integer         = True                  ' FIXED to "on"

    hMainForm AS HWND
    hWndTTip AS HWND                                    ' Tooltip window
    ObjInfo(Q_OBJECT) AS OBJ_INFO                       ' keep track of project components

    DECLARE PROPERTY ExeName() AS string
    DECLARE PROPERTY ExeName(value AS string)
    DECLARE PROPERTY HintStyle() AS integer
    DECLARE PROPERTY HintStyle(value AS integer)
    DECLARE PROPERTY HintColor() AS integer
    DECLARE PROPERTY HintColor(value AS integer)
    DECLARE PROPERTY HintTextColor() AS integer
    DECLARE PROPERTY HintTextColor(value AS integer)
    DECLARE PROPERTY HintHidePause() AS integer
    DECLARE PROPERTY HintHidePause(value AS integer)
    DECLARE PROPERTY Path() AS string
    DECLARE PROPERTY Path(value AS string)
    DECLARE PROPERTY Title() AS string
    DECLARE PROPERTY Title(value AS string)
' Methods
    DECLARE SUB Terminate
' Extras
    DECLARE FUNCTION GetObjectPtr(ObjHandle AS HWND) AS ANY PTR
    DECLARE CONSTRUCTOR
    DECLARE DESTRUCTOR
END TYPE

PROPERTY QAPPLICATION.ExeName() AS string: RETURN _ExeName: END PROPERTY
PROPERTY QAPPLICATION.ExeName(value AS string): END PROPERTY
PROPERTY QAPPLICATION.HintStyle() AS integer: RETURN _HintStyle: END PROPERTY
PROPERTY QAPPLICATION.HintStyle(value AS integer)
    _HintStyle=value
    IF value=hsBalloon THEN
        SetWindowLong(hWndTTip, GWL_STYLE, (GetWindowLong(hWndTTip,GWL_STYLE) OR TTS_BALLOON))
    ELSE
        SetWindowLong(hWndTTip, GWL_STYLE, (GetWindowLong(hWndTTip,GWL_STYLE) AND NOT(TTS_BALLOON)))
    END IF
END PROPERTY
PROPERTY QAPPLICATION.HintColor() AS integer: RETURN _HintColor: END PROPERTY
PROPERTY QAPPLICATION.HintColor(value AS integer)
    _HintColor=value: SendMessage(hWndTTip, TTM_SETTIPBKCOLOR, CAST(WPARAM, value), 0)
END PROPERTY
PROPERTY QAPPLICATION.HintTextColor() AS integer: RETURN _HintTextColor: END PROPERTY
PROPERTY QAPPLICATION.HintTextColor(value AS integer)
    _HintTextColor=value: SendMessage(hWndTTip, TTM_SETTIPTEXTCOLOR, CAST(WPARAM, value), 0)
END PROPERTY
PROPERTY QAPPLICATION.HintHidePause() AS integer: RETURN _HintHidePause: END PROPERTY
PROPERTY QAPPLICATION.HintHidePause(value AS integer)
    _HintHidePause=value: HintPause=value\10: HintShortPause=HintPause\5    ' Set the other timeouts
    SendMessage(hWndTTip, TTM_SETDELAYTIME, TTDT_AUTOPOP, value)
END PROPERTY
PROPERTY QAPPLICATION.Path() AS string: RETURN _Path: END PROPERTY
PROPERTY QAPPLICATION.Path(value AS string): END PROPERTY                   ' Read only
PROPERTY QAPPLICATION.Title() AS string: RETURN _Title: END PROPERTY
PROPERTY QAPPLICATION.Title(value AS string): END PROPERTY                  ' Read only

FUNCTION QAPPLICATION.GetObjectPtr(ObjHandle AS HWND) AS ANY PTR
    FOR i AS integer=1 TO Q_OBJECT
        IF ObjInfo(i).Handle=ObjHandle THEN
            RETURN ObjInfo(i).ObjPtr
        END IF
    NEXT i
    MessageBox(hMainForm, "RapidFRM Internal error! -> GetObjectPtr()", "FB Debug", MB_OK)
    Terminate()
END FUNCTION
SUB QAPPLICATION.Terminate
    SendMessage(hMainForm, WM_CLOSE, 0, 0)
END SUB
CONSTRUCTOR QAPPLICATION
DIM FullName AS string*256                                                  ' Full path and exe name
    hInstance = GetModuleHandle(NULL)
    GetModuleFileName(hInstance, FullName, 255)
    _Path = LEFT(FullName, INSTRREV(FullName, "\")-1)
    _ExeName = TRIM(RIGHT(FullName, LEN(FullName)-INSTRREV(FullName, "\")))
    _Title = LEFT(RTRIM(_ExeName), LEN(RTRIM(_ExeName))-4)
    hMainForm=0
    Font.Handle=CreateDefaultFont
    Cursor = crDefault                                  ' IDC_ARROW
    hWndTTip=CreateWindowEx(NULL, TOOLTIPS_CLASS, "", _
                        WS_POPUP OR TTS_NOPREFIX OR TTS_ALWAYSTIP, _
                                     CW_USEDEFAULT, CW_USEDEFAULT, _
                                     CW_USEDEFAULT, CW_USEDEFAULT, _
                                               NULL, 0, hInstance, 0)
    SetWindowPos(hWndTTip, HWND_TOPMOST, 0, 0, 0, 0, _
                            SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOACTIVATE)
END CONSTRUCTOR
DESTRUCTOR QAPPLICATION
' Do not think anything goes in here, all allocates() are de-allocated
' All child windows of main form are destroyed automatically etc etc
' Although, I have been known to be wrong!
END DESTRUCTOR

'------------------------------
#DEFINE CB_MAX_FORMATS      26
TYPE QCLIPBOARD
' Properties
    Format(0 TO CB_MAX_FORMATS-1) AS UINT               ' Array of format system types
    FormatCount AS integer
    _Text AS zString PTR
    lpByteArray AS BYTE PTR

    DECLARE PROPERTY Text() AS zString PTR
    DECLARE PROPERTY Text(value AS string)
' Methods
    DECLARE SUB Open(Handle AS HWND)
    DECLARE SUB Clear()
    DECLARE SUB Close()
    DECLARE FUNCTION GetAsText(Lenth AS integer) AS zString PTR
    DECLARE SUB SetAsText(Txt AS string)
    DECLARE FUNCTION GetAsHandle(Fmt AS UINT) AS HANDLE
    DECLARE FUNCTION HasFormat(Fmt AS UINT) AS integer
    DECLARE CONSTRUCTOR
    DECLARE DESTRUCTOR
END TYPE

PROPERTY QCLIPBOARD.Text() AS zString PTR: _Text=GetAsText(0): RETURN _Text: END PROPERTY
PROPERTY QCLIPBOARD.Text(value AS string)
    SetAsText(value): _Text=CAST(zString PTR, lpByteArray)
END PROPERTY

SUB QCLIPBOARD.Open(Handle AS HWND)
    OpenClipboard(Handle)
END SUB
SUB QCLIPBOARD.Close()
    CloseClipboard()
END SUB
SUB QCLIPBOARD.Clear()
    Open(NULL)
    EmptyClipboard()
    IF lpByteArray>0 THEN
        DeAllocate(lpByteArray)
        lpByteArray=0
        _Text=CAST(zString PTR,lpByteArray)
    END IF
    Close()
END SUB
FUNCTION QCLIPBOARD.GetAsText(Lenth AS integer) AS zString PTR
DIM AS HANDLE hClip
DIM AS integer siz
    Open(NULL)
    hClip=GetClipboardData(CF_TEXT)
    siz=GlobalSize(hClip)
    lpByteArray=CAST(BYTE PTR,CAllocate(siz+1))
    _Text=CAST(zString PTR,lpByteArray)
    CopyMemory(lpByteArray, hClip, siz)
    IF (Lenth>0) AND (Lenth<siz) THEN siz=Lenth
    lpByteArray[siz]=0
    Close()
    RETURN CAST(zString PTR, lpByteArray)
END FUNCTION
SUB QCLIPBOARD.SetAsText(Txt AS string)
DIM AS HANDLE hClip
DIM AS integer siz=LEN(Txt)
    Clear()
    lpByteArray=CAST(BYTE PTR,CAllocate(siz+1))
    CopyMemory(lpByteArray, STRPTR(Txt), siz)
    lpByteArray[siz]=0
    Open(NULL)
    hClip=SetClipboardData(CF_TEXT, CAST(HANDLE, lpByteArray))
    Close()
END SUB
FUNCTION QCLIPBOARD.GetAsHandle(Fmt AS UINT) AS HANDLE
    RETURN GetClipboardData(Fmt)
END FUNCTION
FUNCTION QCLIPBOARD.HasFormat(Fmt AS UINT) AS integer
    FOR i AS integer = 0 TO FormatCount-1
        IF Format(i)=Fmt THEN RETURN True
    NEXT i
    RETURN False
END FUNCTION
CONSTRUCTOR QCLIPBOARD
DIM AS UINT fmt
    FormatCount=CountClipboardFormats()
    IF FormatCount>CB_MAX_FORMATS THEN FormatCount=CB_MAX_FORMATS
    fmt=EnumClipboardFormats(0)
    IF fmt>0 THEN
        Format(0)=fmt
        FOR i AS integer = 1 TO FormatCount-1
            fmt=EnumClipboardFormats(fmt)
            IF fmt=0 THEN EXIT FOR
            Format(i)=fmt
        NEXT i
    END IF
END CONSTRUCTOR
DESTRUCTOR QCLIPBOARD
    Close()
    IF lpByteArray>0 THEN DeAllocate(lpByteArray)
END DESTRUCTOR

'-----------------------------------------------------------------------------------------
' Global "system" wide data
'-----------------------------------------------------------------------------------------
DIM SHARED AS QSCREEN Screen
DIM SHARED AS QAPPLICATION Application
DIM SHARED AS QCLIPBOARD Clipboard
DIM SHARED AS WNDCLASSEX wc
DIM SHARED AS HHOOK MouseHook
DIM SHARED AS APP_TIMER App_Timer


'**********************************************************************************************
' QBitmap, QImageList & QStringList
' Common to several other components, placed here, so that they are "visible" to them
'**********************************************************************************************
' #30 ====================================================================================
TYPE QBITMAP
' Private (not)
    ObjId AS integer        = Q_BITMAP              ' Component ID
    ObjIndex AS integer     = 0                     ' Unique number per object
    ObjClass AS string*32   = ""                    ' Non-visible class
    ObjStyle AS UINT        = 0                     '
    Font AS QFONT

    _Handle AS HDC          = 0
    _BMP AS string          = ""
    _BMPHandle AS integer   = 0                     ' Resource ident number
    _Height AS integer      = 100
    _Width AS integer       = 100
    _Monochrome AS integer  = False
    _Empty AS integer       = True

    CopyMode AS integer     = BLACKNESS
    PixelFormat AS integer  = pf24bit
    Transparent AS integer  = False
    TransparentColor AS integer = -1
    _Bitmap AS BITMAP
    bmpHWND AS HWND
    bmpDC AS HDC

#IF 0
    TransparentMode AS integer
    Pixel                                 ' |2D ARRAY of INTEGER|RW|
    DECLARE SUB LoadFromStream(Stream)
    DECLARE SUB SaveToStream(Stream)
#ENDIF

' Properties
    DECLARE PROPERTY BMP() AS string
    DECLARE PROPERTY BMP(FileName AS string)
    DECLARE PROPERTY BMPHandle() AS integer
    DECLARE PROPERTY BMPHandle(value AS integer)
    DECLARE PROPERTY Empty() AS integer
    DECLARE PROPERTY Empty(value AS integer)
    DECLARE PROPERTY Handle() AS HDC
    DECLARE PROPERTY Handle(value AS HDC)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Monochrome() AS integer
    DECLARE PROPERTY Monochrome(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB LoadFromFile(FileName AS string)
    DECLARE SUB Rotate(xOrigin AS integer, yOrigin AS integer, Angle AS integer)
    DECLARE SUB SaveToFile(FileName AS string)
    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HWND, S AS RECT PTR)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HDC, S AS RECT PTR)
    DECLARE SUB Draw(x AS integer, y AS integer, FileName AS string)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Paint(x AS integer, y AS integer, c AS integer, borderc AS integer)
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    DECLARE SUB StretchDraw(lpRect AS RECT PTR, FileName AS string)
    DECLARE FUNCTION TxtHeight(Txt AS string) AS integer
    DECLARE FUNCTION TxtWidth(Txt AS string) AS integer
    DECLARE SUB TxtOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TxtRect(lpRect AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
' Extras
    DECLARE FUNCTION Pixel(x AS integer, y AS integer) AS integer
    DECLARE SUB SetBitmapDC()
    DECLARE CONSTRUCTOR
    DECLARE DESTRUCTOR
' Events
END TYPE

PROPERTY QBITMAP.BMP() AS string: RETURN _BMP: END PROPERTY
PROPERTY QBITMAP.BMP(FileName AS string)
DIM AS UINT BmpFlags=LR_LOADFROMFILE
    IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT PROPERTY
    IF Monochrome THEN BmpFlags OR= LR_MONOCHROME
    IF Transparent THEN BmpFlags OR= LR_LOADTRANSPARENT
    IF bmpHWND THEN DeleteObject(bmpHWND)
    _Width=0: _Height=0: _Empty=True
    bmpHWND=LoadImage(NULL, FileName, IMAGE_BITMAP, 0, 0, BmpFlags)
    IF bmpHWND THEN
        GetObject(bmpHWND, SIZEOF(_BitMap), @_BitMap)                   ' Get INFO of this BMP
        _Width=_BitMap.bmwidth: _Height=_BitMap.bmHeight
        SelectObject(bmpDC, bmpHWND)
        Font.Owner=bmpHWND: _Empty=False: _BMP=FileName
    END IF
END PROPERTY
PROPERTY QBITMAP.BMPHandle() AS integer: RETURN 0: END PROPERTY
PROPERTY QBITMAP.BMPHandle(ResNum AS integer)
DIM AS string resString="#" & ResNum
DIM AS UINT BmpFlags=0
    IF Monochrome THEN BmpFlags=LR_MONOCHROME
    IF Transparent THEN BmpFlags OR= LR_LOADTRANSPARENT
    IF bmpHWND THEN DeleteObject(bmpHWND)
    _Width=0: _Height=0: _Empty=True
    bmpHWND=LoadImage(Application.hInstance, resString, IMAGE_BITMAP, 0, 0, BmpFlags)
    IF bmpHWND THEN
        GetObject(bmpHWND, SIZEOF(_BitMap), @_BitMap)
        _Width=_BitMap.bmwidth: _Height=_BitMap.bmHeight
        SelectObject(bmpDC, bmpHWND)
        Font.Owner=bmpHWND: _Empty=False
    END IF
END PROPERTY
PROPERTY QBITMAP.Empty() AS integer: RETURN _Empty: END PROPERTY
PROPERTY QBITMAP.Empty(value AS integer): END PROPERTY                  ' Read only
PROPERTY QBITMAP.Handle() AS HDC: RETURN _Handle: END PROPERTY
PROPERTY QBITMAP.Handle(value AS HDC): END PROPERTY                     ' Read only
PROPERTY QBITMAP.Height() AS integer: RETURN _Height: END PROPERTY
PROPERTY QBITMAP.Height(value AS integer)
    IF value>0 THEN: _Height=value: SetBitmapDC(): END IF
END PROPERTY
PROPERTY QBITMAP.Width() AS integer: RETURN _Width: END PROPERTY
PROPERTY QBITMAP.Width(value AS integer)
    IF value>0 THEN: _Width=value: SetBitmapDC(): END IF
END PROPERTY
PROPERTY QBITMAP.Monochrome() AS integer: RETURN _Monochrome: END PROPERTY
PROPERTY QBITMAP.Monochrome(value AS integer): _Monochrome=value: END PROPERTY

SUB QBITMAP.Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    rqCircle(bmpDC, x1, y1, x2, y2, c, fill)
END SUB
SUB QBITMAP.CopyRect(D AS RECT PTR, Image AS HWND, S AS RECT PTR)
    rqCopyRect(bmpDC, D, Image, S)
END SUB
SUB QBITMAP.CopyRect(D AS RECT PTR, Image AS HDC, S AS RECT PTR)
    rqCopyRect(bmpDC, D, Image, S)
END SUB
SUB QBITMAP.Draw(x AS integer, y AS integer, FileName AS string)
    rqDraw(bmpDC, x, y, FileName)
END SUB
SUB QBITMAP.FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    rqFillRect(bmpDC, x1, y1, x2, y2, c)
END SUB
SUB QBITMAP.Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    rqLine(bmpDC, x1, y1, x2, y2, c)
END SUB
SUB QBITMAP.Paint(x AS integer, y AS integer, c AS integer, borderc AS integer)
    rqPaint(bmpDC, x, y, c, borderc)
END SUB
SUB QBITMAP.Pset(x AS integer, y AS integer, c AS integer)
    rqSetPixel(bmpDC, x, y, c)
END SUB
FUNCTION QBITMAP.Pixel(x AS integer, y AS integer) AS integer
    RETURN rqGetPixel(bmpDC, x, y)
END FUNCTION
SUB QBITMAP.Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    rqRectangle(bmpDC, x1, y1, x2, y2, c)
END SUB
SUB QBITMAP.RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    rqRoundRect(bmpDC, x1, y1, x2, y2, x3, y3, c)
END SUB
SUB QBITMAP.StretchDraw(lpRect AS RECT PTR, FileName AS string)
DIM AS integer W, H
    W=lpRect->Right-lpRect->Left: H=lpRect->Bottom-lpRect->Top
    IF (W<>_Width) OR (H<>_Height) THEN
        _Width=W: _Height=H: SetBitmapDC()
    END IF
    rqStretchDraw(bmpDC, lpRect, FileName)
END SUB

FUNCTION QBITMAP.TxtHeight(Txt AS string) AS integer
DIM AS SIZE siz
    SelectObject(bmpDC, Font.Handle)
    GetTextExtentPoint32(bmpDC, Txt, LEN(Txt), @siz)
    RETURN siz.cy
END FUNCTION
FUNCTION QBITMAP.TxtWidth(Txt AS string) AS integer
DIM AS SIZE siz
    SelectObject(bmpDC, Font.Handle)
    GetTextExtentPoint32(bmpDC, Txt, LEN(Txt), @siz)
    RETURN siz.cx
END FUNCTION
SUB QBITMAP.TxtOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
DIM AS integer lenth=LEN(S)
DIM AS HGDIOBJ Original
DIM AS SIZE siz

    IF lenth=0 THEN EXIT SUB
    IF (x<0) OR (x>Width) THEN EXIT SUB
    IF (y<0) OR (y>Height) THEN EXIT SUB
    Original=SelectObject(bmpDC, GetStockObject(DC_BRUSH))          ' Save copy of original
    SelectObject(bmpDC, Font.Handle)
    DO
        GetTextExtentPoint32(bmpDC, S, lenth, @siz)
        IF siz.cx <= (Width-x) THEN EXIT DO
        lenth -= 1
    LOOP UNTIL lenth=0
    IF lenth THEN
        IF bc <> -1 THEN
            SetBkColor(bmpDC, CAST(COLORREF, bc))
        ELSE
            SetBKmode(bmpDC, 1)                                         ' else Transparent
        END IF
        SetTextColor(bmpDC, CAST(COLORREF, fc))
        TextOut(bmpDC, x, y, S, lenth)
    END IF
    SelectObject(bmpDC, Original)
END SUB
SUB QBITMAP.TxtRect(lpRect AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
DIM AS integer W, H, lenth=LEN(S)
DIM AS HGDIOBJ Original
DIM AS SIZE siz

    IF lenth=0 THEN EXIT SUB
    IF (x>0) AND ((lpRect->Left+x)>lpRect->Right) THEN EXIT SUB
    IF (y>0) AND ((lpRect->Top+y)>lpRect->Bottom) THEN EXIT SUB

    Original=SelectObject(bmpDC, GetStockObject(DC_BRUSH))              ' Save copy of original
    SelectObject(bmpDC, Font.Handle)
    W=lpRect->Right - lpRect->Left: H=lpRect->Bottom - lpRect->Top
    IF x >= 0 THEN W -= x                                               ' Not centered but valid offset?
    DO
        GetTextExtentPoint32(bmpDC, S, lenth, @siz)                     ' Font selected above!
        IF siz.cx <= W THEN EXIT DO
        lenth -= 1
    LOOP UNTIL lenth=0
    IF lenth THEN
        IF x = -1 THEN x=(W-siz.cx)\2
        IF y = -1 THEN y=(H-siz.cy)\2                                   ' Vertical - FB only center text
        IF (y>=0) AND ((lpRect->Top+y)<lpRect->Bottom) THEN
            x=lpRect->Left+x
            y=lpRect->Top+y
            IF bc <> -1 THEN                                            ' Colored background....
                SetBkColor(bmpDC, CAST(COLORREF, bc))
                rqFillRect(bmpDC, lpRect->Left, lpRect->Top, lpRect->Right, lpRect->Bottom, bc)
            ELSE
                SetBKmode(bmpDC, 1)                                     ' ... or Transparent
            END IF
            SetTextColor(bmpDC, CAST(COLORREF, fc))
            TextOut(bmpDC, x, y, S, lenth)
        END IF
    END IF
    SelectObject(bmpDC, Original)
END SUB

SUB QBITMAP.LoadFromFile(FileName AS string)
DIM AS UINT BmpFlags=LR_LOADFROMFILE
    IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT SUB
    IF Monochrome THEN BmpFlags OR= LR_MONOCHROME
    IF Transparent THEN BmpFlags OR= LR_LOADTRANSPARENT
    IF bmpHWND THEN DeleteObject(bmpHWND)
    _Width=0: _Height=0: _Empty=True
    bmpHWND=LoadImage(NULL, FileName, IMAGE_BITMAP, 0, 0, BmpFlags)
    IF bmpHWND THEN
        GetObject(bmpHWND, SIZEOF(_BitMap), @_BitMap)               ' Get INFO of this BMP
        _Width=_BitMap.bmwidth: _Height=_BitMap.bmHeight
        SelectObject(bmpDC, bmpHWND)
        Font.Owner=bmpHWND: _Empty=False: _BMP=FileName
    END IF
END SUB
SUB QBITMAP.SaveToFile(FileName AS string)
    rqBMPToFile(bmpDC, _Width, _Height, FileName)
END SUB

SUB QBITMAP.SetBitmapDC()
DIM AS HDC scrnDC
    IF bmpHWND THEN
        ReleaseDC(bmpHWND, bmpDC)
        DeleteObject(bmpHWND)
    END IF
    scrnDC=GetDC(NULL)
    bmpDC=CreateCompatibleDC(scrnDC)                            ' Create a DC in memory
    _Handle=bmpDC                                               ' QBITMAP fudge!!
    bmpHWND=CAST(HWND, CreateCompatibleBitmap(scrnDC, _Width, _Height))
    Font.Owner=CAST(HWND,bmpDC)
    SelectObject(bmpDC, bmpHWND)                                ' Set dimensions to the bmp
    ReleaseDC(NULL, scrnDC)
END SUB
CONSTRUCTOR QBITMAP
    SetBitmapDC()
    Application.ObjInfo(ObjIndex).Handle=bmpHWND
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=bmpHWND: Font.IsBitmap=1: InitialiseFont(@Font)
END CONSTRUCTOR
DESTRUCTOR QBITMAP
    DeleteDC(bmpDC): DeleteObject(bmpHWND)
END DESTRUCTOR


' #31 ====================================================================================
TYPE QIMAGELIST
' Private (not)
    ObjId AS integer        = Q_IMAGELIST           ' Component ID
    ObjIndex AS integer     = 0                     ' Unique number per object
    ObjClass AS string*32   = ""                    ' Base class
    ObjStyle AS UINT        = 0                     '

    _BkColor AS UINT        = clNone                ' Transparent
    _Count AS integer       = 64
    _Handle AS HIMAGELIST   = 0
    _Height AS integer      = 1
    _Width AS integer       = 1
    _Masked AS integer      = True

#IF 0
    BlendColor AS UINT              ' |INTEGER|RW|<default>|<default>|<choose>
    DrawingStyle AS integer         ' |INTEGER|RW|dsNormal|dsFocused|dsSelected|dsNormal|dsTransparent
    GetBMP AS integer               ' |ARRAY of IMAGES/BMP|R|
    GetICO AS integer               ' |ARRAY of IMAGES/ICO|R|
    ImageType AS integer = itImage  ' |INTEGER|RW|itImage|itImage|itMask
#ENDIF

' Properties
    DECLARE PROPERTY BkColor() AS UINT
    DECLARE PROPERTY BkColor(value AS UINT)
    DECLARE PROPERTY Count() AS integer
    DECLARE PROPERTY Count(value AS integer)
    DECLARE PROPERTY Handle() AS HIMAGELIST
    DECLARE PROPERTY Handle(value AS HIMAGELIST)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Masked() AS integer
    DECLARE PROPERTY Masked(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB AddBMPFile OVERLOAD (FileName AS string, ImgCount AS integer)
    DECLARE SUB AddBMPFile OVERLOAD (FileName AS string, MaskColor AS UINT)
    DECLARE SUB AddBMPFile OVERLOAD (FileName AS string, ImgCount AS integer, MaskColor AS UINT)
    DECLARE SUB AddBMPHandle OVERLOAD (BMP_Resource AS integer, MaskColor AS UINT)
    DECLARE SUB AddBMPHandle OVERLOAD (BMP_Resource AS integer, ImgCount AS integer, MaskColor AS UINT)
    DECLARE SUB AddICOFile(FileName AS string)
    DECLARE SUB AddICOHandle(ICO_Resource AS integer)
    DECLARE SUB Clear()
    DECLARE SUB Delete(Index AS integer)
    DECLARE SUB Draw(Target AS HWND, X AS integer, Y AS integer, Index AS integer)
#IF 0
    DECLARE SUB InsertBMPFile(Index AS integer, Filename AS string, Mask AS integer)
    DECLARE SUB InsertICOFile(Index AS integer, Filename AS string)
    DECLARE SUB InsertBMPHandle(Index AS integer, BMP_Resource AS integer, Mask AS integer)
    DECLARE SUB InsertICOHandle
#ENDIF
' Extras
    DECLARE SUB AddBMPImage(Handle AS HBITMAP)
    DECLARE FUNCTION GetBMP(Index AS integer) AS HBITMAP
    DECLARE CONSTRUCTOR
    DECLARE DESTRUCTOR
' Events
END TYPE

PROPERTY QIMAGELIST.BkColor() AS UINT: RETURN _BkColor: END PROPERTY
PROPERTY QIMAGELIST.BkColor(value AS UINT)
IF value=clNone THEN
    _BkColor=value: ImageList_SetBkColor(Handle,CLR_NONE)                           ' Draw transparently
ELSE
    _BkColor=clDefault: ImageList_SetBkColor(Handle,CLR_DEFAULT)
END IF
END PROPERTY
PROPERTY QIMAGELIST.Count() AS integer: _Count=ImageList_GetImageCount(Handle): RETURN _Count: END PROPERTY
PROPERTY QIMAGELIST.Count(value AS integer): _Count=value: ImageList_SetImageCount(Handle, value): END PROPERTY
PROPERTY QIMAGELIST.Handle() AS HIMAGELIST: RETURN _Handle: END PROPERTY
PROPERTY QIMAGELIST.Handle(value AS HIMAGELIST): END PROPERTY                       ' Read only
PROPERTY QIMAGELIST.Height() AS integer: RETURN _Height: END PROPERTY
PROPERTY QIMAGELIST.Height(value AS integer): _Height=value: ImageList_SetIconSize(Handle, Width, value): END PROPERTY
PROPERTY QIMAGELIST.Masked() AS integer: RETURN _Masked: END PROPERTY
PROPERTY QIMAGELIST.Masked(value AS integer): IF value=0 THEN _Masked=0 ELSE _Masked=True: END IF: END PROPERTY
PROPERTY QIMAGELIST.Width() AS integer: RETURN _Width: END PROPERTY
PROPERTY QIMAGELIST.Width(value AS integer): _Width=value: ImageList_SetIconSize(Handle, value, Height): END PROPERTY

SUB QIMAGELIST.AddBMPFile OVERLOAD (FileName AS string, ImgCount AS integer, MaskColor AS UINT)
DIM AS HBITMAP hBmp

    IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT SUB
    IF (Width=1) AND (Height=1) THEN
        DIM AS QBITMAP bmap
        bmap.BMP=FileName: Width=bmap.Width\ImgCount: Height=bmap.Height
    END IF
    hBmp=LoadImage(NULL, FileName, IMAGE_BITMAP, ImgCount*Width, Height, LR_LOADFROMFILE)    ' From file: Set entire image width
    IF hBmp THEN
        IF Masked THEN
            ImageList_AddMasked(Handle, hBmp, CAST(COLORREF,MaskColor))             ' Load bitmap with mask color
        ELSE
            ImageList_Add(Handle, hBmp, NULL)                                       ' No mask - no transparency
        END IF
        DeleteObject(hBmp)                                                          ' Clean up
    END IF
END SUB
SUB QIMAGELIST.AddBMPFile OVERLOAD (FileName AS string, MaskColor AS UINT)          ' ONLY one image in the bitmap
    AddBMPFile(FileName, 1, MaskColor)
END SUB
SUB QIMAGELIST.AddBMPFile OVERLOAD (FileName AS string, ImgCount AS integer)        ' Determine the mask color
    IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT SUB
    DIM AS QBITMAP bmap
    bmap.BMP=FileName
    AddBMPFile(FileName, ImgCount, bmap.Pixel(0,0))
END SUB
SUB QIMAGELIST.AddBMPHandle OVERLOAD (BMP_Resource AS integer, ImgCount AS integer, MaskColor AS UINT)
DIM AS HBITMAP hBmp
DIM AS string idStr="#"+STR(BMP_Resource)
    hBmp=LoadImage(Application.hInstance, idStr, IMAGE_BITMAP, ImgCount*Width, Height, 0)   ' From resource: Set entire image width
    IF hBmp THEN
        IF Masked THEN
            ImageList_AddMasked(Handle, hBmp, CAST(COLORREF,MaskColor))             ' Load bitmap with mask color
        ELSE
            ImageList_Add(Handle, hBmp, NULL)                                       ' No mask - no transparency
        END IF
        DeleteObject(hBmp)                                                          ' Clean up
    END IF
END SUB
SUB QIMAGELIST.AddBMPHandle OVERLOAD (BMP_Resource AS integer, MaskColor AS UINT)   ' ONLY one bitmap image
    AddBMPHandle(BMP_Resource, 1, MaskColor)
END SUB
SUB QIMAGELIST.AddICOFile(FileName AS string)
DIM AS HICON hIco
    IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT SUB
    hIco=LoadImage(NULL, FileName, IMAGE_ICON, Width, Height, LR_LOADFROMFILE)
    ImageList_ReplaceIcon(Handle, -1, hIco)
    DeleteObject(hIco)
END SUB
SUB QIMAGELIST.AddICOHandle(ICO_Resource AS integer)
DIM AS HICON hIco
DIM AS string idStr="#" & ICO_Resource
    hIco=LoadImage(Application.hInstance, idStr, IMAGE_ICON, Width, Height, 0)
    ImageList_ReplaceIcon(Handle, -1, hIco)                                         ' Add each ico to list
    DeleteObject(hIco)                                                              ' Clean up
END SUB
SUB QIMAGELIST.Clear()
    ImageList_Remove(Handle, -1)                                                    ' Index = -1 remove all images
END SUB
SUB QIMAGELIST.Delete(Index AS integer)
    IF (Index>=0) AND (Index<Count) THEN: ImageList_Remove(Handle, Index): END IF
END SUB
SUB QIMAGELIST.Draw(Target AS HWND, X AS integer, Y AS integer, Index AS integer)
DIM AS HDC hDC=GetDC(Target)
DIM AS UINT fMask
    IF bkColor=clNone THEN: fMask=ILD_TRANSPARENT: ELSE: fMask=ILD_IMAGE: END IF
    ImageList_Draw(Handle, Index, hDC, X, Y, fMask)
    ReleaseDC(Target, hDC)
END SUB
FUNCTION QIMAGELIST.GetBMP(Index AS integer) AS HBITMAP
RETURN CAST(HBITMAP,0)
END FUNCTION

SUB QIMAGELIST.AddBMPImage(hBitmap AS HBITMAP)
    ImageList_Add(Handle, hBitmap, NULL)
END SUB
CONSTRUCTOR QIMAGELIST
    IF Masked THEN
        _Handle=ImageList_Create(Width, Height, (ILC_COLOR32 OR ILC_MASK), Count, Count*2)
        BkColor=clNone
    ELSE
        _Handle=ImageList_Create(Width, Height, ILC_COLOR32, Count, Count*2)
        BkColor=clDefault
    END IF
END CONSTRUCTOR
DESTRUCTOR QIMAGELIST
' Do NOT Clear() as this stuffs up imagelists used inside subs/functions
' They get destroyed when sub/function returns!
'    Clear()                                            ' NO!
END DESTRUCTOR


' #32 ====================================================================================
TYPE QSTRINGLIST
' Private (not)
    ObjId AS integer        = Q_STRINGLIST              ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*32   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    _StringList AS string   = ""
    _Duplicates AS integer  = dupIgnore
    _Item AS string         = ""
    _ItemCount AS integer   = 0
    _Sorted AS integer      = False
#IF 0
    Text AS string                              ' |STRING|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Duplicates() AS integer
    DECLARE PROPERTY Duplicates(value AS integer)
    DECLARE PROPERTY Item(value AS integer) AS string
    DECLARE PROPERTY Item(value AS integer, nStr AS string)
    DECLARE PROPERTY ItemCount() AS integer
    DECLARE PROPERTY ItemCount(value AS integer)
    DECLARE PROPERTY Sorted() AS integer
    DECLARE PROPERTY Sorted(value AS integer)
' Methods
    DECLARE SUB AddItems(NewString AS string)                   ' FUDGE: Only one at a time
    DECLARE SUB AddList(List AS QSTRINGLIST)
    DECLARE FUNCTION Build(Start AS integer, End AS integer, Delim AS string) AS string
    DECLARE SUB Clear()
    DECLARE SUB DelItems(Index AS integer)                      ' FUDGE: Only one at a time
    DECLARE SUB Exchange(Index1 AS integer, Index2 AS integer)
    DECLARE FUNCTION IndexOf(FindString AS string) AS integer
    DECLARE SUB InsertItem(Index AS integer, NewString AS string)
    DECLARE SUB LoadFromFile(FileName AS string)
    DECLARE FUNCTION Parse(Source AS string, Delim AS string) AS long
    DECLARE SUB SaveToFile(FileName AS string)
    DECLARE SUB Sort()
    DECLARE DESTRUCTOR
#IF 0
    DECLARE SUB LoadFromStream(Stream AS QMEMORYSTREAM)
    DECLARE SUB SaveToStream(Stream AS QMEMORYSTREAM)
#ENDIF
' Events
END TYPE

PROPERTY QSTRINGLIST.Duplicates() AS integer: RETURN _Duplicates: END PROPERTY
PROPERTY QSTRINGLIST.Duplicates(value AS integer): _Duplicates=value: END PROPERTY
PROPERTY QSTRINGLIST.ItemCount() AS integer
IF _StringList="" THEN RETURN 0
_ItemCount=rqTALLY(_StringList,CHR(10))+1
RETURN _ItemCount
END PROPERTY
PROPERTY QSTRINGLIST.ItemCount(value AS integer): END PROPERTY              ' Read Only
PROPERTY QSTRINGLIST.Item(value AS integer) AS string
RETURN rqFIELDSTR(_StringList,CHR(10),value+1)                              ' 0 based!!
END PROPERTY
PROPERTY QSTRINGLIST.Item(value AS integer, nStr AS string): END PROPERTY   ' Read Only
PROPERTY QSTRINGLIST.Sorted() AS integer: RETURN _Sorted: END PROPERTY
PROPERTY QSTRINGLIST.Sorted(value AS integer): IF value=0 THEN _Sorted=False ELSE _Sorted=True: END IF: END PROPERTY

' Check Duplicates & Sorted when adding strings
SUB QSTRINGLIST.AddItems(NewString AS string)                               ' One string at a time
DIM AS string tok, tstr, srch
DIM AS integer i, j
    tok=rqFIELDSTR(NewString,CHR(10),1)                                     ' Truncate IF '\n' in string
    tok=rqREPLACESUBSTR(tok,CHR(13),"")                                     ' Remove '\r' chars
    IF tok="" THEN
        IF Duplicates=dupAccept THEN _StringList=_StringList & CHR(10)
    ELSE
        IF ItemCount=0 THEN
            _StringList=tok
        ELSE
            tstr=CHR(10) & _StringList & CHR(10)                            ' Used to look for duplicates
            srch=CHR(10) & tok & CHR(10)                                    ' Duplicate search string
            IF (INSTR(tstr,srch)=0) OR (Duplicates=dupAccept) THEN          ' Include this string?
                IF Sorted THEN
                    FOR i=1 TO ItemCount
                        tstr=rqFIELDSTR(_StringList,CHR(10),i)
                        IF tok < tstr THEN EXIT FOR
                    NEXT
                    IF i=1 THEN
                        _StringList=tok & CHR(10) & _StringList
                    ELSE
                        i -= 1: tstr=""
                        FOR j=1 TO i
                            tstr=tstr & rqFIELDSTR(_StringList,CHR(10),j) & CHR(10)
                        NEXT j
                        tstr=tstr & tok & CHR(10)
                        FOR j=j TO ItemCount
                            tstr=tstr & rqFIELDSTR(_StringList,CHR(10),j) & CHR(10)
                        NEXT j
                        _StringList=LEFT(tstr, LEN(tstr)-1)                 ' Remove trailing '\n'
                    END IF
                ELSE
                    _StringList=_StringList & CHR(10) & tok
                END IF
            END IF
        END IF
    END IF
END SUB
SUB QSTRINGLIST.AddList(List AS QSTRINGLIST)
    IF List.ItemCount>0 THEN
        DIM AS string tok
        FOR i AS integer = 0 TO List.ItemCount-1
            tok=List.Item(i): THIS.AddItems(tok)
        NEXT i
    END IF
END SUB
FUNCTION QSTRINGLIST.Build(qStart AS integer, qEnd AS integer, Delim AS string) AS string
    IF (qStart<0) OR (qEnd<0) OR (qStart>=ItemCount) OR (qEnd>=ItemCount) THEN: RETURN "": END IF
    IF qStart>qEnd THEN Swap qStart, qEnd
    DIM AS string tstr=""
    FOR i AS integer = qStart TO qEnd
        tstr=tstr+rqFIELDSTR(_StringList,CHR(10),i+1)+Delim
    NEXT i
    tstr=MID(tstr,1,LEN(tstr)-LEN(Delim))
    RETURN tstr
END FUNCTION
SUB QSTRINGLIST.Clear()
    _StringList=""
END SUB
SUB QSTRINGLIST.DelItems(Index AS integer)
    IF Index < ItemCount THEN
        DIM AS string tstr=""
        FOR i AS integer = 0 TO ItemCount-1
            IF i <> Index THEN tstr=tstr & rqFIELDSTR(_StringList,CHR(10),i+1) & CHR(10)
        NEXT
        _StringList=LEFT(tstr,LEN(tstr)-1)
    END IF
END SUB
SUB QSTRINGLIST.Exchange(Index1 AS integer, Index2 AS integer)
    IF (Index1<0) OR (Index2<0) OR (Index1>=ItemCount) OR (Index2>=ItemCount) THEN EXIT SUB
    IF Index1=Index2 THEN EXIT SUB
    DIM AS string tstr="", tok1, tok2
    Index1 += 1: Index2 += 1
    tok1=rqFIELDSTR(_StringList,CHR(10),Index1)
    tok2=rqFIELDSTR(_StringList,CHR(10),Index2)
    FOR i AS integer = 1 TO ItemCount
        SELECT CASE i
            CASE Index1: tstr=tstr+tok2+CHR(10)
            CASE Index2: tstr=tstr+tok1+CHR(10)
            CASE ELSE
                tstr=tstr+rqFIELDSTR(_StringList,CHR(10),i)+CHR(10)
        END SELECT
    NEXT i
    _StringList=tstr
END SUB
FUNCTION QSTRINGLIST.IndexOf(FindString AS string) AS integer
    FOR i AS integer = 0 TO ItemCount-1
        IF FindString=rqFIELDSTR(_StringList,CHR(10),i+1) THEN
            RETURN i
        END IF
    NEXT i
    RETURN -1
END FUNCTION
SUB QSTRINGLIST.LoadFromFile(FileName AS string)
    IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT SUB
    DIM AS integer FileNum=FreeFile
    DIM AS string tstr
    OPEN FileName FOR INPUT AS #FileNum
    DO UNTIL EOF(FileNum)
        LINE INPUT #FileNum, tstr
        THIS.AddItems(tstr)
    LOOP
    CLOSE #FileNum
END SUB
FUNCTION QSTRINGLIST.Parse(Source AS string, Delim AS string) AS long
IF Source="" THEN RETURN 0
DIM AS integer OrigCount=THIS.ItemCount
DIM AS integer TokCount=rqTALLY(Source,Delim)+1
DIM AS string tok
FOR i AS integer=1 TO TokCount
    tok=rqFieldSTR(Source,Delim,i)
    THIS.AddItems(tok)                                  ' Depends on Duplicates if added
NEXT i
RETURN (THIS.ItemCount-OrigCount)
END FUNCTION
SUB QSTRINGLIST.SaveToFile(FileName AS string)
DIM AS integer FileNum=FreeFile
    OPEN FileName FOR OUTPUT AS #FileNum
    FOR i AS integer = 1 TO ItemCount
        PRINT #FileNum, rqFIELDSTR(_StringList,CHR(10),i)
    NEXT
    CLOSE #FileNum
END SUB
SUB QSTRINGLIST.Sort()
    IF ItemCount>1 THEN
        DIM AS string tok
        DIM AS QSTRINGLIST tmpList
        tmpList.Sorted=True: tmpList.Duplicates=Duplicates              ' Duplicates same as original list
        FOR i AS integer = 1 TO ItemCount
            tok=rqFIELDSTR(_StringList,CHR(10),i)
            tmpList.AddItems(tok)
        NEXT i
        THIS.Clear
        THIS.AddList(tmpList)
        tmpList.Clear
    END IF
END SUB
SUB QSTRINGLIST.InsertItem(Index AS integer, NewString AS string)
    IF Index<ItemCount THEN
        DIM AS integer j=Index+1
        DIM AS string tstr
        DIM AS QStringList Li
        Li.Clear: Li.Duplicates=Duplicates
        IF Index=0 THEN
            Li.AddItems(NewString)
        ELSE
            FOR i AS integer = 0 TO Index-1: tstr=Item(i): Li.AddItems(tstr): Next i
            Li.AddItems(NewString)
        END IF
        FOR i AS integer = Index TO ItemCount-1: tstr=Item(i): Li.AddItems(tstr): Next i
        THIS.Clear: THIS.AddList(Li): Li.Clear
    END IF
END SUB
DESTRUCTOR QSTRINGLIST
    Clear()
END DESTRUCTOR

' #0 =====================================================================================
TYPE QFORM
    ObjId AS integer        = 0                             ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "RQClass"                     ' Base class
    ObjStyle AS UINT        = 0                             '
    Font AS QFONT

    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 320
    _Height AS integer      = 240

    _BorderStyle AS integer = bsSizeable                    ' Standard borders & resizable
    _Caption AS string      = ""
    _ClientHeight AS integer
    _ClientWidth AS integer
    _Color AS integer       = FORM_COLOR
    _Cursor AS integer      = crDefault
    _Enabled AS integer     = True
    _Handle AS HWND
    _Hint AS string         = ""
    _IcoHandle AS integer
    _Icon AS string         = ""
    _Init AS integer        = 0
    _Parent AS HWND
    _ShowHint AS integer    = False
    _Visible AS integer     = False
    _WindowState AS integer = wsNormal

    OldWndProc AS WNDPROC   = 0
    NewWndProc AS WNDPROC   = 0
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu
    FormStyle AS integer    = 0                             ' fsNormal ONLY
    AutoScroll AS integer   = True                          ' True
    hWndIcon AS HWND
#IF 0
    KeyPreview AS integer           ' |INTEGER|RW|False|False|True
    ModalResult AS integer          ' |INTEGER|W|mrNone|mrNone|mrOK|mrCancel|mrAbort|mrRet...
#ENDIF

' Properties
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY ClientHeight() AS integer
    DECLARE PROPERTY ClientHeight(value AS integer)
    DECLARE PROPERTY ClientWidth() AS integer
    DECLARE PROPERTY ClientWidth(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Cursor() AS integer
    DECLARE PROPERTY Cursor(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY IcoHandle() AS integer
    DECLARE PROPERTY IcoHandle(value AS integer)
    DECLARE PROPERTY Icon() AS string
    DECLARE PROPERTY Icon(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
    DECLARE PROPERTY WindowState() AS integer
    DECLARE PROPERTY WindowState(value AS integer)

' Methods
    DECLARE SUB AddBorderIcons(bIcon AS integer)
    DECLARE SUB Center()
    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB Close()
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HWND, S AS RECT PTR)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HDC, S AS RECT PTR)
    DECLARE SUB DelBorderIcons(bIcon AS integer)
    DECLARE SUB Draw(x AS integer, y AS integer, FileName AS string)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB HideTitleBar()
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Paint(x AS integer, y AS integer, c AS integer, border AS integer)
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Repaint()
    DECLARE SUB Rotate(xOrigin AS integer, yOrigin AS integer, Angle AS integer)
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    DECLARE SUB ShapeForm(Filename AS string, TransparentColor AS integer)
    DECLARE SUB Show()
    DECLARE FUNCTION ShowModal() AS integer
    DECLARE SUB ShowTitleBar()
    DECLARE SUB StretchDraw(lpRect AS RECT PTR, FileName AS string)
    DECLARE FUNCTION TextHeight(Text AS string) AS integer
    DECLARE FUNCTION TextWidth(Text AS string) AS integer
    DECLARE SUB TextRect(lpRect AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
' Extras
    DECLARE FUNCTION Pixel(x AS integer, y AS integer) AS integer
    DECLARE FUNCTION SaveToBMP(FileName AS string) AS integer
    DECLARE SUB FormReSize()
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnClick AS SUB(Sender AS QFORM PTR)
    OnClose AS SUB(BYREF Action AS integer, Sender AS QFORM PTR)
    OnHint AS SUB(Hint AS string, Sender AS QFORM PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QFORM PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QFORM PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QFORM PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QFORM PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QFORM PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QFORM PTR)
    OnPaint AS SUB(Sender AS QFORM PTR)
    OnPopup AS SUB (Index AS integer, Sender AS QFORM PTR)          ' Event handler for popup menu (FB only)
    OnResize AS SUB(Sender AS QFORM PTR)
    OnShow AS SUB(Sender AS QFORM PTR)
END TYPE

DoPositionalProperties(QFORM)
DoCapProperties(QFORM)
DoHintProperties(QFORM)
DoReadOnlyProperties(QFORM)

PROPERTY QFORM.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QFORM.BorderStyle(value AS integer)
    IF (value < bsNone) OR (value > bsSizeToolWin) THEN EXIT PROPERTY
    _BorderStyle=value
END PROPERTY
PROPERTY QFORM.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QFORM.Color(value AS integer): _Color=value: END PROPERTY
PROPERTY QFORM.ClientHeight() AS integer
DIM AS RECT rct
    GetClientRect(Handle, @rct): _ClientHeight=rct.Bottom-rct.Top
    RETURN _ClientHeight
END PROPERTY
PROPERTY QFORM.ClientHeight(value AS integer): END PROPERTY                 ' Read Only
PROPERTY QFORM.ClientWidth() AS integer
DIM AS RECT rct
    GetClientRect(Handle, @rct): _ClientWidth=rct.Right-rct.Left
    RETURN _ClientWidth
END PROPERTY
PROPERTY QFORM.ClientWidth(value AS integer): END PROPERTY                  ' Read Only
PROPERTY QFORM.Enabled() AS integer: RETURN _Enabled: END PROPERTY
PROPERTY QFORM.Enabled(value AS integer)
    IF value<>_Enabled THEN
        IF value=0 THEN _Enabled=0 ELSE _Enabled=1
        EnableWindow(Handle, value)
        SetWindowPos(Handle, 0, Left, Top, 0, 0, SWP_NOSIZE OR SWP_NOZORDER)
    END IF
END PROPERTY
PROPERTY QFORM.Cursor() AS integer: RETURN _Cursor: END PROPERTY
PROPERTY QFORM.Cursor(value AS integer)
    _Cursor=value: IF hCursor=0 THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(value)) 
END PROPERTY
PROPERTY QFORM.IcoHandle() AS integer: RETURN 0: END PROPERTY
PROPERTY QFORM.IcoHandle(value AS integer)
    IF value>0 THEN
        _IcoHandle=value
        IF Handle THEN
            IF hWndIcon THEN DeleteObject(hWndIcon)
            DIM AS string tstr="#" & value
            hWndIcon=LoadImage(Application.hInstance,tstr,IMAGE_ICON,16,16,0)
            SendMessage(Handle,WM_SETICON,ICON_SMALL,CAST(LPARAM,hWndIcon))
        END IF
    END IF
END PROPERTY
PROPERTY QFORM.Icon() AS string: RETURN "": END PROPERTY
PROPERTY QFORM.Icon(value AS string)
    IF FileExists(value) THEN
        _Icon=value
        IF Handle THEN
            IF hWndIcon THEN DeleteObject(hWndIcon)
            hWndIcon=LoadImage(NULL,value,IMAGE_ICON,16,16,LR_LOADFROMFILE)
            SendMessage(Handle,WM_SETICON,ICON_SMALL,CAST(LPARAM,hWndIcon))
        END IF
    END IF
END PROPERTY
PROPERTY QFORM.Visible() AS integer: RETURN _Visible: END PROPERTY
PROPERTY QFORM.Visible(value AS integer)
    _Visible=value: IF value=False THEN ShowWindow(Handle, SW_HIDE) ELSE ShowWindow(Handle, SW_SHOW): END IF
END PROPERTY
PROPERTY QFORM.WindowState() AS integer: RETURN _WindowState: END PROPERTY
PROPERTY QFORM.WindowState(value AS integer)
    IF (value < wsNormal) OR (value > wsMaximized) OR (value = _WindowState) THEN EXIT PROPERTY
    _WindowState=value
    IF (Handle > 0) AND (Visible = True) THEN
        SELECT CASE value
            CASE wsNormal   : ShowWindow(Handle,SW_SHOWNORMAL)
            CASE wsMinimized: ShowWindow(Handle, SW_MINIMIZE)
            CASE wsMaximized: ShowWindow(Handle,SW_MAXIMIZE)
        END SELECT
    END IF
END PROPERTY

FUNCTION QFORM.ShowModal() AS integer
DIM AS MSG wMsg
    Visible=True: ShowWindow(Handle, SW_SHOWNORMAL)
    WHILE GetMessage(@wMsg, NULL, 0, 0) <> False                        ' Hang around awhile!
        TranslateMessage(@wMsg)
        DispatchMessage(@wMsg)
    WEND
    RETURN wMsg.wParam
END FUNCTION
SUB QFORM.Show()
    Visible=True: ShowWindow(Handle, SW_SHOWNORMAL): DoEvents           ' Then return!
END SUB
SUB QFORM.Close()
    PostMessage(Handle,WM_CLOSE,0,0)
END SUB
SUB QFORM.AddBorderIcons(bIcon AS integer)
    SELECT CASE bIcon
        CASE biSystemMenu
            SetWindowLong(Handle,GWL_STYLE,(GetWindowLong(Handle,GWL_STYLE) OR WS_SYSMENU))
        CASE biHelp
            SetWindowLong(Handle,GWL_EXSTYLE,(GetWindowLong(Handle,GWL_EXSTYLE) OR WS_EX_CONTEXTHELP))
        CASE biMinimize
            SetWindowLong(Handle,GWL_STYLE,(GetWindowLong(Handle,GWL_STYLE) OR WS_MINIMIZEBOX))
        CASE biMaximize
            SetWindowLong(Handle,GWL_STYLE,(GetWindowLong(Handle,GWL_STYLE) OR WS_MAXIMIZEBOX))
        CASE ELSE
            EXIT SUB
    END SELECT
    SetWindowPos(Handle,0,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOZORDER OR SWP_FRAMECHANGED)
END SUB
SUB QFORM.DelBorderIcons(bIcon AS integer)
    SELECT CASE bIcon
        CASE biSystemMenu
            SetWindowLong(Handle,GWL_STYLE,(GetWindowLong(Handle,GWL_STYLE) AND NOT(WS_SYSMENU)))
        CASE biHelp
            SetWindowLong(Handle,GWL_EXSTYLE,(GetWindowLong(Handle,GWL_EXSTYLE) AND NOT(WS_EX_CONTEXTHELP)))
        CASE biMinimize
            SetWindowLong(Handle,GWL_STYLE,(GetWindowLong(Handle,GWL_STYLE) AND NOT(WS_MINIMIZEBOX)))
        CASE biMaximize
            SetWindowLong(Handle,GWL_STYLE,(GetWindowLong(Handle,GWL_STYLE) AND NOT(WS_MAXIMIZEBOX)))
        CASE ELSE
            EXIT SUB
    END SELECT
    SetWindowPos(Handle,0,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOZORDER OR SWP_FRAMECHANGED)
END SUB
' FUDGE: Bug with center() - upsets size of form when the form has a menu. Believe
' it is between Resize code in wndProc & AddMenu() code & "simple" centering code
' This "complex" centering code gives identical output with two forms (one with menu)
SUB QFORM.Center()
DIM AS integer W=Width, H=Height, X=0, Y=0
    IF GetMenu(Handle) THEN X=8: Y=46                               ' Offsets if a menu is valid
    Left=(Screen.Width-Width-X)\2: Top=(Screen.Height-Height)\2-Y
    SetWindowPos(Handle,0,0,0,W+X,H+Y,SWP_NOMOVE OR SWP_NOZORDER OR SWP_FRAMECHANGED)
END SUB
SUB QFORM.HideTitleBar()
DIM AS RECT rct
DIM AS string tstr=Caption
DIM AS UINT mask, wStyle=GetWindowLong(Handle, GWL_STYLE)
    mask=WS_SYSMENU OR WS_MAXIMIZEBOX OR WS_MINIMIZEBOX OR WS_CAPTION
    wStyle AND= NOT(mask): Caption="": _Caption=tstr
    GetWindowRect(Handle, @rct)                                     ' Get this BEFORE changing style
    SetWindowLong(Handle, GWL_STYLE, wStyle)
    SetWindowPos(Handle, 0, rct.left, rct.top, rct.right - rct.left, rct.bottom - rct.top, _
                                            SWP_NOREPOSITION OR SWP_NOZORDER OR SWP_FRAMECHANGED)
END SUB
SUB QFORM.ShowTitleBar()
DIM AS RECT rct
DIM AS UINT wStyle=GetWindowLong(Handle, GWL_STYLE)
    wStyle OR= (WS_SYSMENU OR WS_MAXIMIZEBOX OR WS_MINIMIZEBOX OR WS_CAPTION)
    Caption=_Caption
    GetWindowRect(Handle, @rct)                                     ' Get this BEFORE changing style
    SetWindowLong(Handle, GWL_STYLE, wStyle)
    SetWindowPos(Handle, 0, rct.left, rct.top, rct.right - rct.left, rct.bottom - rct.top, _
                                            SWP_NOREPOSITION OR SWP_NOZORDER OR SWP_FRAMECHANGED)
END SUB

ObjectDrawFns(QFORM)

SUB QFORM.FormReSize()
DIM AS RECT rct
    GetWindowRect(Handle, @rct)
    _Left=rct.Left: _Top=rct.Top
    _Width=rct.Right-rct.Left: _Height=rct.Bottom-rct.Top
    GetClientRect(Handle, @rct)
    _ClientWidth=rct.Right-rct.Left: _ClientHeight=rct.Bottom-rct.Top
END SUB
SUB QFORM.PreSetConfig()
    SELECT CASE BorderStyle
        CASE bsNone:        ObjStyle=WS_POPUP                       ' No border or caption bar
        CASE bsSingle:      ObjStyle=WS_POPUPWINDOW OR WS_CAPTION OR WS_MINIMIZEBOX OR WS_MAXIMIZEBOX
        CASE bsSizeable:    ObjStyle=WS_TILEDWINDOW
        CASE bsDialog:      ObjStyle=WS_SYSMENU OR WS_CAPTION       ' Not quite but ok
        CASE bsToolWindow:  ObjStyle=WS_POPUPWINDOW OR WS_CAPTION   ' Plus an Extended style
        CASE bsSizeToolWin: ObjStyle=WS_TILEDWINDOW                 ' Ditto
    END SELECT
END SUB
SUB QFORM.PostConfig()
    Font.Owner=Handle: InitialiseFont(@Font)                        ' Initialise Font
    IF _Icon<>"" THEN
        Icon = _Icon                                                ' (RE-)Load if exist
    ELSEIF _IcoHandle<>0 THEN
        IcoHandle = _IcoHandle                                      ' (RE-)Load if exist
    END IF
    IF Color<>FORM_COLOR THEN
        SetClassLong(Handle, GCL_HBRBACKGROUND, CAST(long, CreateSolidBrush(CAST(COLORREF, Color))))
    END IF
END SUB


#IFDEF __QEDIT
' #1 =====================================================================================
TYPE QEDIT
    ObjId AS integer        = Q_EDIT                        ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "EDIT"                        ' Base class
    ObjStyle AS UINT        = WS_CLIPSIBLINGS OR WS_CLIPCHILDREN                             '
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 120
    _Height AS integer      = 25

    _Align AS integer       = alNone
    _CharCase AS integer    = ecNormal
    _Color AS integer       = &hffffff
    _MaxLength AS integer   = 0                             ' Unlimited (32k in 98 etc, 64k in XP....)
    _Modified AS integer    = 0
    _PasswordChar AS string = ""
    _ReadOnly AS integer    = False
    _SelLength AS integer   = 0
    _SelStart AS integer    = 0
    _SelText AS string      = ""

    AutoSize AS integer     = True
    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu
#IF 0
    EditText AS string              ' |STRING|RW|
    InputMask AS string             ' |STRING|RW|
    IsMasked AS integer             ' |INTEGER|RW|False|False|True
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY CharCase() AS integer
    DECLARE PROPERTY CharCase(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY MaxLength() AS integer
    DECLARE PROPERTY MaxLength(value AS integer)
    DECLARE PROPERTY Modified() AS integer
    DECLARE PROPERTY Modified(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY PasswordChar() AS string
    DECLARE PROPERTY PasswordChar(value AS string)
    DECLARE PROPERTY ReadOnly() AS integer
    DECLARE PROPERTY ReadOnly(value AS integer)
    DECLARE PROPERTY SelLength() AS integer
    DECLARE PROPERTY SelLength(value AS integer)
    DECLARE PROPERTY SelStart() AS integer
    DECLARE PROPERTY SelStart(value AS integer)
    DECLARE PROPERTY SelText() AS string
    DECLARE PROPERTY SelText(value AS string)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Text() AS string
    DECLARE PROPERTY Text(value AS string)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnChange AS SUB(Sender AS QEDIT PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QEDIT PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QEDIT PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QEDIT PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QEDIT PTR)                   ' FB only
END TYPE

DoGeneralProperties(QEDIT)
DoPositionalProperties(QEDIT)
DoAlignProperty(QEDIT)
DoHintProperties(QEDIT)
DoReadOnlyProperties(QEDIT)
PROPERTY QEDIT.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QEDIT.BorderStyle(value AS integer): IF Value<>0 THEN _BorderStyle=1 ELSE _BorderStyle=0: END IF: END PROPERTY
PROPERTY QEDIT.CharCase() AS integer: RETURN _CharCase: END PROPERTY
PROPERTY QEDIT.CharCase(value AS integer): IF (value>=0) AND (value<=2) THEN _CharCase=value: END IF: END PROPERTY
PROPERTY QEDIT.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QEDIT.Color(value AS integer)
DIM AS string tstr=Text
    Text="": _Color=value: InvalidateRect(Handle,NULL,True): Text=tstr
END PROPERTY
PROPERTY QEDIT.MaxLength() AS integer: RETURN _MaxLength: END PROPERTY
PROPERTY QEDIT.MaxLength(value AS integer): _MaxLength=value: END PROPERTY
PROPERTY QEDIT.Modified() AS integer
    _Modified=SendMessage(Handle,EM_GETMODIFY,0,0): IF _Modified<>0 THEN _Modified=1: RETURN _Modified
END PROPERTY
PROPERTY QEDIT.Modified(value AS integer)
    IF value<>0 THEN value=1: SendMessage(Handle,EM_SETMODIFY,value,0): END IF
END PROPERTY
PROPERTY QEDIT.PasswordChar() AS string: RETURN _PasswordChar: END PROPERTY
PROPERTY QEDIT.PasswordChar(value AS string)
    _PasswordChar=MID(value,1,1): SendMessage(Handle, EM_SETPASSWORDCHAR, CAST(UINT,ASC(_PasswordChar)), 0)
END PROPERTY
PROPERTY QEDIT.ReadOnly() AS integer: RETURN _ReadOnly: END PROPERTY
PROPERTY QEDIT.ReadOnly(value AS integer)
    IF Value=0 THEN _ReadOnly=0 ELSE _ReadOnly=1: END IF: SendMessage(Handle,EM_SETREADONLY,_ReadOnly,0)
END PROPERTY
PROPERTY QEDIT.SelLength() AS integer
DIM AS integer tStart, tEnd
    SendMessage(Handle, EM_GETSEL, CAST(WPARAM,@tStart), CAST(LPARAM,@tEnd))
    _SelLength=tEnd-tStart: SelStart=tStart: RETURN _SelLength
END PROPERTY
PROPERTY QEDIT.SelLength(value AS integer): END PROPERTY                    ' Read only
PROPERTY QEDIT.SelStart() AS integer
    DIM AS integer dummy: dummy=SelLength: RETURN _SelStart                 ' SelStart set by reading SelLength
END PROPERTY
PROPERTY QEDIT.SelStart(value AS integer): END PROPERTY                     ' Read only
PROPERTY QEDIT.SelText() AS string
    IF SelLength>0 THEN
        _SelText=SPACE(SelLength+1): SendMessage(Handle, EM_GETSELTEXT, 0, CAST(LPARAM, STRPTR(_SelText)))
        RETURN _SelText
    END IF
END PROPERTY
PROPERTY QEDIT.SelText(value AS string): END PROPERTY                       ' Read only
PROPERTY QEDIT.Text() AS string
DIM AS string*256 tstr
DIM AS integer iCount
    iCount=SendMessage(Handle, WM_GETTEXT, 256, CAST(LPARAM,@tstr)): _Text=tstr
    RETURN _Text
END PROPERTY
PROPERTY QEDIT.Text(value AS string)
    _Text=value
    IF Autosize THEN
        DIM AS integer hite=rqGetTextSize(@Font, value, tsHeight)+2              ' Plus border
        IF hite>Height THEN
            Height=hite: InvalidateRect(Handle,NULL,True)
        END IF
    END IF
    SetWindowText(Handle, _Text)
END PROPERTY

SUB QEDIT.PreSetConfig()
SELECT CASE CharCase
    CASE ecNormal:      ' do nothing
    CASE ecUpperCase:   ObjStyle OR= ES_LOWERCASE
    CASE ecLowerCase:   ObjStyle OR= ES_UPPERCASE
END SELECT
END SUB
SUB QEDIT.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@EditWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook the WndProc
    IF _Text<>"" THEN Text=_Text                                ' IF text preset, then rewrite text
    IF PasswordChar<>"" THEN SendMessage(Handle, EM_SETPASSWORDCHAR, CAST(UINT,ASC(_PasswordChar)), 0)
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
END SUB
#ENDIF          ' #IFDEF __QEDIT


#IFDEF __QRICHEDIT
' #2 =====================================================================================
TYPE QRICHEDIT
    ObjId AS integer        = Q_RICHEDIT                        ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "RichEdit20A"                     ' Base class
    ObjStyle AS UINT        = ES_MULTILINE OR ES_AUTOHSCROLL OR ES_AUTOVSCROLL
    Font AS QFONT

    PrivateProperties()                                         ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 200
    _Height AS integer      = 100
    _Align AS integer       = alNone
    _Color AS integer       = &hffffff
    _HideScrollBars AS integer = True
    _LineCount AS integer   = 0
    _Plaintext AS integer   = 0
    _Readonly AS integer    = 0
    _ScrollBars AS integer  = ssNone
    _SelLength AS integer   = 0
    _SelStart AS integer    = 0
    _SelText AS string      = ""
    _Wordwrap AS integer    = False
    
    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu
#IF 0
    Alignment AS integer            ' |INTEGER|RW|taLeftJustify|taLeftJustify|taRightJustify|taCenter
    HideSelection AS integer        ' |INTEGER|RW|True|False|True
    Line()                          ' |ARRAY of STRING|RW|
    Modified AS integer             ' |INTEGER|R|
    SelAttributes AS HWND           ' |QFONT|W|<default>
    TabOrder AS integer             ' |INTEGER|RW|
    Text AS string                  ' Code there but not doing anything useful
    WantTabs AS integer             ' |INTEGER|RW|False|False|True
    WhereX AS integer               ' |INTEGER|R|
    WhereY AS integer               ' |INTEGER|R|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY HideScrollBars() AS integer
    DECLARE PROPERTY HideScrollBars(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY LineCount() AS integer
    DECLARE PROPERTY LineCount(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Plaintext() AS integer
    DECLARE PROPERTY Plaintext(value AS integer)
    DECLARE PROPERTY ReadOnly() AS integer
    DECLARE PROPERTY ReadOnly(value AS integer)
    DECLARE PROPERTY ScrollBars() AS integer
    DECLARE PROPERTY ScrollBars(value AS integer)
    DECLARE PROPERTY SelLength() AS integer
    DECLARE PROPERTY SelLength(value AS integer)
    DECLARE PROPERTY SelStart() AS integer
    DECLARE PROPERTY SelStart(value AS integer)
    DECLARE PROPERTY SelText() AS string
    DECLARE PROPERTY SelText(value AS string)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Text() AS string
    DECLARE PROPERTY Text(value AS string)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
    DECLARE PROPERTY Wordwrap() AS integer
    DECLARE PROPERTY Wordwrap(value AS integer)
' Methods
    DECLARE SUB AddStrings(value AS string)             ' ONLY one string at a time!
    DECLARE SUB Clear()
    DECLARE SUB LoadFromFile(FileName AS string)
    DECLARE SUB CopyToClipboard()
    DECLARE SUB CutToClipboard()
    DECLARE SUB PasteFromClipboard()
    DECLARE SUB SaveToFile(FileName AS string)
    DECLARE SUB SelectAll()
#IF 0
    LoadFromStream SUB (Stream AS QFILESTREAM/QMEMORYSTREAM) Load text from a stream 1 WX
    SaveToStream SUB (Stream AS QFILESTREAM/QMEMORYSTREAM) Save text to a stream 1 W
#ENDIF
' Extras
    DECLARE SUB DeSelect()
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE DESTRUCTOR
' Events
    OnChange AS SUB(Sender AS QRICHEDIT PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QRICHEDIT PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QRICHEDIT PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QRICHEDIT PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QRICHEDIT PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QRICHEDIT PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QRICHEDIT PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QRICHEDIT PTR)                ' FB only
END TYPE

DoGeneralProperties(QRICHEDIT)
DoPositionalProperties(QRICHEDIT)
DoAlignProperty(QRICHEDIT)
DoHintProperties(QRICHEDIT)
DoReadOnlyProperties(QRICHEDIT)
PROPERTY QRICHEDIT.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QRICHEDIT.BorderStyle(value AS integer): IF Value=0 THEN _BorderStyle=0 ELSE _BorderStyle=1: END IF: END PROPERTY
PROPERTY QRICHEDIT.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QRICHEDIT.Color(value AS integer): _Color=value: SendMessage(Handle, EM_SETBKGNDCOLOR, 0, CAST(COLORREF,value)): END PROPERTY
PROPERTY QRICHEDIT.HideScrollBars() AS integer: RETURN _HideScrollBars: END PROPERTY
PROPERTY QRICHEDIT.HideScrollBars(value AS integer): IF Value=0 THEN _HideScrollBars=0 ELSE _HideScrollBars=1: END IF: END PROPERTY
PROPERTY QRICHEDIT.LineCount() AS integer: _LineCount=SendMessage(Handle, EM_GETLINECOUNT, 0 ,0): RETURN _LineCount: END PROPERTY
PROPERTY QRICHEDIT.LineCount(value AS integer): END PROPERTY                            ' Read only
PROPERTY QRICHEDIT.Plaintext() AS integer: RETURN _Plaintext: END PROPERTY
PROPERTY QRICHEDIT.Plaintext(value AS integer)
DIM AS UINT Which
    IF value=0 THEN Which=TM_RICHTEXT ELSE Which=TM_PLAINTEXT
    Which = Which OR TM_MULTILEVELUNDO OR TM_SINGLECODEPAGE
    SendMessage(Handle, EM_SETTEXTMODE, Which, 0)
    _Plaintext=value
END PROPERTY
PROPERTY QRICHEDIT.ReadOnly() AS integer: RETURN _ReadOnly: END PROPERTY
PROPERTY QRICHEDIT.ReadOnly(value AS integer)
IF value=0 THEN _ReadOnly=0 ELSE _ReadOnly=1: END IF: SendMessage(Handle, EM_SETREADONLY, _ReadOnly, 0)
END PROPERTY
PROPERTY QRICHEDIT.ScrollBars() AS integer: RETURN _ScrollBars: END PROPERTY
PROPERTY QRICHEDIT.ScrollBars(value AS integer)
IF (Value>=ssNone) AND (value<=ssBoth) THEN _ScrollBars=value
END PROPERTY
PROPERTY QRICHEDIT.SelLength() AS integer
DIM AS integer tStart, tEnd
SendMessage(Handle, EM_GETSEL, CAST(WPARAM,@tStart), CAST(LPARAM, @tEnd))
_SelLength=tEnd-tStart: SelStart=tStart: RETURN _SelLength
END PROPERTY
PROPERTY QRICHEDIT.SelLength(value AS integer): END PROPERTY
PROPERTY QRICHEDIT.SelStart() AS integer
DIM AS integer dummy: dummy=SelLength: RETURN _SelStart                         ' SelStart set by reading SelLength
END PROPERTY
PROPERTY QRICHEDIT.SelStart(value AS integer): END PROPERTY                     ' Read only
PROPERTY QRICHEDIT.SelText() AS string
IF SelLength>0 THEN
_SelText=SPACE(SelLength+1): SendMessage(Handle, EM_GETSELTEXT, 0, CAST(LPARAM,STRPTR(_SelText))): RETURN _SelText
END IF
END PROPERTY
PROPERTY QRICHEDIT.SelText(value AS string): END PROPERTY                       ' Read only
PROPERTY QRICHEDIT.Text() AS string: RETURN _Text: END PROPERTY
PROPERTY QRICHEDIT.Text(value AS string): _Text=value: SetWindowText(Handle, _Text): END PROPERTY
PROPERTY QRICHEDIT.Wordwrap() AS integer: RETURN _Wordwrap: END PROPERTY
PROPERTY QRICHEDIT.Wordwrap(value AS integer): IF Value=0 THEN _Wordwrap=0 ELSE _Wordwrap=1: END IF: END PROPERTY

SUB QRICHEDIT.AddStrings(value AS string)
DIM AS string tstr, tok
DIM AS SETTEXTEX stex: stex.flags=ST_NEWCHARS: stex.codepage=CP_ACP
    tstr=rqREPLACESUBSTR(value,CHR(13),"")
    FOR i AS integer = 1 TO rqTALLY(tstr, CHR(10))+1
        tok=RTRIM(rqFIELDSTR(tstr,CHR(10),i))+CHR(13)+CHR(10)
        SendMessage(Handle, EM_SETTEXTEX, CAST(WPARAM,@stex), CAST(LPARAM, STRPTR(tok)))
    NEXT i
END SUB
SUB QRICHEDIT.Clear()
    SelectAll()
    SendMessage(Handle, WM_CLEAR, 0, 0)
END SUB
SUB QRICHEDIT.CopyToClipboard()
DIM AS CHARRANGE tRange
    SendMessage(Handle, EM_EXGETSEL, 0, CAST(LPARAM, @tRange))
    SendMessage(Handle, WM_COPY, 0, 0)
END SUB
SUB QRICHEDIT.CutToClipboard()
DIM AS CHARRANGE tRange
    SendMessage(Handle, EM_EXGETSEL, 0, CAST(LPARAM, @tRange))
    SendMessage(Handle, WM_COPY, 0, 0)
    SendMessage(Handle, WM_CLEAR, 0, 0)
END SUB
SUB QRICHEDIT.LoadFromFile(FileName AS string)
    IF ReadOnly=True THEN EXIT SUB
    IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT SUB
    Clear()
    IF (Plaintext=True) OR (UCASE(RIGHT(Filename,3))="TXT") THEN
        DIM AS string tstr
        DIM AS QStringList iList
        iList.LoadFromFile(FileName)
        FOR i AS integer = 0 TO iList.ItemCount-1
            tstr=iList.Item(i): THIS.AddStrings(tstr)
        NEXT i
        iList.Clear
    ELSE
        IF FillRichEditFromFile(Handle, FileName)=False THEN
            DBG("RapidFRM Internal error! QRichEdit.LoadFromFile()")
        END IF
    END IF
END SUB
SUB QRICHEDIT.PasteFromClipboard()
    IF SendMessage(Handle, EM_CANPASTE, 0, 0) THEN
        SendMessage(Handle, WM_PASTE, 0, 0)
    END IF
END SUB
SUB QRICHEDIT.SaveToFile(FileName AS string)
    IF SaveRichEditToFile(Handle, FileName)=False THEN
        DBG("RapidFRM Internal error! QRichEdit.SaveToFile()")
    END IF
END SUB
SUB QRICHEDIT.SelectAll()
DIM AS CHARRANGE txtRange
    txtRange.cpMin=0: txtRange.cpMax=-1
    SendMessage(Handle, EM_EXSETSEL, 0, CAST(LPARAM,@txtRange))
    SendMessage(Handle, EM_HIDESELECTION, 0, 0)
END SUB
SUB QRICHEDIT.DeSelect()
     SendMessage(Handle, EM_SETSEL, 0, 0)         ' De-select the text
END SUB
SUB SetREFontColor(hWnd AS HWND, colr AS COLORREF)
DIM AS QRICHEDIT PTR lpRed=CAST(QRICHEDIT PTR, Application.GetObjectPtr(hWnd))
    IF lpRed->Plaintext THEN
        DIM AS CHARFORMAT cfmt
        CLEAR(@cfmt, 0, SIZEOF(CHARFORMAT))
        cfmt.cbSize=SIZEOF(CHARFORMAT)
        cfmt.dwMask=CFM_COLOR
        cfmt.crTextColor=colr
        SendMessage(hWnd, EM_SETCHARFORMAT, SCF_ALL, CAST(LPARAM, @cfmt))
    END IF
END SUB
SUB QRICHEDIT.PreSetConfig()
IF HideScrollBars=False THEN
    IF (ScrollBars AND ssHorizontal)>0 THEN ObjStyle OR= WS_HSCROLL
    IF (ScrollBars AND ssVertical)>0 THEN ObjStyle OR= WS_VSCROLL
END IF
END SUB
SUB QRICHEDIT.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: Font.lpFontColor=@SetREFontColor
    InitialiseFont(@Font)
    NewWndProc=@RichEdWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook the WndProc
    IF (Plaintext=True) AND (Font.Color<>0) THEN
        DIM AS COLORREF Colr=Font.Color
        Font.Color=0: Font.Color=Colr                               ' Reset to color
    END IF
    IF Color<>&hffffff THEN Color=_Color                            ' IF not default cause a repaint
    IF _Text<>"" THEN Text=_Text                                    ' IF text pre-preset, then rewrite text
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
END SUB
DESTRUCTOR QRICHEDIT
    Clear()
END DESTRUCTOR
#ENDIF          ' __QRICHEDIT


' #3 =====================================================================================
TYPE QLABEL
    ObjId AS integer        = Q_LABEL                       ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "STATIC"                      ' Base class
    ObjStyle AS UINT        = SS_NOTIFY                     '
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 75
    _Height AS integer      = 25
    _Align AS integer       = alNone
    _Alignment AS integer   = taLeftJustify
    _Color AS integer       = FORM_COLOR

    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    Autosize AS integer     = False
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    Angle AS integer                ' |INTEGER|RW|0
    LabelStyle AS integer           ' |INTEGER|RW|lsNone|lsNone|lsRaised|lsRecessed
    Layout AS integer               ' |INTEGER|RW|tlTop|tlTop|tlCenter|tlBottom
    LowerColor AS integer           ' |INTEGER|RW|<default>|<default>|<choose>
    Transparent AS integer          ' |INTEGER|RW|False|False|True
    UpperColor AS integer           ' |INTEGER|RW|<default>|<default>|<choose>
    Wordwrap AS integer             ' |INTEGER|RW|False|False|True
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY Alignment() AS integer
    DECLARE PROPERTY Alignment(value AS integer)
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Transparent() AS integer
    DECLARE PROPERTY Transparent(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnClick AS SUB(Sender AS QLABEL PTR)
    OnDblClick AS SUB(Sender AS QLABEL PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QLABEL PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QLABEL PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QLABEL PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QLABEL PTR)                 ' FB only
END TYPE

DoGeneralProperties(QLABEL)
DoPositionalProperties(QLABEL)
DoAlignProperty(QLABEL)
DoHintProperties(QLABEL)
DoReadOnlyProperties(QLABEL)
PROPERTY QLABEL.Alignment() AS integer: RETURN _Alignment: END PROPERTY
PROPERTY QLABEL.Alignment(value AS integer)
    IF value<>_Alignment THEN
        IF (value>=0) AND (value<3) THEN _Alignment=value
    END IF
END PROPERTY
PROPERTY QLABEL.Caption() AS string: RETURN _Caption: END PROPERTY
PROPERTY QLABEL.Caption(value AS string)
    IF Autosize THEN
        Width=rqGetTextSize(@Font, value, tsWidth)
        Height=rqGetTextSize(@Font, value, tsHeight)
    END IF
    _Caption=value: SetWindowText(Handle, _Caption): InvalidateRect(Handle,NULL,True)
END PROPERTY
PROPERTY QLABEL.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QLABEL.Color(value AS integer): _Color=value: InvalidateRect(Handle,NULL,True): END PROPERTY
PROPERTY QLABEL.Transparent() AS integer: RETURN _Transparent: END PROPERTY
PROPERTY QLABEL.Transparent(value AS integer): _Transparent=value: END PROPERTY

SUB QLABEL.PreSetConfig()
    ObjStyle += Alignment
END SUB
SUB QLABEL.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@LabelWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook the WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
    IF AutoSize THEN Caption = _Caption                     ' Force a resize and repaint
END SUB


' #4 =====================================================================================
TYPE QBUTTON
    ObjId AS integer        = Q_BUTTON                      ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "BUTTON"                      ' Base class
    ObjStyle AS UINT        = BS_OWNERDRAW OR WS_CLIPSIBLINGS   '
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 75
    _Height AS integer      = 25
    _Align AS integer       = alNone
    _Color AS integer       = FORM_COLOR
    _BMP AS string          = ""
    _BMPHandle AS integer   = 0
    NumBMPs AS integer      = 1

    BtnImages AS QImageList
    Down AS integer         = False                         ' Used by wndProc for drawing
    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    Cancel AS integer               ' |INTEGER|RW|False|False|True
    Default AS integer              ' |INTEGER|RW|False|False|True
    Kind AS integer                 ' |INTEGER|RW|bkCustom|bkCustom|bkOK|bkCancel|bkHelp|bkYes|bkNo|....
    Layout AS integer               ' |INTEGER|RW|blBMPLeft|blBMPLeft|blBMPRight|blBMPTop|blBMPBottom
    ModalResult AS integer          ' |INTEGER|W|mrNone|mrNone|mrOK|mrCancel|mrAbort|mrRetry|mrIgnore....
    Spacing AS integer              ' |INTEGER|RW|4
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BMP() AS string
    DECLARE PROPERTY BMP(FileName AS string)
    DECLARE PROPERTY BMPHandle() AS integer
    DECLARE PROPERTY BMPHandle(value AS integer)
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
' Extras
    DECLARE SUB LoadImages()
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE DESTRUCTOR
' Events
    OnClick AS SUB(Sender AS QBUTTON PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QBUTTON PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QBUTTON PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QBUTTON PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QBUTTON PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QBUTTON PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QBUTTON PTR)
    OnPaint AS SUB(hDC AS HDC, lpRect AS RECT PTR, Sender AS QBUTTON PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QBUTTON PTR)               ' FB only
END TYPE

DoPositionalProperties(QBUTTON)
DoAlignProperty(QBUTTON)
DoCapProperties(QBUTTON)
DoHintProperties(QBUTTON)
DoReadOnlyProperties(QBUTTON)
PROPERTY QBUTTON.BMP() AS string: RETURN _BMP: END PROPERTY
PROPERTY QBUTTON.BMP(FileName AS string)
    IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT PROPERTY
    _BMP=FileName
    IF Handle>0 THEN LoadImages(): InvalidateRect(Handle,NULL,True)
END PROPERTY
PROPERTY QBUTTON.BMPHandle() AS integer: RETURN _BMPHandle: END PROPERTY
PROPERTY QBUTTON.BMPHandle(value AS integer)
    IF value>0 THEN
        _BMPHandle=value
        IF Handle>0 THEN LoadImages(): InvalidateRect(Handle,NULL,True)
    END IF
END PROPERTY
PROPERTY QBUTTON.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QBUTTON.Color(value AS integer): _Color=value: InvalidateRect(Handle,NULL,True): END PROPERTY
PROPERTY QBUTTON.Enabled() AS integer: RETURN _Enabled: END PROPERTY
PROPERTY QBUTTON.Enabled(value AS integer)
    IF value=0 THEN _Enabled=False ELSE _Enabled=True
    EnableWindow(Handle, _Enabled): InvalidateRect(Handle,NULL,True)
END PROPERTY
PROPERTY QBUTTON.Visible() AS integer: RETURN _Visible: END PROPERTY
PROPERTY QBUTTON.Visible(value AS integer)
    _Visible=value: IF value=False THEN ShowWindow(Handle,SW_HIDE) ELSE ShowWindow(Handle,SW_SHOW): END IF
END PROPERTY
PROPERTY QBUTTON.Tag() AS integer: RETURN _Tag: END PROPERTY
PROPERTY QBUTTON.Tag(value AS integer): _Tag=value: END PROPERTY

SUB QBUTTON.LoadImages()
DIM AS QBITMAP bmap
    IF BMP<>"" THEN bmap.BMP=BMP ELSE bmap.BMPHandle=BMPHandle              ' Load image into a QBitmap
    BtnImages.Clear()
    BtnImages.Masked=True: BtnImages.Count=NumBMPs
    BtnImages.Width=bmap.Width\NumBMPs                                      ' Dimensions of (each) image
    IF BtnImages.Width>Width-4 THEN BtnImages.Width=Width-4                 ' Shrink to fit?
    BtnImages.Height=bmap.Height
    IF BtnImages.Height>Height-4 THEN BtnImages.Height=Height-4             ' ditto
    IF BMP<>"" THEN
        BtnImages.AddBMPFile(BMP, NumBMPs, bmap.Pixel(0,0))                 ' Add with transparency
    ELSE
        BtnImages.AddBMPHandle(BMPHandle, NumBMPs, bmap.Pixel(0,0))         ' ditto
    END IF
END SUB
SUB QBUTTON.PreSetConfig()
END SUB
SUB QBUTTON.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@ButnWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook the WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
    IF NumBMPs > 0 THEN
        IF (BMP<>"") OR (BMPHandle>0) THEN LoadImages()
    END IF
END SUB
DESTRUCTOR QBUTTON
    BtnImages.Clear()
END DESTRUCTOR


#IFDEF __QCOOLBTN
' #5 =====================================================================================
TYPE QCOOLBTN
    ObjId AS integer        = Q_COOLBTN                     ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "BUTTON"                      ' Base class
    ObjStyle AS UINT        = BS_OWNERDRAW OR WS_CLIPSIBLINGS   '
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 25
    _Height AS integer      = 25
    _Align AS integer       = alNone
    _Color AS integer       = FORM_COLOR
    _BMP AS string          = ""
    _BMPHandle AS integer   = 0                             ' Resource identifier
    NumBMPs AS integer      = 1

    BtnImages AS QImageList
    Down AS integer         = False
    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    AllowAllUp AS integer           ' |INTEGER|RW|False|False|True
    Flat AS integer                 ' |INTEGER|RW|False|False|True
    GroupIndex AS integer = 0       ' |INTEGER|RW|0
    Layout AS integer               ' |INTEGER|RW|blBMPLeft|blBMPLeft|blBMPRight|blBMPTop|blBMPBottom
    Spacing AS integer = 4          ' |INTEGER|RW|4
    PopupMenu                       ' Not in RQ
    TabOrder AS integer             ' Not in RQ
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BMP() AS string
    DECLARE PROPERTY BMP(value AS string)
    DECLARE PROPERTY BMPHandle() AS integer
    DECLARE PROPERTY BMPHandle(FileName AS integer)
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
' Extras
    DECLARE SUB LoadImages()
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE DESTRUCTOR
' Events
    OnClick AS SUB(Sender AS QCOOLBTN PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QCOOLBTN PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QCOOLBTN PTR)
    OnPaint AS SUB(hDC AS HDC, lpRect AS RECT PTR, Sender AS QCOOLBTN PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QCOOLBTN PTR)              ' FB only
END TYPE

DoPositionalProperties(QCOOLBTN)
DoAlignProperty(QCOOLBTN)
DoHintProperties(QCOOLBTN)
DoReadOnlyProperties(QCOOLBTN)

PROPERTY QCOOLBTN.BMP() AS string: RETURN _BMP: END PROPERTY
PROPERTY QCOOLBTN.BMP(FileName AS string)
    IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT PROPERTY
    _BMP=FileName
    IF Handle>0 THEN LoadImages(): InvalidateRect(Handle,NULL,True)
END PROPERTY
PROPERTY QCOOLBTN.BMPHandle() AS integer: RETURN _BMPHandle: END PROPERTY
PROPERTY QCOOLBTN.BMPHandle(value AS integer)
    IF value>0 THEN
        _BMPHandle=value
        IF Handle>0 THEN LoadImages(): InvalidateRect(Handle,NULL,True)
    END IF
END PROPERTY
PROPERTY QCOOLBTN.Caption() AS string: RETURN _Caption: END PROPERTY
PROPERTY QCOOLBTN.Caption(value AS string): _Caption=value: InvalidateRect(Handle, NULL, True): END PROPERTY
PROPERTY QCOOLBTN.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QCOOLBTN.Color(value AS integer): _Color=value: InvalidateRect(Handle,NULL,True): END PROPERTY
PROPERTY QCOOLBTN.Enabled() AS integer: RETURN _Enabled: END PROPERTY
PROPERTY QCOOLBTN.Enabled(value AS integer)
    IF value=0 THEN _Enabled=False ELSE _Enabled=True
    EnableWindow(Handle, _Enabled): InvalidateRect(Handle,NULL,True)
END PROPERTY
PROPERTY QCOOLBTN.Visible() AS integer: RETURN _Visible: END PROPERTY
PROPERTY QCOOLBTN.Visible(value AS integer)
    _Visible=value: IF value=False THEN ShowWindow(Handle,SW_HIDE) ELSE ShowWindow(Handle,SW_SHOW): END IF
END PROPERTY
PROPERTY QCOOLBTN.Tag() AS integer: RETURN _Tag: END PROPERTY
PROPERTY QCOOLBTN.Tag(value AS integer): _Tag=value: END PROPERTY

SUB QCOOLBTN.LoadImages()
DIM AS QBITMAP bmap
    IF BMP<>"" THEN bmap.BMP=BMP ELSE bmap.BMPHandle=BMPHandle              ' Load image into a QBitmap
    BtnImages.Clear(): BtnImages.Masked=True
    BtnImages.Width=bmap.Width\NumBMPs
    IF BtnImages.Width>Width-4 THEN BtnImages.Width=Width-4                 ' Shrink to fit?
    BtnImages.Height=bmap.Height
    IF BtnImages.Height>Height-4 THEN BtnImages.Height=Height-4             ' ditto
    IF BMP<>"" THEN
        BtnImages.AddBMPFile(BMP, NumBMPs, bmap.Pixel(0,0))                 ' Add with transparency
    ELSE
        BtnImages.AddBMPHandle(BMPHandle, NumBMPs, bmap.Pixel(0,0))         ' ditto
    END IF
END SUB
SUB QCOOLBTN.PreSetConfig()
END SUB
SUB QCOOLBTN.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@CoolWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook the WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
    IF NumBMPs > 0 THEN
        IF (BMP<>"") OR (BMPHandle>0) THEN LoadImages()
    END IF
END SUB
DESTRUCTOR QCOOLBTN
    BtnImages.Clear()
END DESTRUCTOR
#ENDIF          ' #IFDEF __QCOOLBTN


#IFDEF __QOVALBTN
' #6 =====================================================================================
TYPE QOVALBTN
    ObjId AS integer        = Q_OVALBTN                     ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "BUTTON"                      ' Base class
    ObjStyle AS UINT        = BS_OWNERDRAW OR WS_CLIPSIBLINGS     '
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 75
    _Height AS integer      = 40
    _Align AS integer       = alNone
    _Color AS integer       = FORM_COLOR                    ' Main button color
    TransParentColor AS integer = FORM_COLOR
    _BMP AS string          = ""
    _BMPHandle AS integer   = 0
    NumBMPs AS integer      = 1

    BtnImages AS QImageList
    Down AS integer         = False
    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    ColorHighLight AS integer           ' |INTEGER|RW|<default>|<default>|<choose>
    ColorShadow AS integer              ' |INTEGER|RW|<default>|<default>|<choose>
    Flat AS integer                     ' |INTEGER|RW|False|False|True
    GroupIndex AS integer               ' |INTEGER|RW|0
    Layout AS integer                   ' |INTEGER|RW|blBMPLeft|blBMPLeft|blBMPRight|blBMPTop|blBMPBottom
    Spacing AS integer                  ' |INTEGER|RW|
    TabOrder AS integer                 ' |INTEGER|RW|
    Transparent integer                 ' |INTEGER|RW|False|False|True
    PopupMenu                           ' Not in RQ
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BMP() AS string
    DECLARE PROPERTY BMP(value AS string)
    DECLARE PROPERTY BMPHandle() AS integer
    DECLARE PROPERTY BMPHandle(value AS integer)
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Transparent() AS integer
    DECLARE PROPERTY Transparent(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB StartDrag()
    DECLARE SUB LoadBMP()
' Extras
    DECLARE SUB LoadImages()
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE DESTRUCTOR
' Events
    OnClick AS SUB(Sender AS QOVALBTN PTR)
    OnPaint AS SUB(hDC AS HDC, lpRect AS RECT PTR, Sender AS QOVALBTN PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QOVALBTN PTR)             ' FB only
END TYPE

DoPositionalProperties(QOVALBTN)
DoAlignProperty(QOVALBTN)
DoHintProperties(QOVALBTN)
DoReadOnlyProperties(QOVALBTN)
PROPERTY QOVALBTN.BMP() AS string: RETURN _BMP: END PROPERTY
PROPERTY QOVALBTN.BMP(FileName AS string)
    IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT PROPERTY
    _BMP=FileName
    IF Handle>0 THEN LoadImages(): InvalidateRect(Handle,NULL,True)
END PROPERTY
PROPERTY QOVALBTN.BMPHandle() AS integer: RETURN _BMPHandle: END PROPERTY
PROPERTY QOVALBTN.BMPHandle(value AS integer)
    IF value>0 THEN
        _BMPHandle=value
        IF Handle>0 THEN LoadImages(): InvalidateRect(Handle,NULL,True)
    END IF
END PROPERTY
PROPERTY QOVALBTN.Caption() AS string: RETURN _Caption: END PROPERTY
PROPERTY QOVALBTN.Caption(value AS string): _Caption=value: InvalidateRect(Handle, NULL, True): END PROPERTY
PROPERTY QOVALBTN.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QOVALBTN.Color(value AS integer): _Color=value: InvalidateRect(Handle,NULL,True): END PROPERTY
PROPERTY QOVALBTN.TransParent() AS integer: RETURN _Transparent: END PROPERTY
PROPERTY QOVALBTN.TransParent(value AS integer): _Transparent=value: END PROPERTY
PROPERTY QOVALBTN.Enabled() AS integer: RETURN _Enabled: END PROPERTY
PROPERTY QOVALBTN.Enabled(value AS integer)
    IF value=0 THEN _Enabled=False ELSE _Enabled=True
    EnableWindow(Handle, _Enabled): InvalidateRect(Handle,NULL,True)
END PROPERTY
PROPERTY QOVALBTN.Visible() AS integer: RETURN _Visible: END PROPERTY
PROPERTY QOVALBTN.Visible(value AS integer)
    _Visible=value: IF value=False THEN ShowWindow(Handle,SW_HIDE) ELSE ShowWindow(Handle,SW_SHOW): END IF
END PROPERTY
PROPERTY QOVALBTN.Tag() AS integer: RETURN _Tag: END PROPERTY
PROPERTY QOVALBTN.Tag(value AS integer): _Tag=value: END PROPERTY

SUB QOVALBTN.LoadImages()
DIM AS QBITMAP bmap
    IF BMP<>"" THEN bmap.BMP=BMP ELSE bmap.BMPHandle=BMPHandle              ' Load image into a QBitmap
    BtnImages.Clear(): BtnImages.Masked=True
    BtnImages.Width=bmap.Width\NumBMPs
    IF BtnImages.Width>Width-4 THEN BtnImages.Width=Width-4                 ' Shrink to fit?
    BtnImages.Height=bmap.Height
    IF BtnImages.Height>Height-4 THEN BtnImages.Height=Height-4             ' ditto
    IF BMP<>"" THEN
        BtnImages.AddBMPFile(BMP, NumBMPs, bmap.Pixel(0,0))                 ' Add with transparency
    ELSE
        BtnImages.AddBMPHandle(BMPHandle, NumBMPs, bmap.Pixel(0,0))         ' ditto
    END IF
END SUB
SUB QOVALBTN.PreSetConfig()
END SUB
SUB QOVALBTN.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@OvalWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook the WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
    IF NumBMPs > 0 THEN
        IF (BMP<>"") OR (BMPHandle>0) THEN LoadImages()
    END IF
END SUB
DESTRUCTOR QOVALBTN
    BtnImages.Clear()
END DESTRUCTOR
#ENDIF          ' #IFDEF __QOVALBTN


' #7 =====================================================================================
TYPE QCHECKBOX
' Private (not)
    ObjId AS integer        = Q_CHECKBOX                    ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "BUTTON"                      ' Base class
    ObjStyle AS UINT        = BS_AUTOCHECKBOX               '
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 100
    _Height AS integer      = 20
    _Align AS integer       = alNone
    _Alignment AS integer   = taLeftJustify                 ' Def: text on right
    _Checked AS integer     = 0

    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY Alignment() AS integer
    DECLARE PROPERTY Alignment(value AS integer)
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Checked() AS integer
    DECLARE PROPERTY Checked(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnClick AS SUB(Sender AS QCHECKBOX PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QCHECKBOX PTR)          ' FB only
END TYPE

DoGeneralProperties(QCHECKBOX)
DoPositionalProperties(QCHECKBOX)
DoAlignProperty(QCHECKBOX)
DoCapProperties(QCHECKBOX)
DoHintProperties(QCHECKBOX)
DoReadOnlyProperties(QCHECKBOX)
PROPERTY QCHECKBOX.Alignment() AS integer: RETURN _Alignment: END PROPERTY
PROPERTY QCHECKBOX.Alignment(value AS integer)
IF value=taLeftJustify THEN _Alignment=taLeftJustify ELSE _Alignment=taRightJustify
END PROPERTY
PROPERTY QCHECKBOX.Checked() AS integer
IF SendMessage(Handle,BM_GETCHECK,0,0)=BST_CHECKED THEN _Checked=True ELSE _Checked=False
RETURN _Checked
END PROPERTY
PROPERTY QCHECKBOX.Checked(value AS integer)
IF value=0 THEN
    _Checked=0: SendMessage(Handle,BM_SETCHECK,BST_UNCHECKED,0)
ELSE
    _Checked=1: SendMessage(Handle,BM_SETCHECK,BST_CHECKED,0)
END IF
END PROPERTY

SUB QCHECKBOX.PreSetConfig()
IF _Alignment=taRightJustify THEN ObjStyle OR= BS_LEFTTEXT
END SUB
SUB QCHECKBOX.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@CheckWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook the WndProc
    IF _Checked THEN SendMessage(Handle,BM_SETCHECK,BST_CHECKED,0)
END SUB


' #8 =====================================================================================
TYPE QRADIOBUTTON
' Private (not)
    ObjId AS integer        = Q_RADIOBUTTON                 ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "BUTTON"                      ' Base class
    ObjStyle AS UINT        = BS_AUTORADIOBUTTON            '
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 100
    _Height AS integer      = 20
    _Align AS integer       = alNone
    _Alignment AS integer   = taRightJustify                ' Def: text on right
    _Checked AS integer     = 0

    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY Alignment() AS integer
    DECLARE PROPERTY Alignment(value AS integer)
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Checked() AS integer
    DECLARE PROPERTY Checked(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnClick AS SUB(Sender AS QRADIOBUTTON PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QRADIOBUTTON PTR)        ' FB only
END TYPE

DoGeneralProperties(QRADIOBUTTON)
DoPositionalProperties(QRADIOBUTTON)
DoAlignProperty(QRADIOBUTTON)
DoCapProperties(QRADIOBUTTON)
DoHintProperties(QRADIOBUTTON)
DoReadOnlyProperties(QRADIOBUTTON)
PROPERTY QRADIOBUTTON.Alignment() AS integer: RETURN _Alignment: END PROPERTY
PROPERTY QRADIOBUTTON.Alignment(value AS integer)
IF value=taLeftJustify THEN _Alignment=taLeftJustify ELSE _Alignment=taRightJustify
END PROPERTY
PROPERTY QRADIOBUTTON.Checked() AS integer
IF SendMessage(Handle,BM_GETCHECK,0,0)=BST_CHECKED THEN _Checked=True ELSE _Checked=False
RETURN _Checked
END PROPERTY
PROPERTY QRADIOBUTTON.Checked(value AS integer)
IF value=0 THEN _Checked=0 ELSE _Checked=1
END PROPERTY

SUB QRADIOBUTTON.PreSetConfig()
IF _Alignment=taLeftJustify THEN ObjStyle += BS_LEFTTEXT
END SUB
SUB QRADIOBUTTON.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@RadioWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook the WndProc
    IF _Checked THEN SendMessage(Handle,BM_SETCHECK,BST_CHECKED,0)
END SUB


#IFDEF __QPANEL
' #9 =====================================================================================
TYPE QPANEL
' Private (not)
    ObjId AS integer        = Q_PANEL                           ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "STATIC"                          ' Base class
    ObjStyle AS UINT        = SS_OWNERDRAW OR SS_NOTIFY
    Font AS QFONT

    PrivateProperties()                                         ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 150
    _Height AS integer      = 100
    _Align AS integer       = alNone
    _Alignment AS integer   = taCenter
    _BevelInner AS integer  = bvNone
    _BevelOuter AS integer  = bvRaised
    _BevelWidth AS integer  = 1
    _ClientHeight AS integer= 0
    _ClientWidth AS integer = 0
    _Color AS integer       = FORM_COLOR

    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY Alignment() AS integer
    DECLARE PROPERTY Alignment(value AS integer)
    DECLARE PROPERTY BevelInner() AS integer
    DECLARE PROPERTY BevelInner(value AS integer)
    DECLARE PROPERTY BevelOuter() AS integer
    DECLARE PROPERTY BevelOuter(value AS integer)
    DECLARE PROPERTY BevelWidth() AS integer
    DECLARE PROPERTY BevelWidth(value AS integer)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY ClientHeight() AS integer
    DECLARE PROPERTY ClientHeight(value AS integer)
    DECLARE PROPERTY ClientWidth() AS integer
    DECLARE PROPERTY ClientWidth(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HWND, S AS RECT PTR)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HDC, S AS RECT PTR)
    DECLARE SUB Draw(x AS integer, y AS integer, FileName AS string)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Paint(x AS integer, y AS integer, c AS integer, border AS integer)
    DECLARE FUNCTION Pixel(x AS integer, y AS integer) AS integer
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Repaint()
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    DECLARE SUB StretchDraw(lpRect AS RECT PTR, FileName AS string)
    DECLARE FUNCTION TextHeight(Text AS string) AS integer
    DECLARE FUNCTION TextWidth(Text AS string) AS integer
    DECLARE SUB TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TextRect(lpRect AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE FUNCTION SaveToBMP(FileName AS string) AS integer
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnClick AS SUB(Sender AS QPANEL PTR)
    OnDblClick AS SUB(Sender AS QPANEL PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QPANEL PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QPANEL PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QPANEL PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QPANEL PTR)                  ' FB only
END TYPE

DoGeneralProperties(QPANEL)
DoPositionalProperties(QPANEL)
DoAlignProperty(QPANEL)
DoHintProperties(QPANEL)
DoReadOnlyProperties(QPANEL)
PROPERTY QPANEL.Alignment() AS integer: RETURN _Alignment: END PROPERTY
PROPERTY QPANEL.Alignment(value AS integer)
    IF (value>=0) AND (value<3) THEN _Alignment=value
END PROPERTY
PROPERTY QPANEL.BevelInner() AS integer: RETURN _BevelInner: END PROPERTY
PROPERTY QPANEL.BevelInner(value AS integer): _BevelInner=value: END PROPERTY
PROPERTY QPANEL.BevelOuter() AS integer: RETURN _BevelOuter: END PROPERTY
PROPERTY QPANEL.BevelOuter(value AS integer): _BevelOuter=value: END PROPERTY
PROPERTY QPANEL.BevelWidth() AS integer: RETURN _BevelWidth: END PROPERTY
PROPERTY QPANEL.BevelWidth(value AS integer): _BevelWidth=value: END PROPERTY
PROPERTY QPANEL.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QPANEL.BorderStyle(value AS integer): _BorderStyle=value: END PROPERTY
PROPERTY QPANEL.Caption() AS string: RETURN _Caption: END PROPERTY
PROPERTY QPANEL.Caption(value AS string): _Caption=value: InvalidateRect(Handle, NULL, True): END PROPERTY
PROPERTY QPANEL.ClientHeight() AS integer
DIM AS RECT rct
GetClientRect(Handle, @rct): _ClientHeight=rct.Bottom-rct.Top: RETURN _ClientHeight
END PROPERTY
PROPERTY QPANEL.ClientHeight(value AS integer): END PROPERTY                 ' Read Only
PROPERTY QPANEL.ClientWidth() AS integer
DIM AS RECT rct
GetClientRect(Handle, @rct): _ClientWidth=rct.Right-rct.Left: RETURN _ClientWidth
END PROPERTY
PROPERTY QPANEL.ClientWidth(value AS integer): END PROPERTY                 ' Read Only
PROPERTY QPANEL.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QPANEL.Color(value AS integer): _Color=value: InvalidateRect(Handle, NULL, True): END PROPERTY

ObjectDrawFns(QPANEL)

SUB QPANEL.PreSetConfig()
END SUB
SUB QPANEL.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@PanelWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook new WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
END SUB
#ENDIF              ' #IFDEF __QPANEL


#IFDEF __QTABCONTROL
' #10 ====================================================================================
TYPE QTABCONTROL
' Private (not)
    ObjId AS integer        = Q_TABCONTROL                  ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "SysTabControl32"             ' Base class
    ObjStyle AS UINT        = WS_CLIPSIBLINGS               '
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 150
    _Height AS integer      = 100
    _Align AS integer       = alNone

    _ClientHeight AS integer
    _ClientWidth AS integer
    _TabIndex AS integer    = 0
    _TabWidth AS integer    = 42
    _TabHeight AS integer   = 18
    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    MultiLine AS integer    = False
    ButtonStyle AS integer  = False
    FlatButtons AS integer  = False
    VerticalTabs AS integer = False
    TabPosition AS integer  = 0
    TabInactiveFont AS QFONT
    ImgList AS QIMAGELIST
    _BMP AS string                                          ' FB ONLY: Bitmap file
    ClientRect AS RECT                                      ' FB ONLY: Client area of TabControl

    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    Color AS integer                ' |INTEGER|RW|<default>|<default>|<choose>
    FlatSeperators AS integer       ' |INTEGER|RW|False|False|True
    FocusButtons AS integer         ' |INTEGER|RW|False|False|True
    HotTrack AS integer             ' |INTEGER|RW|False|False|True
    ScrollOpposite AS integer       ' |INTEGER|RW|False|False|True
    Tab() AS string                 ' |ARRAY of STRING|RW|    My version csv string!!!!!
    TabInactiveColor AS UINT        ' |INTEGER|RW|<default>|<default>|<choose>
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BMP() AS string
    DECLARE PROPERTY BMP(value AS string)
    DECLARE PROPERTY ClientHeight() AS integer
    DECLARE PROPERTY ClientHeight(value AS integer)
    DECLARE PROPERTY ClientWidth() AS integer
    DECLARE PROPERTY ClientWidth(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY TabHeight() AS integer
    DECLARE PROPERTY TabHeight(value AS integer)
    DECLARE PROPERTY TabIndex() AS integer
    DECLARE PROPERTY TabIndex(value AS integer)
    DECLARE PROPERTY TabWidth() AS integer
    DECLARE PROPERTY TabWidth(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB UpdateTabs()
    DECLARE SUB AddTabs(value AS string)                    ' ONE TAB string at a time!
    DECLARE SUB DelTabs(value AS integer)                   ' Delete by single index number only
    DECLARE SUB InsertTab(Index AS integer, TabStr AS string)
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE DESTRUCTOR
' Events
    OnChange AS SUB(Sender AS QTABCONTROL PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QTABCONTROL PTR)        ' FB only
END TYPE

DoGeneralProperties(QTABCONTROL)
DoPositionalProperties(QTABCONTROL)
DoAlignProperty(QTABCONTROL)
DoHintProperties(QTABCONTROL)
DoReadOnlyProperties(QTABCONTROL)

PROPERTY QTABCONTROL.BMP() AS string: RETURN _BMP: END PROPERTY
PROPERTY QTABCONTROL.BMP(value AS string)
    IF FileExists(value)=False THEN InpFileError(value): EXIT PROPERTY
    _BMP=value
    IF (Handle>0) THEN
        DIM AS integer i=TabCtrl_GetItemCount(Handle)
        IF i>0 THEN
            DIM AS TCITEM tie
            DIM AS QBITMAP bmap
            DIM AS integer H, W
            bmap.BMP=value: H=bmap.Height: W=bmap.Width\i
            ImgList.Height=H: ImgList.Width=W
            ImgList.AddBMPFile(value, i, bmap.Pixel(0,0))
            TabCtrl_SetImageList(Handle, ImgList.Handle)                ' Set ImgList to tabcontrol
            tie.Mask=TCIF_IMAGE
            FOR x AS integer = 0 TO i-1
                tie.iImage=x
                TabCtrl_SetItem(Handle, x, @tie)
            NEXT x
        END IF
    END IF
END PROPERTY
PROPERTY QTABCONTROL.ClientHeight() AS integer
    ClientRect.Left=0: ClientRect.Top=0: ClientRect.Right=Width: ClientRect.Bottom=Height
    SendMessage(Handle,TCM_ADJUSTRECT,0,CAST(LPARAM,@ClientRect))
    RETURN (ClientRect.Bottom-ClientRect.Top)
END PROPERTY
PROPERTY QTABCONTROL.ClientHeight(value AS integer): END PROPERTY               ' Readonly
PROPERTY QTABCONTROL.ClientWidth() AS integer
    ClientRect.Left=0: ClientRect.Top=0: ClientRect.Right=Width: ClientRect.Bottom=Height
    SendMessage(Handle,TCM_ADJUSTRECT,0,CAST(LPARAM,@ClientRect))
    RETURN (ClientRect.Right-ClientRect.Left)
END PROPERTY
PROPERTY QTABCONTROL.ClientWidth(value AS integer): END PROPERTY                ' Readonly
PROPERTY QTABCONTROL.TabIndex() AS integer
    _TabIndex=TabCtrl_GetCurSel(Handle): RETURN _TabIndex
END PROPERTY
PROPERTY QTABCONTROL.TabIndex(value AS integer)
    IF value < TabCtrl_GetItemCount(Handle) THEN
        TabCtrl_SetCurSel(Handle, value)
    END IF
END PROPERTY
PROPERTY QTABCONTROL.TabHeight(value AS integer)
    IF value > Height THEN value=Height                                         ' Limit Height?
    _TabHeight=value
    IF Handle THEN TabCtrl_SetItemSize(Handle,_TabWidth,_TabHeight)
END PROPERTY
PROPERTY QTABCONTROL.TabHeight() AS integer: RETURN _TabHeight: END PROPERTY
PROPERTY QTABCONTROL.TabWidth(value AS integer)
    IF value < Width THEN                                                       ' Limit Width
        _TabWidth=value
        IF Handle THEN TabCtrl_SetItemSize(Handle,_TabWidth,_TabHeight)
    END IF
END PROPERTY
PROPERTY QTABCONTROL.TabWidth() AS integer: RETURN _TabWidth: END PROPERTY

SUB QTABCONTROL.AddTabs(value AS string)
DIM AS TCITEM tie
DIM AS integer i=TabCtrl_GetItemCount(Handle)
DIM AS string tstr=TRIM(value)

    tie.mask = TCIF_TEXT
    tie.pszText = STRPTR(tstr)
    TabCtrl_InsertItem(Handle, i, @tie)
END SUB
SUB QTABCONTROL.InsertTab(idx AS integer, value AS string)
DIM AS TCITEM tie
DIM AS integer i=TabCtrl_GetItemCount(Handle)
DIM AS string tstr=TRIM(value)

    IF idx > i THEN idx=i
    tie.mask = TCIF_TEXT
    tie.pszText = STRPTR(tstr)
    TabCtrl_InsertItem(Handle, idx, @tie)
END SUB
SUB QTABCONTROL.DelTabs(idx AS integer)
    IF idx < TabCtrl_GetItemCount(Handle) THEN
        TabCtrl_DeleteItem(Handle,idx)
    END IF
END SUB
SUB QTABCONTROL.UpdateTabs()
    IF _BMP<>"" THEN
        DIM AS QBITMAP bmap
        DIM AS TCITEM tie
        DIM AS integer i, H, W
        bmap.BMP=_BMP: i=TabCtrl_GetItemCount(Handle)
        H=bmap.Height: W=bmap.Width\i
        ImgList.Height=H: ImgList.Width=W
        ImgList.AddBMPFile(_BMP, i, bmap.Pixel(0,0))
        TabCtrl_SetImageList(Handle, ImgList.Handle)
        tie.Mask=TCIF_IMAGE
        FOR x AS integer = 0 TO i-1
            tie.iImage=x
            TabCtrl_SetItem(Handle, x, @tie)
        NEXT x
    END IF
END SUB
SUB QTABCONTROL.PreSetConfig()
    IF MultiLine THEN ObjStyle OR= TCS_MULTILINE
    IF ButtonStyle THEN ObjStyle OR= TCS_BUTTONS
    IF FlatButtons THEN ObjStyle OR= TCS_FLATBUTTONS
    IF TabPosition THEN ObjStyle OR= TCS_RIGHT                              ' IF VerticalTabs equiv to TCS_BOTTOM
    IF VerticalTabs THEN ObjStyle OR= TCS_VERTICAL
END SUB
SUB QTABCONTROL.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    TabInactiveFont.Owner=Handle: InitialiseFont(@TabInactiveFont)
    NewWndProc=@TabCtlWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook TabCtl WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
    DIM AS integer x=ClientWidth+ClientHeight                               ' Dummy to get initial info after config
    UpdateTabs()
END SUB
DESTRUCTOR QTABCONTROL
    ImgList.Clear()
END DESTRUCTOR
#ENDIF          '#IFDEF __QTABCONTROL


' #11 ====================================================================================
TYPE QCOMBOBOX
' Private (not)
    ObjId AS integer        = Q_COMBOBOX                    ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "COMBOBOX"                    ' Base class
    ObjStyle AS UINT        = WS_VSCROLL OR CBS_DROPDOWN
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 145
    _Height AS integer      = 141
    _Align AS integer       = alNone
    _Color AS integer       = &hffffff
    _DropDownCount AS integer = 8
    _ItemCount AS integer   = 0
    _ItemIndex AS integer   = -1
    _ItemHeight AS integer  = 0
    _MaxLength AS integer   = 0
    _Sorted AS integer      = False
    _Style AS integer       = csDropDown
    hEdit AS HWND           = 0                             ' Internal handle to the edit box
    hList AS HWND           = 0                             ' Internal handle to the dropdown list

    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    CopyMode AS integer             ' |INTEGER|RW|cmBlackness|cmBlackness|cmDstInvert|cmMergeCopy|cmMerge.......
    Item() AS string                ' |ARRAY of STRING|RW|
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY DropDownCount() AS integer
    DECLARE PROPERTY DropDownCount(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY ItemCount() AS integer
    DECLARE PROPERTY ItemCount(value AS integer)
    DECLARE PROPERTY ItemHeight() AS integer
    DECLARE PROPERTY ItemHeight(value AS integer)
    DECLARE PROPERTY ItemIndex() AS integer
    DECLARE PROPERTY ItemIndex(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY MaxLength() AS integer
    DECLARE PROPERTY MaxLength(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Sorted() AS integer
    DECLARE PROPERTY Sorted(value AS integer)
    DECLARE PROPERTY Style() AS integer
    DECLARE PROPERTY Style(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Text() AS string
    DECLARE PROPERTY Text(value AS string)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB AddItems(value AS string)                                       ' Only ONE item at a time!
    DECLARE SUB Clear()
    DECLARE SUB DelItems(Idx AS integer)                                        ' Only ONE at a time
    DECLARE SUB InsertItem(Idx AS integer, value AS string)
    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HWND, S AS RECT PTR)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HDC, S AS RECT PTR)
    DECLARE SUB Draw(x AS integer, y AS integer, FileName AS string)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Paint(x AS integer, y AS integer, c AS integer, border AS integer)
    DECLARE FUNCTION Pixel(x AS integer, y AS integer) AS integer
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Repaint()
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    DECLARE SUB StretchDraw(lpRect AS RECT PTR, FileName AS string)
    DECLARE FUNCTION TextHeight(Text AS string) AS integer
    DECLARE FUNCTION TextWidth(Text AS string) AS integer
    DECLARE SUB TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TextRect(lpRect AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE FUNCTION SaveToBMP(FileName AS string) AS integer
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE DESTRUCTOR
' Events
    OnChange AS SUB(Sender AS QCOMBOBOX PTR)
    OnDrawItem AS SUB(Index AS integer, State AS integer, Rct AS RECT PTR, Sender AS QCOMBOBOX PTR)
    OnMeasureItem AS SUB(Index AS integer, Height AS integer, Sender AS QCOMBOBOX PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QCOMBOBOX PTR)               ' FB only
END TYPE

DoGeneralProperties(QCOMBOBOX)
DoPositionalProperties(QCOMBOBOX)
DoAlignProperty(QCOMBOBOX)
DoHintProperties(QCOMBOBOX)
DoReadOnlyProperties(QCOMBOBOX)

PROPERTY QCOMBOBOX.Color(value AS integer): _Color=value: InvalidateRect(Handle,NULL,True): END PROPERTY
PROPERTY QCOMBOBOX.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QCOMBOBOX.DropDownCount(value AS integer)
_DropDownCount=value: ItemHeight=TextHeight("#M"): Height=(value+2)*ItemHeight: END PROPERTY
PROPERTY QCOMBOBOX.DropDownCount() AS integer: RETURN _DropDownCount: END PROPERTY
PROPERTY QCOMBOBOX.ItemCount(value AS integer): END PROPERTY                    ' ReadOnly
PROPERTY QCOMBOBOX.ItemCount() AS integer: _ItemCount=SendMessage(Handle, CB_GETCOUNT, 0, 0): RETURN _ItemCount: END PROPERTY
PROPERTY QCOMBOBOX.ItemHeight(value AS integer): END PROPERTY                   ' ReadOnly
PROPERTY QCOMBOBOX.ItemHeight() AS integer: _ItemHeight=TextHeight("#M"): RETURN _ItemHeight: END PROPERTY
PROPERTY QCOMBOBOX.ItemIndex(value AS integer): SendMessage(Handle, CB_SETCURSEL, value, 0): _ItemIndex=value: END PROPERTY
PROPERTY QCOMBOBOX.ItemIndex() AS integer: _ItemIndex=SendMessage(Handle, CB_GETCURSEL, 0, 0): RETURN _ItemIndex: END PROPERTY
PROPERTY QCOMBOBOX.MaxLength(value AS integer): SendMessage(Handle, CB_LIMITTEXT, value, 0): _ItemIndex=value: END PROPERTY
PROPERTY QCOMBOBOX.MaxLength() AS integer: RETURN _MaxLength: END PROPERTY
PROPERTY QCOMBOBOX.Sorted(value AS integer): IF value=0 THEN _Sorted=0: ELSE: _Sorted=1: END IF: END PROPERTY
PROPERTY QCOMBOBOX.Sorted() AS integer: RETURN _Sorted: END PROPERTY
PROPERTY QCOMBOBOX.Text(value AS string): END PROPERTY                          ' ReadOnly
PROPERTY QCOMBOBOX.Text() AS string
DIM AS string*256 zItemTxt: SendMessage(Handle, CB_GETLBTEXT, ItemIndex, CAST(LPARAM, @zItemTxt)): _Text=zItemTxt: RETURN _Text
END PROPERTY
PROPERTY QCOMBOBOX.Style(value AS integer)
    SELECT CASE value
        CASE csDropDown:            _Style=CBS_DROPDOWN
        CASE csSimple:              _Style=CBS_SIMPLE
        CASE csDropDownList:        _Style=CBS_DROPDOWNLIST
        CASE csOwnerDrawFixed:      ' _Style = CBS_OWNERDRAWFIXED
        CASE csOwnerDrawVariable:   ' _Style = CBS_OWNERDRAWVARIABLE
        CASE ELSE
            _Style=CBS_SIMPLE
    END SELECT
    _Style OR= WS_VSCROLL: ObjStyle = _Style
END PROPERTY
PROPERTY QCOMBOBOX.Style() AS integer: RETURN _Style: END PROPERTY

SUB QCOMBOBOX.Clear()
    SendMessage(Handle, CB_RESETCONTENT, 0, 0)
END SUB
SUB QCOMBOBOX.AddItems(value AS string)
    SendMessage(Handle, CB_ADDSTRING, 0, CAST(LPARAM, STRPTR(value)))
END SUB
SUB QCOMBOBOX.InsertItem(Idx AS integer, value AS string)
    IF (Idx >= 0) AND (Idx < ItemCount) THEN
        SendMessage(Handle, CB_INSERTSTRING, CAST(WPARAM,Idx), CAST(LPARAM, STRPTR(value)))
    ELSEIF Idx=ItemCount THEN
        AddItems(value)
    END IF
END SUB
SUB QCOMBOBOX.DelItems(Idx AS integer)
    IF (Idx >= 0) AND (Idx < ItemCount) THEN
        SendMessage(Handle, CB_DELETESTRING, CAST(WPARAM,Idx), 0)
    END IF
END SUB

ObjectDrawFns(QCOMBOBOX)

SUB QCOMBOBOX.PreSetConfig()
    IF Sorted THEN ObjStyle OR= CBS_SORT
END SUB
SUB QCOMBOBOX.PostConfig()
DIM AS COMBOBOXINFO cbinfo

    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    cbinfo.cbSize=SIZEOF(COMBOBOXINFO)
    GetComboBoxInfo(Handle, @cbinfo)
    hEdit=cbinfo.hwndItem: hList=cbinfo.hwndList
    NewWndProc=@ComboWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook Combo WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
END SUB
DESTRUCTOR QCOMBOBOX
    Clear()
END DESTRUCTOR


' #12 ====================================================================================
TYPE QLISTBOX
' Private (not)
    ObjId AS integer        = Q_LISTBOX                     ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "LISTBOX"                     ' Base class
    ObjStyle AS UINT        = WS_VSCROLL OR WS_HSCROLL OR LBS_NOTIFY
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 120
    _Height AS integer      = 100
    _Align AS integer       = alNone
    _Color AS integer       = &hffffff
    _Item(1) AS string
    _ItemCount AS integer   = 0
    _ItemHeight AS integer  = 13
    _ItemIndex AS integer   = -1
    _Sorted AS integer      = False
    _Style AS integer       = lbStandard
    _TopIndex AS integer    = 0

    LBoxList AS QSTRINGLIST
    Columns AS integer      = 1
    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    CopyMode AS integer             ' |INTEGER|RW|cmBlackness|cmBlackness|cmDstInvert|cmMergeCopy|cmMergePaint|.....
    ExtendedSelect AS integer = False  ' |INTEGER|RW|False|False|True
    MultiSelect AS integer = False  ' |INTEGER|RW|False|False|True
    SelCount AS integer = 0         ' |INTEGER|R|
    Selected() AS integer           ' |ARRAY of INTEGER|RW|
    TabOrder AS integer             ' |INTEGER|RW|
    TabWidth AS integer             ' |INTEGER|RW|0
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Item(idx AS integer, value AS string)
    DECLARE PROPERTY Item(idx AS integer) AS string
    DECLARE PROPERTY ItemCount() AS integer
    DECLARE PROPERTY ItemCount(value AS integer)
    DECLARE PROPERTY ItemHeight() AS integer
    DECLARE PROPERTY ItemHeight(value AS integer)
    DECLARE PROPERTY ItemIndex() AS integer
    DECLARE PROPERTY ItemIndex(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Sorted() AS integer
    DECLARE PROPERTY Sorted(value AS integer)
    DECLARE PROPERTY Style() AS integer
    DECLARE PROPERTY Style(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Text() AS string
    DECLARE PROPERTY Text(value AS string)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY TopIndex() AS integer
    DECLARE PROPERTY TopIndex(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB AddItems(S AS string)                   ' ONE string item at a time!
    DECLARE SUB Clear()
    DECLARE SUB DelItems(Idx AS integer)                ' ONE index at a time
    DECLARE SUB InsertItem(Index AS integer, S AS string)
    DECLARE SUB LoadFromFile(FileName AS string)
    DECLARE SUB SaveToFile(FileName AS string)

    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HWND, S AS RECT PTR)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HDC, S AS RECT PTR)
    DECLARE SUB Draw(x AS integer, y AS integer, FileName AS string)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Paint(x AS integer, y AS integer, colr AS integer, brdr AS integer)
    DECLARE FUNCTION Pixel(x AS integer, y AS integer) AS integer
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Repaint()
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    DECLARE SUB StretchDraw(lpRect AS RECT PTR, FileName AS string)
    DECLARE FUNCTION TextHeight(Text AS string) AS integer
    DECLARE FUNCTION TextWidth(Text AS string) AS integer
    DECLARE SUB TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TextRect(lpRect AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
' Extras
    DECLARE SUB SortTheList()
    DECLARE FUNCTION SaveToBMP(FileName AS string) AS integer
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE DESTRUCTOR
' Events
    OnClick AS SUB(Sender AS QLISTBOX PTR)
    OnDblClick AS SUB(Sender AS QLISTBOX PTR)
    OnDrawItem AS SUB(Index AS integer, State AS integer, Rct AS RECT PTR, Sender AS QLISTBOX PTR)
    OnEnter AS SUB(Sender AS QLISTBOX PTR)
    OnMeasureItem AS SUB(Index AS integer, Height AS integer, Sender AS QLISTBOX PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QLISTBOX PTR)           ' FB only
END TYPE

DoGeneralProperties(QLISTBOX)
DoPositionalProperties(QLISTBOX)
DoAlignProperty(QLISTBOX)
DoHintProperties(QLISTBOX)
DoReadOnlyProperties(QLISTBOX)

PROPERTY QLISTBOX.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QLISTBOX.BorderStyle(value AS integer): IF Value<>0 THEN _BorderStyle=1 ELSE _BorderStyle=0: END IF: END PROPERTY
PROPERTY QLISTBOX.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QLISTBOX.Color(value AS integer): _Color=value: InvalidateRect(Handle,NULL,True): END PROPERTY
PROPERTY QLISTBOX.Item(idx AS integer) AS string
DIM AS string*256 zItemTxt: SendMessage(Handle, LB_GETTEXT, idx, CAST(LPARAM, @zItemTxt)): RETURN zItemTxt
END PROPERTY
PROPERTY QLISTBOX.Item(idx AS integer,value AS string): END PROPERTY                ' Do nothing
PROPERTY QLISTBOX.ItemCount() AS integer: _ItemCount=SendMessage(Handle, LB_GETCOUNT, 0, 0): RETURN _ItemCount: END PROPERTY
PROPERTY QLISTBOX.ItemCount(value AS integer): END PROPERTY                         ' Read only
PROPERTY QLISTBOX.ItemHeight() AS integer: RETURN _ItemHeight: END PROPERTY
PROPERTY QLISTBOX.ItemHeight(value AS integer)
IF Style=lbOwnerDrawFixed THEN                                                      ' ONLY if OwnerDraw!
    _ItemHeight=value
    SendMessage(Handle, LB_SETITEMHEIGHT, 0, value)                                 ' Set all heights to value
    InvalidateRect(Handle, NULL, True)
END IF
END PROPERTY
PROPERTY QLISTBOX.ItemIndex() AS integer: _ItemIndex=SendMessage(Handle, LB_GETCURSEL, 0, 0): RETURN _ItemIndex: END PROPERTY
PROPERTY QLISTBOX.ItemIndex(value AS integer): SendMessage(Handle, LB_SETCURSEL, value, 0): _ItemIndex=value: END PROPERTY
PROPERTY QLISTBOX.Sorted() AS integer: RETURN _Sorted: END PROPERTY
PROPERTY QLISTBOX.Sorted(value AS integer)
IF value=False THEN
    _Sorted=False
ELSEIF _Sorted=False THEN
    _Sorted=True: IF ItemCount>0 THEN SortTheList()
END IF
END PROPERTY
PROPERTY QLISTBOX.Style() AS integer: RETURN _Style: END PROPERTY
PROPERTY QLISTBOX.Style(value AS integer)
IF (value=lbStandard) OR (value=lbOwnerDrawFixed) THEN
    _Style=value
    IF value=lbOwnerDrawFixed THEN
        SendMessage(Handle, LB_SETITEMHEIGHT, 0, _ItemHeight)
        InvalidateRect(Handle, NULL, True)
    END IF
END IF
END PROPERTY
PROPERTY QLISTBOX.Text() AS string
DIM AS string*256 zItemTxt: SendMessage(Handle, LB_GETTEXT, ItemIndex, CAST(LPARAM, @zItemTxt)): _Text=zItemTxt: RETURN _Text
END PROPERTY
PROPERTY QLISTBOX.Text(value AS string): END PROPERTY                        ' Read only
PROPERTY QLISTBOX.TopIndex() AS integer: _TopIndex=SendMessage(Handle, LB_GETTOPINDEX, 0, 0): RETURN _TopIndex: END PROPERTY
PROPERTY QLISTBOX.TopIndex(value AS integer)
IF (value>=0) AND (value<ItemCount) THEN SendMessage(Handle, LB_SETTOPINDEX, CAST(WPARAM, value), 0): _TopIndex=value: END IF
END PROPERTY

ObjectDrawFns(QLISTBOX)

SUB QLISTBOX.AddItems(value AS string)
DIM AS integer i=SendMessage(Handle, LB_GETCOUNT, 0, 0)
    SendMessage(Handle, LB_INSERTSTRING, i, CAST(LPARAM, STRPTR(value)))
END SUB
SUB QLISTBOX.DelItems(Idx AS integer)
    SendMessage(Handle, LB_DELETESTRING, Idx, 0)
END SUB
SUB QLISTBOX.InsertItem(Index AS integer, S AS string)
    SendMessage(Handle, LB_INSERTSTRING, Index, CAST(LPARAM, STRPTR(S)))
END SUB
SUB QLISTBOX.LoadFromFile(FileName AS string)
DIM AS QSTRINGLIST li
DIM AS string tstr
    IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT SUB
    Clear()
    li.Clear: li.Duplicates=dupAccept
    IF Sorted THEN li.Sorted=True
    li.LoadFromFile(FileName)
    IF li.ItemCount=0 THEN EXIT SUB
    FOR i AS integer = 0 TO li.ItemCount-1
        tstr=li.Item(i)
        SendMessage(Handle, LB_INSERTSTRING, -1, CAST(LPARAM, STRPTR(tstr)))   ' Add to end of list
    NEXT i
    li.Clear
END SUB
SUB QLISTBOX.SaveToFile(FileName AS string)
DIM AS QSTRINGLIST li
DIM AS string*256 tstr
    li.Clear: li.Duplicates=dupAccept
    FOR i AS integer = 0 TO ItemCount-1
        SendMessage(Handle, LB_GETTEXT, i, CAST(LPARAM, @tstr))
        li.AddItems(tstr): tstr=""
    NEXT i
    li.SaveToFile(FileName): li.Clear
END SUB
SUB QLISTBOX.SortTheList()
DIM AS QSTRINGLIST li
DIM AS string*256 tstr
    li.Clear: li.Duplicates=dupAccept: li.Sorted=True
    FOR i AS integer = 0 TO ItemCount-1
        SendMessage(Handle, LB_GETTEXT, i, CAST(LPARAM, @tstr))
        li.AddItems(tstr): tstr=""
    NEXT i
    Clear()
    FOR i AS integer = 0 TO li.ItemCount-1
        tstr=RTRIM(li.Item(i))
        SendMessage(Handle, LB_INSERTSTRING, -1, CAST(LPARAM, STRPTR(tstr)))   ' Add to end of list
    NEXT i
    li.Clear
END SUB
SUB QLISTBOX.Clear()
    SendMessage(Handle, LB_RESETCONTENT, 0, 0)
END SUB

SUB QLISTBOX.PreSetConfig()
IF BorderStyle>0 THEN
    ObjStyle OR= WS_BORDER
ELSE
    ObjStyle AND= NOT(WS_BORDER)
END IF
END SUB
SUB QLISTBOX.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@ListBoxWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook new WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
    IF Style=lbOwnerDrawFixed THEN                                                      ' Ensure heights set
        SendMessage(Handle, LB_SETITEMHEIGHT, 0, ItemHeight): InvalidateRect(Handle, NULL, True)
    END IF
END SUB
DESTRUCTOR QLISTBOX
    Clear()
END DESTRUCTOR


#IFDEF __QGROUPBOX
' #13 ====================================================================================
TYPE QGROUPBOX
' Private (not)
    ObjId AS integer        = Q_GROUPBOX                    ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "BUTTON"                      ' Base class
    ObjStyle AS UINT        = BS_OWNERDRAW                  ' Can't use BS_GROUPBOX -> NO events!!!
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 150
    _Height AS integer      = 100
    _Align AS integer        = alNone
    Color AS UINT           = FORM_COLOR
    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB Repaint()
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnClick AS SUB(Sender AS QGROUPBOX PTR)
#IF 0
    OnDblClick AS SUB(Sender AS QGROUPBOX PTR)
#ENDIF
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QGROUPBOX PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QGROUPBOX PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QGROUPBOX PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QGROUPBOX PTR)           ' FB only
END TYPE

DoGeneralProperties(QGROUPBOX)
DoPositionalProperties(QGROUPBOX)
DoAlignProperty(QGROUPBOX)
DoHintProperties(QGROUPBOX)
DoReadOnlyProperties(QGROUPBOX)

PROPERTY QGROUPBOX.Caption() AS string: RETURN _Caption: END PROPERTY
PROPERTY QGROUPBOX.Caption(value AS string): _Caption=value: InvalidateRect(Handle, NULL, True): END PROPERTY

SUB QGROUPBOX.Repaint()
    InvalidateRect(Handle, NULL, True)
END SUB
SUB QGROUPBOX.PreSetConfig()
END SUB
SUB QGROUPBOX.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@GrpBoxWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))      ' Hook GrpBox WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
END SUB
#ENDIF          '#IFDEF __QGROUPBOX


#IFDEF __QSCROLLBOX
' #14 ====================================================================================
TYPE QSCROLLBOX
    ObjId AS integer        = Q_SCROLLBOX                   ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "BUTTON"                      ' Base class
    ObjStyle AS UINT        = BS_FLAT OR WS_HSCROLL OR WS_VSCROLL
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 150
    _Height AS integer      = 100
    _Align AS integer       = alNone
    _Color AS integer       = FORM_COLOR
    _HorzVisible AS integer = True
    _VertVisible AS integer = True
    _HorzRange AS integer   = 0
    _VertRange AS integer   = 0

    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

    PanHandle AS HWND                                       '|
    PanWnProc AS WNDPROC                                    '|
    PanX AS integer                                         '| The child panel
    PanY AS integer                                         '| Movable panel inside the scrollbox
    PanW AS integer                                         '|
    PanH AS integer                                         '|

#IF 0
    AutoScroll AS integer   = True  ' |INTEGER|RW|True|False|True
    HorzIncrement AS integer = 1    ' |INTEGER|RW|8
    HorzMargin AS integer   = 0     ' |INTEGER|RW|0
    HorzPosition AS integer = 0     ' |INTEGER|RW|0
    HorzTracking AS integer = False ' |INTEGER|RW|False|False|True
    TabOrder AS integer             ' |INTEGER|RW|
    VertIncrement AS integer = 1    ' |INTEGER|RW|8
    VertMargin AS integer   = 0     ' |INTEGER|RW|0
    VertPosition AS integer = 0     ' |INTEGER|RW|0
    VertTracking AS integer = False ' |INTEGER|RW|False|False|True
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY HorzRange() AS integer
    DECLARE PROPERTY HorzRange(value AS integer)
    DECLARE PROPERTY HorzVisible() AS integer
    DECLARE PROPERTY HorzVisible(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY VertRange() AS integer
    DECLARE PROPERTY VertRange(value AS integer)
    DECLARE PROPERTY VertVisible() AS integer
    DECLARE PROPERTY VertVisible(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB Repaint()
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnClick AS SUB(Sender AS QSCROLLBOX PTR)
    OnDblClick AS SUB(Sender AS QSCROLLBOX PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QSCROLLBOX PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QSCROLLBOX PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QSCROLLBOX PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QSCROLLBOX PTR)              ' FB only
    OnResize AS SUB(Sender AS QSCROLLBOX PTR)
END TYPE

DoGeneralProperties(QSCROLLBOX)
DoPositionalProperties(QSCROLLBOX)
DoAlignProperty(QSCROLLBOX)
DoHintProperties(QSCROLLBOX)
DoReadOnlyProperties(QSCROLLBOX)
PROPERTY QSCROLLBOX.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QSCROLLBOX.BorderStyle(value AS integer): IF Value<>0 THEN _BorderStyle=1 ELSE _BorderStyle=0: END IF: END PROPERTY
PROPERTY QSCROLLBOX.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QSCROLLBOX.Color(value AS integer): _Color=value: InvalidateRect(Handle,NULL,True): END PROPERTY
PROPERTY QSCROLLBOX.HorzVisible() AS integer: RETURN _HorzVisible: END PROPERTY
PROPERTY QSCROLLBOX.HorzVisible(value AS integer): IF Value<>0 THEN _HorzVisible=1: ELSE: _HorzVisible=0: END IF: END PROPERTY
PROPERTY QSCROLLBOX.VertVisible() AS integer: RETURN _VertVisible: END PROPERTY
PROPERTY QSCROLLBOX.VertVisible(value AS integer): IF Value<>0 THEN _VertVisible=1: ELSE: _VertVisible=0: END IF: END PROPERTY
PROPERTY QSCROLLBOX.HorzRange() AS integer: RETURN _HorzRange: END PROPERTY
PROPERTY QSCROLLBOX.HorzRange(value AS integer): IF value>_HorzRange THEN _HorzRange=value: END IF: END PROPERTY
PROPERTY QSCROLLBOX.VertRange() AS integer: RETURN _VertRange: END PROPERTY
PROPERTY QSCROLLBOX.VertRange(value AS integer): IF value>_VertRange THEN _VertRange=value: END IF: END PROPERTY

SUB QSCROLLBOX.Repaint()
    InvalidateRect(Handle,NULL,True)
END SUB
SUB QSCROLLBOX.PreSetConfig()
IF HorzVisible=False THEN
    IF VertVisible=True THEN _HorzVisible=0: ObjStyle AND= NOT(WS_HSCROLL)
END IF
IF VertVisible=False THEN
    IF HorzVisible=True THEN _VertVisible=0: ObjStyle AND= NOT(WS_VSCROLL)
END IF
END SUB
SUB QSCROLLBOX.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@ScrollBoxWndProc
    OldWndProc=CAST(WNDPROC, SetWindowLong(Handle, GWL_WNDPROC, CAST(long, NewWndProc)))        ' Hook ScrollBox WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
    SendMessage(Handle, WM_INIT_SCROLLBOX, 0, 0)
END SUB
#ENDIF          'IFDEF __QSCROLLBOX


' #15 ====================================================================================
TYPE QSCROLLBAR
' Private (not)
    ObjId AS integer        = Q_SCROLLBAR                   ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "SCROLLBAR"                   ' Base class
    ObjStyle AS UINT        = SBS_HORZ
    Font AS QFONT                                           ' Not used

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 100
    _Height AS integer      = 20
    _Align AS integer       = alNone
    _Kind AS integer        = SBS_HORZ                      ' sbHorizontal

    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled (value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Kind() AS integer
    DECLARE PROPERTY Kind(value AS integer)
    DECLARE PROPERTY LargeChange() AS integer
    DECLARE PROPERTY LargeChange(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Min() AS integer
    DECLARE PROPERTY Min(value AS integer)
    DECLARE PROPERTY Max() AS integer
    DECLARE PROPERTY Max(value AS integer)
    DECLARE PROPERTY PageSize() AS integer
    DECLARE PROPERTY PageSize(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Position() AS integer
    DECLARE PROPERTY Position(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY SmallChange() AS integer
    DECLARE PROPERTY SmallChange(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnChange AS SUB(Sender AS QSCROLLBAR PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QSCROLLBAR PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QSCROLLBAR PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QSCROLLBAR PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QSCROLLBAR PTR)           ' FB only
    OnScroll AS SUB(ScrollCode AS byte, ScrollPos AS integer, Sender AS QSCROLLBAR PTR)
END TYPE

DoGeneralProperties(QSCROLLBAR)
DoPositionalProperties(QSCROLLBAR)
DoAlignProperty(QSCROLLBAR)
DoHintProperties(QSCROLLBAR)
DoReadOnlyProperties(QSCROLLBAR)
PROPERTY QSCROLLBAR.Kind() AS integer: RETURN _Kind: END PROPERTY
PROPERTY QSCROLLBAR.Kind(value AS integer)
    IF (Value=1) THEN _Kind=1: ObjStyle=SBS_VERT: ELSE: _Kind=0: ObjStyle=SBS_HORZ: END IF
END PROPERTY
PROPERTY QSCROLLBAR.Min() AS integer: RETURN _Min: END PROPERTY
PROPERTY QSCROLLBAR.Min(value AS integer)
    IF (value >= Min) AND (value < Max) THEN _Min=value: SetScrollRange(Handle, SB_CTL, _Min, _Max, 1): END IF
END PROPERTY
PROPERTY QSCROLLBAR.Max() AS integer: RETURN _Max: END PROPERTY
PROPERTY QSCROLLBAR.Max(value AS integer)
    IF (value > Min) THEN _Max=value: SetScrollRange(Handle, SB_CTL, _Min, _Max, 1): END IF
END PROPERTY
PROPERTY QSCROLLBAR.Position() AS integer: RETURN _Position: END PROPERTY
PROPERTY QSCROLLBAR.Position(value AS integer)
    IF (value >= Min) AND (value <= Max) THEN _Position=value: SetScrollPos(Handle, SB_CTL, value, 1): END IF
END PROPERTY
PROPERTY QSCROLLBAR.SmallChange() AS integer: RETURN _SmallChange: END PROPERTY
PROPERTY QSCROLLBAR.SmallChange(value AS integer)
    IF (value >= 1) AND (value <= Max) THEN _SmallChange=value: END IF
END PROPERTY
PROPERTY QSCROLLBAR.LargeChange() AS integer: RETURN _LargeChange: END PROPERTY
PROPERTY QSCROLLBAR.LargeChange(value AS integer)
    IF (value >= 1) AND (value <= Max) THEN _LargeChange=value: END IF
END PROPERTY
PROPERTY QSCROLLBAR.PageSize() AS integer: RETURN _PageSize: END PROPERTY
PROPERTY QSCROLLBAR.PageSize(value AS integer)
    IF (value >= 1) AND (value <= Max) THEN _PageSize=value: END IF
END PROPERTY

SUB QSCROLLBAR.PreSetConfig()
END SUB
SUB QSCROLLBAR.PostConfig()
DIM AS SCROLLINFO ScrollInf

    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    NewWndProc=@ScollBarWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook new WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
    ScrollInf.cbSize=SIZEOF(ScrollInf)
    ScrollInf.fMask=SIF_ALL
    ScrollInf.nMin=Min+1: ScrollInf.nMax=Max+LargeChange: ScrollInf.nPage=LargeChange: ScrollInf.nPos=Position
    SetScrollInfo(Handle, SB_CTL, @ScrollInf, 1)
END SUB

#IFDEF __QSTRINGGRID
' #16 ====================================================================================
TYPE QSTRINGGRID
' Private (not)
    ObjId AS integer        = Q_STRINGGRID                  ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "BUTTON"                      ' Base class
    ObjStyle AS UINT        = BS_OWNERDRAW OR WS_CLIPSIBLINGS
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 150
    _Height AS integer      = 100
    _Align AS integer       = alNone

    _Col AS integer         = 1
    _Color AS integer       = &hffffff
    _ColCount AS integer    = 5
    _ColumnStyle AS integer = gcsNone                       ' Should be an ARRAY of INTEGER, 1 & FIXED!
    _FixedColor AS integer  = FORM_COLOR
    _FixedCols AS integer   = 1                             ' 0 or 1 ONLY
    _FixedRows AS integer   = 1                             ' 0 or 1 ONLY
    _GridHeight AS integer                                  ' "viewable" grid height (can be < clientHeight)
    _GridWidth AS integer                                   ' "viewable" grid width (can be < clientWidth)
    _Hilite AS integer      = 0                             ' "hilite" color of selected cell
    _LeftCol AS integer     = 1
    _Row AS integer         = 1
    _RowCount AS integer    = 5
    _ScrollBars AS integer  = ssBoth
    _Separator AS string    = CHR(255)
    _TopRow AS integer      = 1
    _VisibleColCount AS integer
    _VisibleRowCount AS integer

    DefaultColWidth AS integer  = 64
    DefaultRowHeight AS integer = 24
    ColWidths(0 TO 127) AS integer                          ' max ColCount 128
    RowHeights AS integer                                   ' max visible RowCount
    GridLineWidth AS integer = 1

    GridList AS QSTRINGLIST                                 ' The actual data in the grid
    KeyState AS integer     = 0                             ' Used in the WndProc
    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    Cell AS string()                    ' |2D ARRAY of STRING|RW| - provided by an OVERLOADed Method
    ColumnList AS string()              ' |ARRAY of STRING|RW|
    ColumnStyle AS integer              ' |INTEGER|RW|
    EditorMode AS integer               ' |INTEGER|RW|
    GridLineWidth AS integer=1          ' |INTEGER|RW|
    RowHeights() AS integer             ' |ARRAY of INTEGER|RW|
    TabOrder AS integer                 ' |INTEGER|RW|
    TabStops AS integer()               ' |ARRAY of INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Col() AS integer
    DECLARE PROPERTY Col(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY ColCount() AS integer
    DECLARE PROPERTY ColCount(value AS integer)
    DECLARE PROPERTY ColumnStyle() AS integer
    DECLARE PROPERTY ColumnStyle(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY FixedColor() AS integer
    DECLARE PROPERTY FixedColor(value AS integer)
    DECLARE PROPERTY FixedCols() AS integer
    DECLARE PROPERTY FixedCols(value AS integer)
    DECLARE PROPERTY FixedRows() AS integer
    DECLARE PROPERTY FixedRows(value AS integer)
    DECLARE PROPERTY GridHeight() AS integer
    DECLARE PROPERTY GridHeight(value AS integer)
    DECLARE PROPERTY GridWidth() AS integer
    DECLARE PROPERTY GridWidth(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Hilite() AS integer
    DECLARE PROPERTY Hilite(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY LeftCol() AS integer
    DECLARE PROPERTY LeftCol(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Row() AS integer
    DECLARE PROPERTY Row(value AS integer)
    DECLARE PROPERTY RowCount() AS integer
    DECLARE PROPERTY RowCount(value AS integer)
    DECLARE PROPERTY ScrollBars() AS integer
    DECLARE PROPERTY ScrollBars(value AS integer)
    DECLARE PROPERTY Separator() AS string
    DECLARE PROPERTY Separator(value AS string)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY TopRow() AS integer
    DECLARE PROPERTY TopRow(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY VisibleColCount() AS integer
    DECLARE PROPERTY VisibleColCount(value AS integer)
    DECLARE PROPERTY VisibleRowCount() AS integer
    DECLARE PROPERTY VisibleRowCount(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB AddOptions(opt AS integer)
    DECLARE SUB DeleteCol(Column AS integer)
    DECLARE SUB DeleteRow(Row AS integer)
    DECLARE SUB DelOptions(opt AS integer)
    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, hImage AS HWND, S AS RECT PTR)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, hImage AS HDC, S AS RECT PTR)
    DECLARE SUB Draw(x AS integer, y AS integer, FileName AS string)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB InsertCol(Column AS integer)
    DECLARE SUB InsertRow(Row AS integer)
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB LoadFromFile(File AS string, RowOffset AS integer, ColOffset AS integer, MaxRows AS integer)
    DECLARE SUB Paint(x AS integer, y AS integer, c AS integer, borderc AS integer)
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Repaint()
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    DECLARE SUB SaveToFile(File AS string, RowOffset AS integer, ColOffset AS integer, MaxRows AS integer)
    DECLARE SUB SwapCols(Col1 AS integer, Col2 AS integer)
    DECLARE SUB SwapRows(Row1 AS integer, Row2 AS integer)
    DECLARE SUB StretchDraw(lpRect AS RECT PTR, FileName AS string)
    DECLARE FUNCTION TextHeight(Text AS string) AS integer
    DECLARE FUNCTION TextWidth(Text AS string) AS integer
    DECLARE SUB TextRect(lpRect AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
#IF 0
    DECLARE SUB LoadFromStream(S AS Stream, RowOffset AS integer, ColOffset AS integer, MaxRows AS integer)
    DECLARE SUB SaveToStream(S AS Stream, RowOffset AS integer, ColOffset AS integer, MaxRows AS integer)
#ENDIF
' Extras
    DECLARE FUNCTION Cell OVERLOAD (col AS integer, row AS integer) AS string                   ' Change from a PROPERTY
    DECLARE FUNCTION Cell OVERLOAD (col AS integer, row AS integer, S AS string) AS string      ' Change from a PROPERTY
    DECLARE FUNCTION Pixel(x AS integer, y AS integer) AS integer
    DECLARE FUNCTION SaveToBMP(FileName AS string) AS integer
    DECLARE DESTRUCTOR
    DECLARE SUB ConfigureGrid()
    DECLARE SUB ConfigureScrollBars()
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnDrawCell AS SUB(Col AS integer, Row AS integer, State AS integer, lpRct AS RECT PTR, Sender AS QSTRINGGRID PTR)
    OnEllipsisClick AS SUB(Col AS integer, Row AS integer, Sender AS QSTRINGGRID PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QSTRINGGRID PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QSTRINGGRID PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QSTRINGGRID PTR)
    OnListDropDown AS SUB(Col AS integer, Row AS integer, BYREF S AS string, Sender AS QSTRINGGRID PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QSTRINGGRID PTR)           ' FB only
    OnSelectCell AS SUB(Col AS integer, Row AS integer, CanSelect AS integer, Sender AS QSTRINGGRID PTR)
    OnSetEditText AS SUB(Col AS integer, Row AS integer, Value AS string, Sender AS QSTRINGGRID PTR)
END TYPE

DoGeneralProperties(QSTRINGGRID)
DoPositionalProperties(QSTRINGGRID)
DoAlignProperty(QSTRINGGRID)
DoHintProperties(QSTRINGGRID)
DoReadOnlyProperties(QSTRINGGRID)
PROPERTY QSTRINGGRID.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QSTRINGGRID.BorderStyle(value AS integer): IF Value<>0 THEN _BorderStyle=1 ELSE _BorderStyle=0: END IF: END PROPERTY
PROPERTY QSTRINGGRID.Col() AS integer: RETURN _Col: END PROPERTY
PROPERTY QSTRINGGRID.Col(value AS integer): END PROPERTY                        ' Read ONLY
PROPERTY QSTRINGGRID.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QSTRINGGRID.Color(value AS integer): _Color=value: InvalidateRect(Handle,NULL,True): END PROPERTY
PROPERTY QSTRINGGRID.ColCount() AS integer: RETURN _ColCount: END PROPERTY
PROPERTY QSTRINGGRID.ColCount(value AS integer)
IF (value>1) AND (value<128) THEN
    _ColCount=value: IF Handle THEN InvalidateRect(Handle,NULL,True)
END IF
END PROPERTY
PROPERTY QSTRINGGRID.ColumnStyle() AS integer: RETURN _ColumnStyle: END PROPERTY
PROPERTY QSTRINGGRID.ColumnStyle(value AS integer): END PROPERTY
PROPERTY QSTRINGGRID.FixedColor() AS integer: RETURN _FixedColor: END PROPERTY
PROPERTY QSTRINGGRID.FixedColor(value AS integer): _FixedColor=value: InvalidateRect(Handle,NULL,True): END PROPERTY
PROPERTY QSTRINGGRID.FixedCols() AS integer: RETURN _FixedCols: END PROPERTY
PROPERTY QSTRINGGRID.FixedCols(value AS integer)
IF value=0 THEN _FixedCols=0: ELSE: _FixedCols=1: END IF: _LeftCol=value
END PROPERTY
PROPERTY QSTRINGGRID.FixedRows() AS integer: RETURN _FixedRows: END PROPERTY
PROPERTY QSTRINGGRID.FixedRows(value AS integer)
IF value=0 THEN _FixedRows=0: ELSE: _FixedRows=1: END IF: _TopRow=value
END PROPERTY
PROPERTY QSTRINGGRID.GridHeight() AS integer
DIM AS RECT rct
DIM AS integer H, tmp=0
    GetClientRect(Handle, @rct): H=rct.Bottom-rct.Top
    IF FixedRows>0 THEN tmp=DefaultRowHeight
    FOR i AS integer = TopRow TO RowCount-1: tmp += DefaultRowHeight: NEXT i
    IF tmp<H THEN: _GridHeight=tmp: ELSE: _GridHeight=H: END IF
    RETURN _GridHeight
END PROPERTY
PROPERTY QSTRINGGRID.GridHeight(value AS integer): END PROPERTY                 ' Read ONLY
PROPERTY QSTRINGGRID.GridWidth() AS integer
DIM AS RECT rct
DIM AS integer W, tmp=0
    GetClientRect(Handle, @rct): W=rct.Right-rct.Left
    IF FixedCols>0 THEN tmp=ColWidths(0)
    FOR i AS integer = LeftCol TO ColCount-1: tmp += ColWidths(i): NEXT i
    IF tmp<W THEN: _GridWidth=tmp: ELSE: _GridWidth=W: END IF
    RETURN _GridWidth
END PROPERTY
PROPERTY QSTRINGGRID.GridWidth(value AS integer): END PROPERTY                  ' Read ONLY
PROPERTY QSTRINGGRID.HiLite() AS integer: RETURN _Hilite: END PROPERTY
PROPERTY QSTRINGGRID.HiLite(value AS integer): _Hilite=value: END PROPERTY
PROPERTY QSTRINGGRID.LeftCol() AS integer: RETURN _LeftCol: END PROPERTY
PROPERTY QSTRINGGRID.LeftCol(value AS integer): END PROPERTY
PROPERTY QSTRINGGRID.Row() AS integer: RETURN _Row: END PROPERTY
PROPERTY QSTRINGGRID.Row(value AS integer): END PROPERTY                        ' Read ONLY
PROPERTY QSTRINGGRID.RowCount() AS integer: RETURN _RowCount: END PROPERTY
PROPERTY QSTRINGGRID.RowCount(value AS integer)
DIM AS QStringList li
DIM AS string tstr
    li.Clear: li.Duplicates=dupAccept
    SELECT CASE value
        CASE RowCount: EXIT PROPERTY
        CASE IS < RowCount
            FOR i AS integer = 0 TO RowCount-1
                tstr=GridList.Item(i): li.AddItems(tstr)
            NEXT i
        CASE ELSE
            tstr=GridList.Item(0)
            tstr=String(rqTally(tstr,Separator),Separator)                          ' A blank line
            li.AddList(GridList)
            FOR i AS integer = 1 TO (value-RowCount)
                li.AddItems(tstr)
            NEXT i
    END SELECT
    GridList.Clear: GridList.AddList(li): li.Clear
    _RowCount=value: ConfigureScrollBars()
    IF Handle THEN InvalidateRect(Handle,NULL,True)
END PROPERTY
PROPERTY QSTRINGGRID.ScrollBars() AS integer: RETURN _ScrollBars: END PROPERTY
PROPERTY QSTRINGGRID.ScrollBars(value AS integer): IF (value>=0) AND (value<=3) THEN _ScrollBars=value: END IF: END PROPERTY
PROPERTY QSTRINGGRID.Separator() AS string: RETURN _Separator: END PROPERTY
PROPERTY QSTRINGGRID.Separator(value AS string): _Separator=value: END PROPERTY
PROPERTY QSTRINGGRID.TopRow() AS integer: RETURN _TopRow: END PROPERTY
PROPERTY QSTRINGGRID.TopRow(value AS integer): END PROPERTY                     ' Read ONLY
PROPERTY QSTRINGGRID.VisibleColCount() AS integer: RETURN _VisibleColCount: END PROPERTY
PROPERTY QSTRINGGRID.VisibleColCount(value AS integer): END PROPERTY            ' Read ONLY
PROPERTY QSTRINGGRID.VisibleRowCount() AS integer: RETURN _VisibleRowCount: END PROPERTY
PROPERTY QSTRINGGRID.VisibleRowCount(value AS integer): END PROPERTY            ' Read ONLY

FUNCTION QSTRINGGRID.Cell OVERLOAD (QCol AS integer, QRow AS integer) AS string                 ' Read cell() contents
DIM AS string tstr=GridList.Item(QRow): RETURN rqFieldSTR(tstr,separator,QCol+1)
END FUNCTION
FUNCTION QSTRINGGRID.Cell OVERLOAD (QCol AS integer, QRow AS integer, S AS string) AS string    ' Write cell() contents
    IF ((QCol < 0) OR (QCol > ColCount-1)) THEN RETURN ""
    IF ((QRow < 0) OR (QRow > RowCount-1)) THEN RETURN ""
    DIM AS integer i
    DIM AS string tstr, tok=""
    DIM AS QStringList Li: Li.Clear: Li.Duplicates=dupAccept
    tstr=GridList.Item(QRow)
    FOR i=0 TO ColCount-1
        IF i<>QCol THEN
            tok=tok+rqFIELDSTR(tstr,Separator,i+1)+Separator        ' Keep existing
        ELSE
            tok=tok+S+Separator                             ' Add new
        END IF
    NEXT i
    tstr=MID(tok,1,(LEN(tok)-LEN(Separator)))               ' Remove last separator
    FOR i=0 TO GridList.ItemCount-1
        IF i<>QRow THEN
            Li.AddItems(GridList.Item(i))                   ' Add orig row to temp list
        ELSE
            Li.AddItems(tstr)                               ' Add updated row to temp list
        END IF
    NEXT i
    GridList.Clear: GridList.AddList(Li): Li.Clear          ' Update list with temp list
    IF Handle THEN
        RePaint()
        SetFocus(Handle)
    END IF
    RETURN ""
END FUNCTION
SUB QSTRINGGRID.DeleteCol(QCol AS integer)
    IF (QCol<0) OR (QCol>=ColCount) THEN EXIT SUB
    DIM AS string tstr, tok
    DIM AS QStringList Li: Li.Clear: Li.Duplicates=dupAccept
    FOR i AS integer = 0 TO GridList.ItemCount-1
        tstr=GridList.Item(i): tok=""
        FOR j AS integer = 1 TO ColCount
            IF QCol<>(j-1) THEN tok=tok + rqFIELDSTR(tstr,Separator,j) + Separator
        NEXT j
        tstr=MID(tok,1,(LEN(tok)-LEN(Separator)))
        Li.AddItems(tstr)
    NEXT i
    GridList.Clear: GridList.AddList(Li): Li.Clear

    IF QCol < (ColCount-1) THEN
        FOR i AS integer = QCol TO ColCount-2
            ColWidths(i)=ColWidths(i+1)
        NEXT i
    END IF
    ColCount=ColCount-1
    ConfigureScrollBars()                                   ' Re-adjust scroll bar parms
    RePaint()
END SUB
SUB QSTRINGGRID.DeleteRow(QRow AS integer)
    IF (QRow<0) OR (QRow>=RowCount) THEN EXIT SUB
    DIM AS string tstr
    DIM AS QStringList Li: Li.Clear: Li.Duplicates=dupAccept
    FOR i AS integer = 0 TO GridList.ItemCount-1
        IF i<>QRow THEN: tstr=GridList.Item(i): Li.AddItems(tstr): END IF
    NEXT i
    GridList.Clear: GridList.AddList(Li): Li.Clear          ' RowHeights are constant
    RowCount=RowCount-1
    ConfigureScrollBars()                                   ' Re-adjust scroll bar parms
    RePaint()
END SUB
SUB QSTRINGGRID.InsertCol(QCol AS integer)
    IF (QCol<0) OR (QCol>ColCount) THEN EXIT SUB
    DIM AS string tstr, tok
    DIM AS QStringList Li: Li.Clear: Li.Duplicates=dupAccept
    FOR i AS integer = 0 TO GridList.ItemCount-1
        tstr=GridList.Item(i): tok=""
        FOR j AS integer = 1 TO ColCount
            IF QCol=(j-1) THEN tok=tok+Separator
            tok=tok + rqFIELDSTR(tstr,Separator,j) + Separator
        NEXT j
        tstr=MID(tok,1,(LEN(tok)-LEN(Separator)))           ' Remove trailing separator
        Li.AddItems(tstr)
    NEXT i
    GridList.Clear: GridList.AddList(Li): Li.Clear
    ColCount=ColCount+1                                     ' Add one column
    FOR i AS integer = (ColCount-1) TO (QCol+1) STEP -1
        ColWidths(i)=ColWidths(i-1)
    NEXT i
    ColWidths(QCol)=DefaultColWidth
    ConfigureScrollBars()                                   ' Re-adjust scroll bar parms
    RePaint()
END SUB
SUB QSTRINGGRID.InsertRow(QRow AS integer)
    IF (QRow<0) OR (QRow>RowCount) THEN EXIT SUB
    DIM AS string tstr, tok=String(ColCount,Separator)
    DIM AS QStringList Li: Li.Clear: Li.Duplicates=dupAccept
    FOR i AS integer = 0 TO GridList.ItemCount-1
        IF i=QRow THEN Li.AddItems(tok)
        tstr=GridList.Item(i): Li.AddItems(tstr)
    NEXT i
    GridList.Clear: GridList.AddList(Li): Li.Clear
    RowCount=RowCount+1
    ConfigureScrollBars()                                   ' Re-adjust scroll bar parms
    RePaint()
END SUB
SUB QSTRINGGRID.SwapCols(Col1 AS integer, Col2 AS integer)
    IF (Col1<0) OR (Col2<0) OR (Col1>=ColCount) OR (Col2>=ColCount) THEN EXIT SUB
    DIM AS QStringList Li: Li.Clear: Li.Duplicates=dupAccept
    DIM AS string tstr,tok1,tok2,result
    Swap ColWidths(Col1), ColWidths(Col2)
    Col1 += 1: Col2 += 1
    FOR i AS integer = 0 TO RowCount-1
        tstr=GridList.Item(i): result=""
        tok1=rqFIELDSTR(tstr,Separator,Col1): tok2=rqFIELDSTR(tstr,Separator,Col2)
        FOR j AS integer = 1 TO ColCount
            SELECT CASE j
                CASE Col1: result=result+tok2+Separator
                CASE Col2: result=result+tok1+Separator
                CASE ELSE
                    result=result+rqFIELDSTR(tstr,Separator,j)+Separator
            END SELECT
        NEXT j
        tstr=MID(result,1,LEN(result)-LEN(Separator))
        Li.AddItems(tstr)
    NEXT i
    GridList.Clear: GridList.AddList(Li): Li.Clear
    Repaint()
END SUB
SUB QSTRINGGRID.SwapRows(Row1 AS integer, Row2 AS integer)
    IF (Row1<0) OR (Row2<0) OR (Row1>=RowCount) OR (Row2>=RowCount) THEN EXIT SUB
    DIM AS QStringList Li: Li.Clear: Li.Duplicates=dupAccept
    DIM AS string tstr,tok1,tok2
    tok1=GridList.Item(Row1): tok2=GridList.Item(Row2)
    FOR i AS integer = 0 TO RowCount-1
        SELECT CASE i
            CASE Row1: Li.AddItems(tok2)
            CASE Row2: Li.AddItems(tok1)
            CASE ELSE
                tstr=GridList.Item(i)
                Li.AddItems(tstr)
        END SELECT
    NEXT i
    GridList.Clear: GridList.AddList(Li): Li.Clear
    Repaint()
END SUB
SUB QSTRINGGRID.LoadFromFile(File AS string, RowOffset AS integer, ColOffset AS integer, MaxRows AS integer)
DIM AS QSTRINGLIST Li
DIM AS SCROLLINFO scrInf
DIM AS string tstr, tok, blank, preStr=""
DIM AS integer cnt, maxCount

    IF FileExists(File)=False THEN InpFileError(File): EXIT SUB
    Li.Clear: Li.Duplicates=dupAccept
    Li.LoadFromFile(File)                                   ' Load file into temp list
    IF li.ItemCount=0 THEN EXIT SUB
    IF RowOffset<0 THEN RowOffset=0: IF ColOffset<0 THEN ColOffset=0
    GridList.Clear: GridList.Duplicates=dupAccept

    IF (MaxRows = -1) OR (MaxRows>Li.ItemCount) THEN
        maxCount=Li.ItemCount
    ELSE
        maxCount=MaxRows
    END IF
    cnt=rqTally(Li.Item(0),Separator)+ColOffset             ' Creating a blank line
    IF ColCount>cnt THEN cnt=ColCount
    blank=String(cnt,Separator)
    IF RowOffset>0 THEN                                     ' Need any blank lines?
        FOR i AS integer = 0 TO RowOffset-1: GridList.AddItems(blank): Next i
    END IF
    IF ColOffset>0 THEN preStr=String(ColOffset,Separator)
    FOR i AS integer = 0 TO maxCount-1
        tstr=preStr+Li.Item(i)
        GridList.AddItems(tstr)
    NEXT i
    Li.Clear
    _RowCount=GridList.ItemCount
    IF (ScrollBars AND ssVertical)>0 THEN
        scrInf.cbSize=SIZEOF(scrInf): scrInf.fMask=SIF_RANGE
        GetScrollInfo(Handle, SB_VERT, @ScrInf)
        scrInf.nMax=RowCount
        SetScrollInfo(Handle, SB_VERT, @ScrInf, 0)          ' ReSet vertical scrollbars
    END IF
    RePaint()
    SetFocus(Handle)
END SUB
SUB QSTRINGGRID.SaveToFile(File AS string, RowOffset AS integer, ColOffset AS integer, MaxRows AS integer)
DIM AS QSTRINGLIST Li
DIM AS STRING tstr, tok
DIM AS integer endCount, tokCount, lenth

    IF (MaxRows < -1) OR (MaxRows=0) THEN EXIT SUB
    IF RowOffset<0 THEN RowOffset=0: IF ColOffset<0 THEN ColOffset=0
    IF (MaxRows = -1) OR (MaxRows>RowCount) THEN
        endCount=RowCount
    ELSE
        endCount=RowOffset+MaxRows
    END IF
    Li.Clear: Li.Duplicates=dupAccept
    FOR i AS integer = RowOffSet TO endCount-1
        tstr=GridList.Item(i)
        IF ColOffset>0 THEN
            tokCount=rqTALLY(tstr,Separator)+1
            tok=""
            FOR j AS integer = ColOffset+1 TO tokCount
                tok=tok+rqFIELDSTR(tstr,Separator,j)+Separator
            NEXT j
            lenth=LEN(tok)-LEN(Separator)
            tstr=MID(tok, 1, lenth)
        END IF
        Li.AddItems(tstr)
    NEXT i
    Li.SaveToFile(File): Li.Clear
END SUB

ObjectDrawFns(QSTRINGGRID)

DESTRUCTOR QSTRINGGRID
    GridList.Clear
END DESTRUCTOR
SUB QSTRINGGRID.ConfigureScrollBars()
DIM AS SCROLLINFO scrInf

    scrInf.cbSize=SIZEOF(scrInf)
    scrInf.fMask=SIF_RANGE OR SIF_PAGE OR SIF_POS
    IF (ScrollBars AND ssHorizontal)>0 THEN
        scrInf.nMin=0: scrInf.nMax=ColCount-FixedCols-1: scrInf.nPos=0: scrInf.nPage=1
        SetScrollInfo(Handle, SB_HORZ, @ScrInf, 0)          ' Set horizontal scrollbars
    END IF
    IF (ScrollBars AND ssVertical)>0 THEN
        scrInf.nMin=0: scrInf.nMax=RowCount-FixedRows-1: scrInf.nPos=0: scrInf.nPage=1
        SetScrollInfo(Handle, SB_VERT, @ScrInf, 0)          ' Set vertical scrollbars
    END IF
END SUB
SUB QSTRINGGRID.ConfigureGrid()                             ' Fill with dummy blank data
DIM AS RECT rct
DIM as string tstr=" "
    IF (ColCount<1) OR (RowCount<1) THEN EXIT SUB           ' Internal error?
    FOR i AS integer=1 TO ColCount-1: tstr=tstr+Separator+" ": NEXT i           ' Blank data row
    GridList.Duplicates=dupAccept
    FOR i AS integer=1 TO RowCount: GridList.AddItems(tstr): NEXT i             ' Entire list blank
    IF FixedRows=0 THEN: _TopRow=0: _Row=0: END IF
    IF FixedCols=0 THEN: _LeftCol=0: _Col=0: END IF
    ' ONLY FULL rows/cols AND NOT 'Fixed' rows/cols (client data cells)
    GetClientRect(Handle, @rct)
    _VisibleRowCount=(rct.Bottom-rct.Top)\DefaultRowHeight
    _VisibleRowCount -= FixedRows
    FOR i AS integer=0 TO 127
        IF ColWidths(i)=0 THEN ColWidths(i)=DefaultColWidth
    NEXT i
    RowHeights=DefaultRowHeight
END SUB
SUB QSTRINGGRID.PreSetConfig()
    IF BorderStyle>0 THEN ObjStyle OR= WS_BORDER
    IF (ScrollBars AND ssHorizontal)>0 THEN ObjStyle OR= WS_HSCROLL
    IF (ScrollBars AND ssVertical)>0 THEN ObjStyle OR= WS_VSCROLL
    ConfigureGrid()
END SUB
SUB QSTRINGGRID.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@StrGridWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook the WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
    ConfigureScrollBars()
    RePaint()
END SUB
#ENDIF              ' #IFDEF __QSTRINGGRID


' #17 ====================================================================================
TYPE ItemType
    Caption AS string                                       ' Array of type Item eg ListView.Item(0).Caption
    Checked AS integer                                      ' If CheckBoxes is enabled and item is checked
    Handle AS integer                                       ' Read-only
    ImageIndex AS integer
    Index AS integer                                        ' Read-only
    Selected AS integer
    StateIndex AS integer
END TYPE

TYPE ColumnType                                             ' Array of type column eg ListView.Column(0).Width
    Caption AS string
    Width AS integer
END TYPE

TYPE QLISTVIEW
' Private (not)
    ObjId AS integer        = Q_LISTVIEW                    ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "SysListView32"               ' Base class
    ObjStyle AS UINT        = LVS_REPORT                    '
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 150
    _Height AS integer      = 100
    _Align AS integer       = alNone
    _CheckBoxes AS integer  = False
    _Color AS integer       = &hffffff
    _ColumnClick AS integer = True
    _ColumnsCount AS integer= 0
    _GridLines AS integer   = False
    _HotTrack AS integer    = False
    _ItemCount AS integer   = 0
    _RowSelect AS integer   = False
    _ShowColumnHeaders AS integer = True
    _ViewStyle AS integer   = vsReport                      ' Only ONE style ATT
    _SubCount(0 TO 63) AS integer                           ' Index of SubItems per Item index

    ItemIndex AS integer
    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    Column()                        ' |ARRAY of ColumnType|RW|
    HideSelection AS integer=0      ' |INTEGER|RW|False|False|True
    Item()                          ' |ARRAY of ItemType|RW|
    LargeImages AS HWND             ' |QIMAGELIST|W|
    MultiSelect AS integer          ' |INTEGER|RW|False|False|True
    ReadOnly AS integer             ' |INTEGER|RW|False|False|True
    SelCount AS integer             ' |INTEGER|RW|
    Selected()                      ' |ARRAY of INTEGER|RW|
    SmallImages AS HWND             ' |QIMAGELIST|W|
    SortType AS integer             ' |INTEGER|RW|stNone|stNone|stText
    StateImages AS HWND             ' |QIMAGELIST|W|
    SubItem()                       ' |2D ARRAY of STRING|RW|
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY CheckBoxes() AS integer
    DECLARE PROPERTY CheckBoxes(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY ColumnClick() AS integer
    DECLARE PROPERTY ColumnClick(value AS integer)
    DECLARE PROPERTY ColumnsCount() AS integer
    DECLARE PROPERTY ColumnsCount(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY GridLines() AS integer
    DECLARE PROPERTY GridLines(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY HotTrack() AS integer
    DECLARE PROPERTY HotTrack(value AS integer)
    DECLARE PROPERTY ItemCount() AS integer
    DECLARE PROPERTY ItemCount(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY RowSelect() AS integer
    DECLARE PROPERTY RowSelect(value AS integer)
    DECLARE PROPERTY ShowColumnHeaders() AS integer
    DECLARE PROPERTY ShowColumnHeaders(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY ViewStyle() AS integer
    DECLARE PROPERTY ViewStyle(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB Clear()
    DECLARE SUB AddColumns(cWidth AS integer, value AS string)      ' FUDGE: One column at a time
    DECLARE SUB AddItems(value AS string)                           ' FUDGE: One string at a time (each Row in col 0)
    DECLARE SUB AddSubItem(index AS integer, value AS string)       ' Add to each column of row index
#IF 0
    DECLARE SUB ClearColumns()
    DECLARE SUB InsertItem(index AS integer, string AS string)
    DECLARE SUB DelItems(integer,....)
    DECLARE SUB DelSubItem(index AS integer, SubIndex AS integer)
    DECLARE SUB InsertSubItem(index AS integer, SubIndex AS integer, string AS string)
    DECLARE SUB SwapItem(index1 AS integer, index2 AS integer)
#ENDIF
' Extras
    DECLARE SUB SetExtStyle(nuStyle AS UINT, Status AS integer)
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE DESTRUCTOR
' Events
    OnClick AS SUB(Sender AS QLISTVIEW PTR)
    OnChange AS SUB(Index AS integer, Change AS byte, Sender AS QLISTVIEW PTR)
    OnColumnClick AS SUB(Column AS integer, Sender AS QLISTVIEW PTR)
    OnDblClick AS SUB(Sender AS QLISTVIEW PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QLISTVIEW PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QLISTVIEW PTR)        ' FB only
END TYPE

DoGeneralProperties(QLISTVIEW)
DoPositionalProperties(QLISTVIEW)
DoAlignProperty(QLISTVIEW)
DoHintProperties(QLISTVIEW)
DoReadOnlyProperties(QLISTVIEW)
PROPERTY QLISTVIEW.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QLISTVIEW.BorderStyle(value AS integer): IF value<>0 THEN _BorderStyle=1 ELSE _BorderStyle=0: END IF: END PROPERTY
PROPERTY QLISTVIEW.CheckBoxes() AS integer: RETURN _CheckBoxes: END PROPERTY
PROPERTY QLISTVIEW.CheckBoxes(value AS integer)
IF value=0 THEN _CheckBoxes=False: ELSE: _CheckBoxes=True: END IF
SetExtStyle(LVS_EX_CHECKBOXES,_CheckBoxes)
END PROPERTY
PROPERTY QLISTVIEW.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QLISTVIEW.Color(value AS integer)
_Color=value: ListView_SetBkColor(Handle,CAST(COLORREF,_Color)): ListView_SetTextBkColor(Handle,CAST(COLORREF,_Color))
END PROPERTY
PROPERTY QLISTVIEW.ColumnClick() AS integer: RETURN _ColumnClick: END PROPERTY
PROPERTY QLISTVIEW.ColumnClick(value AS integer): IF value=0 THEN _ColumnClick=0 ELSE _ColumnClick=1: END IF: END PROPERTY
PROPERTY QLISTVIEW.ColumnsCount() AS integer: RETURN _ColumnsCount: END PROPERTY
PROPERTY QLISTVIEW.ColumnsCount(value AS integer): END PROPERTY                     ' Read Only
PROPERTY QLISTVIEW.GridLines() AS integer: RETURN _GridLines: END PROPERTY
PROPERTY QLISTVIEW.GridLines(value AS integer)
IF value=0 THEN _GridLines=False: ELSE: _GridLines=True: END IF
SetExtStyle(LVS_EX_GRIDLINES,_GridLines)
END PROPERTY
PROPERTY QLISTVIEW.HotTrack() AS integer: RETURN _HotTrack: END PROPERTY
PROPERTY QLISTVIEW.HotTrack(value AS integer)
IF value=0 THEN _HotTrack=False: ELSE: _HotTrack=True: END IF
SetExtStyle(LVS_EX_TRACKSELECT,_HotTrack)
END PROPERTY
PROPERTY QLISTVIEW.ItemCount() AS integer: _ItemCount=SendMessage(Handle,LVM_GETITEMCOUNT,0,0): RETURN _ItemCount: END PROPERTY
PROPERTY QLISTVIEW.ItemCount(value AS integer): END PROPERTY                        ' Read Only
PROPERTY QLISTVIEW.RowSelect() AS integer: RETURN _RowSelect: END PROPERTY
PROPERTY QLISTVIEW.RowSelect(value AS integer)
IF value=0 THEN _RowSelect=False: ELSE: _RowSelect=True: END IF
SetExtStyle(LVS_EX_FULLROWSELECT,_RowSelect)
END PROPERTY
PROPERTY QLISTVIEW.ShowColumnHeaders() AS integer: RETURN _ShowColumnHeaders: END PROPERTY
PROPERTY QLISTVIEW.ShowColumnHeaders(value AS integer)
    IF value=0 THEN _ShowColumnHeaders=False ELSE _ShowColumnHeaders=True: END IF
END PROPERTY
PROPERTY QLISTVIEW.ViewStyle() AS integer: RETURN _ViewStyle: END PROPERTY          ' Read Only
PROPERTY QLISTVIEW.ViewStyle(value AS integer): END PROPERTY                        ' FUDGE: Only one style!

SUB QLISTVIEW.Clear
    SendMessage(Handle, LVM_DELETEALLITEMS, 0, 0)
    Erase(_SubCount)
END SUB
SUB QLISTVIEW.AddColumns(cWidth AS integer, value AS string)
DIM AS LVCOLUMN lvColmn
    lvColmn.mask=LVCF_FMT OR LVCF_TEXT OR LVCF_WIDTH
    lvColmn.fmt=LVCFMT_LEFT: lvColmn.cx=cWidth: lvColmn.pszText=STRPTR(value)
    SendMessage(Handle, LVM_INSERTCOLUMN, _ColumnsCount, CAST(LPARAM, @lvColmn))
    _ColumnsCount += 1
END SUB
SUB QLISTVIEW.AddItems(value AS string)
DIM AS LVITEM lvItm
DIM AS integer itmCount=SendMessage(Handle,LVM_GETITEMCOUNT,0,0)
    lvItm.mask=LVIF_TEXT: lvItm.iItem=itmCount: lvItm.pszText=STRPTR(value): lvItm.cchTextMax=LEN(value)+1
    SendMessage(Handle, LVM_INSERTITEM, 0, CAST(LPARAM, @lvItm))
END SUB
SUB QLISTVIEW.AddSubItem(index AS integer, value AS string)
DIM AS LVITEM lvItm
    _SubCount(index) += 1
    lvItm.mask=LVIF_TEXT: lvItm.iItem=index: lvItm.iSubItem=_SubCount(index)
    lvItm.pszText=STRPTR(value): lvItm.cchTextMax=LEN(value)+1
    SendMessage(Handle, LVM_SETITEM, 0, CAST(LPARAM, @lvItm))
END SUB

SUB QLISTVIEW.SetExtStyle(nuStyle AS UINT, Status AS integer)
IF Status THEN
    SendMessage(Handle,LVM_SETEXTENDEDLISTVIEWSTYLE,nuStyle,nuStyle)            ' Enable extended style
ELSE
    SendMessage(Handle,LVM_SETEXTENDEDLISTVIEWSTYLE,nuStyle,0)                  ' Disable style
END IF
END SUB
SUB QLISTVIEW.PreSetConfig()
    IF ShowColumnHeaders=False THEN ObjStyle OR= LVS_NOCOLUMNHEADER ELSE ObjStyle AND= NOT(LVS_NOCOLUMNHEADER)
END SUB
SUB SetLVFontColor(hWnd AS HWND, colr AS COLORREF)
    ListView_SetTextColor(hWnd, colr)
END SUB
SUB QLISTVIEW.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: Font.lpFontColor=@SetLVFontColor
    InitialiseFont(@Font)
    ListView_SetBkColor(Handle,CAST(COLORREF,_Color))
    ListView_SetTextBkColor(Handle,CAST(COLORREF,_Color))
    ListView_SetTextColor(Handle,CAST(COLORREF,Font.Color))
    IF GridLines=True THEN SetExtStyle(LVS_EX_GRIDLINES,True)
    IF CheckBoxes=True THEN SetExtStyle(LVS_EX_CHECKBOXES,True)
    IF RowSelect=True THEN SetExtStyle(LVS_EX_FULLROWSELECT,True)
    IF HotTrack=True THEN SetExtStyle(LVS_EX_TRACKSELECT,True)
    NewWndProc=@ListViewWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook new WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
END SUB
DESTRUCTOR QLISTVIEW
    Clear()
END DESTRUCTOR


#IFDEF __QDIRTREE
' #18 ====================================================================================
TYPE QDIRTREE
' Private (not)
    ObjId AS integer        = Q_DIRTREE                         ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "SysTreeView32"                   ' Base class
    ObjStyle AS UINT        = TVS_HASLINES OR TVS_LINESATROOT OR TVS_HASBUTTONS
    Font AS QFONT

    PrivateProperties()                                         ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 150
    _Height AS integer      = 150
    _Align AS integer       = alNone
    _InitialDir AS string*64= Application.Path
    _Directory AS string*64 = ""
    _Color AS integer       = &hffffff
    tvIns AS TVINSERTSTRUCT
    hImgList AS HIMAGELIST
    Target AS string
    Level AS integer
    hLev(1 TO 16) AS HTREEITEM

    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    FastLoad AS integer             ' |INTEGER|RW|False|False|True
    HideSelection AS integer        ' |INTEGER|RW|False|False|True
    ReadOnly AS integer             ' |INTEGER|RW|False|False|True
    ReadOnStart AS integer          ' |INTEGER|RW|False|False|True
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Directory() AS string
    DECLARE PROPERTY Directory(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY InitialDir() AS string
    DECLARE PROPERTY InitialDir(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
#IF 0
    DECLARE SUB AddDirTypes()
    DECLARE SUB AddDriveTypes()
    DECLARE SUB DelDirTypes()
    DECLARE SUB DelDriveTypes()
#ENDIF
    DECLARE SUB FullCollapse()
    DECLARE SUB FullExpand()
    DECLARE SUB Reload()
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE SUB UpdateTreeView(lParm AS LPARAM)
    DECLARE SUB _LoadImages()
    DECLARE FUNCTION _AddItem(txtFolder AS string, Prev AS HTREEITEM) AS HTREEITEM
    DECLARE SUB _FillTree(strPath AS string)
    DECLARE SUB _FillFolders(strPath AS string, Parnt AS HTREEITEM)
' Events
    OnChange AS SUB(Sender AS QDIRTREE PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QDIRTREE PTR)            ' FB only
END TYPE

DoGeneralProperties(QDIRTREE)
DoPositionalProperties(QDIRTREE)
DoAlignProperty(QDIRTREE)
DoHintProperties(QDIRTREE)
DoReadOnlyProperties(QDIRTREE)
PROPERTY QDIRTREE.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QDIRTREE.BorderStyle(value AS integer): IF value<>0 THEN _BorderStyle=1 ELSE _BorderStyle=0: END IF: END PROPERTY
PROPERTY QDIRTREE.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QDIRTREE.Color(value AS integer): _Color=value: TreeView_SetBkColor(Handle, CAST(COLORREF,value)): END PROPERTY
PROPERTY QDIRTREE.Directory() AS string: RETURN _Directory: END PROPERTY
PROPERTY QDIRTREE.Directory(value AS string): END PROPERTY                      ' Read only!
PROPERTY QDIRTREE.InitialDir() AS string: RETURN _InitialDir: END PROPERTY
PROPERTY QDIRTREE.InitialDir(value AS string): _InitialDir=value: END PROPERTY

SUB QDIRTREE.FullCollapse()
TreeView_Expand(Handle,hLev(1),TVE_COLLAPSE)
END SUB
SUB QDIRTREE.FullExpand()
TreeView_Expand(Handle,hLev(1),TVE_EXPAND)
END SUB
SUB QDIRTREE.Reload()
    TreeView_DeleteAllItems(Handle)
    Target=InitialDir
    CHDIR(Target)
    _Directory=Target                                           ' Update Read Only property
    _FillTree(Target)
END SUB
SUB QDIRTREE.UpdateTreeView(lParm AS LPARAM)
DIM AS TVITEMEX TVitem
DIM AS HTREEITEM Curnt
DIM AS string*64 tstr

    Curnt=TreeView_GetSelection(Handle)
    TVitem.hItem=Curnt
    TVitem.mask=TVIF_HANDLE OR TVIF_TEXT                        ' Get handle & text
    TVitem.pszText=STRPTR(tstr): TVitem.cchTextMax=63
    IF SendMessage(Handle, TVM_GETITEM, 0, CAST(LPARAM, @TVItem)) THEN
        Target=""
        DO WHILE INSTR(tstr,":")=0                              ' Until root of tree
            Target=tstr+"\"+Target                              ' Fill (upwards) full path of Target
            Curnt=TreeView_GetParent(Handle, Curnt)             ' Handle of parent item
            TVitem.hItem=Curnt
            SendMessage(Handle, TVM_GETITEM, 0, CAST(LPARAM, @TVItem))  ' Text of parent item
        LOOP
        Target=tstr+Target                                      ' Full path to selection
        CHDIR Target
        _Directory=CURDIR                                       ' Change Read Only property
        TreeView_DeleteAllItems(Handle)                         ' Clear the TreeView
        _FillTree(Target)                                       ' Re-fill with new target folder
    END IF
END SUB
FUNCTION QDIRTREE._AddItem(txtFolder AS string, Prev AS HTREEITEM) AS HTREEITEM
    tvIns.hParent=Prev
    tvIns.item.pszText=STRPTR(txtFolder)
    tvIns.item.cchTextMax=LEN(txtFolder)
    RETURN TreeView_InsertItem(Handle, @tvIns)
END FUNCTION
SUB QDIRTREE._FillFolders(strPath AS string, Parnt AS HTREEITEM)
DIM AS string tstr, tok, tgt
DIM AS string DirList
DIM AS HTREEITEM hPrev

    Level += 1: DirList=""
    tok=DIR(strPath+"*",fbDirectory)                            ' Fill string with list of folders...
    DO WHILE tok<>""                                            ' ...at this level of the "Target path"
        IF INSTR(tok,".")=0 THEN DirList=DirList+tok+CHR(10)
        tok=DIR()
    LOOP
    tgt=UCASE(rqFIELDSTR(Target,"\",Level))                     ' The Target folder name at this level
    FOR i AS integer = 1 TO rqTALLY(DirList,CHR(10))
        tok=rqFIELDSTR(DirList,CHR(10),i)                       ' Each folder name this directory
        hPrev=_AddItem(tok,Parnt)                               ' Add a folder entry to the Tree
        IF UCASE(tok)=tgt THEN                                  ' Is this our "Target path" folder?
            hLev(Level)=hPrev                                   ' Save the Treeitem handle of this level
            tstr=strPath+tok+"\"                                ' Build the full path to this folder
            _FillFolders(tstr,hPrev)                            ' Recursive call - new path & new parent
        END IF
    NEXT i
    DirList=""                                                  ' De-allocate memory????
    Level -= 1
END SUB
SUB QDIRTREE._FillTree(strPath AS string)
DIM AS string tstr
DIM AS TVITEMEX TVitem

    FOR i AS integer = 1 TO 16: hLev(i)=0: NEXT i
    Level=1
    tstr=rqFIELDSTR(strPath,"\",1)+"\"                          ' The root drive of strPath
    hLev(Level)=_AddItem(tstr,TVI_ROOT)
    _FillFolders(tstr,hLev(Level))                              ' Recurse fill folders from root drive
    FOR i AS integer = 1 TO 16
        IF hLev(i)=0 THEN                                       ' Finished expanding?
            TVitem.Mask=TVIF_STATE+TVIF_HANDLE
            TVitem.hItem=hLev(i-1)                              ' Last valid folder
            TVitem.State=TVIS_SELECTED                          ' Select it for visuals
            TVitem.StateMask=TVIS_SELECTED
            SendMessage(Handle,TVM_SETITEM,0,CAST(LPARAM,@TVitem))
            EXIT FOR
        END IF
        TreeView_Expand(Handle,hLev(i),TVE_EXPAND)              ' Expand Tree along selected path
    NEXT i
END SUB
SUB QDIRTREE._LoadImages
DIM AS HICON hIco
    hImgList=ImageList_Create(GetSystemMetrics(SM_CXSMICON), _
                        GetSystemMetrics(SM_CYSMICON), ILC_COLORDDB OR ILC_MASK, 2, 0)
    FOR i AS integer = 3 TO 4
        hIco=ExtractIcon(0, "Shell32.DLL", i)
        ImageList_ReplaceIcon(hImgList, -1, hIco)
        DestroyIcon(hIco)
    NEXT i
    TreeView_SetImageList(Handle, hImgList, TVSIL_NORMAL)
END SUB

SUB QDIRTREE.PreSetConfig()
    ' Pre-set the insert structure "fixed" data used in _AddItem()
    memset(CAST(BYTE PTR, @tvIns), 0, SIZEOF(tvIns))               ' Can't use FB Clear() here
    tvIns.hInsertAfter=TVI_LAST
    tvIns.Item.Mask=TVIF_TEXT OR TVIF_IMAGE OR TVIF_SELECTEDIMAGE
    tvIns.item.iImage=0
    tvIns.item.iSelectedImage=1
END SUB
SUB SetDTFontColor(hWnd AS HWND, colr AS COLORREF)
    TreeView_SetTextColor(hWnd, colr)
END SUB
SUB QDIRTREE.PostConfig()
DIM AS string tstr
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: Font.lpFontColor=@SetDTFontColor
    InitialiseFont(@Font)
    TreeView_SetBkColor(Handle, CAST(COLORREF,Color))
    TreeView_SetTextColor(Handle, Font.Color)
    _LoadImages()
    IF INSTR(InitialDir,":")=0 THEN                             ' IF invalid (NOT full path)
        tstr=Application.Path
    ELSE
        tstr=rqREPLACESUBSTR(InitialDir,"/","\")                ' Just in case!
    END IF
    IF RIGHT(tstr,1)<>"\" THEN tstr += "\"
    InitialDir=tstr
    Reload

    NewWndProc=@DirTreeWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook new WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
END SUB
#ENDIF          ' IFDEF __QDIRTREE


' #19 ====================================================================================
TYPE QFILELISTBOX
' Private (not)
    ObjId AS integer        = Q_FILELISTBOX                     ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "LISTBOX"                         ' Base class
    ObjStyle AS UINT        = WS_VSCROLL OR WS_HSCROLL OR LBS_NOTIFY
    Font AS QFONT

    PrivateProperties()                                         ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 150
    _Height AS integer      = 150
    _Align AS integer       = alNone
    _Color AS integer       = &hffffff
    _Directory AS string    = Application.Path
    _Drive AS string        = "C:"
    _Filename AS string*128 = ""
    _Item(1) AS string
    _ItemCount AS integer   = 0
    _ItemIndex AS integer   = -1
    _Mask AS string         = "*.*"
    _TopIndex AS integer    = 0

    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    ExtendedSelect AS integer       ' |INTEGER|RW|False|False|True
    ItemHeight AS integer           ' |INTEGER|RW|
    MultiSelect AS integer          ' |INTEGER|RW|False|False|True
    SelCount AS integer             ' |INTEGER|R|
    Selected() AS integer           ' |ARRAY of INTEGER|RW|
    ShowIcons AS integer            ' |INTEGER|RW|False|False|True
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Directory() AS string
    DECLARE PROPERTY Directory(value AS string)
    DECLARE PROPERTY Drive() AS string
    DECLARE PROPERTY Drive(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY FileName() AS string
    DECLARE PROPERTY FileName(value AS string)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Item(idx AS integer) AS string
    DECLARE PROPERTY Item(idx AS integer,value AS string)
    DECLARE PROPERTY ItemCount() AS integer
    DECLARE PROPERTY ItemCount(value AS integer)
    DECLARE PROPERTY ItemIndex() AS integer
    DECLARE PROPERTY ItemIndex(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Mask() AS string
    DECLARE PROPERTY Mask(value AS string)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY TopIndex() AS integer
    DECLARE PROPERTY TopIndex(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB AddFileTypes
    DECLARE SUB DelFileTypes
    DECLARE SUB Update
' Extras
    DECLARE SUB Clear()
    DECLARE SUB FillItems()
    DECLARE SUB SelectFile()
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE DESTRUCTOR
' Events
    OnChange AS SUB(Sender AS QFILELISTBOX PTR)
    OnClick AS SUB(Sender AS QFILELISTBOX PTR)
    OnDblClick AS SUB(Sender AS QFILELISTBOX PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QFILELISTBOX PTR)         ' FB only
END TYPE

DoGeneralProperties(QFILELISTBOX)
DoPositionalProperties(QFILELISTBOX)
DoAlignProperty(QFILELISTBOX)
DoHintProperties(QFILELISTBOX)
DoReadOnlyProperties(QFILELISTBOX)
PROPERTY QFILELISTBOX.Item(idx AS integer) AS string
DIM AS string*256 zItemTxt: SendMessage(Handle, LB_GETTEXT, idx, CAST(LPARAM, @zItemTxt)): RETURN zItemTxt
END PROPERTY
PROPERTY QFILELISTBOX.Item(idx AS integer,value AS string): END PROPERTY      ' Do nothing
PROPERTY QFILELISTBOX.Color(value AS integer): _Color=value: InvalidateRect(Handle,NULL,True): END PROPERTY
PROPERTY QFILELISTBOX.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QFILELISTBOX.Directory(value AS string): _Directory=value: Clear(): FillItems(): END PROPERTY
PROPERTY QFILELISTBOX.Directory() AS string: RETURN _Directory: END PROPERTY
PROPERTY QFILELISTBOX.Drive(value AS string): _Drive=value: END PROPERTY
PROPERTY QFILELISTBOX.Drive() AS string: RETURN _Drive: END PROPERTY
PROPERTY QFILELISTBOX.Filename(value AS string): END PROPERTY               ' Read only
PROPERTY QFILELISTBOX.Filename() AS string: SelectFile(): RETURN _FileName: END PROPERTY
PROPERTY QFILELISTBOX.Mask(value AS string): _Mask=value: Clear(): FillItems(): END PROPERTY
PROPERTY QFILELISTBOX.Mask() AS string: RETURN _Mask: END PROPERTY
PROPERTY QFILELISTBOX.ItemCount(value AS integer): END PROPERTY
PROPERTY QFILELISTBOX.ItemCount() AS integer: _ItemCount=SendMessage(Handle, LB_GETCOUNT, 0, 0): RETURN _ItemCount: END PROPERTY
PROPERTY QFILELISTBOX.ItemIndex(value AS integer): SendMessage(Handle, LB_SETCURSEL, value, 0): _ItemIndex=value: END PROPERTY
PROPERTY QFILELISTBOX.ItemIndex() AS integer: _ItemIndex=SendMessage(Handle, LB_GETCURSEL, 0, 0): RETURN _ItemIndex: END PROPERTY
PROPERTY QFILELISTBOX.TopIndex(value AS integer)
IF (value>=0) AND (value<ItemCount) THEN SendMessage(Handle, LB_SETTOPINDEX, CAST(WPARAM, value), 0): _TopIndex=value: END IF
END PROPERTY
PROPERTY QFILELISTBOX.TopIndex() AS integer: _TopIndex=SendMessage(Handle, LB_GETTOPINDEX, 0, 0): RETURN _TopIndex: END PROPERTY

SUB QFILELISTBOX.SelectFile()
DIM AS string*128 tstr
DIM AS string*64 tok
    tstr=Directory: IF RIGHT(tstr,1)<>"\" THEN tstr += "\"
    SendMessage(Handle, LB_GETTEXT, ItemIndex, CAST(LPARAM,@tok))
    tstr += tok
    _FileName=tstr
END SUB
SUB QFILELISTBOX.FillItems()
DIM AS string FName, tstr
    tstr=Directory: IF RIGHT(tstr,1)<>"\" THEN tstr += "\"
    FName=DIR(tstr+Mask, &h2f)
    WHILE LEN(FName)>0
        SendMessage(Handle, LB_INSERTSTRING, ItemCount, CAST(LPARAM, STRPTR(FName)))
        FName=DIR()
    WEND
END SUB
SUB QFILELISTBOX.Clear()
    SendMessage(Handle, LB_RESETCONTENT, 0, 0)
END SUB

SUB QFILELISTBOX.PreSetConfig()
END SUB
SUB QFILELISTBOX.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@FileLBoxWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook new WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
    Clear(): FillItems()
END SUB
DESTRUCTOR QFILELISTBOX
    Clear()
END DESTRUCTOR


' #20 ====================================================================================
#DEFINE TV_SEP  CHR(4)
TYPE TreeNodeType           '' ie. TreeView.Item(0).Text
    Text AS string
    ImageIndex AS integer
    StateIndex AS integer
    SelectedIndex AS integer
    Count AS integer          '' Read only
    Level AS integer          '' Read only
    IsVisible AS integer      '' Read only
    Handle AS integer         '' Read only
    HasChildren AS integer
    Selected AS integer
END TYPE

TYPE QTREEVIEW
' Private (not)
    ObjId AS integer        = Q_TREEVIEW                        ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "SysTreeView32"                   ' Base class
    ObjStyle AS UINT        = 0
    Font AS QFONT

    PrivateProperties()                                         ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 120
    _Height AS integer      = 100
    _Align AS integer       = alNone
    _Color AS integer       = &hffffff
    _ItemCount AS integer   = 0
    _ItemIndex AS integer   = 0
    _ShowButtons AS integer = True
    _ShowLines AS integer   = True
    _ShowRoot AS integer    = True
    _ReadOnly AS integer    = False

    TVInsert AS TVINSERTSTRUCT
    TVItm AS TVITEM
    hItm AS HTREEITEM
    tvStringList AS QStringList

    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    HideSelection AS integer = 0    ' |INTEGER|RW|False|False|True
    Images AS UINT                  ' QIMAGELIST PTR !!!
    Indent AS integer = 20          ' |INTEGER|RW|19
    Item() AS TreeNodeType          ' Should be an array of Item strucs
    SortType AS integer = 0         ' |INTEGER|RW|stText|stNone|stText|
    StateImages AS UINT             ' QIMAGELIST PTR !!!
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY ItemCount() AS integer
    DECLARE PROPERTY ItemCount(value AS integer)
    DECLARE PROPERTY ItemIndex() AS integer
    DECLARE PROPERTY ItemIndex(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ReadOnly() AS integer
    DECLARE PROPERTY ReadOnly(value AS integer)
    DECLARE PROPERTY ShowButtons() AS integer
    DECLARE PROPERTY ShowButtons(value AS integer)
    DECLARE PROPERTY ShowLines() AS integer
    DECLARE PROPERTY ShowLines(value AS integer)
    DECLARE PROPERTY ShowRoot() AS integer
    DECLARE PROPERTY ShowRoot(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB AddItems(Txt AS string)                         ' FUDGE One string at a time
    DECLARE SUB AddChildItems(Index AS integer, Txt AS string)  ' FUDGE One at a time
    DECLARE SUB Clear()                                         ' Delete all items
    DECLARE SUB Collapse(Index AS integer, Recurse AS integer)  ' Collapses node
    DECLARE SUB DelItems(Index AS integer)                      ' Delete items - Fudge One at a time
    DECLARE SUB Expand(Index AS integer, Recurse AS integer)    ' Expand node
    DECLARE SUB FullCollapse()                                  ' Collapses all nodes
    DECLARE SUB FullExpand()                                    ' Expands all nodes
    DECLARE FUNCTION GetItemAt(X AS integer, Y AS integer) AS long      ' Get the index node at mouse(X,Y)
    DECLARE SUB InsertItem(Index AS integer, Txt AS string)     ' Insert item at Index%
    DECLARE SUB LoadFromFile(Filename AS string)                ' Load items from file
    DECLARE SUB SaveToFile(Filename AS string)                  ' Save items to file
    DECLARE SUB Sort()                                          ' Sort items from A-Z
' Extras
    DECLARE FUNCTION Item(Idx AS integer) AS string
    DECLARE SUB UpdateTreeView(lParam AS LPARAM)
    DECLARE SUB ShowTreeView()
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE DESTRUCTOR
' Events
    OnClick AS SUB(Sender AS QTREEVIEW PTR)
    OnChange AS SUB(Index AS integer, Sender AS QTREEVIEW PTR)
    OnChanging AS SUB(Index AS integer, AllowChange AS integer, Sender AS QTREEVIEW PTR)
    OnCollapse AS SUB(Index AS integer, Sender AS QTREEVIEW PTR)
    OnCollapsing AS SUB(Index AS integer, AllowCollapse AS integer, Sender AS QTREEVIEW PTR)
    OnDblClick AS SUB(Sender AS QTREEVIEW PTR)
    OnDeletion AS SUB(Index AS integer, Sender AS QTREEVIEW PTR)
    OnEdited AS SUB(Index AS integer, BYREF S AS string, Sender AS QTREEVIEW PTR)
    OnEditing AS SUB(Index AS integer, AllowEdit AS integer, Sender AS QTREEVIEW PTR)
    OnExpand AS SUB(Index AS integer, Sender AS QTREEVIEW PTR)
    OnExpanding AS SUB(Index AS integer, AllowExpansion AS integer, Sender AS QTREEVIEW PTR)
    OnGetImageIndex AS SUB(Index AS integer, Sender AS QTREEVIEW PTR)
    OnGetSelectedIndex AS SUB(Index AS integer, Sender AS QTREEVIEW PTR)
    OnKeyDown AS SUB(Key AS word, Shift AS integer, Sender AS QTREEVIEW PTR)
    OnKeyPress AS SUB(Key AS byte, Sender AS QTREEVIEW PTR)
    OnKeyUp AS SUB(Key AS word, Shift AS integer, Sender AS QTREEVIEW PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QTREEVIEW PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QTREEVIEW PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QTREEVIEW PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QTREEVIEW PTR)               ' FB only
END TYPE

DoGeneralProperties(QTREEVIEW)
DoPositionalProperties(QTREEVIEW)
DoAlignProperty(QTREEVIEW)
DoHintProperties(QTREEVIEW)
DoReadOnlyProperties(QTREEVIEW)
PROPERTY QTREEVIEW.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QTREEVIEW.BorderStyle(value AS integer): IF value=0 THEN _BorderStyle=0: ELSE: _BorderStyle=1: END IF: END PROPERTY
PROPERTY QTREEVIEW.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QTREEVIEW.Color(value AS integer): _Color=Value: TreeView_SetBkColor(Handle,CAST(COLORREF,value)): END PROPERTY
PROPERTY QTREEVIEW.ItemCount() AS integer: _ItemCount=TreeView_GetCount(Handle): RETURN _ItemCount: END PROPERTY
PROPERTY QTREEVIEW.ItemCount(value AS integer): END PROPERTY                        ' Read only
PROPERTY QTREEVIEW.ItemIndex() AS integer: RETURN _ItemIndex: END PROPERTY          ' Updated by mouse selection
PROPERTY QTREEVIEW.ItemIndex(value AS integer): END PROPERTY                        ' Read only
PROPERTY QTREEVIEW.ReadOnly() AS integer: RETURN _ReadOnly: END PROPERTY
PROPERTY QTREEVIEW.ReadOnly(value AS integer): IF value=0 THEN _ReadOnly=0: ELSE: _Readonly=1: END IF: END PROPERTY
PROPERTY QTREEVIEW.ShowButtons() AS integer: RETURN _ShowButtons: END PROPERTY
PROPERTY QTREEVIEW.ShowButtons(value AS integer)
IF value=0 THEN _ShowButtons=0: ELSE: _ShowButtons=1: END IF
rqUpdateStyle(Handle, TVS_HASBUTTONS, _ShowButtons)
END PROPERTY
PROPERTY QTREEVIEW.ShowLines() AS integer: RETURN _ShowLines: END PROPERTY
PROPERTY QTREEVIEW.ShowLines(value AS integer)
IF value=0 THEN _ShowLines=0: ELSE: _ShowLines=1: END IF
rqUpdateStyle(Handle, TVS_HASLINES, _ShowLines)
END PROPERTY
PROPERTY QTREEVIEW.ShowRoot() AS integer: RETURN _ShowRoot: END PROPERTY
PROPERTY QTREEVIEW.ShowRoot(value AS integer)
IF value=0 THEN _ShowRoot=0: ELSE: _ShowRoot=1: END IF
rqUpdateStyle(Handle, TVS_LINESATROOT, _ShowRoot)
END PROPERTY

FUNCTION QTREEVIEW.Item(Idx AS integer) AS string
    RETURN tvStringList.Item(Idx)                                           ' FUDGE: just return a single string
END FUNCTION
SUB QTREEVIEW.Clear()
    TreeView_DeleteAllItems(Handle)
    _ItemCount=0: tvStringList.Clear
END SUB
SUB QTREEVIEW.ShowTreeView()
DIM AS integer i, tgt, lev=0
DIM AS string tstr, tok
DIM AS HTREEITEM hLevels(0 TO 15)                                           ' max 16 levels?????

    TreeView_DeleteAllItems(Handle)                                         ' Clear out and start afresh
    memset(CAST(BYTE PTR, @TVInsert), 0, SIZEOF(TVInsert))                  ' Default to root node
    TVInsert.hInsertAfter=TVI_LAST
    TVInsert.item.Mask=TVIF_TEXT OR TVIF_PARAM
    FOR i=0 TO tvStringList.ItemCount-1                                     ' Populate with tvStringList
        tstr=tvStringList.Item(i)
        lev=VALINT(rqFieldStr(tstr,TV_SEP,1))
        tstr=rqFieldStr(tstr,TV_SEP,2)
        IF lev=0 THEN
            TVInsert.hParent=NULL
        ELSE
            TVInsert.hParent=hLevels(lev-1)
        END IF
        TVInsert.item.pszText=STRPTR(tstr)
        TVInsert.item.cchTextMax=LEN(tstr)
        TVInsert.item.lParam=i
        hLevels(lev)=TreeView_InsertItem(Handle, @TVInsert)
        TreeView_EnsureVisible(Handle,hLevels(lev))
    NEXT i
    _ItemCount=tvStringList.ItemCount
    SetScrollPos(Handle, SB_VERT, 0, True)
END SUB
SUB QTREEVIEW.SaveToFile(Filename AS string)
DIM AS string tstr
DIM AS integer i,j
DIM AS QStringList tmpList

    IF _ItemCount=0 THEN EXIT SUB
    tmpList.Clear: tmpList.Duplicates=dupAccept
    FOR i=0 TO tvStringList.ItemCount-1
        tstr=tvStringList.Item(i)
        j=VALINT(rqFieldSTR(tstr,TV_SEP,1))
        tstr=rqFieldSTR(tstr,TV_SEP,2)
        WHILE j>0
            tstr=CHR(9)+tstr
            j -= 1
        WEND
        tmpList.AddItems(tstr)
    NEXT i
    tmpList.SaveToFile(FileName)
    tmpList.Clear
END SUB
SUB QTREEVIEW.LoadFromFile(Filename AS string)
DIM AS string tstr, tok
DIM AS QStringList tmpList

    IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT SUB
    tvStringList.Clear: tvStringList.Duplicates=dupAccept
    tmpList.Clear: tmpList.Duplicates=dupAccept
    tmpList.LoadFromFile(FileName)
    IF tmpList.ItemCount>0 THEN
        FOR i AS integer = 0 TO tmpList.ItemCount-1
            tstr=tmpList.Item(i)
            IF INSTR(tstr,CHR(9))>0 THEN
                tok=STR(rqTally(tstr,CHR(9)))+TV_SEP
                tstr=rqReplaceSubStr(tstr,CHR(9),"")
                tvStringList.AddItems(tok+tstr)
            ELSE
                tvStringList.AddItems("0"+TV_SEP+tstr)
            END IF
        NEXT i
        ShowTreeView()                                                  ' Update the screen
    ELSE
        DBG("RapidFRM Internal error! TreeView.LoadFile()")
    END IF
END SUB
SUB QTREEVIEW.AddItems(Txt AS string)
    IF ReadOnly=True THEN EXIT SUB
    tvStringList.AddItems("0"+TV_SEP+Txt)                                   ' Add to my stringlist copy
    ShowTreeView()                                                          ' Update the screen
END SUB
SUB QTREEVIEW.AddChildItems(Index AS integer, Txt AS string)                ' FUDGE One at a time
DIM AS string tstr
DIM AS integer i, lev, tgt
DIM tmpList AS QStringList

    IF ReadOnly=True THEN EXIT SUB
    IF Index>=tvStringList.ItemCount THEN EXIT SUB
    tstr=tvStringList.Item(Index)
    lev=VALINT(rqFieldSTR(tstr,TV_SEP,1))+1
    IF Index=tvStringList.ItemCount-1 THEN                                  ' Index last entry in list?
        tvStringList.AddItems(STR(lev)+TV_SEP+Txt)                          ' Just add it to the end
    ELSE
        FOR i=Index+1 TO tvStringList.ItemCount-1
            tstr=tvStringList.Item(i)
            tgt=VALINT(rqFieldSTR(tstr,TV_SEP,1))                           ' Search for a drop in level
            IF tgt<lev THEN
                tgt=i: EXIT FOR                                             ' Found new entry point
            END IF
        NEXT i
        IF i<tvStringList.ItemCount THEN                                    ' New entry point B4 end of the list...
            tmpList.Clear: tmpList.Duplicates=dupAccept                     ' ...so insert between items
            FOR i=0 TO tgt-1
                tstr=tvStringList.Item(i)
                tmpList.AddItems(tstr)
            NEXT i
            tmpList.AddItems(STR(lev)+TV_SEP+Txt)
            FOR i=tgt TO tvStringList.ItemCount-1
                tstr=tvStringList.Item(i)
                tmpList.AddItems(tstr)
            NEXT i
            tvStringList.Clear
            tvStringList.AddList(tmpList)
            tmpList.Clear
        ELSE
            tvStringList.AddItems(STR(lev)+TV_SEP+Txt)                      ' End of list, just add it to end
        END IF
    END IF
    _ItemCount=tvStringList.ItemCount
    ShowTreeView()                                                          ' Update the screen
END SUB
SUB QTREEVIEW.Sort()
    tvStringList.Sort
    ShowTreeView()
END SUB
SUB QTREEVIEW.UpdateTreeView(lParm AS LPARAM)
DIM AS TVITEMEX TVitem
DIM AS HTREEITEM Curnt
DIM AS string*64 tstr

    Curnt=TreeView_GetSelection(Handle)                                     ' From mouse selection
    TVitem.hItem=Curnt
    TVitem.mask=TVIF_HANDLE OR TVIF_TEXT OR TVIF_PARAM                      ' Get handle, text etc
    TVitem.pszText=STRPTR(tstr): TVitem.cchTextMax=63
    IF SendMessage(Handle, TVM_GETITEM, 0, CAST(LPARAM, @TVItem)) THEN
        _ItemIndex=TVitem.lParam
    END IF
END SUB

SUB QTREEVIEW.PreSetConfig()
    IF _ShowButtons THEN objStyle OR= TVS_HASBUTTONS
    IF _ShowLines THEN objStyle OR= TVS_HASLINES
    IF _ShowRoot THEN objStyle OR= TVS_LINESATROOT
    tvStringList.Duplicates=dupAccept
END SUB
SUB SetTVFontColor(hWnd AS HWND, colr AS COLORREF)
    TreeView_SetTextColor(hWnd, colr)
END SUB
SUB QTREEVIEW.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: Font.lpFontColor=@SetTVFontColor
    InitialiseFont(@Font)
    TreeView_SetBkColor(Handle, _Color)
    TreeView_SetTextColor(Handle, Font.Color)
    NewWndProc=@TreeViewWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook new WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
END SUB
DESTRUCTOR QTREEVIEW
    Clear()
END DESTRUCTOR


#IF 0
' #21 ====================================================================================
' Old style Win3.1 tree view - NOT interested in this component!
TYPE QOUTLINE
' Properties
' Methods
' Events
END TYPE
#ENDIF


#IFDEF __QGAUGE
' #22 ====================================================================================
TYPE QGAUGE
' Private (not)
    ObjId AS integer        = Q_GAUGE                       ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "STATIC"                      ' Base class
    ObjStyle AS UINT        = SS_OWNERDRAW OR SS_NOTIFY     '
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 100
    _Height AS integer      = 25
    _Align AS integer       = alNone
    _Color AS integer       = &h9f9f9f
    _BackColor AS integer   = &hffffff
    _ForeColor AS integer   = 0
    _ShowText AS integer    = True
    _Kind AS integer        = gkHorizontalBar

    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BackColor() AS integer
    DECLARE PROPERTY BackColor(value AS integer)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY ForeColor() AS integer
    DECLARE PROPERTY ForeColor(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Kind() AS integer
    DECLARE PROPERTY Kind(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Min() AS integer
    DECLARE PROPERTY Min(value AS integer)
    DECLARE PROPERTY Max() AS integer
    DECLARE PROPERTY Max(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Position() AS integer
    DECLARE PROPERTY Position(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY ShowText() AS integer
    DECLARE PROPERTY ShowText(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE SUB GaugeDraw(lParm AS LPARAM)
' Events
    OnPopup AS SUB(Index AS integer, Sender AS QGAUGE PTR)                ' FB only
END TYPE

DoGeneralProperties(QGAUGE)
DoPositionalProperties(QGAUGE)
DoAlignProperty(QGAUGE)
DoHintProperties(QGAUGE)
DoReadOnlyProperties(QGAUGE)
PROPERTY QGAUGE.BackColor() AS integer: RETURN _BackColor: END PROPERTY
PROPERTY QGAUGE.BackColor(value AS integer): _BackColor=value: END PROPERTY
PROPERTY QGAUGE.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QGAUGE.BorderStyle(value AS integer): IF Value<>0 THEN _BorderStyle=1 ELSE _BorderStyle=0: END IF: END PROPERTY
PROPERTY QGAUGE.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QGAUGE.Color(value AS integer): _Color=value: END PROPERTY
PROPERTY QGAUGE.ForeColor() AS integer: RETURN _ForeColor: END PROPERTY
PROPERTY QGAUGE.ForeColor(value AS integer): _ForeColor=value: END PROPERTY
PROPERTY QGAUGE.Kind() AS integer: RETURN _Kind: END PROPERTY
PROPERTY QGAUGE.Kind(value AS integer): IF (value >= 0) AND (value<5) THEN _Kind=value: END IF: END PROPERTY
PROPERTY QGAUGE.Min() AS integer: RETURN _Min: END PROPERTY
PROPERTY QGAUGE.Min(value AS integer): IF (value >= 0) AND (value<Max) THEN _Min=value: END IF: END PROPERTY
PROPERTY QGAUGE.Max() AS integer: RETURN _Max: END PROPERTY
PROPERTY QGAUGE.Max(value AS integer): IF value>Min THEN _Max=value: END IF: END PROPERTY
PROPERTY QGAUGE.Position() AS integer: RETURN _Position: END PROPERTY
PROPERTY QGAUGE.Position(value AS integer)
IF Enabled=True THEN
    IF value<Min THEN value=Min: IF value>Max THEN value=Max
    _Position=value: InvalidateRect(Handle,NULL,1)
END IF
END PROPERTY
PROPERTY QGAUGE.ShowText() AS integer: RETURN _ShowText: END PROPERTY
PROPERTY QGAUGE.ShowText(value AS integer): IF Value<>0 THEN Value=1: END IF: _ShowText=value: END PROPERTY

SUB QGAUGE.PreSetConfig()
END SUB
SUB QGAUGE.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@GaugeWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook the WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
END SUB
#ENDIF          ' #IFDEF __QGAUGE


' #23 ====================================================================================
TYPE QTRACKBAR
' Private (not)
    ObjId AS integer        = Q_TRACKBAR                    ' Component ID
    ObjIndex AS integer     = 0                             ' Unique number per object
    ObjClass AS string*32   = "msctls_trackbar32"           ' Base class
    ObjStyle AS UINT        = TBS_TOOLTIPS OR TBS_ENABLESELRANGE
    Font AS QFONT

    PrivateProperties()                                     ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 150
    _Height AS integer      = 45
    _Align AS integer       = alNone
    _Color AS integer       = FORM_COLOR
    _Frequency AS integer   = 10
    _Orientation AS integer = tbHorizontal
    _SelStart AS integer    = 0
    _SelEnd AS integer      = 0
    _TickMarks AS integer   = tmBottomRight
    _TickStyle AS integer   = tsAuto

    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    LineSize AS integer = 1         ' |INTEGER|RW|1
    PageSize AS integer = 2         ' |INTEGER|RW|2
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Frequency() AS integer
    DECLARE PROPERTY Frequency(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Min() AS integer
    DECLARE PROPERTY Min(value AS integer)
    DECLARE PROPERTY Max() AS integer
    DECLARE PROPERTY Max(value AS integer)
    DECLARE PROPERTY Orientation() AS integer
    DECLARE PROPERTY Orientation(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Position() AS integer
    DECLARE PROPERTY Position(value AS integer)
    DECLARE PROPERTY SelStart() AS integer
    DECLARE PROPERTY SelStart(value AS integer)
    DECLARE PROPERTY SelEnd() AS integer
    DECLARE PROPERTY SelEnd(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY TickMarks() AS integer
    DECLARE PROPERTY TickMarks(value AS integer)
    DECLARE PROPERTY TickStyle() AS integer
    DECLARE PROPERTY TickStyle(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnChange AS SUB(Sender AS QTRACKBAR PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QTRACKBAR PTR)               ' FB only
END TYPE

DoGeneralProperties(QTRACKBAR)
DoPositionalProperties(QTRACKBAR)
DoAlignProperty(QTRACKBAR)
DoHintProperties(QTRACKBAR)
DoReadOnlyProperties(QTRACKBAR)
PROPERTY QTRACKBAR.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QTRACKBAR.Color(value AS integer): _Color=value: SendMessage(Handle,WM_SETFOCUS,0,0): END PROPERTY
PROPERTY QTRACKBAR.Frequency() AS integer: RETURN _Frequency: END PROPERTY
PROPERTY QTRACKBAR.Frequency(value AS integer): _Frequency=value: END PROPERTY
PROPERTY QTRACKBAR.Orientation() AS integer: RETURN _Orientation: END PROPERTY
PROPERTY QTRACKBAR.Orientation(value AS integer): IF value<>0 THEN value=1: END IF: _Orientation=value: END PROPERTY
PROPERTY QTRACKBAR.SelStart() AS integer: RETURN _SelStart: END PROPERTY
PROPERTY QTRACKBAR.SelStart(value AS integer)
IF (value >= 0) AND (value < Max) THEN _SelStart=value
END PROPERTY
PROPERTY QTRACKBAR.SelEnd() AS integer: RETURN _SelEnd: END PROPERTY
PROPERTY QTRACKBAR.SelEnd(value AS integer)
IF (value >= 0) AND (value <= Max) THEN _SelEnd=value
IF SelEnd > SelStart THEN
    SendMessage(Handle,TBM_SETSELSTART,False,SelStart): SendMessage(Handle,TBM_SETSELEND,True,SelEnd)
END IF
END PROPERTY
PROPERTY QTRACKBAR.TickMarks() AS integer: RETURN _TickMarks: END PROPERTY
PROPERTY QTRACKBAR.TickMarks(value AS integer): IF (value >= 0) AND (value <=2) THEN _TickMarks=value: END IF: END PROPERTY
PROPERTY QTRACKBAR.TickStyle() AS integer: RETURN _TickStyle: END PROPERTY
PROPERTY QTRACKBAR.TickStyle(value AS integer): IF (value >= 0) AND (value <=2) THEN _TickStyle=value: END IF: END PROPERTY
PROPERTY QTRACKBAR.Min() AS integer: RETURN _Min: END PROPERTY
PROPERTY QTRACKBAR.Min(value AS integer)
    IF (value >= 0) AND (value < Max) THEN _Min=value: SendMessage(Handle, TBM_SETRANGE, 1, MAKELPARAM(Min, Max)): END IF
END PROPERTY
PROPERTY QTRACKBAR.Max() AS integer: RETURN _Max: END PROPERTY
PROPERTY QTRACKBAR.Max(value AS integer)
    IF value > Min THEN _Max=value: SendMessage(Handle, TBM_SETRANGE, 1, MAKELPARAM(Min, Max)): END IF
END PROPERTY
PROPERTY QTRACKBAR.Position() AS integer: RETURN _Position: END PROPERTY
PROPERTY QTRACKBAR.Position(value AS integer)
    IF (value >= Min) AND (value <= Max) THEN _Position=value: SendMessage(Handle, TBM_SETPOS, 1, CAST(LPARAM, value)): END IF
END PROPERTY

SUB QTRACKBAR.PreSetConfig()
    IF Orientation=tbVertical THEN ObjStyle OR= TBS_VERT ELSE ObjStyle AND= NOT(TBS_VERT)
    IF TickStyle=tsAuto THEN
        ObjStyle OR= TBS_AUTOTICKS
        IF TickMarks=tmBoth THEN
            ObjStyle OR= TBS_BOTH
        ELSEIF TickMarks=tmTopLeft THEN
            IF Orientation=tbHorizontal THEN ObjStyle OR= TBS_TOP ELSE ObjStyle OR= TBS_LEFT
        ELSE
            IF Orientation=tbHorizontal THEN ObjStyle OR= TBS_BOTTOM ELSE ObjStyle OR= TBS_RIGHT
        END IF
    END IF
END SUB
SUB QTRACKBAR.PostConfig()
DIM AS UINT value=0
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@TrackWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook the WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
    IF TickStyle<>0 THEN SendMessage(Handle, TBM_SETTICFREQ, CAST(WPARAM,10), 0)
    IF TickMarks=tmBottomRight THEN
        IF Orientation=tbHorizontal THEN value=TBTS_TOP ELSE value=TBTS_LEFT
    ELSE
        IF Orientation=tbHorizontal THEN value=TBTS_BOTTOM ELSE value=TBTS_RIGHT
    END IF
    SendMessage(Handle, TBM_SETTIPSIDE, CAST(WPARAM,value), 0)
    SendMessage(Handle,WM_SETFOCUS,0,0)
END SUB


' #24 ====================================================================================
TYPE QHEADER
' Private (not)
    ObjId AS integer        = Q_HEADER                          ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "SysHeader32"                     ' Base class
    ObjStyle AS UINT        = WS_BORDER OR HDS_BUTTONS OR HDS_HORZ
    Font AS QFONT

    PrivateProperties()                                         ' Common property variables
    Left AS integer                                             ' User settings ignored
    Top AS integer          = 0
    Width AS integer                                            ' User settings ignored
    Height AS integer       = 17
    _Align AS integer       = alTop                             ' FIXED!

    _SectionsCount AS integer = 0
    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                                 ' Handle to the popup menu

#IF 0
    CopyMode AS integer             ' |INTEGER|RW|cmBlackness|cmBlackness|cmDstInvert|cmMergeCop...
    HotTrack AS integer             ' |INTEGER|RW|False|False|True
    Pixel()                         ' |2D ARRAY of INTEGER|RW|
    Sections()                      ' |ARRAY of SectionsType|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY ClientHeight() AS integer
    DECLARE PROPERTY ClientHeight(value AS integer)
    DECLARE PROPERTY ClientWidth() AS integer
    DECLARE PROPERTY ClientWidth(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY SectionsCount() AS integer
    DECLARE PROPERTY SectionsCount(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
' Methods
    DECLARE SUB AddSections(value AS string)                    ' ONE section at a time!
    DECLARE SUB Clear()

    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HWND, S AS RECT PTR)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HDC, S AS RECT PTR)
    DECLARE SUB Draw(x AS integer, y AS integer, FileName AS string)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Paint(x AS integer, y AS integer, colr AS integer, brdr AS integer)
    DECLARE FUNCTION Pixel(x AS integer, y AS integer) AS integer
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Repaint()
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    DECLARE SUB StretchDraw(lpRect AS RECT PTR, FileName AS string)
    DECLARE FUNCTION TextHeight(Text AS string) AS integer
    DECLARE FUNCTION TextWidth(Text AS string) AS integer
    DECLARE SUB TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TextRect(lpRect AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
' Extras
    DECLARE FUNCTION SaveToBMP(FileName AS string) AS integer
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE CONSTRUCTOR
    DECLARE DESTRUCTOR
' Events
    OnDrawSection AS SUB(Index AS integer, Pressed AS integer, Rct AS RECT PTR, Sender AS QHEADER PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QHEADER PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QHEADER PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QHEADER PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QHEADER PTR)                   ' FB only
    OnResize AS SUB(Sender AS QHEADER PTR)
    OnSectionClick AS SUB(Index AS integer, Sender AS QHEADER PTR)
    OnSectionResize AS SUB(Index AS integer, Sender AS QHEADER PTR)
    OnSectionTrack AS SUB(Index AS integer, Width AS integer, State AS integer, Sender AS QHEADER PTR)
END TYPE

DoGeneralProperties(QHEADER)
'DoAlignProperty(QHEADER)
DoHintProperties(QHEADER)
DoReadOnlyProperties(QHEADER)
PROPERTY QHEADER.ClientHeight() AS integer
DIM AS RECT rct: GetClientRect(Handle,@rct): RETURN rct.bottom-rct.top
END PROPERTY
PROPERTY QHEADER.ClientHeight(value AS integer): END PROPERTY                   ' Read only
PROPERTY QHEADER.ClientWidth() AS integer
DIM AS RECT rct: GetClientRect(Handle,@rct): RETURN rct.right-rct.left
END PROPERTY
PROPERTY QHEADER.ClientWidth(value AS integer): END PROPERTY                    ' Read only
PROPERTY QHEADER.SectionsCount() AS integer: RETURN _SectionsCount: END PROPERTY
PROPERTY QHEADER.SectionsCount(value AS integer): END PROPERTY                  ' Read only

ObjectDrawFns(QHEADER)

SUB QHEADER.AddSections(value AS string)
DIM AS integer W
DIM AS RECT rct
DIM AS HDITEMA hdItem

    _SectionsCount += 1
    GetClientRect(GetParent(Handle), @rct)
    W=(rct.right-rct.left)\_SectionsCount
    hdItem.mask=HDI_TEXT OR HDI_FORMAT OR HDI_WIDTH
    hdItem.fmt=HDF_CENTER OR HDF_STRING
    hdItem.cxy=W
    hdItem.cchTextMax=LEN(value)+1
    hdItem.pszText=STRPTR(value)
    SendMessage(Handle, HDM_INSERTITEM, CAST(WPARAM,_SectionsCount), CAST(LPARAM, @hdItem)) ' Add AFTER last
    hdItem.mask=HDI_WIDTH
    FOR i AS integer = 0 TO _SectionsCount-1
        SendMessage(Handle, HDM_SETITEM, i, CAST(LPARAM, @hdItem))  ' Re-adjust widths equi-distance
    NEXT
END SUB
SUB QHEADER.Clear()
    FOR i AS integer = 0 TO _SectionsCount-1
        SendMessage(Handle, HDM_DELETEITEM, i, 0)
    NEXT
    _SectionsCount=0
END SUB

SUB QHEADER.PreSetConfig()
END SUB
SUB QHEADER.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@HeadrWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook the WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
END SUB
CONSTRUCTOR QHEADER
DIM AS HD_LAYOUT Layout
DIM AS WINDOWPOS wPos                                           ' def align alTop
DIM AS RECT rct
    GetClientRect(GetParent(Handle), @rct)
    wPos.hWnd=Handle: wPos.hwndInsertAfter=0: wPos.flags=SWP_SHOWWINDOW
    wPos.x=0: wPos.y=0: wPos.cx=rct.right-rct.left: wPos.cy=rct.bottom-rct.top
    Layout.prc=@rct
    Layout.pwpos=@wPos
    SendMessage(Handle, HDM_LAYOUT, 0, CAST(LPARAM, @Layout))
    _SectionsCount=0
END CONSTRUCTOR
DESTRUCTOR QHEADER
    Clear()
END DESTRUCTOR


' #25 ====================================================================================
TYPE PanelType
    Alignment AS integer                                        ' default - taLeftJustify
    Caption AS string                                           ' eg StatusBar.Panel(0).Caption
    Width AS integer
END TYPE

TYPE QSTATUSBAR
' Private (not)
    ObjId AS integer        = Q_STATUSBAR                       ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "msctls_statusbar32"              ' Base class
    ObjStyle AS UINT        = 0                                 '
    Font AS QFONT

    PrivateProperties()                                         ' Common property variables
    Left AS integer                                             ' User settings ignored
    Top AS integer
    Width AS integer                                            ' User settings ignored
    Height AS integer       = 19
    _Align AS integer       = alBottom

    _SizeGrip AS integer    = False                             ' Cannot switch OFF!!!!
    _SimpleText AS string   = ""
    _SimplePanel AS integer = True
    _NumPanels AS integer   = 1

    Panel(8) AS PanelType
    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                                 ' Handle to the popup menu

#IF 0
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY NumPanels() AS integer
    DECLARE PROPERTY NumPanels(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY SimplePanel() AS integer
    DECLARE PROPERTY SimplePanel(value AS integer)
    DECLARE PROPERTY SimpleText() AS string
    DECLARE PROPERTY SimpleText(value AS string)
    DECLARE PROPERTY SizeGrip() AS integer
    DECLARE PROPERTY SizeGrip(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
' Methods
    DECLARE SUB AddPanels()                  ' STRING, infinite
    DECLARE SUB Clear()
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnPopup AS SUB(Index AS integer, Sender AS QSTATUSBAR PTR)         ' FB only
    OnResize AS SUB(Sender AS QSTATUSBAR PTR)
END TYPE

DoGeneralProperties(QSTATUSBAR)
DoAlignProperty(QSTATUSBAR)
DoHintProperties(QSTATUSBAR)
DoReadOnlyProperties(QSTATUSBAR)
PROPERTY QSTATUSBAR.NumPanels() AS integer: RETURN _NumPanels: END PROPERTY
PROPERTY QSTATUSBAR.NumPanels(Value AS integer): IF value>1 THEN _NumPanels=value: END IF: END PROPERTY
PROPERTY QSTATUSBAR.SimpleText() AS string: RETURN _SimpleText: END PROPERTY
PROPERTY QSTATUSBAR.SimpleText(value AS string)
    _SimpleText=value: SetWindowText(Handle, _SimpleText)
    Panel(0).Caption=_SimpleText: Panel(0).Width=Width
END PROPERTY
PROPERTY QSTATUSBAR.SimplePanel() AS integer: RETURN _SimplePanel: END PROPERTY
PROPERTY QSTATUSBAR.SimplePanel(Value AS integer): IF value=0 THEN _SimplePanel=0 ELSE _SimplePanel=1: END IF: END PROPERTY
PROPERTY QSTATUSBAR.SizeGrip() AS integer: RETURN _SizeGrip: END PROPERTY
PROPERTY QSTATUSBAR.SizeGrip(Value AS integer): IF value=0 THEN _SizeGrip=0 ELSE _SizeGrip=1: END IF: END PROPERTY

SUB QSTATUSBAR.Clear()
    IF SimplePanel THEN
        SimpleText=""
        SetWindowText(Handle, "")
    ELSE
        DIM AS string tstr=""
        FOR i AS integer = 0 TO NumPanels-1
            SendMessage(Handle, SB_SETTEXT, i, CAST(INTEGER, STRPTR(tstr)))
        NEXT i
    END IF
END SUB
SUB QSTATUSBAR.PreSetConfig()
    IF SizeGrip=True THEN ObjStyle OR= SBARS_SIZEGRIP            ' Defaults to (always) on!!
END SUB
SUB QSTATUSBAR.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@StatusWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook new WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
    SetWindowText(Handle, SimpleText)
END SUB


' #26 ====================================================================================
TYPE QCANVAS
' Private (not)
    ObjId AS integer        = Q_CANVAS                          ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "STATIC"                          ' Base class
    ObjStyle AS UINT        = WS_CLIPCHILDREN OR SS_NOTIFY OR SS_BITMAP      '
    Font AS QFONT

    PrivateProperties()                                         ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 100
    _Height AS integer      = 100
    _Align AS integer       = alNone
    Color AS integer        = &hffffff

    Cursor AS integer       = crDefault
    hCursor AS HCURSOR      = 0
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    ClientHeight AS integer         ' |INTEGER|RW|
    ClientWidth AS integer          ' |INTEGER|RW|
    CopyMode AS integer             ' |INTEGER|RW|cmBlackness|cmBlackness|cmDstInvert|cmMergeCopy|cmMer...
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HWND, S AS RECT PTR)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HDC, S AS RECT PTR)
    DECLARE SUB Draw(x AS integer, y AS integer, FileName AS string)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Paint(x AS integer, y AS integer, c AS integer, border AS integer)
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Repaint()
    DECLARE SUB Rotate(xOrigin AS integer, yOrigin AS integer, Angle AS integer)
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    DECLARE SUB StretchDraw(lpRect AS RECT PTR, FileName AS string)
    DECLARE FUNCTION TextHeight(Text AS string) AS integer
    DECLARE FUNCTION TextWidth(Text AS string) AS integer
    DECLARE SUB TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TextRect(lpRect AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
' Extras
    DECLARE FUNCTION Pixel(x AS integer, y AS integer) AS integer
    DECLARE FUNCTION SaveToBMP(FileName AS string) AS integer
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnClick AS SUB(Sender AS QCANVAS PTR)
    OnDblClick AS SUB(Sender AS QCANVAS PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QCANVAS PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QCANVAS PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QCANVAS PTR)
    OnPaint AS SUB(hDC AS HDC, lpRect AS RECT PTR, Sender AS QCANVAS PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QCANVAS PTR)                   ' FB only
END TYPE

DoGeneralProperties(QCANVAS)
DoPositionalProperties(QCANVAS)
DoAlignProperty(QCANVAS)
DoHintProperties(QCANVAS)
DoReadOnlyProperties(QCANVAS)

ObjectDrawFns(QCANVAS)

SUB QCANVAS.PreSetConfig()
END SUB
SUB QCANVAS.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@CanvasWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook new WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
END SUB


' #27 ====================================================================================
TYPE QIMAGE
' Private (not)
    ObjId AS integer        = Q_IMAGE               ' Component ID
    ObjIndex AS integer     = 0                     ' Unique number per object
    ObjClass AS string*32   = "STATIC"              ' Base class
    ObjStyle AS UINT        = WS_CLIPCHILDREN OR SS_NOTIFY OR SS_BITMAP
    Font AS QFONT

    PrivateProperties()                             ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 100
    _Height AS integer      = 100
    _Align AS integer       = alNone
    _Autosize AS integer    = False                 ' Re-sizes width & height to bmp
    _Stretch AS integer     = False                 ' Re-sizes bmp to width & Height -- Overrides AutoSize
    _BMP AS string          = ""
    _BMPHandle AS integer   = 0
    _Icon AS string         = ""
    _ICOHandle AS integer   = 0

    hBMP AS HWND            = 0
    hCursor AS HCURSOR      = 0
    Cursor AS integer       = crDefault
    PopupMenu AS HMENU      = 0                             ' Handle to the popup menu

#IF 0
    Center AS integer               ' |INTEGER|RW|False|False|True
    CopyMode AS integer             ' |INTEGER|RW|cmBlackness|cmBlackness|cmDstInvert|cmMergeCopy|cmMe...
    IncrementalDisplay AS integer   ' |INTEGER|RW|False|False|True
    Transparent AS integer          ' |INTEGER|RW|False|False|True
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY Autosize() AS integer
    DECLARE PROPERTY Autosize(value AS integer)
    DECLARE PROPERTY BMP() AS string
    DECLARE PROPERTY BMP(FileName AS string)
    DECLARE PROPERTY BMPHandle() AS integer
    DECLARE PROPERTY BMPHandle(value AS integer)
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY ICOHandle() AS integer
    DECLARE PROPERTY ICOHandle(value AS integer)
    DECLARE PROPERTY Icon() AS string
    DECLARE PROPERTY Icon(FileName AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Stretch() AS integer
    DECLARE PROPERTY Stretch(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Transparent() AS integer
    DECLARE PROPERTY Transparent(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HWND, S AS RECT PTR)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HDC, S AS RECT PTR)
    DECLARE SUB Draw(x AS integer, y AS integer, FileName AS string)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Paint(x AS integer, y AS integer, c AS integer, border AS integer)
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Repaint()
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    DECLARE SUB StretchDraw(lpRect AS RECT PTR, FileName AS string)
    DECLARE FUNCTION TextHeight(Text AS string) AS integer
    DECLARE FUNCTION TextWidth(Text AS string) AS integer
    DECLARE SUB TextRect(lpRect AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
#IF 0
    DECLARE SUB Center()
    DECLARE SUB Rotate(xOrigin AS integer, yOrigin AS integer, Angle AS integer)
#ENDIF
' Extras
    DECLARE DESTRUCTOR
    DECLARE FUNCTION Pixel(x AS integer, y AS integer) AS integer
    DECLARE FUNCTION SaveToBMP(FileName AS string) AS integer
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnClick AS SUB(Sender AS QIMAGE PTR)
    OnDblClick AS SUB(Sender AS QIMAGE PTR)
    OnMouseDown AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QIMAGE PTR)
    OnMouseMove AS SUB(X AS integer, Y AS integer, Shift AS integer, Sender AS QIMAGE PTR)
    OnMouseUp AS SUB(Button AS integer, X AS integer, Y AS integer, Shift AS integer, Sender AS QIMAGE PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QIMAGE PTR)                ' FB only
END TYPE

DoGeneralProperties(QIMAGE)
DoPositionalProperties(QIMAGE)
DoAlignProperty(QIMAGE)
DoHintProperties(QIMAGE)
DoReadOnlyProperties(QIMAGE)

PROPERTY QIMAGE.Autosize() AS integer: RETURN _Autosize: END PROPERTY
PROPERTY QIMAGE.Autosize(value AS integer): _Autosize=value: END PROPERTY
PROPERTY QIMAGE.Stretch() AS integer: RETURN _Stretch: END PROPERTY
PROPERTY QIMAGE.Stretch(value AS integer): _Stretch=value: END PROPERTY
PROPERTY QIMAGE.Transparent() AS integer: RETURN _Transparent: END PROPERTY
PROPERTY QIMAGE.Transparent(value AS integer): _Transparent=value: END PROPERTY
PROPERTY QIMAGE.BMP() AS string: RETURN _BMP: END PROPERTY
PROPERTY QIMAGE.BMP(FileName AS string)
IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT PROPERTY
DIM AS integer W=0,H=0                          ' Def: Stretch & AustoSize False
IF Stretch=True THEN W=Width: H=Height: END IF
IF hBMP>0 THEN DeleteObject(hBMP)
hBMP=LoadImage(NULL,FileName,IMAGE_BITMAP, W, H, LR_LOADFROMFILE OR LR_DEFAULTSIZE)
IF hBMP THEN
    SendMessage(Handle, STM_SETIMAGE, IMAGE_BITMAP, CAST(LPARAM,hBMP)): _BMP=FileName
    IF (Stretch=False) AND (AutoSize=True) THEN
        DIM AS BITMAP tmpbmp
        GetObject(hBMP, SIZEOF(BITMAP), @tmpbmp)
        Width=tmpbmp.bmWidth: Height=tmpbmp.bmHeight
    END IF
END IF
END PROPERTY
PROPERTY QIMAGE.BMPHandle() AS integer: RETURN 0: END PROPERTY
PROPERTY QIMAGE.BMPHandle(Resource AS integer)
DIM AS string resString="#" & Resource
DIM AS integer W=0,H=0                          ' Def: Stretch & AustoSize False
IF Stretch=True THEN W=Width: H=Height: END IF
IF hBMP>0 THEN DeleteObject(hBMP)
hBMP=LoadImage(Application.hInstance,resString,IMAGE_BITMAP, W, H, LR_DEFAULTCOLOR OR LR_DEFAULTSIZE)
IF hBMP THEN
    SendMessage(Handle, STM_SETIMAGE, IMAGE_BITMAP, CAST(LPARAM,hBMP))
    IF (Stretch=False) AND (AutoSize=True) THEN
        DIM AS BITMAP tmpbmp
        GetObject(hBMP, SIZEOF(BITMAP), @tmpbmp)
        Width=tmpbmp.bmWidth: Height=tmpbmp.bmHeight
    END IF
END IF
END PROPERTY
PROPERTY QIMAGE.Icon() AS string: RETURN _Icon: END PROPERTY
PROPERTY QIMAGE.Icon(FileName AS string)
IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT PROPERTY
IF hBMP>0 THEN DeleteObject(hBMP)
hBMP=LoadImage(NULL, FileName, IMAGE_ICON, 0, 0, LR_LOADFROMFILE OR LR_DEFAULTSIZE)
IF hBMP THEN
    DIM AS UINT Mask=GetWindowLong(Handle,GWL_STYLE)
    IF (Mask AND SS_BITMAP)=SS_BITMAP THEN Mask AND= NOT (SS_BITMAP)
    Mask OR= SS_ICON: ObjStyle=Mask
    SetWindowLong(Handle, GWL_STYLE, Mask)
    SendMessage(Handle, STM_SETIMAGE, IMAGE_ICON, CAST(LPARAM,hBMP)): _Icon=FileName
END IF
END PROPERTY
PROPERTY QIMAGE.ICOHandle() AS integer: RETURN 0: END PROPERTY
PROPERTY QIMAGE.ICOHandle(Resource AS integer)
DIM AS string resString="#" & Resource
IF hBMP>0 THEN DeleteObject(hBMP)
hBMP=LoadImage(Application.hInstance,resString,IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR OR LR_DEFAULTSIZE)
IF hBMP THEN
    DIM AS UINT Mask=GetWindowLong(Handle,GWL_STYLE)
    IF (Mask AND SS_BITMAP)=SS_BITMAP THEN Mask AND= NOT (SS_BITMAP)
    Mask OR= SS_ICON: ObjStyle=Mask
    SetWindowLong(Handle, GWL_STYLE, Mask)
    SendMessage(Handle, STM_SETIMAGE, IMAGE_ICON, CAST(LPARAM,hBMP))
END IF
END PROPERTY

ObjectDrawFns(QIMAGE)

DESTRUCTOR QIMAGE
    IF hBMP>0 THEN DeleteObject(hBMP)
END DESTRUCTOR
SUB QIMAGE.PreSetConfig()
END SUB
SUB QIMAGE.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@ImgWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook new WndProc
    IF Cursor<>crDefault THEN hCursor=LoadCursor(NULL,MAKEINTRESOURCE(Cursor))
    IF _BMP<>"" THEN
        BMP=_BMP
    ELSEIF _BMPHandle>0 THEN
        BMPHandle=_BMPHandle
    END IF
END SUB

' #28 QOLECONTAINER * Properties *
' #29 QSPLITTER * Properties *


' #33 ====================================================================================
TYPE QTIMER
' Private (not)
    ObjId AS integer        = Q_TIMER                   ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*32   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    PrivateProperties()                                 ' Common property variables
    _Interval AS integer

' Properties
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Interval() AS integer
    DECLARE PROPERTY Interval(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
' Methods
' Events
    OnTimer AS SUB(Sender AS QTIMER PTR)
END TYPE

PROPERTY QTIMER.Enabled() AS integer: RETURN _Enabled: END PROPERTY
PROPERTY QTIMER.Enabled(value AS integer): IF value=False THEN _Enabled=False ELSE _Enabled=True: END IF: END PROPERTY
PROPERTY QTIMER.Interval() AS integer: RETURN _Interval: END PROPERTY
PROPERTY QTIMER.Interval(value AS integer): _Interval=value: END PROPERTY
PROPERTY QTIMER.Parent() AS HWND: RETURN _Parent: END PROPERTY
PROPERTY QTIMER.Parent(value AS HWND): _Parent=value: END PROPERTY
PROPERTY QTIMER.Tag() AS integer: RETURN _Tag: END PROPERTY
PROPERTY QTIMER.Tag(value AS integer): _Tag=value: END PROPERTY


#IFDEF __QSOCKET
' #34 ====================================================================================
TYPE QSOCKET
' Private (not)
    ObjId AS integer        = Q_SOCKET                  ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*32   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    Tag AS integer          = 0
    ConnPending AS integer  = 0                         ' Server mode - client connection T/F flag
    DiscPending AS integer  = 0                         ' Peer socket disconnection
    localHost AS hostent PTR = 0
    localIP AS zString PTR  = 0
    saServer AS sockaddr_in

    _Family AS integer      = AF_INET
    _Parent AS HWND         = 0
    _Protocol AS integer    = IPPROTO_IP
    _sktType AS integer     = SOCK_STREAM
    _WMessage AS integer    = WM_SOCK_NOTIFY
    _LParam AS integer      = 0

    MySocket AS integer     = 0                     ' Stores return values of operations
    Transferred AS integer

' Properties
    DECLARE PROPERTY Family() AS integer
    DECLARE PROPERTY Family(value AS integer)
    DECLARE PROPERTY LParam() AS integer
    DECLARE PROPERTY LParam(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Protocol() AS integer
    DECLARE PROPERTY Protocol(value AS integer)
    DECLARE PROPERTY sktType() AS integer
    DECLARE PROPERTY sktType(value AS integer)
    DECLARE PROPERTY WMessage() AS integer
    DECLARE PROPERTY WMessage(value AS integer)
' Methods
    DECLARE FUNCTION sktOpen(PortNum AS integer) AS integer                         ' Returns server Sock% Open for listening
    DECLARE FUNCTION sktAccept(Socket AS integer) AS integer                        ' Returns ClientSock% Connection to the server
    DECLARE FUNCTION sktConnect(ServerName AS string, PortNum AS integer) AS integer    ' Returns Sock% for a client connection
    DECLARE SUB sktClose(Socket AS integer)

    DECLARE FUNCTION ConnectionReady(Sock AS integer) AS integer                    ' Returns True/False
    DECLARE FUNCTION GetHostIP() AS string                                          ' Returns host IP Address
    DECLARE FUNCTION GetHostName() AS string                                        ' Returns host name
    DECLARE FUNCTION ReqPeerName(Socket AS integer) AS string                       ' Returns peer name
    DECLARE FUNCTION IsClientReady(Sock AS integer, ClientSock AS integer) AS integer   ' True/False if client is sending data
    DECLARE FUNCTION IsServerReady(Sock AS integer) AS integer                      ' True/False if server is sending data
    DECLARE FUNCTION sktPeek(Socket AS integer, NumBytes AS integer) AS string      '
    DECLARE FUNCTION Read(Socket AS integer, NumBytes AS integer) AS string         ' Read NumBytes%
    DECLARE FUNCTION ReadByte(Socket AS integer) AS byte                            ' Read a single byte 2 WXG
    DECLARE FUNCTION ReadLine(Socket AS integer) AS string                          ' Read complete line 1 WXG
    DECLARE SUB Write(Socket AS integer, Message AS string, NumBytes AS integer)
    DECLARE SUB WriteByte(Socket AS integer, B AS BYTE)
    DECLARE FUNCTION WriteLine(Socket AS integer, Message AS string) AS integer     ' Returns # bytes sent
' Extras
    DECLARE CONSTRUCTOR
    DECLARE DESTRUCTOR
' Events
END TYPE

PROPERTY QSOCKET.Family() AS integer: RETURN _Family: END PROPERTY
PROPERTY QSOCKET.Family(value AS integer): _Family=value: END PROPERTY
PROPERTY QSOCKET.Parent() AS HWND: RETURN _Parent: END PROPERTY
PROPERTY QSOCKET.Parent(value AS HWND): _Parent=value: END PROPERTY
PROPERTY QSOCKET.Protocol() AS integer: RETURN _Protocol: END PROPERTY
PROPERTY QSOCKET.Protocol(value AS integer): _Protocol=value: END PROPERTY
PROPERTY QSOCKET.sktType() AS integer: RETURN _sktType: END PROPERTY
PROPERTY QSOCKET.sktType(value AS integer): _sktType=value: END PROPERTY
PROPERTY QSOCKET.LParam() AS integer: RETURN _LParam: END PROPERTY
PROPERTY QSOCKET.LParam(value AS integer): END PROPERTY
PROPERTY QSOCKET.WMessage() AS integer: RETURN _WMessage: END PROPERTY
PROPERTY QSOCKET.WMessage(value AS integer): END PROPERTY

'--- Server mode fns
' Open socket for "listening" - server (TCPIP)
FUNCTION QSOCKET.sktOpen(PortNum AS integer) AS integer
DIM AS integer retSocket

    retSocket=OpenSocket(AF_INET, SOCK_STREAM, IPPROTO_TCP)        ' ONLY TCP/IP
    ' Get the local host information
    localHost=GetHostbyName("")                                     ' Local info
    localIP=inet_ntoa (*(CAST(in_addr PTR,*localHost->h_addr_list)))
    ' Set up the sockaddr structure
    saServer.sin_family=AF_INET
    saServer.sin_addr.s_addr=inet_addr(localIP)
    saServer.sin_port=htons(PortNum)
    ' Setup the TCP listening socket
    IF Bind(retSocket, CAST(SOCKADDR PTR, @saServer), SIZEOF(saServer))=SOCKET_ERROR THEN
        MySocket=WSAGetLastError()
        CloseSocket(retSocket)
        WSACleanup()
        RETURN 0
    END IF
    ' Asynch (non-blocking) master socket, listens for remote connections
    ' Notifies of requested connection via windows MSG
    WSAAsyncSelect(retSocket, Parent, WM_SOCK_NOTIFY, FD_ACCEPT)
    MySocket=Listen(retSocket, 16)
    IF MySocket=SOCKET_ERROR THEN
        MySocket=WSAGetLastError()
        CloseSocket(retSocket)
        WSACleanup()
        RETURN 0
    END IF
    RETURN retSocket
END FUNCTION
FUNCTION QSOCKET.ConnectionReady(Sock AS integer) AS integer
    RETURN ConnPending
END FUNCTION
FUNCTION QSOCKET.sktAccept(Socket AS integer) AS integer
DIM AS integer retSock=Accept(Socket, NULL, NULL)
    ConnPending=0
    IF retSock=INVALID_SOCKET THEN
        MySocket=WSAGetLastError()
        retSock=0
    ELSE                                                ' retSock is IDENTICAL to master socket
        MySocket=0: DiscPending=0
        WSAAsyncSelect(retSock, Parent, WM_SOCK_NOTIFY, FD_CLOSE) ' Change retSock event notification
    END IF
    RETURN retSock
END FUNCTION
'------- Client mode
FUNCTION QSOCKET.sktConnect(ServerName AS string, PortNum AS integer) AS integer
DIM AS integer retSock
    MySocket=0
    retSock=OpenSocket(Family, sktType, Protocol)
    ' Set up the sockaddr structure
    saServer.sin_family=Family
    saServer.sin_addr.s_addr=inet_addr(ServerName)
    saServer.sin_port=htons(PortNum)
    IF connect(retSock, CAST(SOCKADDR PTR, @saServer), SIZEOF(saServer))=SOCKET_ERROR THEN
        MySocket=WSAGetLastError()
        CloseSocket(retSock)
        WSACleanup()
        RETURN 0
    END IF
    DiscPending=0
    WSAAsyncSelect(retSock, Parent, WM_SOCK_NOTIFY, FD_CLOSE) ' Add retSock event notification
    RETURN retSock
END FUNCTION
'------ GP fns
FUNCTION QSOCKET.GetHostIP() AS string
    localHost=GetHostbyName("")
    localIP=inet_ntoa (*(CAST(in_addr PTR,*localHost->h_addr_list)))
    RETURN *localIP
END FUNCTION
FUNCTION QSOCKET.GetHostName() AS string
    localHost=GetHostbyName("")
    RETURN *localHost->h_name
END FUNCTION
FUNCTION QSOCKET.ReqPeerName(Sock AS integer) AS string
DIM AS String RemoteIP
DIM AS byte addrRemote(0 TO 15)                 ' This is actually a sockaddr_in structure
DIM AS hostent PTR RemotePeer
DIM AS integer dat, i=16
DIM AS long IPnum
    IF getpeername(Sock, CAST(SOCKADDR PTR,@addrRemote(0)), @i)<0 THEN RETURN ""
    RemoteIP=""
    FOR i=4 TO 7                                ' For each of the 4 bytes in sockaddr_in struct
        dat=addrRemote(i): If dat<0 THEN dat=dat AND &hFF
        RemoteIP=RemoteIP & dat & "."           ' Create "dotted IP" address string
    NEXT i
    RemoteIP=LEFT(RemoteIP, LEN(RemoteIP)-1)    ' Strip trailing "."
    IPnum=inet_addr(RemoteIP)                   ' Address in network byte order
    IF IPnum = -1 THEN RETURN ""
    RemotePeer=gethostbyaddr(CAST(byte PTR,@IPnum), 4, AF_INET)
    RETURN *RemotePeer->h_name
END FUNCTION
FUNCTION QSOCKET.IsClientReady(Sock AS integer, ClientSock AS integer) AS integer
DIM AS integer iCount=0
    IF ioctlsocket(ClientSock, FIONREAD, @iCount)=0 THEN
        IF iCount>0 THEN RETURN True
    END IF
    RETURN False
END FUNCTION
FUNCTION QSOCKET.IsServerReady(Sock AS integer) AS integer
DIM AS integer iCount=0
    IF ioctlsocket(Sock, FIONREAD, @iCount)=0 THEN
        IF iCount>0 THEN RETURN True
    END IF
    RETURN False
END FUNCTION
FUNCTION QSOCKET.sktPeek(Socket AS integer, NumBytes AS integer) AS string
DIM AS integer iCount=0
DIM AS string buf = SPACE(NumBytes)
    IF ioctlsocket(Socket, FIONREAD, @iCount)=0 THEN
        IF iCount>0 THEN
            iCount=recv(Socket, STRPTR(buf), NumBytes, MSG_PEEK)
            buf=LEFT(buf,iCount)
        END IF
    END IF
    RETURN buf
END FUNCTION
FUNCTION QSOCKET.ReadLine(Socket AS integer) AS string
DIM AS string tstr
DIM AS integer iCount
DIM AS byte dat
    MySocket=0
    DO
        IF ioctlsocket(Socket, FIONREAD, @iCount)=0 THEN
            IF iCount>0 THEN
                iCount=recv(Socket, @dat, 1, 0)
                IF iCount<0 THEN
                    MySocket=WSAGetLastError()
                    RETURN ""
                ELSE
                    tstr=tstr+CHR(dat)                  ' Check for LF char
                    IF dat=10 THEN RETURN tstr
                END IF
            END IF
        ELSE
            MySocket=WSAGetLastError()
            RETURN ""
        END IF
    LOOP
END FUNCTION
FUNCTION QSOCKET.Read(Socket AS integer, NumBytes AS integer) AS string
DIM AS integer iCount=0
DIM AS string buf = SPACE(NumBytes)
    IF ioctlsocket(Socket, FIONREAD, @iCount)=0 THEN
        IF iCount>0 THEN
            iCount=recv(Socket, STRPTR(buf), NumBytes, 0)
            buf=LEFT(buf,iCount)
        END IF
    END IF
    RETURN buf
END FUNCTION
FUNCTION QSOCKET.ReadByte(Socket AS integer) AS byte
DIM AS integer iCount=0
DIM AS byte dat
    MySocket=0
    IF ioctlsocket(Socket, FIONREAD, @iCount)=0 THEN
        IF iCount>0 THEN
            iCount=recv(Socket, @dat, 1, 0)
            RETURN Dat
        ELSE
            MySocket=WSAGetLastError()
        END IF
    END IF
    RETURN 0
END FUNCTION
SUB QSOCKET.Write(Socket AS integer, Message AS string, NumBytes AS integer)
    MySocket=0
    IF Send(Socket, Message, NumBytes, 0)=SOCKET_ERROR THEN MySocket=WSAGetLastError()
END SUB
SUB QSOCKET.WriteByte(Socket AS integer, B AS BYTE)
DIM AS byte dat=B
    MySocket=0
    IF Send(Socket, @dat, 1, 0)=SOCKET_ERROR THEN MySocket=WSAGetLastError()
END SUB
FUNCTION QSOCKET.WriteLine(Socket AS integer, Message AS string) AS integer
DIM AS string tstr=Message+CHR(10)
DIM AS integer iCount, NumBytes=LEN(tstr)
    MySocket=0
    iCount=Send(Socket, tstr, NumBytes, 0)
    IF iCount=SOCKET_ERROR THEN
        MySocket=WSAGetLastError()
        RETURN SOCKET_ERROR
    END IF
    RETURN iCount
END FUNCTION
SUB QSOCKET.sktClose(Socket AS integer)
    CloseSocket(Socket)
END SUB

CONSTRUCTOR QSOCKET
DIM AS WSAData wsaDat
IF WSAStartup(MAKEWORD(2, 0), @wsaDat) = 0 THEN
    IF wsaDat.wVersion <> MAKEWORD(2, 0) THEN
        DBG("RapidFRM Internal error! Winsock32.dll not detected!")
    ELSE
        Parent=Application.hMainForm
    END IF
END IF
END CONSTRUCTOR
DESTRUCTOR QSOCKET
    WSACleanup()
END DESTRUCTOR
#ENDIF          ' IFDEF __QSOCKET


' #35 ====================================================================================
TYPE QFILESTREAM
' Private (not)
    ObjId AS integer        = Q_FILESTREAM              ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*32   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    _EOF AS integer         = False
    _Handle AS FILE ptr     = NULL
    _LineCount AS integer   = 0
    _Position AS integer    = 0
    _Size AS integer        = 0

' Properties
    DECLARE PROPERTY EOF() AS integer
    DECLARE PROPERTY EOF(value AS integer)
    DECLARE PROPERTY Handle() AS FILE ptr
    DECLARE PROPERTY Handle(value AS FILE ptr)
    DECLARE PROPERTY LineCount() AS integer
    DECLARE PROPERTY LineCount(value AS integer)
    DECLARE PROPERTY Position() AS integer
    DECLARE PROPERTY Position(value AS integer)
    DECLARE PROPERTY Size() AS integer
    DECLARE PROPERTY Size(value AS integer)
' Methods
    DECLARE SUB Close()
    DECLARE SUB Open(FileName AS string, Method AS integer)
    DECLARE FUNCTION ReadLine() AS string
    DECLARE FUNCTION ReadBinStr(NumBytes AS integer) AS string
    DECLARE FUNCTION ReadStr(NumBytes AS integer) AS string
    DECLARE SUB Seek(Offset AS long, From AS integer)
    DECLARE SUB WriteLine(S AS string)
    DECLARE SUB WriteBinStr(S AS string, NumBytes AS integer)
    DECLARE SUB WriteStr(S AS string, NumBytes AS integer)
    DECLARE SUB WriteNum OVERLOAD (number AS byte)
    DECLARE SUB WriteNum OVERLOAD (number AS word)
    DECLARE SUB WriteNum OVERLOAD (number AS integer)
    DECLARE SUB WriteNum OVERLOAD (number AS long)
    DECLARE SUB WriteNum OVERLOAD (number AS single)
    DECLARE SUB WriteNum OVERLOAD (number AS double)
#IF 0
    DECLARE SUB CopyFrom(Stream AS BYTE PTR, NumBytes AS integer)
    DECLARE SUB ExtractRes(Resource AS long)
    DECLARE SUB LoadArray(Array AS ANY PTR, ElementSize AS integer, NumElements AS integer)
    DECLARE SUB Read(nVar AS ANY)
    DECLARE FUNCTION ReadNum(Num_Type AS integer) AS double
    DECLARE SUB ReadUDT(MyType AS BYTE PTR, UDTSize AS integer)
    DECLARE SUB SaveArray(Array AS ANY PTR, ElementSize AS integer, NumElements AS integer)
    DECLARE SUB Write(variable) Generic Write, determines the storage space and saves data to file 1 WXG
    DECLARE SUB WriteUDT(MyType AS BYTE PTR, UDTSize AS integer)
    DECLARE SUB WriteNum(number, NumElements)
#ENDIF
' Extras
    DECLARE SUB GetLineCount()
    DECLARE DESTRUCTOR
' Events
END TYPE

PROPERTY QFILESTREAM.EOF() AS integer: _EOF=feof(Handle): RETURN _EOF: END PROPERTY
PROPERTY QFILESTREAM.EOF(value AS integer): END PROPERTY                    ' Read Only
PROPERTY QFILESTREAM.Handle() AS FILE ptr: RETURN _Handle: END PROPERTY
PROPERTY QFILESTREAM.Handle(value AS FILE ptr): END PROPERTY                ' Read Only
PROPERTY QFILESTREAM.LineCount() AS integer: GetLineCount(): RETURN _LineCount: END PROPERTY
PROPERTY QFILESTREAM.LineCount(value AS integer): END PROPERTY              ' Read Only
PROPERTY QFILESTREAM.Position() AS integer: _Position=ftell(Handle): RETURN _Position: END PROPERTY
PROPERTY QFILESTREAM.Position(value AS integer): END PROPERTY               ' Read Only
PROPERTY QFILESTREAM.Size() AS integer: RETURN _Size: END PROPERTY
PROPERTY QFILESTREAM.Size(value AS integer): END PROPERTY                   ' Read Only

SUB QFILESTREAM.WriteNum OVERLOAD (number AS byte)
DIM AS string tstr=SPACE(8)
    tstr[0]=number
    WriteBinStr(tstr, 1)
'    DBG("byte: "+STR(SIZEOF(number)))
END SUB
SUB QFILESTREAM.WriteNum OVERLOAD (number AS word)
DIM AS string tstr=SPACE(8)
    FOR i AS integer = 0 TO 1
        tstr[i]=CAST(BYTE,((number SHR i*8) AND &hff))
    NEXT i
    WriteBinStr(tstr, 2)
'    DBG("word: "+STR(SIZEOF(number)))
END SUB
SUB QFILESTREAM.WriteNum OVERLOAD (number AS integer)
DIM AS string tstr=SPACE(8)
    FOR i AS integer = 0 TO 3
        tstr[i]=CAST(BYTE,((number SHR i*8) AND &hff))
    NEXT i
    WriteBinStr(tstr, 4)
'    DBG("integer: "+STR(SIZEOF(number)))
END SUB
SUB QFILESTREAM.WriteNum OVERLOAD (number AS long)
DIM AS string tstr=SPACE(8)
    FOR i AS integer = 0 TO 3
        tstr[i]=CAST(BYTE,((number SHR i*8) AND &hff))
    NEXT i
    WriteBinStr(tstr, 4)
'    DBG("long: "+STR(SIZEOF(number)))
END SUB
SUB QFILESTREAM.WriteNum OVERLOAD (number AS single)
DIM AS string tstr=SPACE(8)
    FOR i AS integer = 0 TO 3
        tstr[i]=CAST(BYTE,((number SHR i*8) AND &hff))
    NEXT i
    WriteBinStr(tstr, 4)
'    DBG("single: "+STR(SIZEOF(number)))
END SUB
SUB QFILESTREAM.WriteNum OVERLOAD (number AS double)
DIM AS string tstr=SPACE(8)
    FOR i AS integer = 0 TO 7
        tstr[i]=CAST(BYTE,((number SHR i*8) AND &hff))
    NEXT i
    WriteBinStr(tstr, 8)
'    DBG("double: "+STR(SIZEOF(number)))
END SUB

SUB QFILESTREAM.Close()
    IF Handle THEN fclose(Handle)
    _Handle=0: _Size=0: _LineCount=0: _Position=0
END SUB
SUB QFILESTREAM.Open(FileName AS string, Method AS integer)
DIM AS integer ItExists=FileExists(FileName)
    _LineCount=0: _Size=0
    SELECT CASE Method
        CASE fmCreate                                       ' Create
            IF ItExists THEN KILL(FileName)
            _Handle=fopen(FileName,"w")
        CASE fmOpenRead                                     ' Read
            IF ItExists=False THEN
                InpFileError(FileName)
                EXIT SUB
            END IF
            _Handle=fopen(FileName,"r")
            fseek(Handle,0,SEEK_END)
            _Size=ftell(Handle)
            rewind(Handle)
        CASE fmOpenReadWrite                                ' Read/write
            _Handle=fopen(FileName,"rw")
            IF ItExists THEN
                fseek(Handle,0,SEEK_END)
                _Size=ftell(Handle)
                rewind(Handle)
            END IF
        CASE fmOpenWrite                                    ' Append or create
            _Handle=fopen(FileName,"w")
            IF ItExists THEN
                fseek(Handle,0,SEEK_END)                    ' Start at end of file
                _Size=ftell(Handle)
            END IF
    END SELECT
END SUB
FUNCTION QFILESTREAM.ReadLine() AS string
DIM AS integer cnt=Size-ftell(Handle)
DIM AS integer dat
DIM AS string tstr=""
    FOR i AS integer = 1 TO cnt
        dat=fgetc(Handle)
        tstr=tstr+CHR(dat)
        IF dat=10 THEN EXIT FOR
    NEXT i
    tstr=tstr+CHR(0)
    RETURN tstr
END FUNCTION
FUNCTION QFILESTREAM.ReadBinStr(NumBytes AS integer) AS string
DIM AS integer cnt=Size-ftell(Handle)
DIM AS integer dat
DIM AS string tstr=""
    IF NumBytes<cnt THEN cnt=NumBytes
    FOR i AS integer = 1 TO cnt
        dat=fgetc(Handle)
        tstr=tstr+CHR(dat)
    NEXT i
    RETURN tstr
END FUNCTION
FUNCTION QFILESTREAM.ReadStr(NumBytes AS integer) AS string
DIM AS integer cnt=Size-ftell(Handle)
DIM AS integer dat
DIM AS string tstr=""
    IF NumBytes<cnt THEN cnt=NumBytes
    FOR i AS integer = 1 TO cnt
        dat=fgetc(Handle)
        tstr=tstr+CHR(dat)
        IF dat=0 THEN EXIT FOR
        IF dat=10 THEN
            tstr=tstr+CHR(0)
            EXIT FOR
        END IF
    NEXT i
    tstr=tstr+CHR(0)
    RETURN tstr
END FUNCTION
SUB QFILESTREAM.Seek(Offset AS long, From AS integer)
    SELECT CASE From
        CASE soFromBeginning:   fseek(Handle,Offset,SEEK_SET)
        CASE soFromCurrent:     fseek(Handle,Offset,SEEK_CUR)
        CASE soFromEnd:         fseek(Handle,Offset,SEEK_END)
    END SELECT
END SUB
SUB QFILESTREAM.WriteLine(S AS string)
DIM AS string tstr=S+CHR(13)                                    ' S can be "" -> blank line
    fputs(STRPTR(tstr),Handle)                                  ' LF auto added
END SUB
SUB QFILESTREAM.WriteBinStr(S AS string, NumBytes AS integer)
DIM AS integer cnt=LEN(S)
    IF cnt>NumBytes THEN cnt=NumBytes
    FOR i AS integer = 0 TO cnt-1
        fputc(S[i],Handle)                                      ' Writes everything to disk
    NEXT i
END SUB
SUB QFILESTREAM.WriteStr(S AS string, NumBytes AS integer)
DIM AS integer cnt=LEN(S)
    IF cnt>NumBytes THEN cnt=NumBytes
    FOR i AS integer = 0 TO cnt-1
        IF S[i]=0 THEN EXIT FOR                                 ' Null termination?
        fputc(S[i],Handle)
        IF S[i]=10 THEN EXIT FOR                                ' Line termination?
    NEXT i
END SUB

#IF 0
' Needs more work here!!!!
FUNCTION QFILESTREAM.ReadNum(Num_Type AS integer) AS double
DIM AS DOUBLE ret
    SELECT CASE Num_Type
        CASE Num_BYTE: fscanf(Handle,"%c",@ret)         ' 1 byte
        CASE Num_SHORT: fscanf(Handle,"%hx",@ret)       ' 2 bytes
        CASE Num_WORD: fscanf(Handle,"%x",@ret)         ' 4 bytes
        CASE Num_LONG: fscanf(Handle,"%lx",@ret)        ' 8 bytes
        CASE Num_DWORD: fscanf(Handle,"%lx",@ret)       ' 8 bytes
        CASE Num_SINGLE: fscanf(Handle,"%f",@ret)       ' 4 bytes
        CASE Num_DOUBLE: fscanf(Handle,"%Lf",@ret)      ' 8 bytes
    END SELECT
    RETURN ret
END FUNCTION
SUB QFILESTREAM.CopyFrom(Stream AS BYTE PTR, NumBytes AS integer)
'DIM AS BYTE dat
'FOR i AS integer = 1 TO NumBytes
'    dat=*Stream: Stream += 1
'    fputc(dat,Handle)
'NEXT
END SUB
SUB QFILESTREAM.LoadArray(Array AS ANY PTR, ElementSize AS integer, NumElements AS integer)
'DIM AS BYTE dat
'    FOR i AS integer = 0 TO NumElements-1
'        IF fscanf(Handle,"%c",@dat)=EOF THEN EXIT FOR
'        *(Array+i)=dat
'    NEXT i
END SUB
SUB QFILESTREAM.WriteNum OVERLOAD (number AS UBYTE, NumElements AS integer)
    FOR i AS integer = 1 TO NumElements: fputc(number,Handle): NEXT
END SUB
SUB QFILESTREAM.WriteNum OVERLOAD (number AS USHORT, NumElements AS integer)
FOR i AS integer = 1 TO NumElements
    fputc((number AND &hff),Handle)
    fputc(((number SHR 8) AND &hff),Handle)
NEXT
END SUB
SUB QFILESTREAM.WriteNum OVERLOAD (number AS UINT, NumElements AS integer)
FOR i AS integer = 1 TO NumElements
    fputc((number AND &hff),Handle)
    fputc(((number SHR 8) AND &hff),Handle)
    fputc(((number SHR 16) AND &hff),Handle)
    fputc(((number SHR 24) AND &hff),Handle)
NEXT
END SUB
SUB QFILESTREAM.WriteNum OVERLOAD (number AS SINGLE, NumElements AS integer)
END SUB
SUB QFILESTREAM.WriteNum OVERLOAD (number AS DOUBLE, NumElements AS integer)
END SUB
#ENDIF          '#IF 0  more work needed here!!!!!

SUB QFILESTREAM.GetLineCount()
DIM AS integer dat
    rewind(Handle): _LineCount=0
    FOR i AS integer = 1 TO Size
        dat=fgetc(Handle)
        IF dat=10 THEN _LineCount += 1
    NEXT i
    rewind(Handle)
END SUB
DESTRUCTOR QFILESTREAM
    IF Handle THEN fclose(Handle)
END DESTRUCTOR


' #36 ====================================================================================
TYPE QMEMORYSTREAM
' Private (not)
    ObjId AS integer        = Q_MEMORYSTREAM            ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*32   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    _Pointer AS BYTE PTR    = 0
    _LineCount AS integer   = 0
    _Position AS integer    = 0
    _Size AS integer        = 0

    PageCount AS integer    = 0                         ' Internal use
    RemainBytes AS integer  = 0                         ' ditto

' Properties
    DECLARE PROPERTY Pointer() AS BYTE ptr
    DECLARE PROPERTY Pointer(value AS BYTE ptr)
    DECLARE PROPERTY LineCount() AS integer
    DECLARE PROPERTY LineCount(value AS integer)
    DECLARE PROPERTY Position() AS integer
    DECLARE PROPERTY Position(value AS integer)
    DECLARE PROPERTY Size() AS integer
    DECLARE PROPERTY Size(value AS integer)
' Methods
    DECLARE SUB Close()
    DECLARE SUB LoadArray(Array AS ANY PTR, ElementSize AS integer, NumElements AS integer)
    DECLARE SUB MemCopyFrom(Address AS BYTE PTR, NumBytes AS integer)
    DECLARE SUB MemCopyTo(Address AS BYTE PTR, NumBytes AS integer)
    DECLARE FUNCTION ReadBinStr(NumBytes AS integer) AS string
    DECLARE FUNCTION ReadLine() AS string
    DECLARE FUNCTION ReadStr(NumBytes AS integer) AS string
    DECLARE SUB ReadUDT(MyType AS ANY PTR, MyTypeSize AS integer)   ' Read data into a MyType
    DECLARE SUB SaveArray(Array AS ANY PTR, ElementSize AS integer, NumElements AS integer)
    DECLARE SUB Seek(Offset AS integer, From AS integer)
    DECLARE SUB WriteLine(S AS string)                              ' Writes string with CR+LF
    DECLARE SUB WriteBinStr(S AS string, NumBytes AS integer)
    DECLARE SUB WriteStr(S AS string, NumBytes AS integer)
    DECLARE SUB WriteUDT(MyType AS ANY PTR, MyTypeSize AS integer)  ' Write data into a MyType
#IF 0
    DECLARE SUB CopyFrom(Stream AS QFileStream, NumBytes AS integer)
    DECLARE SUB ExtractRes(Resource AS long)
    DECLARE SUB Read(nVar AS ANY)
    DECLARE FUNCTION ReadNum(Num_Type AS integer) AS double
    DECLARE SUB Write(variable) Generic Write, determines the storage space and saves data to file 1 WXG
    DECLARE SUB WriteNum(number AS variant, bytes AS integer)
#ENDIF
' Extras
    DECLARE SUB GetLineCount()
    DECLARE SUB IncreaseSize(numbytes AS integer)
    DECLARE CONSTRUCTOR
    DECLARE DESTRUCTOR
' Events
END TYPE

PROPERTY QMEMORYSTREAM.Pointer() AS BYTE PTR: RETURN _Pointer: END PROPERTY
PROPERTY QMEMORYSTREAM.Pointer(value AS BYTE PTR): END PROPERTY         ' Read Only
PROPERTY QMEMORYSTREAM.LineCount() AS integer: GetLineCount(): RETURN _LineCount: END PROPERTY
PROPERTY QMEMORYSTREAM.LineCount(value AS integer): END PROPERTY        ' Read Only
PROPERTY QMEMORYSTREAM.Position() AS integer: RETURN _Position: END PROPERTY
PROPERTY QMEMORYSTREAM.Position(value AS integer)
IF (value>=0) AND (value<_Position) THEN _Position=value
END PROPERTY
PROPERTY QMEMORYSTREAM.Size() AS integer: RETURN _Size: END PROPERTY
PROPERTY QMEMORYSTREAM.Size(value AS integer): END PROPERTY     ' Read Only

SUB QMEMORYSTREAM.Close()                                       ' Resets ONLY!
    DeAllocate(_Pointer)
    _Pointer=CAST(BYTE PTR,CAllocate(4096))
    _LineCount=0: _Position=0: _Size=0
    PageCount=1: RemainBytes=4096
END SUB
SUB QMEMORYSTREAM.MemCopyFrom(Address AS BYTE PTR, NumBytes AS integer)
DIM AS BYTE PTR bPtr
    IF RemainBytes < NumBytes THEN IncreaseSize(NumBytes)       ' Need to increase memory?
    bPtr=_Pointer+_Position
    memcpy(Bptr,Address,NumBytes)
    _Position += NumBytes: _Size += NumBytes
    RemainBytes -= NumBytes
END SUB
SUB QMEMORYSTREAM.MemCopyTo(Address AS BYTE PTR, NumBytes AS integer)
DIM AS BYTE PTR bPtr=_Pointer + _Position
DIM AS integer i=_Size - _Position                                ' Limit copy to initialised data!
    IF i>0 THEN
        IF i>=NumBytes THEN i=NumBytes
        memcpy(Address,bPtr,i)
        _Position += i
    END IF
END SUB
FUNCTION QMEMORYSTREAM.ReadLine() AS string
DIM AS string tstr=SPACE(_Size - _Position+1)
DIM AS BYTE PTR bPtr=_Pointer + _Position
DIM AS integer i=0
DIM AS BYTE ch
    DO WHILE _Position < _Size
        ch=*bPtr: bPtr += 1: _Position += 1
        IF ch=10 THEN EXIT DO                                   ' Newline terminates
        tstr[i]=ch: i += 1
    LOOP
    RETURN RTRIM(tstr)
END FUNCTION
FUNCTION QMEMORYSTREAM.ReadBinStr(NumBytes AS integer) AS string
DIM AS string tstr=SPACE(_Size - _Position+1)
DIM AS BYTE PTR bPtr=_Pointer + _Position
DIM AS integer i=0
DIM AS BYTE ch
    IF NumBytes<=0 THEN RETURN ""
    DO WHILE _Position < _Size
        ch=*bPtr: bPtr+=1: _Position+=1
        tstr[i]=ch: i+=1
        IF i=NumBytes THEN EXIT DO
    LOOP
    tstr[i]=0
    RETURN RTRIM(tstr)
END FUNCTION
FUNCTION QMEMORYSTREAM.ReadStr(NumBytes AS integer) AS string
DIM AS string tstr=SPACE(_Size - _Position+1)
DIM AS BYTE PTR bPtr=_Pointer + _Position
DIM AS integer i=0
DIM AS BYTE ch
    IF NumBytes<=0 THEN RETURN ""
    DO WHILE _Position < _Size
        ch=*bPtr: bPtr += 1: _Position += 1
        tstr[i]=ch: i += 1
        IF ch=0 THEN EXIT DO
        IF i=NumBytes THEN EXIT DO
    LOOP
    tstr[i]=0
    RETURN RTRIM(tstr)
END FUNCTION
SUB QMEMORYSTREAM.Seek(Offset AS integer, From AS integer)      ' Offset + or -
    SELECT CASE From
        CASE soFromBeginning:   IF (Offset >= 0) AND (Offset < _Size) THEN _Position=Offset
        CASE soFromCurrent:     IF (_Position+Offset >= 0) AND (_Position+Offset < _Size) THEN _Position += Offset
        CASE soFromEnd:         IF (Offset<0) AND (_Size+Offset >= 0) THEN _Position += Offset
    END SELECT
END SUB
SUB QMEMORYSTREAM.WriteLine(S AS string)                        ' Writes string with CR+LF
DIM AS BYTE PTR bPtr
DIM AS string tstr=S+CHR(13)+CHR(10)
DIM AS integer lnth=LEN(tstr)
    IF RemainBytes < lnth THEN IncreaseSize(lnth)               ' Need to increase memory?
    bPtr=_Pointer + _Position
    memcpy(Bptr,CAST(BYTE PTR, STRPTR(tstr)),lnth)
    _Position += lnth: _Size += lnth
    RemainBytes -= lnth
END SUB
SUB QMEMORYSTREAM.WriteBinStr(S AS string, NumBytes AS integer)
DIM AS BYTE PTR bPtr
    IF RemainBytes < NumBytes THEN IncreaseSize(NumBytes)      ' Need to increase memory?
    bPtr=_Pointer + _Position
    memcpy(Bptr,CAST(BYTE PTR, STRPTR(S)),NumBytes)
    _Position += NumBytes: _Size += NumBytes
    RemainBytes -= NumBytes
END SUB
SUB QMEMORYSTREAM.WriteStr(S AS string, NumBytes AS integer)
DIM AS BYTE PTR srcPtr, dstPtr
DIM AS integer i
    IF RemainBytes < NumBytes THEN IncreaseSize(NumBytes)      ' Need to increase memory?
    srcPtr=CAST(BYTE PTR,STRPTR(S))
    dstPtr=_Pointer + _Position
    FOR i = 0 TO NumBytes-1
        IF @srcPtr=0 THEN EXIT FOR
        *dstPtr=*srcPtr
        dstPtr += 1: srcPtr += 1
    NEXT i
    _Position += i: _Size += i
    RemainBytes -= i
END SUB
#IF 0
SUB QMEMORYSTREAM.LoadArray(Array AS ANY PTR, ElementSize AS integer, NumElements AS integer)
DIM AS BYTE PTR bPtr=Array
    FOR i AS integer = 1 TO NumElements
        *bPtr=ReadBinStr(ElementSize)                                   ' Read data into Array()
        bPtr += ElementSize
    NEXT i
END SUB
SUB QMEMORYSTREAM.ReadUDT(MyType AS ANY PTR, MyTypeSize AS integer)     ' Read data into MyType
    LoadArray(MyType, MyTypeSize, 1)
END SUB
SUB QMEMORYSTREAM.SaveArray(Array AS ANY PTR, ElementSize AS integer, NumElements AS integer)
DIM AS BYTE PTR bPtr=Array
DIM AS string buf=SPACE(8)
    FOR i AS integer = 1 TO NumElements
        FOR j AS integer = 0 TO ElementSize-1
            buf[i]=*bPtr
            bPtr += 1
        NEXT j
        WriteBinStr(buf, ElementSize)                                   ' Write data to stream
    NEXT i
END SUB
SUB QMEMORYSTREAM.WriteUDT(MyType AS ANY PTR, MyTypeSize AS integer)    ' Write data into a MyType
    SaveArray(MyType, MyTypeSize, 1)
END SUB
#ENDIF
SUB QMEMORYSTREAM.GetLineCount()
DIM AS BYTE PTR bPtr = _Pointer
    _LineCount=0
    FOR i AS integer = 1 TO Size
        IF *bPtr=10 THEN _LineCount += 1                                ' Counts LFs only
        bPtr += 1
    NEXT i
END SUB
SUB QMEMORYSTREAM.IncreaseSize(numbytes AS integer)
DIM AS BYTE PTR bPtr
DIM AS integer pCount = numbytes\4096+1

    bPtr=ReAllocate(_Pointer, (PageCount+pCount)*4096)
    IF bPtr=0 THEN
        DBG("RapidFRM Internal error! QMemoryStream.IncreaseSize()")
        Deallocate(_Pointer): _Pointer=0
        Application.Terminate
    END IF
    _Pointer=bPtr: PageCount+=pCount: _Size=PageCount*4096
    RemainBytes=RemainBytes+pCount*4096
END SUB
CONSTRUCTOR QMEMORYSTREAM
    _Pointer=CAST(BYTE PTR,CAllocate(4096))
    _LineCount=0: _Position=0: _Size=0
    PageCount=1: RemainBytes=4096
END CONSTRUCTOR
DESTRUCTOR QMEMORYSTREAM
    IF _Pointer>0 THEN Deallocate(_Pointer)
END DESTRUCTOR

#IF 0
'# 38 QMYSQL
'# 39 QOLEOBJECT
'# 40 QREGISTRY
#ENDIF

' #41 ====================================================================================
TYPE QOPENDIALOG
' Private (not)
    ObjId AS integer        = Q_OPENDIALOG              ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*32   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    _Left AS integer        = -1                        ' Default to center
    _Top AS integer         = -1                        ' ditto
    Width AS integer                                    ' Not used
    Height AS integer                                   ' Not used
    Caption AS string       = ""

    _NewStyle AS integer    = False                     ' True/False
    InitialDir AS string    = Application.Path
    FileName AS string      = ""                        ' FULL path and filename
    FileTitle AS string     = ""                        ' Filename + ext (no path)
    Filter AS string        = "All files (*.*)|*.*"     ' User entered string '|' separated fields
    nuFilter AS string                                  ' Converted into correct format for dialog
    FilterIndex AS integer = 1
' Properties
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY NewStyle() AS integer
    DECLARE PROPERTY NewStyle(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
' Methods
    DECLARE FUNCTION Execute() AS integer
' Events
END TYPE

PROPERTY QOPENDIALOG.Left() AS integer: RETURN _Left: END PROPERTY
PROPERTY QOPENDIALOG.Left(value AS integer): _Left=value: END PROPERTY
PROPERTY QOPENDIALOG.Top() AS integer: RETURN _Top: END PROPERTY
PROPERTY QOPENDIALOG.Top(value AS integer): _Top=value: END PROPERTY
PROPERTY QOPENDIALOG.NewStyle() AS integer: RETURN _NewStyle: END PROPERTY
PROPERTY QOPENDIALOG.NewStyle(value AS integer)
    IF value THEN _NewStyle=True ELSE _NewStyle=False
END PROPERTY

' Currently Hook func only works in old style..more investigation needed.
FUNCTION OpenHookProc(hWnd AS HWND, uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
   IF uMsg = WM_INITDIALOG THEN                         ' ALL initializing is done here
        DIM AS OPENFILENAME PTR lpOpen = CAST(OPENFILENAME PTR, lParam)
        DIM AS QOPENDIALOG PTR lpDlg = CAST(QOPENDIALOG PTR,lpOpen->lCustData)
        DIM AS integer X, Y, W, H
        X=lpDlg->Left: Y=lpDlg->Top
        IF (X<0) OR (Y<0) THEN
            DIM AS RECT rct
            GetWindowRect(hWnd, @rct)
            IF X<0 THEN W=rct.Right-rct.Left: X=(Screen.Width - W)\2
            IF Y<0 THEN H=rct.Bottom-rct.Top: Y=(Screen.Height - H)\2
        END IF
        SetWindowPos(hWnd, 0, X, Y, 0, 0, SWP_NOSIZE OR SWP_NOZORDER)
        RETURN 1
    END IF
    RETURN 0
END FUNCTION
FUNCTION QOPENDIALOG.Execute() AS integer
DIM AS OPENFILENAME ofn
DIM AS integer cnt

    IF INSTR(Filter,"|")=0 THEN Filter="All files (*.*)|*.*"    ' Invalid entry? set default
    cnt=rqTALLY(Filter,"|")+1
    FOR i AS integer = 1 TO cnt
        nuFilter=nuFilter+rqFIELDSTR(Filter,"|",i)+CHR(0)       ' Get filter into correct format
    NEXT i
    nuFilter=nuFilter+CHR(0)                                    ' Double NUL to mark the end!!
    FileName=STRING(256,0)
    FileTitle=STRING(64,0)
    CLEAR(@ofn, 0, SIZEOF(OPENFILENAME))
WITH ofn
    .lStructSize=SIZEOF(OPENFILENAME)
    .hwndOwner=Application.hMainForm
    IF Caption <> "" THEN .lpstrTitle=STRPTR(Caption)
    .lpstrInitialDir=STRPTR(InitialDir)
    .lpstrFilter=STRPTR(nuFilter)
    .nFilterIndex=FilterIndex
    .lpstrFile=STRPTR(FileName)
    .nMaxFile=256
    .lpstrFileTitle=STRPTR(FileTitle)
    .nMaxFileTitle=64
    .lCustData=CAST(LPARAM, @THIS)
    .lpfnHook=CAST(LPOFNHOOKPROC, @OpenHookProc)
    .Flags=OFN_FILEMUSTEXIST OR OFN_PATHMUSTEXIST
    IF NewStyle THEN
        .Flags = .Flags OR OFN_EXPLORER                 ' New style 'explorer look'
    ELSE
        .Flags = .Flags OR OFN_ENABLEHOOK               ' Old style with positioning enabled
    END IF
END WITH
    IF GetOpenFileName(@ofn) THEN
        FileName=RTRIM(FileName)
        RETURN True
    END IF
    RETURN False
END FUNCTION


' #42 ====================================================================================
TYPE QSAVEDIALOG
' Private (not)
    ObjId AS integer        = Q_SAVEDIALOG              ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*32   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    _Left AS integer        = -1                        ' Default to center
    _Top AS integer         = -1                        ' ditto
    Width AS integer                                    ' Not used
    Height AS integer                                   ' Not used
    Caption AS string       = ""

    _NewStyle AS integer    = False                     ' True/False
    FileName AS string      = ""                        ' FULL path and filename
    FileTitle AS string     = ""                        ' Filename + ext (no path)
    InitialDir AS string    = Application.Path
    Filter AS string        = "All files (*.*)|*.*"     ' User entered string '|' separated fields
    nuFilter AS string                                  ' Converted into correct format for dialog
    FilterIndex AS integer  = 1
' Properties
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY NewStyle() AS integer
    DECLARE PROPERTY NewStyle(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
' Methods
    DECLARE FUNCTION Execute() AS integer
' Events
END TYPE

PROPERTY QSAVEDIALOG.Left() AS integer: RETURN _Left: END PROPERTY
PROPERTY QSAVEDIALOG.Left(value AS integer): _Left=value: END PROPERTY
PROPERTY QSAVEDIALOG.Top() AS integer: RETURN _Top: END PROPERTY
PROPERTY QSAVEDIALOG.Top(value AS integer): _Top=value: END PROPERTY
PROPERTY QSAVEDIALOG.NewStyle() AS integer: RETURN _NewStyle: END PROPERTY
PROPERTY QSAVEDIALOG.NewStyle(value AS integer)
    IF value THEN _NewStyle=True ELSE _NewStyle=False
END PROPERTY

' Currently Hook func only works in old style..more investigation needed.
FUNCTION SaveHookProc(hWnd AS HWND, uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
   IF uMsg = WM_INITDIALOG THEN                         ' ALL initializing is done here
        DIM AS OPENFILENAME PTR lpSave = CAST(OPENFILENAME PTR, lParam)
        DIM AS QSAVEDIALOG PTR lpDlg = CAST(QSAVEDIALOG PTR,lpSave->lCustData)
        DIM AS integer X, Y, W, H
        X=lpDlg->Left: Y=lpDlg->Top
        IF (X<0) OR (Y<0) THEN
            DIM AS RECT rct
            GetWindowRect(hWnd, @rct)
            IF X<0 THEN W=rct.Right-rct.Left: X=(Screen.Width - W)\2
            IF Y<0 THEN H=rct.Bottom-rct.Top: Y=(Screen.Height - H)\2
        END IF
        SetWindowPos(hWnd, 0, X, Y, 0, 0, SWP_NOSIZE OR SWP_NOZORDER)
        RETURN 1
    END IF
    RETURN 0
END FUNCTION
FUNCTION QSAVEDIALOG.Execute() AS integer
DIM AS OPENFILENAME ofn
DIM AS integer cnt

    IF INSTR(Filter,"|")=0 THEN Filter="All files (*.*)|*.*"    ' Invalid entry? set default
    cnt=rqTALLY(Filter,"|")+1
    FOR i AS integer = 1 TO cnt
        nuFilter=nuFilter+rqFIELDSTR(Filter,"|",i)+CHR(0)       ' Get filter into correct format
    NEXT i
    nuFilter=nuFilter+CHR(0)                            ' Double NUL marks the end!!
    FileName=STRING(256,0)
    FileTitle=STRING(64,0)
    CLEAR(@ofn, 0, SIZEOF(OPENFILENAME))
WITH ofn
    .lStructSize=SIZEOF(OPENFILENAME)
    .hwndOwner=Application.hMainForm
    .hInstance=Application.hInstance
    IF Caption<>"" THEN .lpstrTitle=STRPTR(Caption)
    .lpstrInitialDir=STRPTR(InitialDir)
    .lpstrFilter=STRPTR(nuFilter)
    .nFilterIndex=FilterIndex
    .lpstrFile=STRPTR(FileName)
    .nMaxFile=256
    .lpstrFileTitle=STRPTR(FileTitle)
    .nMaxFileTitle=64
    .lCustData=CAST(LPARAM, @THIS)
    .lpfnHook=CAST(LPOFNHOOKPROC, @SaveHookProc)
    .Flags=OFN_FILEMUSTEXIST OR OFN_PATHMUSTEXIST
    IF NewStyle THEN
        .Flags = .Flags OR OFN_EXPLORER                 ' New style 'explorer look'
    ELSE
        .Flags = .Flags OR OFN_ENABLEHOOK               ' Old style with positioning enabled
    END IF
END WITH
    RETURN GetSaveFileName(@ofn)
END FUNCTION


' #43 ====================================================================================
TYPE QFONTDIALOG
' Private (not)
    ObjId AS integer        = Q_FONTDIALOG              ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*32   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    _Left AS integer        = -1                        ' Default to center
    _Top AS integer         = -1                        ' ditto
    Width AS integer                                    ' Not used
    Height AS integer                                   ' Not used
    Caption AS string       = ""

    Color AS integer        = 0
    Name AS string          = Application.Font.Name
    Size AS integer         = Application.Font.Size
    fntChoose AS CHOOSEFONTA
    fntLF AS LOGFONT                                    ' logical font structure
    fntHeight AS integer                                ' Product of size & LOGPIXELSY
#IF 0
    FontCount AS integer                                ' Read only
    FontName(1) AS string                               ' Array of strings Read only
    MaxFontSize AS integer
    MinFontSize AS integer
#ENDIF

' Properties
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
' Methods
    DECLARE SUB AddStyles(value AS integer)
    DECLARE SUB DelStyles(value AS integer)
    DECLARE FUNCTION Execute() AS INTEGER
    DECLARE SUB GetFont(lpFont AS QFONT PTR)
    DECLARE SUB SetFont(lpFont AS QFONT PTR)
#IF 0
    DECLARE SUB AddOptions(value AS integer)            ' SUBI Add options [fdLimitSize, fdNoSizeSel, etc.]
    DECLARE SUB DelOptions(value AS integer)            ' SUBI Delete options [fdNoStyleSel, fdScalableOnly, etc.]
#ENDIF
' Extras
    DECLARE CONSTRUCTOR
' Events
    OnApply AS SUB(Sender AS QFONTDIALOG)
END TYPE

PROPERTY QFONTDIALOG.Left() AS integer: RETURN _Left: END PROPERTY
PROPERTY QFONTDIALOG.Left(value AS integer): _Left=value: END PROPERTY
PROPERTY QFONTDIALOG.Top() AS integer: RETURN _Top: END PROPERTY
PROPERTY QFONTDIALOG.Top(value AS integer): _Top=value: END PROPERTY

SUB QFONTDIALOG.AddStyles(value AS integer)
    SELECT CASE value
        CASE fsBold:        fntLF.lfWeight = FW_BOLD
        CASE fsItalic:      fntLF.lfItalic = 1
        CASE fsUnderline:   fntLF.lfUnderline = 1
        CASE fsStrikeOut:   fntLF.lfStrikeOut = 1
    END SELECT
END SUB
SUB QFONTDIALOG.DelStyles(value AS integer)
    SELECT CASE value
        CASE fsBold:        fntLF.lfWeight = FW_NORMAL
        CASE fsItalic:      fntLF.lfItalic = 0
        CASE fsUnderline:   fntLF.lfUnderline = 0
        CASE fsStrikeOut:   fntLF.lfStrikeOut = 0
    END SELECT
END SUB
SUB QFONTDIALOG.SetFont(lpFont AS QFONT PTR)            ' Get update from ChooseFont struc
    lpFont->Name=RTRIM(fntLF.lfFaceName)
    lpFont->italic=fntLF.lfItalic
    lpFont->Underline=fntLF.lfUnderline
    lpFont->StrikeOut=fntLF.lfStrikeOut
    IF fntLF.lfWeight>=FW_BOLD THEN lpFont->Bold=True ELSE lpFont->Bold=False
    lpFont->Size = -MulDiv(fntLF.lfHeight, 72, fntHeight)
    lpFont->Color=Color
END SUB
SUB QFONTDIALOG.GetFont(lpFont AS QFONT PTR)            ' Preset the ChooseFont struc
    fntLF.lfFaceName=lpFont->Name
    fntLF.lfItalic=lpFont->italic
    fntLF.lfUnderline=lpFont->Underline
    fntLF.lfStrikeOut=lpFont->StrikeOut
    IF lpFont->Bold THEN fntLF.lfWeight=FW_BOLD ELSE fntLF.lfWeight=FW_NORMAL
    fntLF.lfHeight = -MulDiv(lpFont->Size, fntHeight, 72)
    Color=lpFont->Color
END SUB

FUNCTION FontHookProc(hWnd AS HWND, uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
   IF uMsg = WM_INITDIALOG THEN                             ' ALL initializing is done here
        DIM AS CHOOSEFONTA PTR lpChoose = CAST(CHOOSEFONTA PTR, lParam)
        DIM AS QFONTDIALOG PTR lpDlg = CAST(QFONTDIALOG PTR,lpChoose->lCustData)
        DIM AS integer X, Y, W, H
        X=lpDlg->Left: Y=lpDlg->Top
        IF (X<0) OR (Y<0) THEN
            DIM AS RECT rct
            GetWindowRect(hWnd, @rct)
            IF X<0 THEN W=rct.Right-rct.Left: X=(Screen.Width - W)\2
            IF Y<0 THEN H=rct.Bottom-rct.Top: Y=(Screen.Height - H)\2
        END IF
        SetWindowPos(hWnd, 0, X, Y, 0, 0, SWP_NOSIZE OR SWP_NOZORDER)
        IF lpDlg->Caption <> "" THEN SetWindowText(hWnd, lpDlg->Caption)
        RETURN 1
    END IF
    RETURN 0
END FUNCTION
FUNCTION QFONTDIALOG.Execute() AS INTEGER
    fntChoose.lStructSize=SIZEOF(CHOOSEFONTA)
    fntChoose.hwndOwner=Application.hMainForm
    fntChoose.lpLogFont=CAST(ANY PTR, @fntLF)
    fntChoose.rgbColors=Color
    fntChoose.lpfnHook=CAST(ANY PTR, @FontHookProc)
    fntChoose.lCustData=CAST(LPARAM, @THIS)             ' Pass ptr to THIS fontdlg struc
    fntChoose.Flags=CF_SCREENFONTS OR CF_EFFECTS OR CF_INITTOLOGFONTSTRUCT OR CF_ENABLEHOOK
    IF ChooseFont(@fntChoose) THEN
        Color=fntChoose.rgbColors
        Name=RTRIM(fntLF.lfFaceName)
        Size = -MulDiv(fntLF.lfHeight, 72, fntHeight)
        InvalidateRect(Application.hMainForm,NULL,True) ' Repaint (everything)
        RETURN True
    END IF
    RETURN False
END FUNCTION

CONSTRUCTOR QFONTDIALOG
DIM AS HDC hDC=GetDC(NULL)
    fntHeight=GetDeviceCaps(hDC, LOGPIXELSY)
    ReleaseDC(NULL,hDC)
END CONSTRUCTOR


' #44 ====================================================================================
TYPE QCOLORDIALOG
' Private (not)
    ObjId AS integer        = Q_COLORDIALOG             ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*32   = ""                        ' Base class
    ObjStyle AS integer     = 0                         '

    _Left AS integer        = -1                        ' Default to center
    _Top AS integer         = -1                        ' ditto
    Width AS integer                                    ' Not used
    Height AS integer                                   ' Not used
    Caption AS string       = ""                        ' Default ColorDlg caption

    _Style AS integer       = cdNormal                  ' Compact but expandable
    _Color AS integer       = 0                         ' Default to Black
    Colors(0 TO 15) AS integer                          ' Custom colors
' Properties
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Style() AS integer
    DECLARE PROPERTY Style(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
' Methods
    DECLARE FUNCTION Execute() AS integer
    DECLARE CONSTRUCTOR
' Events
END TYPE

PROPERTY QCOLORDIALOG.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QCOLORDIALOG.Color(value AS integer): _Color=value: END PROPERTY
PROPERTY QCOLORDIALOG.Left() AS integer: RETURN _Left: END PROPERTY
PROPERTY QCOLORDIALOG.Left(value AS integer): _Left=value: END PROPERTY
PROPERTY QCOLORDIALOG.Style() AS integer: RETURN _Style: END PROPERTY
PROPERTY QCOLORDIALOG.Style(value AS integer)
    IF (value<0) OR (value>3) THEN EXIT PROPERTY
    _Style=value
END PROPERTY
PROPERTY QCOLORDIALOG.Top() AS integer: RETURN _Top: END PROPERTY
PROPERTY QCOLORDIALOG.Top(value AS integer): _Top=value: END PROPERTY

FUNCTION ccHookProc(hWnd AS HWND, uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
    IF uMsg=WM_INITDIALOG THEN                              ' ALL initializing is done here
        DIM AS CHOOSECOLOR PTR lpCC=CAST(CHOOSECOLOR PTR,lParam)
        DIM AS QCOLORDIALOG PTR lpCCDlg=CAST(QCOLORDIALOG PTR, lpCC->lCustData)
        DIM AS integer X, Y, W, H
        X=lpCCDlg->Left: Y=lpCCDlg->Top
        IF (X<0) OR (Y<0) THEN
            DIM AS RECT rct
            GetWindowRect(hWnd, @rct)
            IF X<0 THEN W=rct.Right-rct.Left: X=(Screen.Width - W)\2
            IF Y<0 THEN H=rct.Bottom-rct.Top: Y=(Screen.Height - H)\2
        END IF
        SetWindowPos(hWnd, 0, X, Y, 0, 0, SWP_NOSIZE OR SWP_NOZORDER)
        IF lpCCDlg->Caption <> "" THEN SetWindowText(hWnd, lpCCDlg->Caption)
        RETURN 1
    END IF
    RETURN 0
END FUNCTION

FUNCTION QCOLORDIALOG.Execute() AS integer
DIM AS CHOOSECOLOR cc                                       ' Common dialog box structure

    CLEAR(@cc, 0, SIZEOF(CHOOSECOLOR))                      ' Initialize CHOOSECOLOR structure
    cc.lStructSize=SIZEOF(CHOOSECOLOR)
    cc.hInstance=NULL
    cc.hwndOwner=Application.hMainForm
    cc.lpfnHook=CAST(LPCCHOOKPROC, @ccHookProc)
    cc.lCustData=CAST(LPARAM, @THIS)                        ' Pass ptr to colordlg struc
    cc.Flags=CC_ANYCOLOR OR CC_RGBINIT OR CC_ENABLEHOOK
    SELECT CASE Style
        CASE cdNormal
        CASE cdFullOpen: cc.Flags=cc.Flags OR CC_FULLOPEN
        CASE cdNoFullOpen: cc.Flags=cc.Flags OR CC_PREVENTFULLOPEN
    END SELECT
    cc.rgbResult=CAST(COLORREF, Color)                      ' Default selected color
    cc.lpCustColors=CAST(COLORREF PTR, @Colors(0))          ' Custom color set
    IF ChooseColor(@cc) THEN
        Color=CAST(integer, cc.rgbResult)
        RETURN True
    END IF
    RETURN False
END FUNCTION

CONSTRUCTOR QCOLORDIALOG
    FOR i AS integer=0 TO 15: Colors(i)=&hcfcfcf: NEXT      ' "no" color
END CONSTRUCTOR

'  =======================================================================================
'# 45 QDXTimer * Properties *
'# 46 QDXSound * Properties *
'# 47 QDXScreen * Properties *
'# 48 QDXImageList * Properties *
'# 49 QD3DFace * Properties *
'# 50 QD3DMeshBuilder * Properties *
'# 51 QD3DFrame * Properties *
'# 52 QD3DLight * Properties *
'# 53 QD3DTexture * Properties *
'# 54 QD3DVector * Properties *
'# 55 QD3DWrap * Properties *


' #56 ====================================================================================
TYPE QPAGESETUPDIALOG
' Private (not)
    ObjId AS integer        = Q_PAGESETUPDIALOG         ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*32   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    _Left AS integer        = -1                        ' Default to center
    _Top AS integer         = -1                        ' ditto
    Width AS integer                                    ' Not used
    Height AS integer                                   ' Not used
    Caption AS string       = ""

    Metric AS integer       = True                      ' mm (True) or inches?
    PaperWidth AS single                                ' Converted to mm: ptPaperSize AS POINT (in 100ths of mm)
    PaperHeight AS single
    MinLeftMargin AS single                             '|
    MinTopMargin AS single                              '| rtMinMargin AS RECT
    MinRightMargin AS single                            '| Converted to mm
    MinBottomMargin AS single                           '|
    LeftMargin AS single                                '|
    TopMargin AS single                                 '| rtMargin AS RECT
    RightMargin AS single                               '| Converted to mm
    BottomMargin AS single                              '|

    _PrinterName AS string

    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY PrinterName() AS string
    DECLARE PROPERTY PrinterName(value AS string)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
' Method
    DECLARE FUNCTION Execute() AS integer
' Events
END TYPE
PROPERTY QPAGESETUPDIALOG.Left() AS integer: RETURN _Left: END PROPERTY
PROPERTY QPAGESETUPDIALOG.Left(value AS integer): _Left=value: END PROPERTY
PROPERTY QPAGESETUPDIALOG.PrinterName() AS string: RETURN _PrinterName: END PROPERTY
PROPERTY QPAGESETUPDIALOG.PrinterName(value AS string): END PROPERTY            ' Read only
PROPERTY QPAGESETUPDIALOG.Top() AS integer: RETURN _Top: END PROPERTY
PROPERTY QPAGESETUPDIALOG.Top(value AS integer): _Top=value: END PROPERTY

FUNCTION PageHookProc(hWnd AS HWND, uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
    IF uMsg=WM_INITDIALOG THEN                              ' ALL initializing is done here
        DIM AS PAGESETUPDLG PTR lpPSD=CAST(PAGESETUPDLG PTR,lParam)
        DIM AS QPAGESETUPDIALOG PTR lpPSDDlg=CAST(QPAGESETUPDIALOG PTR, lpPSD->lCustData)
        DIM AS integer X, Y, W, H
        X=lpPSDDlg->Left: Y=lpPSDDlg->Top
        IF (X<0) OR (Y<0) THEN
            DIM AS RECT rct
            GetWindowRect(hWnd, @rct)
            IF X<0 THEN W=rct.Right-rct.Left: X=(Screen.Width - W)\2
            IF Y<0 THEN H=rct.Bottom-rct.Top: Y=(Screen.Height - H)\2
        END IF
        SetWindowPos(hWnd, 0, X, Y, 0, 0, SWP_NOSIZE OR SWP_NOZORDER)
        IF lpPSDDlg->Caption <> "" THEN SetWindowText(hWnd, lpPSDDlg->Caption)
        RETURN 1
    END IF
    RETURN 0
END FUNCTION

FUNCTION QPAGESETUPDIALOG.Execute() AS integer
DIM AS PAGESETUPDLG psd
DIM AS double value, divsor=100.0                                  ' Default metric

    CLEAR(@psd, 0, SIZEOF(PAGESETUPDLG))
	psd.lStructSize=SIZEOF(PAGESETUPDLG)
    psd.hwndOwner=Application.hMainForm
    psd.lCustData=CAST(LPARAM, @THIS)                        ' Pass ptr to printdlg struc
    psd.Flags=PSD_ENABLEPAGESETUPHOOK
    IF Metric THEN
        psd.Flags OR= PSD_INHUNDREDTHSOFMILLIMETERS
    ELSE
        psd.Flags OR= PSD_INTHOUSANDTHSOFINCHES
    END IF
    psd.lpfnPageSetupHook=CAST(LPPAGESETUPHOOK, @PageHookProc)
	IF PageSetupDlg(@psd) THEN
        DIM AS DEVNAMES PTR dn
        dn=GlobalLock(psd.hDevNames)
        _PrinterName=*CAST(zString PTR, CAST(BYTE PTR, dn) + dn->wDeviceOffset)
        GlobalUnlock(dn)
        IF Metric THEN
            PaperWidth=psd.ptPaperSize.x/100.0: PaperHeight=psd.ptPaperSize.y/100.0
            LeftMargin=psd.rtMargin.Left/100.0: TopMargin=psd.rtMargin.Top/100.0
            RightMargin=psd.rtMargin.Right/100.0: BottomMargin=psd.rtMargin.Bottom/100.0
        ELSE
            PaperWidth=psd.ptPaperSize.x/1000.0: PaperHeight=psd.ptPaperSize.y/1000.0
            LeftMargin=psd.rtMargin.Left/1000.0: TopMargin=psd.rtMargin.Top/1000.0
            RightMargin=psd.rtMargin.Right/1000.0: BottomMargin=psd.rtMargin.Bottom/1000.0
        END IF
        RETURN True
    END IF
    RETURN False
END FUNCTION


' #57 ====================================================================================
TYPE QPRINTDIALOG
' Private (not)
    ObjId AS integer        = Q_PRINTDIALOG             ' Component ID
    ObjIndex AS integer     = 0                         ' Unique number per object
    ObjClass AS string*32   = ""                        ' Base class
    ObjStyle AS UINT        = 0                         '

    _Left AS integer        = -1                        ' Default to center
    _Top AS integer         = -1                        ' ditto
    Width AS integer                                    ' Not used
    Height AS integer                                   ' Not used
    Caption AS string       = ""

    _SetupDialog AS integer = False                     ' SetupDialog or PrintDialog
    PrinterName AS string
    AllowToFile AS integer      = True
    AllowToNetwork AS integer   = True
    ShowHelpButton AS integer   = False
    HelpFile AS string      = ""
    FromPage AS integer     = 1
    ToPage AS integer       = 3

    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY SetupDialog() AS integer
    DECLARE PROPERTY SetupDialog(value AS integer)
' Method
    DECLARE FUNCTION Execute() AS integer
' Events
END TYPE

PROPERTY QPRINTDIALOG.Left() AS integer: RETURN _Left: END PROPERTY
PROPERTY QPRINTDIALOG.Left(value AS integer): _Left=value: END PROPERTY
PROPERTY QPRINTDIALOG.Top() AS integer: RETURN _Top: END PROPERTY
PROPERTY QPRINTDIALOG.Top(value AS integer): _Top=value: END PROPERTY
PROPERTY QPRINTDIALOG.SetupDialog() AS integer: RETURN _SetupDialog: END PROPERTY
PROPERTY QPRINTDIALOG.SetupDialog(value AS integer)
    IF value THEN _SetupDialog=True ELSE _SetupDialog=False
END PROPERTY

' Currently, these two HookProcs are exactly the same code, but may change....
FUNCTION PrintHookProc(hWnd AS HWND, uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
    IF uMsg=WM_INITDIALOG THEN                              ' ALL initializing is done here
        DIM AS PRINTDLG PTR lpPRN=CAST(PRINTDLG PTR,lParam)
        DIM AS QPRINTDIALOG PTR lpPRNDlg=CAST(QPRINTDIALOG PTR, lpPRN->lCustData)
        DIM AS integer X, Y, W, H
        X=lpPRNDlg->Left: Y=lpPRNDlg->Top
        IF (X<0) OR (Y<0) THEN
            DIM AS RECT rct
            GetWindowRect(hWnd, @rct)
            IF X<0 THEN W=rct.Right-rct.Left: X=(Screen.Width - W)\2
            IF Y<0 THEN H=rct.Bottom-rct.Top: Y=(Screen.Height - H)\2
        END IF
        SetWindowPos(hWnd, 0, X, Y, 0, 0, SWP_NOSIZE OR SWP_NOZORDER)
        IF lpPRNDlg->Caption <> "" THEN SetWindowText(hWnd, lpPRNDlg->Caption)
        RETURN 1
    END IF
    RETURN 0
END FUNCTION
FUNCTION SetUpHookProc(hWnd AS HWND, uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
    IF uMsg=WM_INITDIALOG THEN                              ' ALL initializing is done here
        DIM AS PRINTDLG PTR lpPRN=CAST(PRINTDLG PTR,lParam)
        DIM AS QPRINTDIALOG PTR lpPRNDlg=CAST(QPRINTDIALOG PTR, lpPRN->lCustData)
        DIM AS integer X, Y, W, H
        X=lpPRNDlg->Left: Y=lpPRNDlg->Top
        IF (X<0) OR (Y<0) THEN
            DIM AS RECT rct
            GetWindowRect(hWnd, @rct)
            IF X<0 THEN W=rct.Right-rct.Left: X=(Screen.Width - W)\2
            IF Y<0 THEN H=rct.Bottom-rct.Top: Y=(Screen.Height - H)\2
        END IF
        SetWindowPos(hWnd, 0, X, Y, 0, 0, SWP_NOSIZE OR SWP_NOZORDER)
        IF lpPRNDlg->Caption <> "" THEN SetWindowText(hWnd, lpPRNDlg->Caption)
        RETURN 1
    END IF
    RETURN 0
END FUNCTION
' Handles either a Print Setup dialog or Printer dialog
FUNCTION QPRINTDIALOG.Execute() AS integer
DIM AS PRINTDLG pd

    CLEAR(@pd, 0, SIZEOF(PRINTDLG))
	pd.lStructSize=SIZEOF(PRINTDLG)
    pd.hwndOwner=Application.hMainForm
    pd.lCustData=CAST(LPARAM, @THIS)                        ' Pass ptr to printdlg struc
    IF SetupDialog THEN
        pd.Flags=PD_PRINTSETUP OR PD_ENABLESETUPHOOK
        pd.lpfnSetupHook=CAST(LPSETUPHOOKPROC, @SetUpHookProc)
    ELSE
        pd.lpfnPrintHook=CAST(LPPRINTHOOKPROC, @PrintHookProc)
        pd.Flags=PD_ENABLEPRINTHOOK                             ' OR PD_PAGENUMS causes error!
        IF AllowToFile=False THEN pd.Flags=pd.Flags OR PD_HIDEPRINTTOFILE
        IF AllowToNetwork=False THEN pd.Flags=pd.Flags OR PD_NONETWORKBUTTON
        IF ShowHelpButton THEN pd.Flags=pd.Flags OR PD_SHOWHELP
        pd.nFromPage=CAST(word,FromPage): pd.nToPage=CAST(word,ToPage)
    END IF
	IF PrintDlg(@pd) THEN
        DIM AS DEVNAMES PTR dn
        dn=GlobalLock(pd.hDevNames)
        PrinterName=*CAST(zString PTR, CAST(BYTE PTR, dn) + dn->wDeviceOffset)
        GlobalUnlock(dn)
        RETURN True
    END IF
    RETURN False
END FUNCTION


' #58 ====================================================================================
TYPE QPROGRESSBAR
' Private (not)
    ObjId AS integer        = Q_PROGRESSBAR                     ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "msctls_progress32"               ' Base class
    ObjStyle AS UINT        = 0                                 ' pbsDefault (segmented)
    Font AS QFONT
    PrivateProperties()                                         ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 250
    _Height AS integer      = 25
    _Align AS integer       = alBottom
    _BackColor AS UINT      = &hffffff
    _ForeColor AS UINT      = 0
    _Orientation AS integer = pbHorizontal                      ' pbHorizontal,pbVertical
    _Style AS integer       = 0

    PopupMenu AS HMENU      = 0                                 ' Handle to the popup menu
#IF 0
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Align() AS integer
    DECLARE PROPERTY Align(value AS integer)
    DECLARE PROPERTY BackColor() AS UINT
    DECLARE PROPERTY BackColor(value AS UINT)
    DECLARE PROPERTY ForeColor() AS UINT
    DECLARE PROPERTY ForeColor(value AS UINT)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Min() AS integer
    DECLARE PROPERTY Min(value AS integer)
    DECLARE PROPERTY Max() AS integer
    DECLARE PROPERTY Max(value AS integer)
    DECLARE PROPERTY Orientation() AS integer
    DECLARE PROPERTY Orientation(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Position() AS integer
    DECLARE PROPERTY Position(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Style() AS integer
    DECLARE PROPERTY Style(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnPopup AS SUB(Index AS integer, Sender AS QPROGRESSBAR PTR)           ' FB only
END TYPE

DoGeneralProperties(QPROGRESSBAR)
DoPositionalProperties(QPROGRESSBAR)
DoAlignProperty(QPROGRESSBAR)
DoHintProperties(QPROGRESSBAR)
DoReadOnlyProperties(QPROGRESSBAR)

PROPERTY QPROGRESSBAR.BackColor() AS UINT: RETURN _BackColor: END PROPERTY
PROPERTY QPROGRESSBAR.BackColor(value AS UINT)
    _BackColor=value: SendMessage(Handle, PBM_SETBKCOLOR, 0, value)
END PROPERTY
PROPERTY QPROGRESSBAR.ForeColor() AS UINT: RETURN _ForeColor: END PROPERTY
PROPERTY QPROGRESSBAR.ForeColor(value AS UINT)
    _ForeColor=value: SendMessage(Handle, PBM_SETBARCOLOR, 0, value)
END PROPERTY
PROPERTY QPROGRESSBAR.Min() AS integer: RETURN _Min: END PROPERTY
PROPERTY QPROGRESSBAR.Min(value AS integer)
    IF (value >= 0) AND (value<Max) THEN _Min=value: SendMessage(Handle, PBM_SETRANGE, 0, MAKELPARAM(Min, Max)): END IF
END PROPERTY
PROPERTY QPROGRESSBAR.Max() AS integer: RETURN _Max: END PROPERTY
PROPERTY QPROGRESSBAR.Max(value AS integer)
    IF value>Min THEN _Max=value: SendMessage(Handle, PBM_SETRANGE, 0, MAKELPARAM(Min, Max)): END IF
END PROPERTY
PROPERTY QPROGRESSBAR.Orientation() AS integer: RETURN _Orientation: END PROPERTY
PROPERTY QPROGRESSBAR.Orientation(value AS integer)
    IF value=pbHorizontal THEN _Orientation=pbHorizontal ELSE _Orientation=pbVertical
END PROPERTY
PROPERTY QPROGRESSBAR.Position() AS integer: RETURN _Position: END PROPERTY
PROPERTY QPROGRESSBAR.Position(value AS integer)
    IF (Style AND pbsMarquee) THEN EXIT PROPERTY                    ' Not if pbsMarquee style
    IF (value >= Min) AND (value <= Max) THEN
        _Position=value: SendMessage(Handle, PBM_SETPOS, CAST(WPARAM, value), 0)
    END IF
END PROPERTY
PROPERTY QPROGRESSBAR.Style() AS integer: RETURN _Style: END PROPERTY
PROPERTY QPROGRESSBAR.Style(value AS integer)
    IF (value>=0) AND (value<=4) THEN _Style=value
END PROPERTY

SUB QPROGRESSBAR.PreSetConfig()
    SELECT CASE Align
        CASE alNone: IF Orientation=pbVertical THEN ObjStyle=4
        CASE alLeft, alRight: ObjStyle=4
    END SELECT
    SELECT CASE Style
        CASE pbsSmooth:         ObjStyle OR= 1
        CASE pbsSmoothReverse:  ObjStyle OR= 16                      ' Not working!!!
'        CASE pbsMarquee:        ObjStyle OR= 8                      ' Not working!!!
    END SELECT
'    IF (Style AND pbsMarquee) THEN ObjStyle = 8                     ' Not working!!!
END SUB
SUB QPROGRESSBAR.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: InitialiseFont(@Font)
    NewWndProc=@ProgressWndProc
    OldWndProc=CAST(WNDPROC,SetWindowLong(Handle, GWL_WNDPROC, CAST(long,NewWndProc)))  ' Hook the WndProc
    SendMessage(Handle, PBM_SETRANGE, 0, MAKELPARAM(Min,Max))
    SendMessage(Handle, PBM_SETBKCOLOR, 0, BackColor)
    SendMessage(Handle, PBM_SETBARCOLOR, 0, ForeColor)
'    IF (Style AND pbsMarquee) THEN SendMessage(Handle, PBM_SETMARQUEE,True,50)
END SUB


' #59 ====================================================================================
TYPE QCALENDAR
    ObjId AS integer        = Q_CALENDAR                        ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "SysMonthCal32"                   ' Base class
    ObjStyle AS UINT        = WS_BORDER OR MCS_DAYSTATE         '
    Font AS QFONT

    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 175                               ' Default
    _Height AS integer      = 155                               ' Default

    _Color AS integer       = &hffffff
    _Enabled AS integer     = True
    _Visible AS integer     = True
    _Handle AS HWND
    _Parent AS HWND
    _Tag AS integer
    _Init AS integer        = 0
    _DateFormat AS string
    _Selection AS string

    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY DateFormat() AS string
    DECLARE PROPERTY DateFormat(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Selection() AS string
    DECLARE PROPERTY Selection(value AS string)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Method
    DECLARE SUB ParseDate(lpSysTime AS SYSTEMTIME PTR)
    DECLARE SUB PreSetDate(value AS string)
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Event
    OnSelect AS SUB(DateString AS string, Sender AS QCALENDAR PTR)
END TYPE

DoGeneralProperties(QCALENDAR)
DoReadOnlyProperties(QCALENDAR)
PROPERTY QCALENDAR.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QCALENDAR.Color(value AS integer)
    _Color=value: SendMessage(Handle, MCM_SETCOLOR, MCSC_TITLEBK, value)
END PROPERTY
PROPERTY QCALENDAR.DateFormat() AS string: RETURN _DateFormat: END PROPERTY
PROPERTY QCALENDAR.DateFormat(value AS string): END PROPERTY                ' Read only
PROPERTY QCALENDAR.Height() AS integer: RETURN _Height: END PROPERTY
PROPERTY QCALENDAR.Height(value AS integer)
    IF value>0 THEN
        _Height=value: SetWindowPos(Handle,0,0,0,_Width,_Height,SWP_NOMOVE OR SWP_NOZORDER)
    END IF
END PROPERTY
PROPERTY QCALENDAR.Left() AS integer: RETURN _Left: END PROPERTY
PROPERTY QCALENDAR.Left(value AS integer): _Left=value: END PROPERTY
PROPERTY QCALENDAR.Selection() AS string: RETURN _Selection: END PROPERTY
PROPERTY QCALENDAR.Selection(value AS string): END PROPERTY                ' Read only
PROPERTY QCALENDAR.Top() AS integer: RETURN _Top: END PROPERTY
PROPERTY QCALENDAR.Top(value AS integer): _Top=value: END PROPERTY
PROPERTY QCALENDAR.Width() AS integer: RETURN _Width: END PROPERTY
PROPERTY QCALENDAR.Width(value AS integer)
    IF value>0 THEN
        _Width=value: SetWindowPos(Handle,0,0,0,_Width,_Height,SWP_NOMOVE OR SWP_NOZORDER)
    END IF
END PROPERTY

SUB QCALENDAR.ParseDate(lpSysTime AS SYSTEMTIME PTR)
DIM AS string tstr, tok, ds=UCASE(TRIM(_DateFormat))

    _Selection=""
    FOR i AS integer = 1 TO 3
        tstr=rqFIELDSTR(ds,"/",i)
        SELECT CASE tstr
            CASE "D", "DD": tok=STR(lpSysTime->wDay)
            CASE "MM": tok=STR(lpSysTime->wMonth)
            CASE "YY", "YYYY"
                IF (lpSysTime->wYear<100) THEN
                    tok=STR(2000+lpSysTime->wYear)
                ELSE
                    tok=STR(lpSysTime->wYear)
                END IF
        END SELECT
        IF i<3 THEN _Selection = _Selection+tok+"/"
    NEXT i
    _Selection = _Selection+tok
END SUB
SUB QCALENDAR.PreSetDate(value AS string)
DIM AS SYSTEMTIME st
DIM AS string tstr, ds=UCASE(TRIM(_DateFormat))
DIM AS integer dat

    IF rqTally(value,"/")<>2 THEN EXIT SUB
    FOR i AS integer = 1 TO 3
        tstr=rqFIELDSTR(ds,"/",i)
        dat=VAL(rqFIELDSTR(value,"/",i))
        SELECT CASE tstr
            CASE "D", "DD": IF ((dat>0) AND (dat<32)) THEN st.wDay=dat ELSE EXIT SUB
            CASE "MM": IF ((dat>0) AND (dat<13)) THEN st.wMonth=dat ELSE EXIT SUB
            CASE "YY", "YYYY"
                IF ((dat>=0) AND (dat<100)) THEN dat += 2000
                st.wYear=dat
            CASE ELSE
                EXIT SUB
        END SELECT
    NEXT i
    SendMessage(Handle, MCM_SETCURSEL, 0, CAST(LPARAM, @st))
END SUB
SUB SetCalFontColor(hWnd AS HWND, colr AS COLORREF)
    SendMessage(hWnd, MCM_SETCOLOR, MCSC_TITLETEXT, colr)
END SUB
SUB QCALENDAR.PreSetConfig()
    _DateFormat=GetSysDateFormat()
END SUB
SUB QCALENDAR.PostConfig()
    Font.Owner=Handle: Font.lpFontColor=@SetCalFontColor
    InitialiseFont(@Font)
    IF Font.Color<>0 THEN SetCalFontColor(Handle, Font.Color)
    IF _Color<>&hffffff THEN SendMessage(Handle, MCM_SETCOLOR, MCSC_TITLEBK, _Color)
END SUB


' #60 ====================================================================================
TYPE QDATEPICKER
' Private (not)
    ObjId AS integer        = Q_DATEPICKER                      ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "SysDateTimePick32"               ' Base class
    ObjStyle AS UINT        = WS_BORDER                         '
    Font AS QFONT

    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 200                               ' Default
    _Height AS integer      = 25                                ' Default

    _Color  AS integer      = &hffffff
    _Enabled AS integer     = True
    _Visible AS integer     = True
    _Handle AS HWND
    _Parent AS HWND
    _Tag AS integer
    _Init AS integer        = 0
    _DateFormat AS string
    _Selection AS string

    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color(value AS integer)
    DECLARE PROPERTY DateFormat() AS string
    DECLARE PROPERTY DateFormat(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Selection() AS string
    DECLARE PROPERTY Selection(value AS string)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Method
    DECLARE SUB ParseDate(lpSysTime AS SYSTEMTIME PTR)
    DECLARE SUB PreSetDate(DateString AS string)
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Event
    OnSelect AS SUB(DateString AS string, Sender AS QDATEPICKER PTR)
END TYPE

DoGeneralProperties(QDATEPICKER)
DoReadOnlyProperties(QDATEPICKER)
PROPERTY QDATEPICKER.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QDATEPICKER.Color(value AS integer)
    _Color=value: SendMessage(Handle, DTM_SETMCCOLOR, MCSC_TEXT, value)
END PROPERTY
PROPERTY QDATEPICKER.DateFormat() AS string: RETURN _DateFormat: END PROPERTY
PROPERTY QDATEPICKER.DateFormat(value AS string): END PROPERTY                ' Read only
PROPERTY QDATEPICKER.Height() AS integer: RETURN _Height: END PROPERTY
PROPERTY QDATEPICKER.Height(value AS integer): END PROPERTY       ' Read Only
PROPERTY QDATEPICKER.Left() AS integer: RETURN _Left: END PROPERTY
PROPERTY QDATEPICKER.Left(value AS integer): _Left=value: END PROPERTY
PROPERTY QDATEPICKER.Selection() AS string: RETURN _Selection: END PROPERTY
PROPERTY QDATEPICKER.Selection(value AS string): END PROPERTY                ' Read only
PROPERTY QDATEPICKER.Top() AS integer: RETURN _Top: END PROPERTY
PROPERTY QDATEPICKER.Top(value AS integer): _Top=value: END PROPERTY
PROPERTY QDATEPICKER.Width() AS integer: RETURN _Width: END PROPERTY
PROPERTY QDATEPICKER.Width(value AS integer): END PROPERTY        ' Read Only

SUB QDATEPICKER.ParseDate(lpSysTime AS SYSTEMTIME PTR)
DIM AS string tstr, tok, ds=UCASE(TRIM(_DateFormat))

    _Selection=""
    FOR i AS integer = 1 TO 3
        tstr=rqFIELDSTR(ds,"/",i)
        SELECT CASE tstr
            CASE "D", "DD": tok=STR(lpSysTime->wDay)
            CASE "MM": tok=STR(lpSysTime->wMonth)
            CASE "YY", "YYYY"
                IF (lpSysTime->wYear<100) THEN
                    tok=STR(2000+lpSysTime->wYear)
                ELSE
                    tok=STR(lpSysTime->wYear)
                END IF
        END SELECT
        IF i<3 THEN _Selection = _Selection+tok+"/"
    NEXT i
    _Selection = _Selection+tok
END SUB
SUB QDATEPICKER.PreSetDate(value AS string)
DIM AS SYSTEMTIME st
DIM AS string tstr, ds=UCASE(TRIM(_DateFormat))
DIM AS integer dat

    IF rqTally(value,"/")<>2 THEN EXIT SUB
    FOR i AS integer = 1 TO 3
        tstr=rqFIELDSTR(ds,"/",i)
        dat=VAL(rqFIELDSTR(value,"/",i))
        SELECT CASE tstr
            CASE "D", "DD": IF ((dat>0) AND (dat<32)) THEN st.wDay=dat ELSE EXIT SUB
            CASE "MM": IF ((dat>0) AND (dat<13)) THEN st.wMonth=dat ELSE EXIT SUB
            CASE "YY", "YYYY"
                IF ((dat>=0) AND (dat<100)) THEN dat += 2000
                st.wYear=dat
            CASE ELSE
                EXIT SUB
        END SELECT
    NEXT i
    SendMessage(Handle, DTM_SETSYSTEMTIME, CAST(WPARAM,GDT_VALID), CAST(LPARAM, @st))
END SUB
SUB QDATEPICKER.PreSetConfig()
    _DateFormat=GetSysDateFormat()
END SUB
SUB QDATEPICKER.PostConfig()
DIM AS string tstr=_DateFormat
    IF tstr<>"" THEN SendMessage(Handle, DTM_SETFORMAT, 0, CAST(LPARAM, STRPTR(tstr)))
    SendMessage(Handle, DTM_SETMCFONT, CAST(WPARAM, Font.Handle), True)
END SUB


' #61 ====================================================================================
TYPE QDRIVELIST
' Private (not)
    ObjId AS integer        = Q_DRIVELIST                       ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = ""                                ' Base class
    ObjStyle AS UINT        = 0                                 '

    _DriveCount AS integer
    Drive(0 TO 15) AS string
    DriveType(0 TO 15) AS integer
    DriveSize(0 TO 15) AS Ulongint                              ' Total size of drive
    DriveFreeSpace(0 TO 15) AS Ulongint                         ' Free space of drive

    DECLARE PROPERTY DriveCount() AS integer
    DECLARE PROPERTY DriveCount (value AS integer)
'Methods
    DECLARE FUNCTION GetDiskInfo(Drive AS string) AS integer
    DECLARE FUNCTION GetDiskSpace(drivename AS string, lpAvail AS Ulongint PTR, _
                                        lpTotal AS Ulongint PTR, lpFree  AS Ulongint PTR) AS integer
    DECLARE SUB Refresh()
'Extras
    DECLARE CONSTRUCTOR
'Events
END TYPE

PROPERTY QDRIVELIST.DriveCount() AS integer
DIM AS UINT Mask=1, drvMask=GetLogicalDrives()
    _DriveCount=0
    FOR i AS integer = 1 TO 26
        IF (drvMask AND Mask) THEN _DriveCount += 1
        Mask = Mask SHL 1
    NEXT i
    IF _DriveCount>16 THEN _DriveCount=16
    RETURN _DriveCount
END PROPERTY
PROPERTY QDRIVELIST.DriveCount (value AS integer): END PROPERTY     ' Read Only

FUNCTION QDRIVELIST.GetDiskInfo(DriveName AS string) AS integer
    FOR i AS integer = 0 TO DriveCount-1
        IF Drive(i)=DriveName THEN
            GetDiskSpace(DriveName, 0, @DriveSize(i), @DriveFreeSpace(i))
            RETURN True
        END IF
    NEXT i
    RETURN False
END FUNCTION
FUNCTION QDRIVELIST.GetDiskSpace(drivename AS string, lpAvail AS Ulongint PTR, _
                                        lpTotal AS Ulongint PTR, lpFree  AS Ulongint PTR) AS integer
    RETURN GetDiskFreeSpaceEx(drivename, CAST(ULARGE_INTEGER PTR, lpAvail), _
                                CAST(ULARGE_INTEGER PTR, lpTotal), CAST(ULARGE_INTEGER PTR, lpFree))
END FUNCTION
SUB QDRIVELIST.Refresh()
DIM AS UINT Mask=1, drvMask=GetLogicalDrives()

    _DriveCount=0
    FOR i AS integer = 0 TO 15
        Drive(i)="": DriveType(i)=0
        DriveSize(i)=0: DriveFreeSpace(i)=0
    NEXT i
    FOR i AS integer = 1 TO 26
        IF (drvMask AND Mask) THEN
            Drive(_DriveCount)=CHR(64+i)+":\"
            DriveType(_DriveCount)=GetDriveType(Drive(_DriveCount))
            SELECT CASE DriveType(_DriveCount)
                CASE DRIVE_REMOVABLE, DRIVE_FIXED
                    GetDiskSpace(Drive(_DriveCount), 0, @DriveSize(_DriveCount), _
                                                            @DriveFreeSpace(_DriveCount))
            END SELECT
            _DriveCount += 1
            IF _DriveCount>15 THEN EXIT FOR
        END IF
        Mask = Mask SHL 1
    NEXT i
END SUB
CONSTRUCTOR QDRIVELIST
    Refresh()
END CONSTRUCTOR


' #62 ====================================================================================
TYPE QUPDOWN
' Private (not)
    ObjId AS integer        = Q_UPDOWN                          ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "msctls_updown32"                 ' Base class
    ObjStyle AS UINT        = 0                                 '
    Font AS QFONT

    PrivateProperties()                                         ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 25
    _Height AS integer      = 75
    _Buddy AS integer       = 0                                 ' True/False

    Align AS integer        = alNone
    ArrowKeys AS integer    = False
    Orientation AS integer  = spVertical
    Wrap AS integer         = False
    PopupMenu AS HMENU      = 0                                 ' Handle to the popup menu

#IF 0
    TabOrder AS integer             ' |INTEGER|RW|
#ENDIF

' Properties
    DECLARE PROPERTY Buddy() AS integer
    DECLARE PROPERTY Buddy(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Min() AS integer
    DECLARE PROPERTY Min(value AS integer)
    DECLARE PROPERTY Max() AS integer
    DECLARE PROPERTY Max(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY Position() AS integer
    DECLARE PROPERTY Position(value AS integer)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
' Extras
    DECLARE SUB SetBuddy(BuddyHwnd AS HWND)
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnChange AS SUB(Sender AS QUPDOWN PTR)
    OnPopup AS SUB(Index AS integer, Sender AS QUPDOWN PTR)                 ' FB only
END TYPE

DoGeneralProperties(QUPDOWN)
DoPositionalProperties(QUPDOWN)
DoHintProperties(QUPDOWN)
DoReadOnlyProperties(QUPDOWN)

PROPERTY QUPDOWN.Buddy() AS integer: RETURN _Buddy: END PROPERTY
PROPERTY QUPDOWN.Buddy(value AS integer)
    IF Value THEN _Buddy=True ELSE _Buddy=False
END PROPERTY
PROPERTY QUPDOWN.Min() AS integer: RETURN _Min: END PROPERTY
PROPERTY QUPDOWN.Min(value AS integer)
    IF value >=0 THEN                       ' NB PURPOSELY done THIS way in case setting both....
        _Min=value                          ' ...Min & Max "on-the-fly". Don't change code here
        IF value < Max THEN SendMessage(Handle, UDM_SETRANGE, 0, MAKELPARAM(Max, Min))
    END IF
END PROPERTY
PROPERTY QUPDOWN.Max() AS integer: RETURN _Max: END PROPERTY
PROPERTY QUPDOWN.Max(value AS integer)
    IF value > 0 THEN                       ' NB PURPOSELY done THIS way in case setting both....
        _Max=value                          ' ...Min & Max "on-the-fly". Don't change code here
        IF value > Min THEN SendMessage(Handle, UDM_SETRANGE, 0, MAKELPARAM(Max, Min))
    END IF
END PROPERTY
PROPERTY QUPDOWN.Position() AS integer: RETURN _Position: END PROPERTY
PROPERTY QUPDOWN.Position(value AS integer): _Position=value: END PROPERTY

SUB QUPDOWN.SetBuddy(BuddyHwnd AS HWND)
    IF SendMessage(Handle, UDM_GETBUDDY, 0, 0)=0 THEN
        SendMessage(Handle, UDM_SETBUDDY, CAST(WPARAM,BuddyHwnd), 0)
        _Buddy=True
    END IF
END SUB
SUB QUPDOWN.PreSetConfig()
    IF Buddy THEN ObjStyle OR= UDS_SETBUDDYINT
    SELECT CASE Align
        CASE alLeft
            ObjStyle OR= UDS_ALIGNLEFT
        CASE alRight
            ObjStyle OR= UDS_ALIGNRIGHT
    END SELECT
    IF Orientation=spHorizontal THEN ObjStyle OR= UDS_HORZ
    IF ArrowKeys THEN ObjStyle OR= UDS_ARROWKEYS
    IF Wrap THEN ObjStyle OR= UDS_WRAP
END SUB
SUB QUPDOWN.PostConfig()
    Font.Owner=Handle: InitialiseFont(@Font)
    SendMessage(Handle, UDM_SETRANGE, 0, MAKELPARAM(Max, Min))
END SUB


' #63 ====================================================================================
TYPE QPAGER
' Private (not)
    ObjId AS integer        = Q_PAGER                           ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "SysPager"                        ' Base class
    ObjStyle AS UINT        = 0                                 '
    Font AS QFONT                                               ' Not used

    PrivateProperties()                                         ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 250
    _Height AS integer      = 25

    _BackColor AS integer   = &hffffff
    _BorderWidth AS integer = 4
    _ButtonSize AS integer  = 12
    _Orientation AS integer = pgHorizontal                      ' Default
    PopupMenu AS HMENU      = 0                                 ' Handle to the popup menu

' Properties
    DECLARE PROPERTY BackColor() AS integer
    DECLARE PROPERTY BackColor(value AS integer)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle(value AS integer)
    DECLARE PROPERTY BorderWidth() AS integer
    DECLARE PROPERTY BorderWidth(value AS integer)
    DECLARE PROPERTY ButtonSize() AS integer
    DECLARE PROPERTY ButtonSize(value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled(value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Orientation() AS integer
    DECLARE PROPERTY Orientation(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB SetChildObject(hChild AS HWND)
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnPopup AS SUB(Index AS integer, Sender AS QPAGER PTR)               ' FB only
END TYPE

DoGeneralProperties(QPAGER)
DoPositionalProperties(QPAGER)
DoHintProperties(QPAGER)
DoReadOnlyProperties(QPAGER)
PROPERTY QPAGER.BackColor() AS integer: RETURN _BackColor: END PROPERTY
PROPERTY QPAGER.BackColor(value AS integer): _BackColor=value: END PROPERTY
PROPERTY QPAGER.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QPAGER.BorderStyle(value AS integer): _BorderStyle=value: END PROPERTY
PROPERTY QPAGER.BorderWidth() AS integer: RETURN _BorderWidth: END PROPERTY
PROPERTY QPAGER.BorderWidth(value AS integer)
    IF (value>=0) AND (value<17) THEN _BorderWidth=value        ' MY max set at 16
END PROPERTY
PROPERTY QPAGER.ButtonSize() AS integer: RETURN _ButtonSize: END PROPERTY
PROPERTY QPAGER.ButtonSize(value AS integer)
    IF (value>11) AND (value<Width\3) THEN _ButtonSize=value     ' Min set at 12
END PROPERTY
PROPERTY QPAGER.Orientation() AS integer: RETURN _Orientation: END PROPERTY
PROPERTY QPAGER.Orientation(value AS integer)
    IF value=0 THEN _Orientation=pgHorizontal ELSE _Orientation=pgVertical
END PROPERTY

SUB QPAGER.SetChildObject(hChild AS HWND)
    SendMessage(Handle, PGM_SETCHILD, 0, CAST(LPARAM,hChild))
    SendMessage(Handle, PGM_RECALCSIZE, 0, 0)
'    Pager_SetScrollInfo(Handle, 250, 10, 5)    ' 250 mSecs, 10 lines, 5 pix per line
    SendMessage(Handle, PGM_FIRST+13, 250, CAST(LPARAM,&H50010))
END SUB

SUB QPAGER.PreSetConfig()
    IF BorderStyle=bsSingle THEN ObjStyle=WS_BORDER
    IF Orientation=pgHorizontal THEN ObjStyle OR= PGS_HORZ ELSE ObjStyle OR= PGS_VERT
END SUB
SUB QPAGER.PostConfig()
    IF BorderStyle=0 THEN BorderWidth=0                         ' Override BorderWidth
    SendMessage(Handle, PGM_SETBORDER, 0, BorderWidth)
    SendMessage(Handle, PGM_SETBUTTONSIZE, 0, ButtonSize)
    SendMessage(Handle, PGM_SETBKCOLOR, 0, CAST(COLORREF,BackColor))
END SUB


' #64 ====================================================================================
TYPE QREBAR
' Private (not)
    ObjId AS integer        = Q_REBAR                           ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "ReBarWindow32"                   ' Base class
    ObjStyle AS UINT        = WS_CLIPSIBLINGS OR WS_CLIPCHILDREN OR RBS_VARHEIGHT OR RBS_BANDBORDERS
    Font AS QFONT

    Left AS integer         = 0
    Top AS integer          = 0
    Width AS integer        = 100
    Height AS integer       = 25

    _BorderStyle AS integer = bsSingle
    _Color AS integer       = FORM_COLOR
    _Enabled AS integer     = True
    _Handle AS HWND
    _Hint AS string         = ""
    _Parent AS HWND
    _ShowHint AS integer    = False
    _Tag AS integer         = 0
    _Visible AS integer     = True

    _Init AS integer        = 0
    _BandCount AS integer   = 0
    _BMP AS string          = ""                                ' Bitmap strip for imgList
    ImgList AS QIMAGELIST                                       ' One image per band
    imgBacking AS QBITMAP                                       ' Bitmap used for backing image
    PopupMenu AS HMENU      = 0                                 ' Handle to the popup menu

' Properties
    DECLARE PROPERTY BandCount() AS integer
    DECLARE PROPERTY BandCount (value AS integer)
    DECLARE PROPERTY BMP() AS string
    DECLARE PROPERTY BMP (value AS string)
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle (value AS integer)
    DECLARE PROPERTY Color() AS integer
    DECLARE PROPERTY Color (value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled (value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
' Methods
    DECLARE SUB AddBand OVERLOAD (hWnd AS HWND)
    DECLARE SUB AddBand OVERLOAD (hWnd AS HWND, Caption AS string)
    DECLARE SUB AddBand OVERLOAD (hWnd AS HWND, idx AS integer, Caption AS string)
' Extras
    DECLARE SUB UpdateRebar()
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
    OnPopup AS SUB(Index AS integer, Sender AS QREBAR PTR)               ' FB only
END TYPE

DoGeneralProperties(QREBAR)
DoHintProperties(QREBAR)
DoReadOnlyProperties(QREBAR)

PROPERTY QREBAR.BandCount() AS integer: RETURN _BandCount: END PROPERTY
PROPERTY QREBAR.BandCount (value AS integer)
    IF value>0 THEN _BandCount=value
END PROPERTY
PROPERTY QREBAR.BMP() AS string: RETURN _BMP: END PROPERTY
PROPERTY QREBAR.BMP(value AS string)
    IF FileExists(value)=False THEN InpFileError(value): EXIT PROPERTY
    _BMP=value
END PROPERTY
PROPERTY QREBAR.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QREBAR.BorderStyle(value AS integer): IF Value<>0 THEN _BorderStyle=1 ELSE _BorderStyle=0: END IF: END PROPERTY
PROPERTY QREBAR.Color() AS integer: RETURN _Color: END PROPERTY
PROPERTY QREBAR.Color(value AS integer)
    IF value<>_Color THEN
        _Color=value: SendMessage(Handle, RB_SETBKCOLOR, 0, CAST(LPARAM, _Color))
    END IF
END PROPERTY

SUB QREBAR.AddBand OVERLOAD (hWnd AS HWND, idx AS integer, Caption AS string)
DIM AS REBARBANDINFO rbBand
DIM AS RECT rct

    rbBand.cbSize=SIZEOF(REBARBANDINFO)
    rbBand.fMask=RBBIM_STYLE OR RBBIM_CHILD OR RBBIM_CHILDSIZE OR RBBIM_SIZE
    IF (idx > -1) AND (ImgList.Count>0) THEN
        rbBand.fMask OR= RBBIM_IMAGE
        rbBand.iImage = idx
    END IF
    IF Caption <> "" THEN
        rbBand.fMask OR= RBBIM_TEXT
        rbBand.lpText = STRPTR(Caption)
    END IF
    rbBand.fStyle=RBBS_CHILDEDGE OR RBBS_GRIPPERALWAYS          ' (RBBIM_STYLE flag)

    rbBand.hwndChild=hWnd                                       ' (RBBIM_CHILD flag)
    GetWindowRect(hWnd, @rct)
    rbBand.cxMinChild=rct.Right-rct.Left                        ' Minimum width of band (RBBIM_CHILDSIZE flag)
    rbBand.cyMinChild=rct.Bottom-rct.Top                        ' Minimum height of band (RBBIM_CHILDSIZE flag)
    rbBand.cx=rct.Right-rct.Left                                ' Length of the band (RBBIM_SIZE flag)
    SendMessage(Handle, RB_INSERTBAND, -1, CAST(lParam,@rbBand))
END SUB
SUB QREBAR.AddBand OVERLOAD (hWnd AS HWND, Caption AS string)
    AddBand(hWnd, -1, Caption)
END SUB
SUB QREBAR.AddBand OVERLOAD (hWnd AS HWND)
    AddBand(hWnd, -1, "")
END SUB
SUB QREBAR.UpdateRebar()
    IF (_BMP<>"") AND (BandCount>0) THEN
        ImgList.AddBMPFile(_BMP, BandCount)
        DIM AS REBARINFO inf
        inf.cbSize=SIZEOF(REBARINFO)
        inf.fMask=RBIM_IMAGELIST
        inf.himl=ImgList.Handle
        SendMessage(Handle, RB_SETBARINFO, 0, CAST(LPARAM,@inf))
    END IF
END SUB

SUB SetRebarFontColor(hWnd AS HWND, Colr AS COLORREF)
    SendMessage(hWnd, RB_SETTEXTCOLOR, 0, CAST(LPARAM,Colr))
END SUB
SUB QREBAR.PreSetConfig()
    IF BorderStyle THEN ObjStyle OR= WS_BORDER
END SUB
SUB QREBAR.PostConfig()
    Application.ObjInfo(ObjIndex).Handle=Handle
    Application.ObjInfo(ObjIndex).ObjPtr=CAST(ANY PTR, @THIS)
    Font.Owner=Handle: Font.lpFontColor=@SetRebarFontColor
    InitialiseFont(@Font)
    IF _Color <> FORM_COLOR THEN SendMessage(Handle, RB_SETBKCOLOR, 0, CAST(LPARAM, _Color))
    SetRebarFontColor(Handle, Font.Color)
    UpdateRebar()
END SUB


' #65 ====================================================================================
TYPE QTOOLBAR
' Private (not)
    ObjId AS integer        = Q_TOOLBAR                         ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = "ToolbarWindow32"                 ' Base class
    ObjStyle AS UINT        = 0
    Font AS QFONT

    Left AS integer         = 0
    Top AS integer          = 0
    Width AS integer        = 0
    Height AS integer       = 0

    _BorderStyle AS integer = bsSingle
    _Enabled AS integer     = True
    _Handle AS HWND
    _Hint AS string         = ""
    _Parent AS HWND
    _ShowHint AS integer    = False
    _Tag AS integer         = 0
    _Visible AS integer     = True

    _Init AS integer        = 0
    btnID AS integer        = 0
    NumButtons AS integer   = 0
    btnWidth AS integer     = 25
    btnHeight AS integer    = 25
    BMP AS string           = ""
    ImgList AS QIMAGELIST                                       ' Toolar with images
    txtList AS QSTRINGLIST                                      ' Toolbar with text

    PopupMenu AS HMENU      = 0                                 ' Handle to the popup menu

' Properties
    DECLARE PROPERTY BorderStyle() AS integer
    DECLARE PROPERTY BorderStyle (value AS integer)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled (value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
' Methods
    DECLARE SUB AddBMPFile(FileName AS string)
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
    DECLARE DESTRUCTOR
' Events
    OnClick AS SUB(Index AS integer)
    OnPopup AS SUB(Index AS integer, Sender AS QTOOLBAR PTR)              ' FB only
END TYPE

DoGeneralProperties(QTOOLBAR)
DoHintProperties(QTOOLBAR)
DoReadOnlyProperties(QTOOLBAR)

PROPERTY QTOOLBAR.BorderStyle() AS integer: RETURN _BorderStyle: END PROPERTY
PROPERTY QTOOLBAR.BorderStyle(value AS integer)
    IF Value=0 THEN _BorderStyle=0 ELSE _BorderStyle=1
END PROPERTY

SUB QTOOLBAR.AddBMPFile(FileName AS string)
    IF FileExists(FileName)=False THEN InpFileError(FileName): EXIT SUB
    IF ImgList.Count=0 THEN
        DIM AS QBITMAP imgBMP
        imgBMP.BMP=FileName
        ImgList.Width=imgBMP.Width                                          ' Width & Height for imgList
        ImgList.Height=imgBMP.Height
    END IF
    ImgList.AddBMPFile(FileName, 1)
    Width=ImgList.Width
END SUB
SUB QTOOLBAR.PreSetConfig()
    IF BorderStyle THEN ObjStyle OR= WS_DLGFRAME
END SUB
SUB QTOOLBAR.PostConfig()
DIM AS TBBUTTON tbBtn
DIM AS string tstr
DIM AS UINT StdStyle=ObjStyle

    IF Visible THEN StdStyle OR= WS_VISIBLE
    Handle=CreateWindowEx(0, ObjClass, "", WS_CHILD OR StdStyle, Left, Top, Width, Height, _
                                                            Parent, CAST(HMENU,ObjIndex), 0, 0)
    SendMessage(Handle, TB_BUTTONSTRUCTSIZE, SIZEOF(TBBUTTON), NULL)        ' Identifies which vers of dll

    Font.Owner=Handle: InitialiseFont(@Font)
    IF BMP<>"" THEN
        DIM AS QBITMAP imgBMP
        imgBMP.BMP=BMP
        IF ImgList.Count=0 THEN                                             ' IF no other images
            ImgList.Width=btnWidth                                          ' Width & Height adjustable!!
            ImgList.Height=btnHeight
        END IF
        ImgList.AddBMPFile(BMP, NumButtons, imgBMP.Pixel(0,0))              ' Image strip plus mask color
    END IF
    IF ImgList.Count>0 THEN                                                 ' Set ImgList to toolbar
        SendMessage(Handle, TB_SETIMAGELIST, 0, CAST(LPARAM,ImgList.Handle))
    END IF
    FOR i AS integer = 0 TO NumButtons-1
        IF ImgList.Count>0 THEN
            tbBtn.iBitmap = i                                               ' Index of image in ImgList
        END IF
        IF txtList.ItemCount>0 THEN
            tstr=txtList.Item(i)
            tbBtn.iString=CAST(INT_PTR,STRPTR(tstr))
        END IF
        tbBtn.idCommand = TOOLBAR_IDX+i                                     ' id in WM_COMMAND msg
        tbBtn.fsStyle = BTNS_BUTTON                                         ' Standard buttons
        tbBtn.fsState = TBSTATE_ENABLED
        tbBtn.dwData = 0
        SendMessage(Handle, TB_ADDBUTTONS, 1, CAST(LPARAM, @tbBtn))         ' Add it to toolbar
    NEXT i
    SendMessage(Handle, TB_AUTOSIZE, 0 ,0)                                  ' Toolbar re-adjusts itself
END SUB
DESTRUCTOR QTOOLBAR
    ImgList.Clear
    TxtList.Clear
END DESTRUCTOR


'http://msdn.microsoft.com/en-us/library/windows/desktop/ms646956%28v=vs.85%29.aspx
TYPE QSEARCHREPLACE
' Private (not)
    ObjId AS integer        = Q_OBJECT-1                        ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = ""                                ' Base class
    ObjStyle AS UINT        = 0                                 '
    Font AS QFONT

    _Left AS integer        = -1
    _Top AS integer         = -1
    Width AS integer                                            ' Not used
    Height AS integer                                           ' Not used
    Caption AS string       = ""
    _Handle AS HWND
    Parent AS HWND
    SearchString AS string*64
    ReplaceString AS string*64
    WMFindMsg AS UINT
    Dummy AS integer
' Properties
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
' Methods
    DECLARE FUNCTION Find() AS INTEGER
    DECLARE FUNCTION Replace() AS INTEGER
    DECLARE CONSTRUCTOR
END TYPE

PROPERTY QSEARCHREPLACE.Handle() AS HWND: RETURN _Handle: END PROPERTY
PROPERTY QSEARCHREPLACE.Handle(value AS HWND): END PROPERTY                    ' Read only
PROPERTY QSEARCHREPLACE.Left() AS integer: RETURN _Left: END PROPERTY
PROPERTY QSEARCHREPLACE.Left(value AS integer)
IF value<0 THEN _Left=-1 ELSE _Left=value
END PROPERTY
PROPERTY QSEARCHREPLACE.Top() AS integer: RETURN _Top: END PROPERTY
PROPERTY QSEARCHREPLACE.Top(value AS integer)
IF value<0 THEN _Top=-1 ELSE _Top=value
END PROPERTY

FUNCTION FindHookProc(hWnd AS HWND, uMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
    IF uMsg=WM_INITDIALOG THEN                                  ' ALL initializing is done here
        DIM AS FINDREPLACE PTR lpFind=CAST(FINDREPLACE PTR,lParam)
        DIM AS QSEARCHREPLACE PTR lpFndDlg=CAST(QSEARCHREPLACE PTR, lpFind->lCustData)
        DIM AS integer X, Y, W, H
        X=lpFndDlg->Left: Y=lpFndDlg->Top
        IF (X<0) OR (Y<0) THEN
            DIM AS RECT rct
            GetWindowRect(hWnd, @rct)
            IF X<0 THEN W=rct.Right-rct.Left: X=(Screen.Width - W)\2
            IF Y<0 THEN H=rct.Bottom-rct.Top: Y=(Screen.Height - H)\2
        END IF
        SetWindowPos(hWnd, 0, X, Y, 0, 0, SWP_NOSIZE OR SWP_NOZORDER)
        IF lpFndDlg->Caption <> "" THEN SetWindowText(hWnd, lpFndDlg->Caption)
        RETURN 1
    END IF
    RETURN 0
END FUNCTION
FUNCTION QSEARCHREPLACE.Find() AS integer
DIM AS FINDREPLACE fnd

    CLEAR(@fnd, 0, SIZEOF(FINDREPLACE))
	fnd.lStructSize=SIZEOF(FINDREPLACE)
    fnd.hwndOwner=Parent
    fnd.lCustData=CAST(LPARAM, @THIS)                           ' Pass ptr to QSEARCHREPLACE struc
    fnd.lpfnHook=CAST(LPFRHOOKPROC, @FindHookProc)
    fnd.Flags=FR_ENABLEHOOK
    fnd.lpstrFindWhat=STRPTR(SearchString)
    fnd.wFindWhatLen=LEN(SearchString)
    fnd.lpstrReplaceWith=STRPTR(ReplaceString)
    fnd.wReplaceWithLen=LEN(ReplaceString)
    _Handle=FindText(@fnd)                                      ' Creates the modeless dialog box
    IF _Handle THEN RETURN True ELSE RETURN False
END FUNCTION
FUNCTION QSEARCHREPLACE.Replace() AS integer
DIM AS FINDREPLACE fnd

    SearchString=STRING(64,0)
    ReplaceString=STRING(64,0)

    CLEAR(@fnd, 0, SIZEOF(FINDREPLACE))
	fnd.lStructSize=SIZEOF(FINDREPLACE)
    fnd.hwndOwner=Application.hMainForm
    fnd.lCustData=CAST(LPARAM, @THIS)                           ' Pass ptr to QSEARCHREPLACE struc
    fnd.lpfnHook=CAST(LPFRHOOKPROC, @FindHookProc)
    fnd.Flags=FR_ENABLEHOOK
    fnd.lpstrFindWhat=STRPTR(SearchString)
    fnd.wFindWhatLen=64
    fnd.lpstrReplaceWith=STRPTR(ReplaceString)
    fnd.wReplaceWithLen=64
    _Handle=ReplaceText(@fnd)                                   ' Creates the modeless dialog box
    IF _Handle THEN RETURN True ELSE RETURN False
END FUNCTION
CONSTRUCTOR QSEARCHREPLACE
    WMFindMsg=RegisterWindowMessage(STRPTR(FINDMSGSTRING))
END CONSTRUCTOR

' #99 ====================================================================================
'  A blank object used in other objects (eg QRebar)
TYPE QOBJECT
' Private (not)
    ObjId AS integer        = Q_OBJECT                          ' Component ID
    ObjIndex AS integer     = 0                                 ' Unique number per object
    ObjClass AS string*32   = ""                                ' Base class
    ObjStyle AS UINT        = 0                                 '
    Font AS QFONT

    PrivateProperties()                                         ' Common property variables
    _Left AS integer        = 0
    _Top AS integer         = 0
    _Width AS integer       = 150
    _Height AS integer      = 150

' Properties
    DECLARE PROPERTY Caption() AS string
    DECLARE PROPERTY Caption(value AS string)
    DECLARE PROPERTY Enabled() AS integer
    DECLARE PROPERTY Enabled (value AS integer)
    DECLARE PROPERTY Handle() AS HWND
    DECLARE PROPERTY Handle(value AS HWND)
    DECLARE PROPERTY Height() AS integer
    DECLARE PROPERTY Height(value AS integer)
    DECLARE PROPERTY Hint() AS string
    DECLARE PROPERTY Hint(value AS string)
    DECLARE PROPERTY Left() AS integer
    DECLARE PROPERTY Left(value AS integer)
    DECLARE PROPERTY Parent() AS HWND
    DECLARE PROPERTY Parent(value AS HWND)
    DECLARE PROPERTY ShowHint() AS integer
    DECLARE PROPERTY ShowHint(value AS integer)
    DECLARE PROPERTY Tag() AS integer
    DECLARE PROPERTY Tag(value AS integer)
    DECLARE PROPERTY Top() AS integer
    DECLARE PROPERTY Top(value AS integer)
    DECLARE PROPERTY Visible() AS integer
    DECLARE PROPERTY Visible(value AS integer)
    DECLARE PROPERTY Width() AS integer
    DECLARE PROPERTY Width(value AS integer)
' Methods
    DECLARE SUB Circle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer, fill AS integer)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HWND, S AS RECT PTR)
    DECLARE SUB CopyRect OVERLOAD (D AS RECT PTR, Image AS HDC, S AS RECT PTR)
    DECLARE SUB Draw(x AS integer, y AS integer, FileName AS string)
    DECLARE SUB FillRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Line(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Paint(x AS integer, y AS integer, c AS integer, border AS integer)
    DECLARE FUNCTION Pixel(x AS integer, y AS integer) AS integer
    DECLARE SUB Pset(x AS integer, y AS integer, c AS integer)
    DECLARE SUB Rectangle(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, c AS integer)
    DECLARE SUB Repaint()
    DECLARE SUB RoundRect(x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, c AS integer)
    DECLARE SUB StretchDraw(lpRect AS RECT PTR, FileName AS string)
    DECLARE FUNCTION TextHeight(Text AS string) AS integer
    DECLARE FUNCTION TextWidth(Text AS string) AS integer
    DECLARE SUB TextOut(x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE SUB TextRect(lpRect AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
    DECLARE FUNCTION SaveToBMP(FileName AS string) AS integer
' Extras
    DECLARE SUB PreSetConfig()
    DECLARE SUB PostConfig()
' Events
END TYPE

DoGeneralProperties(QOBJECT)
DoCapProperties(QOBJECT)
DoPositionalProperties(QOBJECT)
DoHintProperties(QOBJECT)
DoReadOnlyProperties(QOBJECT)

ObjectDrawFns(QOBJECT)

SUB QOBJECT.PreSetConfig()
END SUB
SUB QOBJECT.PostConfig()
    Font.Owner=Handle: InitialiseFont(@Font)
END SUB

'################################# END OF OBJECTS #######################################

'----------------------------------------------------------------------------------------
' Top part of component structs - common to most visible components with Align property
'----------------------------------------------------------------------------------------
TYPE ObjectHeader
    ObjId AS integer                                        ' Component ID
    ObjIndex AS integer                                     ' Unique number per object
    ObjClass AS string*32                                   ' Base class
    ObjStyle AS UINT                                        '
    Font AS QFONT
    PrivateProperties()                                     ' Common property variables
    Left AS integer
    Top AS integer
    Width AS integer
    Height AS integer
END TYPE

SUB AdjustForAlign(Handle AS HWND, Aline AS integer, lpObject AS ANY PTR)
DIM AS ObjectHeader PTR lpObj=CAST(ObjectHeader PTR, lpObject)
DIM AS RECT rct
DIM AS integer H, W, Update=False

    GetClientRect(GetParent(Handle), @rct)
    H=rct.Bottom-rct.Top: W=rct.Right-rct.Left
    SELECT CASE Aline
        CASE alLeft
            IF (lpObj->Left<>rct.Left) OR (lpObj->Top<>rct.Top) OR (lpObj->Height<>H) THEN
                lpObj->Left=rct.Left: lpObj->Top=rct.Top: lpObj->Height=H: Update=True
            END IF
        CASE alTop
            IF (lpObj->Left<>rct.Left) OR (lpObj->Top<>rct.Top) OR (lpObj->Width<>W) THEN
                lpObj->Left=rct.Left: lpObj->Top=rct.Top: lpObj->Width=W: Update=True
            END IF
        CASE alRight
            DIM AS integer X=rct.Right-lpObj->Width
            IF (lpObj->Left<>X) OR (lpObj->Top<>rct.Top) OR (lpObj->Height<>H) THEN
                lpObj->Left=X: lpObj->Top=rct.Top: lpObj->Height=H: Update=True
            END IF
        CASE alBottom
            DIM AS integer Y=rct.Bottom-lpObj->Height
            IF (lpObj->Left<>rct.Left) OR (lpObj->Top<>Y) OR (lpObj->Width<>W) THEN
                lpObj->Left=rct.Left: lpObj->Top=Y: lpObj->Width=W: Update=True
            END IF
        CASE alClient
            lpObj->Left=rct.Left: lpObj->Top=rct.Top: lpObj->Width=W: lpObj->Height=H
    END SELECT
    IF Update THEN
        MoveWindow(Handle, lpObj->Left, lpObj->Top, lpObj->Width, lpObj->Height, False)
    END IF
END SUB

'-------------------------------------------------------------------------------------------------------------
' Additional WndProcs (for standard components)
' Group1 "Parent" type objects, Child MSGs passed on to parent of these objects
'-------------------------------------------------------------------------------------------------------------
#IFDEF __QPANEL
FUNCTION PanelWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QPANEL PTR lpPanel=CAST(QPANEL PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpPanel->Align<>alNone THEN AdjustForAlign(hWnd, lpPanel->Align, lpPanel)
            DIM AS integer tmp, Border
            DIM AS RECT rct, rct2
            DIM AS PAINTSTRUCT pnt
            DIM AS HDC hDC = BeginPaint(hWnd, @pnt)
            DIM AS HGDIOBJ original = SelectObject(hDC, GetStockObject(DC_BRUSH))

            SetDCBrushColor(hDC, CAST(COLORREF, lpPanel->Color))                    ' Main background color
            SelectObject(hDC, GetStockObject(DC_PEN))
            SetDCPenColor(hDC, CAST(COLORREF, lpPanel->Color))

            GetClientRect(hWnd, @rct)
            Rectangle(hDC, rct.Left, rct.Top, rct.Right, rct.Bottom)                ' Fill background

            rct2=rct                                                                ' rct2 becomes ClientRect
            IF lpPanel->BorderStyle = bsSingle THEN                                 ' Draw background borders
                SELECT CASE lpPanel->BevelOuter
                    CASE bsNone: Border=0
                    CASE bvLowered: Border=EDGE_SUNKEN
                    CASE bvRaised: Border=EDGE_RAISED
                END SELECT
                IF Border THEN
                    tmp=lpPanel->BevelWidth-1
                    rct2.Left += tmp: rct2.Top += tmp
                    rct2.Right -= tmp: rct2.Bottom -= tmp
                    FOR i AS integer = 0 TO tmp
                        DrawEdge(hDC, @rct2, Border, BF_TOPLEFT)
                        DrawEdge(hDC, @rct2, Border, BF_BOTTOMRIGHT)
                        rct2.Left -= 1: rct2.Top -= 1
                        rct2.Right += 1: rct2.Bottom += 1
                    NEXT i
                    tmp += 1
                    rct2.Left += tmp: rct2.Top += tmp
                    rct2.Right -= tmp: rct2.Bottom -= tmp
                END IF
                SELECT CASE lpPanel->BevelInner
                    CASE bsNone: Border=0
                    CASE bvLowered: Border=EDGE_SUNKEN
                    CASE bvRaised: Border=EDGE_RAISED
                END SELECT
                IF Border THEN
                    tmp=lpPanel->BevelWidth-1
                    rct2.Left += tmp: rct2.Top += tmp
                    rct2.Right -= tmp: rct2.Bottom -= tmp
                    FOR i AS integer = 0 TO tmp
                        DrawEdge(hDC, @rct2, Border, BF_TOPLEFT)
                        DrawEdge(hDC, @rct2, Border, BF_BOTTOMRIGHT)
                        rct2.Left -= 1: rct2.Top -= 1
                        rct2.Right += 1: rct2.Bottom += 1
                    NEXT i
                    tmp += 1
                    rct2.Left += tmp: rct2.Top += tmp
                    rct2.Right -= tmp: rct2.Bottom -= tmp
                END IF
            END IF
            SelectObject(hDC, lpPanel->Font.Handle)                                 ' Set the font
            SetBkMode(hDC, 1)                                                       ' Transparent
            SetTextColor(hDC, CAST(COLORREF, lpPanel->Font.Color))
            SELECT CASE lpPanel->Alignment
                CASE taLeftJustify  : tmp=DT_LEFT
                CASE taCenter       : tmp=DT_CENTER
                CASE taRightJustify : tmp=DT_RIGHT
            END SELECT
            DrawText(hDC, lpPanel->Caption, -1, @rct2, DT_SINGLELINE OR DT_VCENTER OR tmp)
            SelectObject(hDC, original)
            EndPaint(hWnd, @pnt)
            RETURN 1

        CASE WM_COMMAND, WM_NOTIFY                                                  ' Child objects?
            SendMessage(GetParent(hWnd), wMsg, wParam, lParam)                      ' Pass these on to parent
            RETURN 0

        CASE WM_SETFONT
            lpPanel->Font.Handle = CAST(HFONT, wParam)
            InvalidateRect(lpPanel->Handle, NULL, True)
            RETURN 1

        CASE WM_CTLCOLORBTN, WM_CTLCOLOREDIT, WM_CTLCOLORSTATIC, WM_CTLCOLORLISTBOX
            RETURN SendMessage(GetParent(hWnd), wMsg, wParam, lParam)               ' Pass on to parent get return value

        CASE WM_MOUSEMOVE
            IF lpPanel->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpPanel->hCursor)
            END IF
            IF lpPanel->OnMouseMove>0 THEN
                lpPanel->OnMouseMove(LOWORD(lParam), HIWORD(lParam), 0, lpPanel)
            END IF
            RETURN 1

        CASE WM_LBUTTONDOWN, WM_RBUTTONDOWN
            IF lpPanel->OnMouseDown>0 THEN
                IF wMsg=WM_LBUTTONDOWN THEN
                    lpPanel->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpPanel)
                ELSE
                    lpPanel->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpPanel)
                END IF
            END IF
            RETURN 1

        CASE WM_LBUTTONUP, WM_RBUTTONUP
            IF lpPanel->OnMouseUp>0 THEN
                IF wMsg=WM_LBUTTONUP THEN
                    lpPanel->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpPanel)
                ELSE
                    lpPanel->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpPanel)
                END IF
            END IF
            IF wMsg=WM_LBUTTONUP THEN
                PostMessage(GetParent(hWnd),WM_COMMAND,CAST(WPARAM,lpPanel->ObjIndex),CAST(LPARAM,hWnd))
            END IF
            RETURN 1
    END SELECT
    RETURN CallWindowProc(lpPanel->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION
#ENDIF          '#IFDEF __QPANEL

#IFDEF __QGROUPBOX
FUNCTION GrpBoxWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QGROUPBOX PTR lpGrpBox=CAST(QGROUPBOX PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpGrpBox->Align<>alNone THEN AdjustForAlign(hWnd, lpGrpBox->Align, lpGrpBox)
            DIM AS PAINTSTRUCT pnt
            DIM AS HDC hDC = BeginPaint(hWnd, @pnt)
            DIM AS HGDIOBJ Original = SelectObject(hDC, GetStockObject(DC_BRUSH))
            DIM AS RECT rct, tmpRct
            DIM AS integer x=rqGetTextSize(@lpGrpBox->Font, "###", tsHeight)

            SetDCBrushColor(hDC, CAST(COLORREF, lpGrpBox->Color))                   ' Object color
            SetTextColor(hDC, lpGrpBox->Font.Color)                                 ' Color Txt
            GetClientRect(hWnd, @rct)
            FillRect(hDC, @rct, NULL)                                               ' Use current Brush color
            tmpRct=rct: tmpRct.Top = tmpRct.Top + x\2
            DrawEdge(hDC, @tmpRct, EDGE_ETCHED, BF_TOPLEFT)                         '
            DrawEdge(hDC, @tmpRct, EDGE_ETCHED, BF_BOTTOMRIGHT)                     '
            IF lpGrpBox->Caption <> "" THEN
                tmpRct=rct: tmpRct.Bottom = tmpRct.Top + x + 4                      ' 2 pix padding top & bottom
                x=rqGetTextSize(@lpGrpBox->Font, lpGrpBox->Caption, tsWidth)+8      ' 4 pix padding left & right
                tmpRct.Left=4: tmpRct.Right=x
                FillRect(hDC, @tmpRct, NULL)                                        ' Use current Brush color
                rqTextRect(@lpGrpBox->Font, @rct, 6, 0, lpGrpBox->Caption, lpGrpBox->Font.Color, -1)
            END IF
            SelectObject(hDC, Original)                                             ' Set back to original
            EndPaint(hWnd, @pnt)
            RETURN 1

        CASE WM_COMMAND, WM_NOTIFY                                                  ' Child objects?
            SendMessage(GetParent(hWnd), wMsg, wParam, lParam)                      ' Pass these on to parent
            RETURN 0

        CASE WM_CTLCOLORBTN, WM_CTLCOLOREDIT, WM_CTLCOLORSTATIC, WM_CTLCOLORLISTBOX
            RETURN SendMessage(GetParent(hWnd), wMsg, wParam, lParam)               ' Pass on to parent get return value

        CASE WM_MOUSEMOVE
            IF lpGrpBox->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpGrpBox->hCursor)
            END IF
            IF lpGrpBox->OnMouseMove>0 THEN
                lpGrpBox->OnMouseMove(LOWORD(lParam), HIWORD(lParam), 0, lpGrpBox)
            END IF
            RETURN 1

        CASE WM_LBUTTONDOWN, WM_RBUTTONDOWN
            IF lpGrpBox->OnMouseDown>0 THEN
                IF wMsg=WM_LBUTTONDOWN THEN
                    lpGrpBox->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpGrpBox)
                ELSE
                    lpGrpBox->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpGrpBox)
                END IF
            END IF
            RETURN 1

        CASE WM_LBUTTONUP, WM_RBUTTONUP
            IF lpGrpBox->OnMouseUp>0 THEN
                IF wMsg=WM_LBUTTONUP THEN
                    lpGrpBox->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpGrpBox)
                ELSE
                    lpGrpBox->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpGrpBox)
                END IF
            END IF
            IF wMsg=WM_LBUTTONUP THEN
                PostMessage(GetParent(hWnd),WM_COMMAND,CAST(WPARAM,lpGrpBox->ObjIndex),CAST(LPARAM,hWnd))
            END IF
            RETURN 1
    END SELECT
    RETURN CallWindowProc(lpGrpBox->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION
#ENDIF          '#IFDEF __QGROUPBOX

#IFDEF __QTABCONTROL
FUNCTION TabCtlWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QTABCONTROL PTR lpTabCtl=CAST(QTABCONTROL PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpTabCtl->Align<>alNone THEN AdjustForAlign(hWnd, lpTabCtl->Align, lpTabCtl)

        CASE WM_COMMAND, WM_NOTIFY                                                  ' Child objects?
            SendMessage(GetParent(hWnd), wMsg, wParam, lParam)                      ' Pass these on to parent
            RETURN 0

        CASE WM_CTLCOLORBTN, WM_CTLCOLOREDIT, WM_CTLCOLORSTATIC, WM_CTLCOLORLISTBOX ' Child objects?
            RETURN SendMessage(GetParent(hWnd), wMsg, wParam, lParam)               ' Pass on to parent get return value

        CASE WM_MOUSEMOVE
            IF lpTabCtl->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpTabCtl->hCursor)
            END IF
            RETURN 1
    END SELECT
    RETURN CallWindowProc(lpTabCtl->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION
#ENDIF          '#IFDEF __QTABCONTROL

#IFDEF __QSCROLLBOX
' The child panel that is scrolled
FUNCTION ScrollPanWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QSCROLLBOX PTR lpScrBox=CAST(QSCROLLBOX PTR, Application.GetObjectPtr(GetParent(hWnd)))

    SELECT CASE wMsg
        CASE WM_PAINT
            DIM AS PAINTSTRUCT pnt
            DIM AS HDC hDC = BeginPaint(hWnd, @pnt)
            DIM AS HGDIOBJ Original = SelectObject(hDC, GetStockObject(DC_BRUSH))
            DIM AS RECT rct

            GetClientRect(hWnd, @rct)
            IF lpScrBox->Enabled THEN
                SetDCBrushColor(hDC, CAST(COLORREF, lpScrBox->Color))               ' Color
            ELSE
                SetDCBrushColor(hDC, CAST(COLORREF, &hbfbfbf))                      ' Color
            END IF
            FillRect(hDC, @rct, NULL)                                               ' Use current Brush color
            SelectObject(hDC, Original)                                             ' Set back to original
            EndPaint(hWnd, @pnt)
            RETURN 1

        CASE WM_COMMAND, WM_NOTIFY                                                  ' Child objects?
            SendMessage(GetParent(hWnd), wMsg, wParam, lParam)                      ' Pass these on to parent
            RETURN 0

        CASE WM_CTLCOLORBTN, WM_CTLCOLOREDIT, WM_CTLCOLORSTATIC, WM_CTLCOLORLISTBOX
            RETURN SendMessage(GetParent(hWnd), wMsg, wParam, lParam)               ' Pass on to parent get return value

        CASE WM_MOUSEMOVE
            IF lpScrBox->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpScrBox->hCursor)
            END IF
            IF lpScrBox->OnMouseMove>0 THEN
                lpScrBox->OnMouseMove(LOWORD(lParam), HIWORD(lParam), 0, lpScrBox)
            END IF
            RETURN 1
    END SELECT
    RETURN CallWindowProc(lpScrBox->PanWnProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION ScrollBoxWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QSCROLLBOX PTR lpScrBox=CAST(QSCROLLBOX PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_INIT_SCROLLBOX                                                    ' Load internal panel
            DIM AS SCROLLINFO scrInfo

            ' Place a LARGE "scrollable" panel inside the scrollbox (uses HorzRange and/or VertRange)
            lpScrBox->PanX=0: lpScrBox->PanY=0
            lpScrBox->PanW=Screen.Width
            lpScrBox->PanH=Screen.Height
            scrInfo.cbSize=SIZEOF(scrInfo)                                          ' Set parameters of the ScrollBox
            scrInfo.fMask=SIF_RANGE OR SIF_PAGE OR SIF_POS
            IF lpScrBox->HorzVisible THEN
                scrInfo.nMin=1: scrInfo.nMax=lpScrBox->PanW: scrInfo.nPage=lpScrBox->Width
                scrInfo.nPos=1: SetScrollInfo(hWnd, SB_HORZ, @ScrInfo, 1)
            END IF
            IF lpScrBox->VertVisible THEN
                scrInfo.nMin=1: scrInfo.nMax=lpScrBox->PanH: scrInfo.nPage=lpScrBox->Height
                scrInfo.nPos=1: SetScrollInfo(hWnd, SB_VERT, @ScrInfo, 1)
            END IF
            lpScrBox->PanHandle=CreateWindowEx(0, "STATIC", "", _
                                    WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS OR SS_NOTIFY, _
                                    0, 0, lpScrBox->PanW, lpScrBox->PanH, hWnd, CAST(HMENU,9999), 0, 0)
            lpScrBox->PanWnProc=CAST(WNDPROC, SetWindowLong(lpScrBox->PanHandle, GWL_WNDPROC, CAST(long, @ScrollPanWndProc)))


        ' NB Opposite move direction: eg ScrollBar moves RIGHT -> Contents scrolls LEFT ...etc!
        CASE WM_HSCROLL,WM_VSCROLL             ' Action these msgs
            DIM AS integer BarPos, Delta
            DIM AS integer BoxW, BoxH
            DIM AS RECT rct
            GetClientRect(hWnd, @rct)                                               ' Dimensions of ScrollBox...
            BoxW=rct.Right-rct.Left+20: BoxH=rct.Bottom-rct.Top+20                  ' ...width & height (plus scrollbars)
            IF wMsg=WM_HSCROLL THEN
                BarPos=GetScrollPos(hWnd, SB_HORZ): Delta=BoxW/10
                SELECT CASE wParam
                    CASE 0: IF BarPos>Delta THEN BarPos -= Delta: lpScrBox->PanX += Delta: END IF
                    CASE 1: IF BarPos<=(lpScrBox->PanW-BoxW-Delta) THEN BarPos += Delta: lpScrBox->PanX -= Delta: END IF
                    CASE 2: IF BarPos>BoxW THEN BarPos -= BoxW: lpScrBox->PanX += BoxW: END IF
                    CASE 3: IF (BarPos+BoxW)<(lpScrBox->PanW-BoxW+1) THEN BarPos += BoxW: lpScrBox->PanX -= BoxW: END IF
                END SELECT
                SetScrollPos(hWnd, SB_HORZ, BarPos, True)                           ' Move scrollbar pos marker
                SetWindowPos(lpScrBox->PanHandle,0,lpScrBox->PanX,lpScrBox->PanY,0,0,SWP_NOSIZE OR SWP_NOZORDER)      ' Move the inner panel
            ELSE
                BarPos=GetScrollPos(hWnd, SB_VERT): Delta=BoxH/10
                SELECT CASE wParam
                    CASE 0: IF BarPos>1 THEN BarPos -= Delta: lpScrBox->PanY += Delta: END IF
                    CASE 1: IF BarPos<=(lpScrBox->PanH-BoxH-Delta) THEN BarPos += Delta: lpScrBox->PanY -= Delta: END IF
                    CASE 2: IF BarPos>BoxH THEN BarPos -= BoxH: lpScrBox->PanY += BoxH: END IF
                    CASE 3: IF (BarPos+BoxH)<(lpScrBox->PanH-BoxH+1) THEN BarPos += BoxH: lpScrBox->PanY -= BoxH: END IF
                END SELECT
                SetScrollPos(hWnd, SB_VERT, BarPos, True)                           ' Move scrollbar pos marker
                SetWindowPos(lpScrBox->PanHandle,0,lpScrBox->PanX,lpScrBox->PanY,0,0,SWP_NOSIZE OR SWP_NOZORDER)      ' Move the inner panel
            END IF

        CASE WM_COMMAND, WM_NOTIFY                                                  ' Child objects?
            IF LOWORD(wParam)=9999 THEN                                             ' ID of ScrollPanel itself
                IF lpScrBox->OnClick>0 THEN lpScrBox->OnClick(lpScrBox)
            ELSE
                SendMessage(GetParent(hWnd), wMsg, wParam, lParam)                  ' Pass on child objs of ScrollPanel
            END IF

        CASE WM_CTLCOLORBTN, WM_CTLCOLOREDIT, WM_CTLCOLORSTATIC, WM_CTLCOLORLISTBOX
            RETURN SendMessage(GetParent(hWnd), wMsg, wParam, lParam)               ' Pass on to parent get return value

        CASE ELSE
            RETURN CallWindowProc(lpScrBox->OldWndProc, hWnd, wMsg, wParam, lParam)
    END SELECT
    RETURN 0
END FUNCTION
#ENDIF          '#IFDEF __QSCROLLBOX

'-------------------------------------------------------------------------------------------------------------
' Additional WndProcs (for standard components)
' Group2 (Mainly) OwnerDraw type objects
'-------------------------------------------------------------------------------------------------------------
#IFDEF __QGAUGE
FUNCTION GaugeWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QGAUGE PTR lpGauge=CAST(QGAUGE PTR, Application.GetObjectPtr(hWnd))

    ' Set the mix mode so that the pen color is the
    ' inverse of the background color.
    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpGauge->Align<>alNone THEN AdjustForAlign(hWnd, lpGauge->Align, lpGauge)
            DIM AS PAINTSTRUCT pnt
            DIM AS HDC hDC = BeginPaint(hWnd, @pnt)
            DIM AS HGDIOBJ Original = SelectObject(hDC, GetStockObject(DC_BRUSH))
            DIM AS RECT rct, tmpRect
            DIM AS integer H, W, cBack, cFront, cFont

            IF lpGauge->Enabled THEN
                cBack=lpGauge->BackColor: cFront=lpGauge->ForeColor: cFont=lpGauge->Font.Color
            ELSE
                cBack=&hbfbfbf: cFront=&h7f7f7f: cFont=&h3f3f3f
            END IF

            GetClientRect(hWnd, @rct)
            IF lpGauge->BorderStyle>0 THEN
                DrawEdge(hDC, @rct, EDGE_RAISED, BF_TOPLEFT)
                DrawEdge(hDC, @rct, EDGE_ETCHED, BF_BOTTOMRIGHT)
                rct.Left += 3: rct.Top += 3: rct.Right -= 3: rct.Bottom -= 3
            END IF
            tmpRect=rct
            SELECT CASE lpGauge->Kind
                CASE gkText,gkPie,gkNeedle
                    tmpRect.left=0: tmpRect.top=0: tmpRect.right=0: tmpRect.bottom=0
                CASE gkHorizontalBar                                                ' L -> Right
                    W=tmpRect.right-tmpRect.left-1
                    tmpRect.right=tmpRect.left+W*lpGauge->Position\lpGauge->Max
                CASE gkVerticalBar                                                  ' B -> Top
                    H=tmpRect.bottom-tmpRect.top-1
                    tmpRect.top=tmpRect.top+H*(lpGauge->Max-lpGauge->Position)\lpGauge->Max
            END SELECT
            SelectObject(hDC, GetStockObject(DC_PEN))
            SetDCBrushColor(hDC, CAST(COLORREF, cBack))                             ' Color gauge backing
            SetDCPenColor(hDC, CAST(COLORREF, cBack))                               ' Color gauge backing
            Rectangle(hDC, rct.Left, rct.Top, rct.Right, rct.Bottom)
            SetDCBrushColor(hDC, CAST(COLORREF, cFront))                            ' Color gauge bar position
            SetDCPenColor(hDC, CAST(COLORREF, cFront))                              ' Color gauge bar position
            Rectangle(hDC, tmpRect.left, tmpRect.top, tmpRect.right, tmpRect.bottom)
            IF lpGauge->ShowText THEN
                lpGauge->_Text=STR(lpGauge->Position*100\lpGauge->Max)+"%"
                SelectObject(hDC, lpGauge->Font.Handle)                             ' Set the font
                SetTextColor(hDC, CAST(COLORREF, cFont))                            ' Text color
                SetBKMode(hDC, 1)                                                   ' Transparent
                DrawText(hDC, lpGauge->_Text, LEN(lpGauge->_Text), @rct, DT_CENTER OR DT_SINGLELINE OR DT_VCENTER)
            END IF
            SelectObject(hDC, Original)                                             ' Set back to original
            EndPaint(hWnd, @pnt)
            RETURN 1

        CASE WM_MOUSEMOVE
            IF lpGauge->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpGauge->hCursor)
            END IF
            RETURN 1
    END SELECT
    RETURN CallWindowProc(lpGauge->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION
#ENDIF          ' #IFDEF __QGAUGE

#IFDEF __QCOOLBTN
' NOTE: Mouse btn up/down MUST fall through to default handler (for animation!!)
FUNCTION CoolWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QCOOLBTN PTR lpCoolBtn=CAST(QCOOLBTN PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpCoolBtn->Align<>alNone THEN AdjustForAlign(hWnd, lpCoolBtn->Align, lpCoolBtn)
            DIM AS PAINTSTRUCT pnt
            DIM AS HDC hDC = BeginPaint(hWnd, @pnt)
            DIM AS HGDIOBJ Original = SelectObject(hDC, GetStockObject(DC_BRUSH))
            DIM AS RECT rct
            GetClientRect(hWnd, @rct)

            IF lpCoolBtn->OnPaint>0 THEN
                lpCoolBtn->OnPaint(hDC, @rct, lpCoolBtn)                            ' User does ALL drawing
                SelectObject(hDC, Original)
                EndPaint(hWnd, @pnt)
                RETURN 1
            END IF

            IF lpCoolBtn->Down THEN
                DrawFrameControl(hDC, @rct, DFC_BUTTON, DFCS_BUTTONPUSH OR DFCS_PUSHED)
            ELSE
                DrawFrameControl(hDC, @rct, DFC_BUTTON, DFCS_BUTTONPUSH)
            END IF
            IF (lpCoolBtn->BMP<>"") OR (lpCoolBtn->BMPHandle>0) THEN
                DIM AS integer X=(lpCoolBtn->Width-lpCoolBtn->BtnImages.Width)\2
                DIM AS integer Y=(lpCoolBtn->Height-lpCoolBtn->BtnImages.Height)\2
                DIM AS integer Idx=0                                                    ' Default image index=0
                IF lpCoolBtn->Enabled THEN
                    IF lpCoolBtn->Down THEN
                        rct.Left += 2: rct.Top += 2
                        IF lpCoolBtn->NumBMPs>2 THEN Idx=2                              ' else default 0
                    END IF
                ELSE
                    IF lpCoolBtn->NumBMPs>1 THEN Idx=1                                  ' else default 0
                END IF
                lpCoolBtn->BtnImages.Draw(lpCoolBtn->Handle,rct.Left+X,rct.Top+Y,Idx)
            ELSE
                rct.Left += 2: rct.Right -= 2: rct.Top +=2: rct.Bottom -= 2             ' Frame offsets adjust
                IF lpCoolBtn->Enabled THEN
                    SetDCBrushColor(hDC, CAST(COLORREF, lpCoolBtn->Color))              ' Color btn
                    SetTextColor(hDC, lpCoolBtn->Font.Color)                            ' Color Txt
                ELSE
                    SetDCBrushColor(hDC, CAST(COLORREF, &hbfbfbf))                      ' Color btn disabled
                    SetTextColor(hDC, &h7f7f7f)                                         ' Color Txt disabled
                END IF
                FillRect(hDC, @rct, NULL)                                               ' Use current Brush color
                IF  lpCoolBtn->Down=True THEN
                    rct.Left += 3: rct.top += 3                                         ' Animation of the text
                END IF
                SetBkMode(hDC, 1)                                                       ' 1=TRANSPARENT, 2=OPAQUE
                SelectObject(hDC, lpCoolBtn->Font.Handle)                               ' Set the font
                DrawText(hDC, lpCoolBtn->Caption, LEN(lpCoolBtn->Caption), @rct, DT_CENTER Or DT_SINGLELINE Or DT_VCENTER)
            END IF
            SelectObject(hDC, Original)                                             ' Set back to original
            EndPaint(hWnd, @pnt)
            RETURN 1

        CASE WM_MOUSEMOVE
            IF lpCoolBtn->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpCoolBtn->hCursor)
            END IF
            RETURN 1

        CASE WM_LBUTTONDOWN, WM_RBUTTONDOWN
            IF lpCoolBtn->Enabled THEN
                IF wMsg=WM_LBUTTONDOWN THEN
                    lpCoolBtn->Down=True
                    InvalidateRect(hWnd,NULL,True)
                END IF
                IF lpCoolBtn->OnMouseDown>0 THEN
                    IF wMsg=WM_LBUTTONDOWN THEN
                        lpCoolBtn->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpCoolBtn)
                    ELSE
                        lpCoolBtn->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpCoolBtn)
                    END IF
                END IF
            END IF

        CASE WM_LBUTTONUP
            IF lpCoolBtn->Enabled THEN
                lpCoolBtn->Down=False
                InvalidateRect(hWnd,NULL,True)
                IF lpCoolBtn->OnMouseUp>0 THEN
                    lpCoolBtn->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpCoolBtn)
                END IF
            END IF

        CASE WM_RBUTTONUP
            IF lpCoolBtn->Enabled THEN
                IF lpCoolBtn->OnMouseUp>0 THEN
                    lpCoolBtn->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpCoolBtn)
                END IF
            END IF
    END SELECT
    RETURN CallWindowProc(lpCoolBtn->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION
#ENDIF          '#IFDEF __QCOOLBTN

#IFDEF __QOVALBTN
FUNCTION OvalWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QOVALBTN PTR lpOvalBtn=CAST(QOVALBTN PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpOvalBtn->Align<>alNone THEN AdjustForAlign(hWnd, lpOvalBtn->Align, lpOvalBtn)
            DIM AS PAINTSTRUCT pnt
            DIM AS HDC hDC = BeginPaint(hWnd, @pnt)
            DIM AS HGDIOBJ Original = SelectObject(hDC, GetStockObject(DC_BRUSH))
            DIM AS RECT rct
            GetClientRect(hWnd, @rct)

            IF lpOvalBtn->OnPaint>0 THEN
                lpOvalBtn->OnPaint(hDC, @rct, lpOvalBtn)                            ' User does ALL drawing
                SelectObject(hDC, Original)
                EndPaint(hWnd, @pnt)
                RETURN 1
            END IF
            ' Draw the button frame
            IF lpOvalBtn->Enabled=False THEN                                        ' Btn Disabled?
                SetDCBrushColor(hDC, CAST(COLORREF, &hbfbfbf))                      ' Color btn disabled
                SetTextColor(hDC, &h7f7f7f)                                         ' Color Txt disabled
            ELSE
                SetDCBrushColor(hDC, CAST(COLORREF, lpOvalBtn->Color))              ' Color btn
                SelectObject(hDC, GetStockObject(DC_PEN))
                SetDCPenColor(hDC, CAST(COLORREF,&h3f3f3f))                         ' Color outline
                IF lpOvalBtn->Down=True THEN                                        ' Btn Selected?
                    Ellipse(hDC, rct.Left, rct.Top, rct.Right, rct.Bottom)
                    rct.Left += 1
                    Ellipse(hDC, rct.Left, rct.Top, rct.Right, rct.Bottom)
                    rct.Top += 1
                END IF
            END IF
            Ellipse(hDC, rct.Left, rct.Top, rct.Right, rct.Bottom)
            IF lpOvalBtn->Down THEN rct.Left += 2: rct.Top += 1
            ' Text or image?
            IF (lpOvalBtn->BMP<>"") OR (lpOvalBtn->BMPHandle > 0) THEN
                DIM AS integer X=(lpOvalBtn->Width-lpOvalBtn->BtnImages.Width)\2
                DIM AS integer Y=(lpOvalBtn->Height-lpOvalBtn->BtnImages.Height)\2
                DIM AS integer Idx=0                                                ' Default image index=0
                IF lpOvalBtn->Enabled THEN
                    IF lpOvalBtn->Down THEN
                        IF lpOvalBtn->NumBMPs>2 THEN Idx=2                          ' else default 0
                    END IF
                ELSE
                    IF lpOvalBtn->NumBMPs>1 THEN Idx=1                              ' else default 0
                END IF
                lpOvalBtn->BtnImages.Draw(lpOvalBtn->Handle,rct.Left+X,rct.Top+Y,Idx)
            ELSE
                IF (lpOvalBtn->Down) AND (lpOvalBtn->Enabled) THEN
                    rct.Left += 1: rct.Top += 1                                     ' Visual effect only
                END IF
                SetTextColor(hDC, lpOvalBtn->Font.Color)                            ' Color Txt disabled
                SetBkMode(hDC, 1)                                                   ' 1=TRANSPARENT, 2=OPAQUE
                SelectObject(hDC, lpOvalBtn->Font.Handle)                           ' Set the font
                DrawText(hDC, lpOvalBtn->Caption, LEN(lpOvalBtn->Caption), @rct, DT_CENTER OR DT_SINGLELINE OR DT_VCENTER)
            END IF
            SelectObject(hDC, original)
            EndPaint(hWnd, @pnt)
            RETURN 1

        CASE WM_MOUSEMOVE
            IF lpOvalBtn->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpOvalBtn->hCursor)
            END IF
            RETURN 1

        CASE WM_LBUTTONDOWN
            IF lpOvalBtn->Enabled THEN
                lpOvalBtn->Down=True
                InvalidateRect(hWnd,NULL,True)
            END IF
            RETURN 1

        CASE WM_LBUTTONUP
            IF lpOvalBtn->Enabled THEN
                PostMessage(GetParent(hWnd), WM_COMMAND, CAST(WPARAM,lpOvalBtn->ObjIndex), CAST(LPARAM,hWnd))
                InvalidateRect(hWnd,NULL,True)
                lpOvalBtn->Down=False
            END IF
            RETURN 1
    END SELECT
    RETURN CallWindowProc(lpOvalBtn->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION
#ENDIF          '#IFDEF __QOVALBTN

#IFDEF __QSTRINGGRID
' Re-adjust "client rect" to the "data" area
SUB AdjustMainRect(lpStrGrid AS QSTRINGGRID PTR, lpRect AS RECT PTR)
DIM AS integer tmp, max

    IF lpStrGrid->FixedCols>0 THEN
        lpRect->Left = lpRect->Left+lpStrGrid->ColWidths(0)
    END IF
    tmp=0: max=lpRect->Right-lpRect->Left
    FOR i AS integer = lpStrGrid->LeftCol TO lpStrGrid->ColCount-1
        tmp += lpStrGrid->ColWidths(i)
    NEXT i
    IF tmp < max THEN lpRect->Right=lpRect->Left+tmp                    ' Adjust if necessary
    IF lpStrGrid->FixedRows>0 THEN
        lpRect->Top = lpRect->Top+lpStrGrid->DefaultRowHeight
    END IF
    tmp=0: max=lpRect->Bottom-lpRect->Top
    FOR i AS integer = lpStrGrid->TopRow TO lpStrGrid->RowCount-1
        tmp += lpStrGrid->DefaultRowHeight
    NEXT i
    IF tmp < max THEN lpRect->Bottom=lpRect->Top+tmp                    ' Adjust if necessary
    lpStrGrid->GridWidth=lpRect->Right-lpRect->Left                     ' Update this
    lpStrGrid->GridHeight=lpRect->Bottom-lpRect->Top                    ' ditto
END SUB

FUNCTION StrGridWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QSTRINGGRID PTR lpStrGrid=CAST(QSTRINGGRID PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpStrGrid->Align<>alNone THEN AdjustForAlign(hWnd, lpStrGrid->Align, lpStrGrid)
            DIM AS string tstr, tok
            DIM AS integer cnt, tmp
            DIM AS RECT rct, rct2, txtRct
            DIM AS PAINTSTRUCT pnt
            DIM AS HDC hDC = BeginPaint(hWnd, @pnt)
            DIM AS HGDIOBJ original = SelectObject(hDC, GetStockObject(DC_BRUSH))
            SetDCBrushColor(hDC, CAST(COLORREF, lpStrGrid->Color))                  ' Main background color
            SelectObject(hDC, lpStrGrid->Font.Handle)                               ' Set the font
            SelectObject(hDC, GetStockObject(DC_PEN))
            SetDCPenColor(hDC, CAST(COLORREF, &hdfdfdf))                            ' Grid lines color
            SetBkMode(hDC, 1)                                                       ' Transparent

            GetClientRect(hWnd, @rct)
            Rectangle(hDC, rct.Left, rct.Top, rct.Right, rct.Bottom)                ' Draw background in 'Color'

            ' Fixed row? Draw and populate it
            IF lpStrGrid->FixedRows>0 THEN
                SetDCBrushColor(hDC, CAST(COLORREF, lpStrGrid->FixedColor))         ' Background color
                SetTextColor(hDC, CAST(COLORREF, &h3f3f3f))
                rct2=rct: rct2.Bottom=rct2.Top+lpStrGrid->DefaultRowHeight
                Rectangle(hDC, rct2.Left, rct2.Top, rct2.Right, rct2.Bottom)        ' Draw background
                tstr=lpStrGrid->GridList.Item(0)
                IF lpStrGrid->FixedCols>0 THEN
                    tok=rqFieldStr(tstr,lpStrGrid->Separator,1)                     ' Cell(0,0)
                    rct2.Right=lpStrGrid->ColWidths(0)
                    DrawEdge(hDC, @rct2, EDGE_RAISED, BF_TOPLEFT)
                    DrawEdge(hDC, @rct2, EDGE_RAISED, BF_BOTTOMRIGHT)
                    txtRct=rct2: txtRct.Left += 2: txtRct.Right -= 2
                    DrawText(hDC, tok, -1, @txtRct, DT_SINGLELINE OR DT_VCENTER)
                    IF lpStrGrid->OnDrawCell>0 THEN lpStrGrid->OnDrawCell(0, 0, True, @rct2, lpStrGrid)
                    rct2.Left += lpStrGrid->ColWidths(0)+1
                END IF
                FOR i AS integer = lpStrGrid->LeftCol TO lpStrGrid->ColCount-1      ' For each column
                    tok=rqFieldStr(tstr,lpStrGrid->Separator,(i+1))                 ' Data row(0)
                    rct2.Right = rct2.Left+lpStrGrid->ColWidths(i)
                    DrawEdge(hDC, @rct2, EDGE_RAISED, BF_TOPLEFT)
                    DrawEdge(hDC, @rct2, EDGE_RAISED, BF_BOTTOMRIGHT)
                    txtRct=rct2: txtRct.Left += 2: txtRct.Right -= 2
                    DrawText(hDC, tok, -1, @txtRct, DT_SINGLELINE OR DT_VCENTER)
                    IF lpStrGrid->OnDrawCell>0 THEN lpStrGrid->OnDrawCell(i, 0, True, @rct2, lpStrGrid)
                    rct2.Left += lpStrGrid->ColWidths(i)
                    IF rct2.Left>rct.Right THEN EXIT FOR
                NEXT i
            END IF
            ' Fixed column?  Draw and populate it
            IF lpStrGrid->FixedCols>0 THEN
                SetDCBrushColor(hDC, CAST(COLORREF, lpStrGrid->FixedColor))         ' Background color
                SetTextColor(hDC, CAST(COLORREF, &h3f3f3f))
                rct2=rct: rct2.Right=rct2.Left+lpStrGrid->ColWidths(0)
                Rectangle(hDC, rct2.Left, rct2.Top, rct2.Right, rct2.Bottom)        ' Draw background
                rct2.Bottom=rct2.Top+lpStrGrid->DefaultRowHeight
                IF lpStrGrid->FixedRows>0 THEN
                    tstr=lpStrGrid->GridList.Item(0)
                    tok=rqFieldStr(tstr,lpStrGrid->Separator,1)                     ' Cell(0,0)
                    DrawEdge(hDC, @rct2, EDGE_RAISED, BF_TOPLEFT)
                    DrawEdge(hDC, @rct2, EDGE_RAISED, BF_BOTTOMRIGHT)
                    txtRct=rct2: txtRct.Left += 2: txtRct.Right -= 2
                    DrawText(hDC, tok, -1, @txtRct, DT_SINGLELINE OR DT_VCENTER)
                    IF lpStrGrid->OnDrawCell>0 THEN lpStrGrid->OnDrawCell(0, 0, True, @rct2, lpStrGrid)
                    rct2.Top += lpStrGrid->DefaultRowHeight
                    rct2.Bottom += lpStrGrid->DefaultRowHeight
                END IF
                FOR i AS integer = lpStrGrid->TopRow TO lpStrGrid->RowCount-1       ' For each row
                    tstr=lpStrGrid->GridList.Item(i)
                    tok=rqFieldStr(tstr,lpStrGrid->Separator,1)                     ' Data column(0)
                    DrawEdge(hDC, @rct2, EDGE_RAISED, BF_TOPLEFT)
                    DrawEdge(hDC, @rct2, EDGE_RAISED, BF_BOTTOMRIGHT)
                    txtRct=rct2: txtRct.Left += 2: txtRct.Right -= 2
                    DrawText(hDC, tok, -1, @txtRct, DT_SINGLELINE OR DT_VCENTER)
                    IF lpStrGrid->OnDrawCell>0 THEN lpStrGrid->OnDrawCell(0, i, True, @rct2, lpStrGrid)
                    rct2.Top += lpStrGrid->DefaultRowHeight
                    rct2.Bottom += lpStrGrid->DefaultRowHeight
                    IF rct2.Top>rct.Bottom THEN EXIT FOR
                NEXT i
            END IF

            ' Background done, now for the data...
            SetDCBrushColor(hDC, CAST(COLORREF, lpStrGrid->Color))                  ' Main background color
            SetTextColor(hDC, CAST(COLORREF, lpStrGrid->Font.Color))                ' Remainder this colour
            AdjustMainRect(lpStrGrid, @rct)                                         ' <<<<<Non-fixed area of grid

            MoveToEx(hDC, rct.Left, rct.Top, NULL)
            LineTo(hDC, rct.Left, rct.Bottom)
            tmp=rct.Left: lpStrGrid->_VisibleColCount=0
            FOR i AS integer = lpStrGrid->LeftCol TO lpStrGrid->ColCount-1          ' Draw vert lines
                tmp += lpStrGrid->ColWidths(i)
                IF tmp>rct.Right THEN EXIT FOR
                MoveToEx(hDC, tmp, rct.Top, NULL)
                LineTo(hDC, tmp, rct.Bottom)
                lpStrGrid->_VisibleColCount += 1
            NEXT i
            MoveToEx(hDC, rct.Left, rct.Top, NULL)
            LineTo(hDC, rct.Right, rct.Top)
            tmp=rct.Top: lpStrGrid->_VisibleRowCount=0: cnt=0
            FOR i AS integer = lpStrGrid->TopRow TO lpStrGrid->RowCount-1           ' Draw horiz lines
                tmp += lpStrGrid->DefaultRowHeight
                IF tmp>rct.Bottom THEN EXIT FOR
                MoveToEx(hDC, rct.Left, tmp, NULL)
                LineTo(hDC, rct.Right, tmp)
                lpStrGrid->_VisibleRowCount += 1
                cnt += 1
            NEXT i
            rct2=rct: rct2.Bottom=rct2.Top+lpStrGrid->DefaultRowHeight
            FOR i AS integer = lpStrGrid->TopRow TO lpStrGrid->TopRow + cnt - 1
                tstr=lpStrGrid->GridList.Item(i)                                    ' For each row
                FOR j AS integer = lpStrGrid->LeftCol TO lpStrGrid->ColCount-1      ' Cells start to end
                    rct2.Right = rct2.Left+lpStrGrid->ColWidths(j)
                    tok=rqFieldStr(tstr, lpStrGrid->Separator, j+1)
                    txtRct=rct2: txtRct.Left += 2: txtRct.Right -= 2
                    DrawText(hDC, tok, -1, @txtRct, DT_SINGLELINE OR DT_VCENTER)
                    IF lpStrGrid->OnDrawCell>0 THEN lpStrGrid->OnDrawCell(j, i, True, @rct2, lpStrGrid)
                    rct2.Left += lpStrGrid->ColWidths(j)                            ' Column housekeeping
                NEXT j
                rct2.Left=rct.Left
                rct2.Top += lpStrGrid->DefaultRowHeight
                rct2.Bottom += lpStrGrid->DefaultRowHeight
            NEXT i
            ' Highlight selected cell (IF not fixed column or row and hilite not -1)
            IF (lpStrGrid->Col >= lpStrGrid->LeftCol) AND (lpStrGrid->Row >= lpStrGrid->TopRow) _
                                                                AND (lpStrGrid->Hilite <> -1) THEN
                DIM AS HPEN dotPen=CreatePen(PS_DOT, 1, lpStrGrid->Hilite)       ' Single pix dotted
                rct2=rct
                rct2.Top=rct2.Top+(lpStrGrid->Row-lpStrGrid->TopRow)*lpStrGrid->DefaultRowHeight
                rct2.Bottom=rct2.Top+lpStrGrid->DefaultRowHeight
                rct2.Right=rct2.Left+lpStrGrid->ColWidths(lpStrGrid->LeftCol)
                IF lpStrGrid->Col > lpStrGrid->LeftCol THEN
                    FOR tmp = lpStrGrid->LeftCol+1 TO lpStrGrid->Col
                        rct2.Left=rct2.Right
                        rct2.Right += lpStrGrid->ColWidths(tmp)
                    NEXT tmp
                END IF
                rct2.Left += 1: rct2.Top +=1: rct2.Right -= 1: rct2.Bottom -= 1
                SelectObject(hDC, dotPen)                                           ' Set hilite 1 pix inside border
                MoveToEx(hDC, rct2.Left, rct2.Top, NULL)
                LineTo(hDC, rct2.Right, rct2.Top): LineTo(hDC, rct2.Right, rct2.Bottom)
                LineTo(hDC, rct2.Left, rct2.Bottom): LineTo(hDC, rct2.Left, rct2.Top)
            END IF
            SelectObject(hDC, original)
            EndPaint(hWnd, @pnt)
            RETURN 1

        CASE WM_MOUSEMOVE
            IF lpStrGrid->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpStrGrid->hCursor)
            END IF
            RETURN 1

        'NB NOT the correct use of 'CanSelect'
        CASE WM_LBUTTONUP
            DIM AS integer i, tmp, delta, ThisRow, ThisCol, CanSelect=True
            DIM AS RECT rct
            DIM AS SCROLLINFO ScrInf

            GetClientRect(hWnd, @rct)
            AdjustMainRect(lpStrGrid, @rct)                                         ' The selectable area of grid
            IF (LOWORD(lParam)<rct.Left) OR (LOWORD(lParam)>rct.Right) OR _
                        (HIWORD(lParam)<rct.Top) OR (HIWORD(lParam)>rct.Bottom) THEN
                CanSelect=False
            ELSE
                tmp=0
                FOR i=lpStrGrid->TopRow TO lpStrGrid->RowCount-1
                    tmp += lpStrGrid->DefaultRowHeight
                    IF HIWORD(lParam) < (rct.Top+tmp) THEN
                        ThisRow=i
                        EXIT FOR
                    END IF
                NEXT i
                IF (rct.Top+tmp)>rct.Bottom THEN lpStrGrid->_TopRow=ThisRow
                tmp=0
                FOR i=lpStrGrid->LeftCol TO lpStrGrid->ColCount-1
                    tmp += lpStrGrid->ColWidths(i)
                    IF LOWORD(lParam) < (rct.Left+tmp) THEN
                        ThisCol=i
                        EXIT FOR
                    END IF
                NEXT i
                IF (rct.Left+tmp)>rct.Right THEN lpStrGrid->_LeftCol=ThisCol
            END IF
            IF CanSelect THEN
                IF lpStrGrid->_Col<>ThisCol THEN
                    lpStrGrid->_Col=ThisCol
                    IF (lpStrGrid->ScrollBars AND ssHorizontal)>0 THEN
                        ScrInf.cbSize=SIZEOF(SCROLLINFO): ScrInf.fMask=SIF_POS
                        ScrInf.nPos=lpStrGrid->_Col
                        SetScrollInfo(hWnd, SB_HORZ, @ScrInf, True)
                    END IF
                END IF
                IF lpStrGrid->_Row<>ThisRow THEN
                    lpStrGrid->_Row=ThisRow
                    IF (lpStrGrid->ScrollBars AND ssVertical)>0 THEN
                        ScrInf.cbSize=SIZEOF(SCROLLINFO): ScrInf.fMask=SIF_POS
                        ScrInf.nPos=lpStrGrid->_Row
                        SetScrollInfo(hWnd, SB_VERT, @ScrInf, True)
                    END IF
                END IF
                IF lpStrGrid->OnSelectCell>0 THEN
                    lpStrGrid->OnSelectCell(lpStrGrid->_Col, lpStrGrid->_Row, CanSelect, lpStrGrid)
                END IF
                InvalidateRect(hWnd,NULL,True)                                      ' Repaint on mse up
                RETURN 1
            END IF

        CASE WM_CHAR
            IF lpStrGrid->OnKeyPress>0 THEN
                DIM AS UBYTE ch=CAST(ubyte,wParam)
                lpStrGrid->OnKeyPress(ch, lpStrGrid)
                RETURN 0
            END IF

        CASE WM_SYSKEYDOWN, WM_SYSKEYUP
            IF (GetKeyState(VK_MENU) AND &h8000)>0 THEN
                lpStrGrid->KeyState OR= &h10
            ELSE
                lpStrGrid->KeyState AND= &hffffffef
            END IF

        CASE WM_KEYDOWN
            DIM AS word ch=CAST(word,(wParam AND &hff))
            DIM AS integer Update=False
            DIM AS SCROLLINFO ScrInf

            ScrInf.cbSize = SIZEOF(SCROLLINFO): ScrInf.fMask=SIF_POS
            SELECT CASE ch
                CASE VK_LEFT
                    IF lpStrGrid->_Col > lpStrGrid->FixedCols THEN
                        lpStrGrid->_Col -= 1
                        IF lpStrGrid->_Col < lpStrGrid->LeftCol THEN
                            lpStrGrid->_LeftCol -= 1
                        END IF
                        IF (lpStrGrid->ScrollBars AND ssHorizontal)>0 THEN
                            GetScrollInfo(hWnd, SB_HORZ, @ScrInf)
                            ScrInf.nPos -= 1
                            SetScrollInfo(hWnd, SB_HORZ, @ScrInf, True)
                        END IF
                        Update=True
                    END IF
                CASE VK_RIGHT
                    IF lpStrGrid->_Col < lpStrGrid->ColCount-1 THEN
                        lpStrGrid->_Col += 1
                        IF lpStrGrid->_Col >= (lpStrGrid->LeftCol+lpStrGrid->VisibleColCount) THEN
                            lpStrGrid->_LeftCol += 1
                        END IF
                        IF (lpStrGrid->ScrollBars AND ssHorizontal)>0 THEN
                            GetScrollInfo(hWnd, SB_HORZ, @ScrInf)
                            ScrInf.nPos += 1
                            SetScrollInfo(hWnd, SB_HORZ, @ScrInf, True)
                        END IF
                        Update=True
                    END IF
                CASE VK_UP
                    IF lpStrGrid->_Row > lpStrGrid->FixedRows THEN
                        lpStrGrid->_Row -= 1
                        IF lpStrGrid->_Row < lpStrGrid->TopRow THEN
                            lpStrGrid->_TopRow -= 1
                        END IF
                        IF (lpStrGrid->ScrollBars AND ssVertical)>0 THEN
                            GetScrollInfo(hWnd, SB_VERT, @ScrInf)
                            ScrInf.nPos -= 1
                            SetScrollInfo(hWnd, SB_VERT, @ScrInf, True)
                        END IF
                        Update=True
                    END IF
                CASE VK_DOWN
                    IF lpStrGrid->_Row < lpStrGrid->RowCount-1 THEN
                        lpStrGrid->_Row += 1
                        IF lpStrGrid->_Row >= (lpStrGrid->TopRow+lpStrGrid->VisibleRowCount) THEN
                            lpStrGrid->_TopRow += 1
                        END IF
                        IF (lpStrGrid->ScrollBars AND ssVertical)>0 THEN
                            GetScrollInfo(hWnd, SB_VERT, @ScrInf)
                            ScrInf.nPos += 1
                            SetScrollInfo(hWnd, SB_VERT, @ScrInf, True)
                        END IF
                        Update=True
                    END IF
                CASE ELSE
                    IF lpStrGrid->OnKeyDown>0 THEN
                        IF (GetKeyState(VK_CONTROL) AND &h8000)>0 THEN
                            lpStrGrid->KeyState OR= &h1
                        ELSE
                            lpStrGrid->KeyState AND= &hfffffffe
                        END IF
                        IF (GetKeyState(VK_SHIFT) AND &h8000)>0 THEN
                            lpStrGrid->KeyState OR= &h100
                        ELSE
                            lpStrGrid->KeyState AND= &hfffffeff
                        END IF
                        lpStrGrid->OnKeyDown(ch, lpStrGrid->KeyState, lpStrGrid)
                    END IF
            END SELECT
            IF Update=True THEN
                InvalidateRect(hWnd,NULL,True)
                RETURN 1
            END IF

        CASE WM_KEYUP
            DIM AS word ch=CAST(word,(wParam AND &hff))
            IF (ch=VK_RETURN) AND (lpStrGrid->OnSelectCell>0) THEN
                DIM AS integer CanSelect=False
                IF (lpStrGrid->Col >= lpStrGrid->FixedCols) AND _
                            (lpStrGrid->Row >= lpStrGrid->FixedRows) THEN CanSelect=True
                lpStrGrid->OnSelectCell(lpStrGrid->_Col, lpStrGrid->_Row, CanSelect, lpStrGrid)
            END IF
            IF lpStrGrid->OnKeyUp>0 THEN
                IF (GetKeyState(VK_CONTROL) AND &h8000)>0 THEN
                    lpStrGrid->KeyState OR= &h1
                ELSE
                    lpStrGrid->KeyState AND= &hfffffffe
                END IF
                IF (GetKeyState(VK_SHIFT) AND &h8000)>0 THEN
                    lpStrGrid->KeyState OR= &h100
                ELSE
                    lpStrGrid->KeyState AND= &hfffffeff
                END IF
                lpStrGrid->OnKeyUp(ch, lpStrGrid->KeyState, lpStrGrid)
            END IF

        CASE WM_HSCROLL
            IF (lpStrGrid->ScrollBars AND ssHorizontal)>0 THEN
                DIM AS integer hDelta, Update=False
                DIM AS SCROLLINFO ScrInf
                SetFocus(hWnd)
                ScrInf.cbSize = SIZEOF(SCROLLINFO)
                ScrInf.fMask=SIF_POS OR SIF_PAGE
                GetScrollInfo(hWnd, SB_HORZ, @ScrInf)
                SELECT CASE LOWORD(wParam)
                    CASE SB_LINELEFT, SB_PAGELEFT
                        IF lpStrGrid->_Col > lpStrGrid->FixedCols THEN
                            lpStrGrid->_Col -= 1: ScrInf.nPos -= 1
                            IF lpStrGrid->_Col < lpStrGrid->LeftCol THEN
                                lpStrGrid->_LeftCol -= 1
                            END IF
                            Update=True
                        END IF

                    CASE SB_LINERIGHT, SB_PAGERIGHT
                        IF lpStrGrid->_Col < lpStrGrid->ColCount-1 THEN
                            lpStrGrid->_Col += 1: ScrInf.nPos += 1
                            IF lpStrGrid->_Col >= (lpStrGrid->LeftCol+lpStrGrid->VisibleColCount) THEN
                                lpStrGrid->_LeftCol += 1
                            END IF
                            Update=True
                        END IF
                END SELECT
                IF Update=True THEN
                    ScrInf.fMask=SIF_POS
                    SetScrollInfo(hWnd, SB_HORZ, @ScrInf, True)
                    InvalidateRect(hWnd,NULL,True)
                    RETURN 1
                END IF
            END IF

        CASE WM_VSCROLL
            IF (lpStrGrid->ScrollBars AND ssVertical)>0 THEN
                DIM AS integer Update=False
                DIM AS SCROLLINFO ScrInf
                SetFocus(hWnd)
                ScrInf.cbSize = SIZEOF(SCROLLINFO)
                ScrInf.fMask=SIF_POS
                GetScrollInfo(hWnd, SB_VERT, @ScrInf)
                SELECT CASE LOWORD(wParam)
                    CASE SB_LINEUP
                        IF lpStrGrid->_TopRow > lpStrGrid->FixedRows THEN
                            lpStrGrid->_TopRow -= 1: Update=True
                        END IF
                    CASE SB_PAGEUP
                        SELECT CASE lpStrGrid->_TopRow-lpStrGrid->FixedRows
                            CASE 0:                                         ' Update=False
                            CASE IS < lpStrGrid->VisibleRowCount
                                lpStrGrid->_TopRow=lpStrGrid->FixedRows
                                Update=True
                            CASE ELSE
                                lpStrGrid->_TopRow=lpStrGrid->_TopRow - lpStrGrid->VisibleRowCount
                                Update=True
                        END SELECT
                    CASE SB_LINEDOWN
                        IF (lpStrGrid->_TopRow+lpStrGrid->VisibleRowCount) < lpStrGrid->RowCount THEN
                            lpStrGrid->_TopRow += 1: Update=True
                        END IF
                    CASE SB_PAGEDOWN
                        IF (lpStrGrid->_TopRow+lpStrGrid->VisibleRowCount) < lpStrGrid->RowCount THEN
                            lpStrGrid->_TopRow=lpStrGrid->_TopRow+lpStrGrid->VisibleRowCount
                            Update=True
                        END IF
                END SELECT
                IF Update=True THEN
                    ScrInf.fMask=SIF_POS
                    ScrInf.nPos=lpStrGrid->TopRow
                    SetScrollInfo(hWnd, SB_VERT, @ScrInf, True)
                    InvalidateRect(hWnd,NULL,True)
                    RETURN 1
                END IF
            END IF

'        CASE WM_LBUTTONDOWN
'        CASE WM_RBUTTONDOWN
'        CASE WM_RBUTTONUP
'        CASE WM_COMMAND
'        CASE WM_NOTIFY
    END SELECT
    RETURN CallWindowProc(lpStrGrid->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION
#ENDIF          '#IFDEF __QSTRINGGRID


'-------------------------------------------------------------------------------------------------------------
' Additional WndProcs (for standard components)
' Group3  Remainder of components that have a cursor property plus ....
'-------------------------------------------------------------------------------------------------------------
#IFDEF __QEDIT
FUNCTION EditWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QEDIT PTR lpEdit=CAST(QEDIT PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpEdit->Align<>alNone THEN AdjustForAlign(hWnd, lpEdit->Align, lpEdit)

        CASE WM_MOUSEMOVE
            IF lpEdit->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpEdit->hCursor)
            END IF
            RETURN 1

        CASE WM_KEYDOWN
            IF lpEdit->OnKeyDown>0 THEN
                DIM AS word ch=CAST(word,(wParam AND &hff))
                lpEdit->OnKeyDown(ch, GetKeyState(VK_SHIFT), lpEdit)
            END IF

        CASE WM_CHAR
            DIM AS UBYTE ch=CAST(UBYTE,wParam)
            IF lpEdit->Autosize THEN
                DIM AS integer hite=rqGetTextSize(@lpEdit->Font, "#yg@", tsHeight)+2
                IF hite > lpEdit->Height THEN
                    lpEdit->Height=hite
                    InvalidateRect(lpEdit->Handle,NULL,True)
                END IF
            END IF
            IF lpEdit->OnKeyPress>0 THEN
                lpEdit->OnKeyPress(ch, lpEdit)
            END IF

        CASE WM_KEYUP
            IF lpEdit->OnKeyUp>0 THEN
                DIM AS word ch=CAST(word,(wParam AND &hff))
                lpEdit->OnKeyUp(ch, GetKeyState(VK_SHIFT), lpEdit)
            END IF
    END SELECT
    RETURN CallWindowProc(lpEdit->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION
#ENDIF

#IFDEF __QRICHEDIT
FUNCTION RichEdWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QRICHEDIT PTR lpRichEd=CAST(QRICHEDIT PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpRichEd->Align<>alNone THEN AdjustForAlign(hWnd, lpRichEd->Align, lpRichEd)
            SetWindowPos(hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOOWNERZORDER)

        CASE WM_MOUSEMOVE
            IF lpRichEd->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpRichEd->hCursor)
            END IF
            IF lpRichEd->OnMouseMove>0 THEN
                lpRichEd->OnMouseMove(LOWORD(lParam), HIWORD(lParam), 0, lpRichEd)
            END IF
            RETURN 1

        CASE WM_LBUTTONDOWN, WM_RBUTTONDOWN
            IF lpRichEd->OnMouseDown>0 THEN
                IF wMsg=WM_LBUTTONDOWN THEN
                    lpRichEd->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpRichEd)
                ELSE
                    lpRichEd->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpRichEd)
                END IF
            END IF

        CASE WM_LBUTTONUP, WM_RBUTTONUP
            IF lpRichEd->OnMouseUp>0 THEN
                IF wMsg=WM_LBUTTONUP THEN
                    lpRichEd->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpRichEd)
                ELSE
                    lpRichEd->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpRichEd)
                END IF
            END IF

        CASE WM_KEYDOWN
            IF lpRichEd->OnKeyDown>0 THEN
                DIM AS word ch=CAST(word,(wParam AND &hff))
                lpRichEd->OnKeyDown(ch, GetKeyState(VK_SHIFT), lpRichEd)
                RETURN 1
            END IF

        CASE WM_CHAR
            IF lpRichEd->OnKeyPress>0 THEN
                DIM AS UBYTE ch=CAST(ubyte,wParam)
                lpRichEd->OnKeyPress(ch, lpRichEd)
                RETURN 1
            END IF

        CASE WM_KEYUP
            IF lpRichEd->OnKeyUp>0 THEN
                DIM AS word ch=CAST(word,(wParam AND &hff))
                lpRichEd->OnKeyUp(ch, GetKeyState(VK_SHIFT), lpRichEd)
                RETURN 1
            END IF
    END SELECT
    RETURN CallWindowProc(lpRichEd->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION
#ENDIF

FUNCTION ButnWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QBUTTON PTR lpButton=CAST(QBUTTON PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpButton->Align<>alNone THEN AdjustForAlign(hWnd, lpButton->Align, lpButton)
            DIM AS PAINTSTRUCT pnt
            DIM AS HDC hDC = BeginPaint(hWnd, @pnt)
            DIM AS HGDIOBJ Original = SelectObject(hDC, GetStockObject(DC_BRUSH))
            DIM AS RECT rct
            GetClientRect(hWnd, @rct)

            IF lpButton->OnPaint>0 THEN
                lpButton->OnPaint(hDC, @rct, lpButton)                                  ' User does ALL drawing
                SelectObject(hDC, Original)
                EndPaint(hWnd, @pnt)
                RETURN 1
            END IF

            IF lpButton->Down THEN
                DrawFrameControl(hDC, @rct, DFC_BUTTON, DFCS_BUTTONPUSH OR DFCS_PUSHED)
            ELSE
                DrawFrameControl(hDC, @rct, DFC_BUTTON, DFCS_BUTTONPUSH)
            END IF
            rct.Left += 2: rct.Right -= 2: rct.Top +=2: rct.Bottom -= 2                 ' Frame offsets adjust
            IF (lpButton->BMP<>"") OR (lpButton->BMPHandle>0) THEN
                DIM AS integer X, Y, Idx=0                                              ' Default image index=0
                IF lpButton->Enabled THEN
                    IF lpButton->Down THEN
                        IF lpButton->NumBMPs>2 THEN Idx=2                               ' else default 0
                    END IF
                ELSE
                    IF lpButton->NumBMPs>1 THEN Idx=1                                   ' else default 0
                END IF
                X=(lpButton->Width-lpButton->BtnImages.Width)\2
                Y=(lpButton->Height-lpButton->BtnImages.Height)\2
                IF lpButton->Down THEN
                    X += 1: Y += 1
                END IF
                lpButton->BtnImages.Draw(lpButton->Handle,X,Y,Idx)
            ELSE
                IF lpButton->Enabled THEN
                    SetDCBrushColor(hDC, CAST(COLORREF, lpButton->Color))               ' Color btn
                    SetTextColor(hDC, lpButton->Font.Color)                             ' Color Txt
                ELSE
                    SetDCBrushColor(hDC, CAST(COLORREF, &hbfbfbf))                      ' Color btn disabled
                    SetTextColor(hDC, &h7f7f7f)                                         ' Color Txt disabled
                END IF
                FillRect(hDC, @rct, NULL)                                               ' Use current Brush color
                IF lpButton->Down THEN
                    rct.Left += 1: rct.top += 2                                         ' Animation of the text
                END IF
                SetBkMode(hDC, 1)                                                       ' 1=TRANSPARENT, 2=OPAQUE
                SelectObject(hDC, lpButton->Font.Handle)                                ' Set the font
                DrawText(hDC, lpButton->Caption, LEN(lpButton->Caption), @rct, DT_CENTER Or DT_SINGLELINE Or DT_VCENTER)
            END IF
            SelectObject(hDC, Original)                                                 ' Set back to original
            EndPaint(hWnd, @pnt)
            RETURN 1

        CASE WM_MOUSEMOVE
            IF lpButton->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpButton->hCursor)
            END IF
            IF lpButton->OnMouseMove>0 THEN
                lpButton->OnMouseMove(LOWORD(lParam), HIWORD(lParam), lpButton->Down, lpButton)
            END IF
            RETURN 1

        CASE WM_LBUTTONDOWN
            IF lpButton->Enabled THEN
                IF lpButton->OnMouseDown>0 THEN
                    lpButton->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpButton)
                END IF
                lpButton->Down=True
                InvalidateRect(hWnd,NULL,True)
            END IF

        CASE WM_LBUTTONUP
            IF lpButton->Enabled THEN
                IF lpButton->OnMouseUp>0 THEN
                    lpButton->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpButton)
                END IF
                lpButton->Down=False
                InvalidateRect(hWnd,NULL,True)
            END IF

        CASE WM_RBUTTONDOWN
            IF lpButton->Enabled THEN
                IF lpButton->OnMouseDown>0 THEN
                    lpButton->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpButton)
                END IF
            END IF

        CASE WM_RBUTTONUP
            IF lpButton->Enabled THEN
                IF lpButton->OnMouseUp>0 THEN
                    lpButton->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpButton)
                END IF
            END IF

        CASE WM_KEYDOWN
            IF lpButton->OnKeyDown>0 THEN
                DIM AS word ch=CAST(word,(wParam AND &hff))
                lpButton->OnKeyDown(ch, GetKeyState(VK_SHIFT), lpButton)
                RETURN 1
            END IF

        CASE WM_CHAR
            IF lpButton->OnKeyPress>0 THEN
                DIM AS UBYTE ch=CAST(ubyte,wParam)
                lpButton->OnKeyPress(ch, lpButton)
                RETURN 1
            END IF

        CASE WM_KEYUP
            IF lpButton->OnKeyUp>0 THEN
                DIM AS word ch=CAST(word,(wParam AND &hff))
                lpButton->OnKeyUp(ch, GetKeyState(VK_SHIFT), lpButton)
                RETURN 1
            END IF
    END SELECT
    RETURN CallWindowProc(lpButton->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION CheckWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QCHECKBOX PTR lpChkBox=CAST(QCHECKBOX PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpChkBox->Align<>alNone THEN AdjustForAlign(hWnd, lpChkBox->Align, lpChkBox)

    END SELECT
    RETURN CallWindowProc(lpChkBox->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION RadioWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QRADIOBUTTON PTR lpRadio=CAST(QRADIOBUTTON PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpRadio->Align<>alNone THEN AdjustForAlign(hWnd, lpRadio->Align, lpRadio)

    END SELECT
    RETURN CallWindowProc(lpRadio->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION CanvasWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QCANVAS PTR lpCanvas=CAST(QCANVAS PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpCanvas->Align<>alNone THEN AdjustForAlign(hWnd, lpCanvas->Align, lpCanvas)
            DIM AS HDC hDC = GetDC(hWnd)
            DIM AS RECT rct
            GetClientRect(hWnd, @rct)

            IF lpCanvas->OnPaint>0 THEN
                lpCanvas->OnPaint(hDC, @rct, lpCanvas)
            ELSE
                rqFillRect(hDC, rct.Left, rct.Top, rct.Right, rct.Bottom, lpCanvas->Color)
            END IF
            ReleaseDC(hWnd, hDC)

        CASE WM_MOUSEMOVE
            IF lpCanvas->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpCanvas->hCursor)
            END IF
            RETURN 1

        CASE WM_LBUTTONDOWN
            IF lpCanvas->OnMouseDown>0 THEN
                lpCanvas->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpCanvas)
            END IF

        CASE WM_RBUTTONDOWN
            IF lpCanvas->OnMouseDown>0 THEN
                lpCanvas->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpCanvas)
            END IF
    END SELECT
    RETURN CallWindowProc(lpCanvas->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION ComboWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QCOMBOBOX PTR lpCombo=CAST(QCOMBOBOX PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpCombo->Align<>alNone THEN AdjustForAlign(hWnd, lpCombo->Align, lpCombo)

        CASE WM_MOUSEMOVE
            IF lpCombo->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpCombo->hCursor)
            END IF
            RETURN 1
    END SELECT
    RETURN CallWindowProc(lpCombo->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION FileLBoxWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QFILELISTBOX PTR lpFLBox=CAST(QFILELISTBOX PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpFLBox->Align<>alNone THEN AdjustForAlign(hWnd, lpFLBox->Align, lpFLBox)

        CASE WM_MOUSEMOVE
            IF lpFLBox->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpFLBox->hCursor)
            END IF
            RETURN 1
    END SELECT
    RETURN CallWindowProc(lpFLBox->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

#IFDEF __QDIRTREE
FUNCTION DirTreeWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QDIRTREE PTR lpDTree=CAST(QDIRTREE PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpDTree->Align<>alNone THEN AdjustForAlign(hWnd, lpDTree->Align, lpDTree)

        CASE WM_MOUSEMOVE
            IF lpDTree->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpDTree->hCursor)
            END IF
            RETURN 1
    END SELECT
    RETURN CallWindowProc(lpDTree->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION
#ENDIF

FUNCTION HeadrWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QHEADER PTR lpHeadr=CAST(QHEADER PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
'            IF lpHeadr->Align<>alNone THEN AdjustForAlign(hWnd, lpHeadr->Align, lpHeadr)

        CASE WM_MOUSEMOVE
            IF lpHeadr->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpHeadr->hCursor)
            END IF
            RETURN 1
    END SELECT
    RETURN CallWindowProc(lpHeadr->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION ImgWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QIMAGE PTR lpImage=CAST(QIMAGE PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpImage->Align<>alNone THEN AdjustForAlign(hWnd, lpImage->Align, lpImage)

        CASE WM_MOUSEMOVE
            IF lpImage->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpImage->hCursor)
            END IF
            IF lpImage->OnMouseMove>0 THEN
                lpImage->OnMouseMove(LOWORD(lParam), HIWORD(lParam), 0, lpImage)
            END IF
            RETURN 1

        CASE WM_LBUTTONDOWN
            IF lpImage->OnMouseDown>0 THEN
                lpImage->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpImage)
            END IF

        CASE WM_RBUTTONDOWN
            IF lpImage->OnMouseDown>0 THEN
                lpImage->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpImage)
            END IF
    END SELECT
    RETURN CallWindowProc(lpImage->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION LabelWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QLABEL PTR lpLabel=CAST(QLABEL PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpLabel->Align<>alNone THEN AdjustForAlign(hWnd, lpLabel->Align, lpLabel)

        CASE WM_MOUSEMOVE
            IF lpLabel->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpLabel->hCursor)
            END IF
            IF lpLabel->OnMouseMove>0 THEN
                lpLabel->OnMouseMove(LOWORD(lParam), HIWORD(lParam), 0, lpLabel)
            END IF
            RETURN 1

        CASE WM_LBUTTONDOWN, WM_RBUTTONDOWN
            IF lpLabel->OnMouseDown>0 THEN
                IF wMsg=WM_LBUTTONDOWN THEN
                    lpLabel->OnMouseDown(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpLabel)
                ELSE
                    lpLabel->OnMouseDown(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpLabel)
                END IF
            END IF
            RETURN 1

        CASE WM_LBUTTONUP, WM_RBUTTONUP
            IF lpLabel->OnMouseUp>0 THEN
                IF wMsg=WM_LBUTTONUP THEN
                    lpLabel->OnMouseUp(MK_LBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpLabel)
                ELSE
                    lpLabel->OnMouseUp(MK_RBUTTON, LOWORD(lParam), HIWORD(lParam), 0, lpLabel)
                END IF
            END IF
            IF wMsg=WM_LBUTTONUP THEN
                PostMessage(GetParent(hWnd),WM_COMMAND,CAST(WPARAM,lpLabel->ObjIndex),CAST(LPARAM,hWnd))
            END IF
            RETURN 1
    END SELECT
    RETURN CallWindowProc(lpLabel->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION ListBoxWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QLISTBOX PTR lpLBox=CAST(QLISTBOX PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpLBox->Align<>alNone THEN AdjustForAlign(hWnd, lpLBox->Align, lpLBox)

        CASE WM_MOUSEMOVE
            IF lpLBox->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpLBox->hCursor)
            END IF
            RETURN 1

        CASE WM_LBUTTONDOWN
            IF lpLBox->OnDrawItem>0 THEN
                DIM AS integer X=LOWORD(lParam), Y=HIWORD(lParam)
                DIM AS RECT rct
                DIM AS integer Idx=SendMessage(lpLBox->Handle, LB_ITEMFROMPOINT, 0, MAKELPARAM(X,Y))
                IF HIWORD(Idx)=0 THEN                                   ' LOWORD=valid index
                    SendMessage(lpLBox->Handle, LB_GETITEMRECT, Idx, CAST(LPARAM, @rct))
                    lpLBox->OnDrawItem(Idx, 0, @rct, lpLBox)
                END IF
            END IF
            RETURN 1

        CASE WM_KEYUP
            DIM AS word ch=CAST(word,(wParam AND &hff))
            IF (ch=VK_RETURN) AND (lpLBox->OnEnter>0) THEN
                lpLBox->OnEnter(lpLBox)
                RETURN 1
            END IF
    END SELECT
    RETURN CallWindowProc(lpLBox->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION ListViewWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QLISTVIEW PTR lpLView=CAST(QLISTVIEW PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpLView->Align<>alNone THEN AdjustForAlign(hWnd, lpLView->Align, lpLView)

        CASE WM_MOUSEMOVE
            IF lpLView->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpLView->hCursor)
            END IF
            RETURN 1

        CASE WM_CHAR
            IF lpLView->OnKeyPress>0 THEN
                DIM AS UBYTE ch=CAST(ubyte,wParam)
                lpLView->OnKeyPress(ch, lpLView)
            END IF
    END SELECT
    RETURN CallWindowProc(lpLView->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION ScollBarWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QSCROLLBAR PTR lpScrollBar=CAST(QSCROLLBAR PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpScrollBar->Align<>alNone THEN AdjustForAlign(hWnd, lpScrollBar->Align, lpScrollBar)

        CASE WM_MOUSEMOVE
            IF lpScrollBar->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpScrollBar->hCursor)
            END IF
            RETURN 1

        CASE WM_KEYDOWN
            IF lpScrollBar->OnKeyDown>0 THEN
                DIM AS word ch=CAST(word,(wParam AND &hff))
                lpScrollBar->OnKeyDown(ch, GetKeyState(VK_SHIFT), lpScrollBar)
                RETURN 1
            END IF

        CASE WM_CHAR
            IF lpScrollBar->OnKeyPress>0 THEN
                DIM AS UBYTE ch=CAST(ubyte,wParam)
                lpScrollBar->OnKeyPress(ch, lpScrollBar)
                RETURN 1
            END IF

        CASE WM_KEYUP
            IF lpScrollBar->OnKeyUp>0 THEN
                DIM AS word ch=CAST(word,(wParam AND &hff))
                lpScrollBar->OnKeyUp(ch, GetKeyState(VK_SHIFT), lpScrollBar)
                RETURN 1
            END IF
    END SELECT
    RETURN CallWindowProc(lpScrollBar->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION StatusWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QSTATUSBAR PTR lpStat=CAST(QSTATUSBAR PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpStat->Align<>alNone THEN AdjustForAlign(hWnd, lpStat->Align, lpStat)

        CASE WM_MOUSEMOVE
            IF lpStat->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpStat->hCursor)
            END IF
            RETURN 1
    END SELECT
    RETURN CallWindowProc(lpStat->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION TrackWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QTRACKBAR PTR lpTrack=CAST(QTRACKBAR PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpTrack->Align<>alNone THEN AdjustForAlign(hWnd, lpTrack->Align, lpTrack)

        CASE WM_MOUSEMOVE
            IF lpTrack->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpTrack->hCursor)
            END IF
            RETURN 1
    END SELECT
    RETURN CallWindowProc(lpTrack->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION TreeViewWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QTREEVIEW PTR lpTView=CAST(QTREEVIEW PTR, Application.GetObjectPtr(hWnd))

    SELECT CASE wMsg
        CASE WM_PAINT
            IF lpTView->Align<>alNone THEN AdjustForAlign(hWnd, lpTView->Align, lpTView)

        CASE WM_MOUSEMOVE
            IF lpTView->Cursor<>crDefault THEN
                DIM AS HCURSOR oldCursor=SetCursor(lpTView->hCursor)
            END IF
            RETURN 1

        CASE WM_KEYDOWN
            IF lpTView->OnKeyDown>0 THEN
                DIM AS word ch=CAST(word,(wParam AND &hff))
                lpTView->OnKeyDown(ch, GetKeyState(VK_SHIFT), lpTView)
                RETURN 1
            END IF

        CASE WM_CHAR
            IF lpTView->OnKeyPress>0 THEN
                DIM AS UBYTE ch=CAST(ubyte,wParam)
                lpTView->OnKeyPress(ch, lpTView)
                RETURN 1
            END IF

        CASE WM_KEYUP
            IF lpTView->OnKeyUp>0 THEN
                DIM AS word ch=CAST(word,(wParam AND &hff))
                lpTView->OnKeyUp(ch, GetKeyState(VK_SHIFT), lpTView)
                RETURN 1
            END IF
    END SELECT
    RETURN CallWindowProc(lpTView->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

FUNCTION ProgressWndProc(hWnd AS HWND, wMsg AS UINT, wParam AS WPARAM, lParam AS LPARAM) AS LRESULT
DIM AS QPROGRESSBAR PTR lpPBar=CAST(QPROGRESSBAR PTR, Application.GetObjectPtr(hWnd))

    IF wMsg = WM_PAINT THEN
        IF lpPBar->Align<>alNone THEN AdjustForAlign(hWnd, lpPBar->Align, lpPBar)
    END IF
    RETURN CallWindowProc(lpPBar->OldWndProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

'-------------------------------------------------------------------------------------------------------------
' Common graphics code
'-------------------------------------------------------------------------------------------------------------
'
' Graphics stuff - shared by several components
'
' CopyRect() overloaded function due to QBitmap handle problem
SUB rqCopyRect(dstDC AS HDC, dstRect AS RECT PTR, srcHandle AS HWND, srcRect AS RECT PTR)
DIM AS HDC srcDC
DIM AS integer w1,h1,w2,h2

    w1=dstRect->Right-dstRect->Left: h1=dstRect->Bottom-dstRect->Top        ' destination dimensions
    w2=srcRect->Right-srcRect->Left: h2=srcRect->Bottom-srcRect->Top        ' source dimensions

    srcDC=GetDC(srcHandle)
    SetStretchBltMode(dstDC, HALFTONE)
    StretchBlt(dstDC, dstRect->Left, dstRect->Top, w1, h1, srcDC, srcRect->Left, srcRect->Top, w2, h2, SRCCOPY)
    DeleteObject(srcDC)
END SUB

SUB rqCopyRect(dstDC AS HDC, dstRect AS RECT PTR, srcDC AS HDC, srcRect AS RECT PTR)
DIM AS integer w1,h1,w2,h2

    w1=dstRect->Right-dstRect->Left: h1=dstRect->Bottom-dstRect->Top        ' destination dimensions
    w2=srcRect->Right-srcRect->Left: h2=srcRect->Bottom-srcRect->Top        ' source dimensions

    SetStretchBltMode(dstDC, HALFTONE)
    StretchBlt(dstDC, dstRect->Left, dstRect->Top, w1, h1, srcDC, srcRect->Left, srcRect->Top, w2, h2, SRCCOPY)
END SUB

SUB rqDraw(dstDC AS HDC, x AS integer, y AS integer, FileName AS string)
DIM AS UINT Flags=LR_LOADFROMFILE
DIM AS BITMAP BMap
DIM AS hBitmap hBmp
DIM AS HDC memDC, scrnDC
DIM AS RECT srcRct, dstRct

    hBmp=LoadImage(NULL, FileName, IMAGE_BITMAP, 0, 0, Flags)               ' Load the image bmp
    IF hBmp THEN
        scrnDC=GetDC(NULL): memDC=CreateCompatibleDC(scrnDC)
        SelectObject(memDC, hBmp)
        GetObject(hBmp, SIZEOF(BITMAP), @BMap)                              ' INFO (ONLY) about image object
        srcRct.Left=0: srcRct.Top=0
        srcRct.Right=BMap.bmWidth: srcRct.Bottom=BMap.bmHeight
        dstRct.Left=x: dstRct.Top=y
        dstRct.Right=srcRct.Right+x: dstRct.Bottom=srcRct.Bottom+y
        rqCopyRect(dstDC, @dstRct, memDC, @srcRct)
        DeleteObject(hBmp)
        DeleteDC(memDC)
        ReleaseDC(NULL, scrnDC)
    END IF
END SUB

SUB rqStretchDraw(dstDC AS HDC, lpRect AS RECT PTR, FileName AS string)
DIM AS HBITMAP hBmp
DIM AS HDC memDC, scrnDC
DIM AS integer W, H

    W=lpRect->Right-lpRect->Left: H=lpRect->Bottom-lpRect->Top
    hBmp=LoadImage(NULL, FileName, IMAGE_BITMAP, W, H, LR_LOADFROMFILE)     ' Load & stretch image
    IF hBmp THEN
        scrnDC=GetDC(NULL): memDC=CreateCompatibleDC(scrnDC)
        SelectObject(memDC, hBmp)
        rqCopyRect(dstDC, lpRect, memDC, lpRect)
        DeleteObject(hBmp)
        DeleteDC(memDC)
        ReleaseDC(NULL, scrnDC)
    END IF
END SUB

SUB rqSetPixel(srcDC AS HDC, x AS integer, y AS integer, colr AS integer)
    SetPixel(srcDC, x, y, CAST(COLORREF,colr))
END SUB

SUB rqLine(srcDC AS HDC, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer)
DIM AS HGDIOBJ Original=SelectObject(srcDC, GetStockObject(DC_BRUSH))           ' Save copy of original

    SelectObject(srcDC, GetStockObject(DC_PEN))
    SetDCPenColor(srcDC, CAST(COLORREF, colr))
    MoveToEx(srcDC, x1, y1, NULL)
    LineTo(srcDC, x2, y2)
    SelectObject(srcDC, Original)
END SUB

SUB rqRectangle(srcDC AS HDC, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer)
DIM AS HGDIOBJ Original=SelectObject(srcDC, GetStockObject(DC_BRUSH))           ' Save copy of original

    SelectObject(srcDC, GetStockObject(DC_PEN))
    SetDCPenColor(srcDC, CAST(COLORREF, colr))
    MoveToEx(srcDC, x1, y1, NULL)
    LineTo(srcDC, x2-1, y1): LineTo(srcDC, x2-1, y2-1)
    LineTo(srcDC, x1, y2-1): LineTo(srcDC, x1, y1)
    SelectObject(srcDC, Original)
END SUB

SUB rqFillRect(srcDC AS HDC, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer)
DIM AS HGDIOBJ Original=SelectObject(srcDC, GetStockObject(DC_BRUSH))           ' Save copy of original

    SetDCBrushColor(srcDC, CAST(COLORREF, Colr))
    SelectObject(srcDC, GetStockObject(DC_PEN))
    SetDCPenColor(srcDC, CAST(COLORREF, colr))
    Rectangle(srcDC, x1, y1, x2, y2)
    SelectObject(srcDC, Original)
END SUB

SUB rqRoundRect(srcDC AS HDC, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, x3 AS integer, y3 AS integer, colr AS integer)
DIM AS HGDIOBJ Original=SelectObject(srcDC, GetStockObject(DC_BRUSH))           ' Save copy of original

    SetDCBrushColor(srcDC, CAST(COLORREF, Colr))
    SelectObject(srcDC, GetStockObject(DC_PEN))
    SetDCPenColor(srcDC, CAST(COLORREF, colr))
    RoundRect(srcDC, x1, y1, x2, y2, x3, y3)
    SelectObject(srcDC, Original)
END SUB

SUB rqCircle(srcDC AS HDC, x1 AS integer, y1 AS integer, x2 AS integer, y2 AS integer, colr AS integer, FillColr AS integer)
DIM AS HGDIOBJ Original=SelectObject(srcDC, GetStockObject(DC_BRUSH))           ' Save copy of original

    SetDCBrushColor(srcDC, CAST(COLORREF, FillColr))
    SelectObject(srcDC, GetStockObject(DC_PEN))
    SetDCPenColor(srcDC, CAST(COLORREF, colr))
    IF FillColr = -1 THEN                                                       ' Transparent - no fill
        Arc(srcDC, x1, y1, x2, y2, 0, 0, 0, 0)
    ELSE
        Ellipse(srcDC, x1, y1, x2, y2)                                          ' Standard circle/ellipse filled
    END IF
    SelectObject(srcDC, Original)
END SUB

SUB rqPaint(srcDC AS HDC, x AS integer, y AS integer, colr AS integer, brdr AS integer)
DIM AS HGDIOBJ original=SelectObject(srcDC, GetStockObject(DC_BRUSH))

    SetDCBrushColor(srcDC, CAST(COLORREF, colr))
    ExtFloodFill(srcDC, x, y, CAST(COLORREF, brdr), FLOODFILLBORDER)
    SelectObject(srcDC, original)
END SUB

' Top to Bottom co-ordinate system (not bitmap file order)
' Anything out of valid range returns -1
FUNCTION rqGetPixel(srcDC AS HDC, x AS integer, y AS integer) AS integer
    RETURN CAST(integer,GetPixel(srcDC, x, y))
END FUNCTION

FUNCTION rqGetTextSize(lpFont AS QFONT PTR, Text AS string, DirnFlag AS integer) AS integer
DIM AS HDC ownDC
DIM AS SIZE siz
DIM AS HWND Handle=lpFont->Owner

    ownDC=GetDC(Handle)
    SelectObject(ownDC,lpFont->Handle)
    GetTextExtentPoint32(ownDC, Text, LEN(Text), @siz)
    IF DirnFlag THEN RETURN siz.cy ELSE RETURN siz.cx
    ReleaseDC(Handle, ownDC)
END FUNCTION

SUB rqTextRect(lpFont AS QFONT PTR, lpRct AS RECT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
DIM AS integer W, H, lenth=LEN(S)
DIM AS HDC ownDC
DIM AS HGDIOBJ Original
DIM AS SIZE siz

    ownDC=GetDC(lpFont->Owner)
    Original=SelectObject(ownDC, GetStockObject(DC_BRUSH))              ' Save copy of original
    SelectObject(ownDC,lpFont->Handle)
    W=lpRct->Right - lpRct->Left: H=lpRct->Bottom - lpRct->Top
    IF x >= 0 THEN W -= x                                               ' Not centered but valid offset?
    DO
        GetTextExtentPoint32(ownDC, S, lenth, @siz)                     ' Font selected above!
        IF siz.cx <= W THEN EXIT DO
        lenth -= 1
    LOOP UNTIL lenth=0
    IF lenth THEN
        IF x = -1 THEN x=(W-siz.cx)\2
        IF y = -1 THEN y=(H-siz.cy)\2                                   ' Vertical - FB only center text
        IF (y>=0) AND ((lpRct->Top+y)<lpRct->Bottom) THEN
            x=lpRct->Left+x
            y=lpRct->Top+y
            IF bc <> -1 THEN                                            ' Colored background....
                SetBkColor(ownDC, CAST(COLORREF, bc))
                rqFillRect(ownDC, lpRct->Left, lpRct->Top, lpRct->Right, lpRct->Bottom, bc)
            ELSE
                SetBKmode(ownDC, 1)                                     ' ... or Transparent
            END IF
            SetTextColor(ownDC, CAST(COLORREF, fc))
            TextOut(ownDC, x, y, S, lenth)
        END IF
    END IF
    SelectObject(ownDC, Original)
    ReleaseDC(lpFont->Owner, ownDC)
END SUB

SUB rqTextOut(lpFont AS QFONT PTR, x AS integer, y AS integer, S AS string, fc AS integer, bc AS integer)
DIM AS integer W, H, lenth=LEN(S)
DIM AS HDC ownDC
DIM AS HGDIOBJ Original
DIM AS SIZE siz
DIM AS RECT rct
DIM AS HWND Handle=lpFont->Owner

    IF LEN(S)=0 THEN EXIT SUB
    ownDC=GetDC(Handle)
    Original=SelectObject(ownDC, GetStockObject(DC_BRUSH))              ' Save copy of original
    SelectObject(ownDC,lpFont->Handle)
    IF bc <> -1 THEN SetBkColor(ownDC, CAST(COLORREF, bc)) ELSE SetBKmode(ownDC, 1)    ' else Transparent
    SetTextColor(ownDC, CAST(COLORREF, fc))
    TextOut(ownDC, x, y, S, lenth)
    SelectObject(ownDC, Original)
    ReleaseDC(Handle, ownDC)
END SUB

' Screen Function: Capture (part of) screen into a QBITMAP
FUNCTION rqScreenToBMP(lpRect AS RECT PTR, bmpHandle AS HDC) AS integer
DIM AS HDC ScreenDC
DIM AS integer W, H
DIM Result AS integer

    W=lpRect->Right-lpRect->Left: H=lpRect->Bottom-lpRect->top
    ScreenDC = GetDC(NULL)
    Result=BitBlt(bmpHandle, 0, 0, W, H, ScreenDC, lpRect->Left, lpRect->Top, SRCCOPY)
    ReleaseDC(NULL, ScreenDC)
    RETURN True
END FUNCTION

'-------------------------------------------------------------------------------------------------
' File creation fns
'-------------------------------------------------------------------------------------------------
' Write image (QImage, QBitmap, screen...) to a file
SUB rqWriteFile(srcDC AS HDC, hBMap AS HBITMAP, W AS integer, H AS integer, OutFileName AS string)
DIM AS BITMAPINFOHEADER bi
DIM AS BITMAPFILEHEADER bmfHeader
DIM AS BYTE PTR pDIB
DIM AS DWORD dwBmpSize, dwSizeofDIB

    CLEAR(@bi, 0, SIZEOF(BITMAPINFOHEADER))
    bi.biSize = SIZEOF(BITMAPINFOHEADER)
    bi.biWidth = W
    bi.biHeight = H
    bi.biPlanes = 1
    bi.biBitCount = 32
    bi.biCompression = BI_RGB

    dwBmpSize = (((W+1) * bi.biBitCount - 1) SHR 3)*H
    pDIB = CAllocate(dwBmpSize)                                                         ' Allocate a memory buffer

    GetDIBits(srcDC, hBMap, 0, H, pDIB, CAST(BITMAPINFO PTR, @bi), DIB_RGB_COLORS)      ' Copy image bits into buffer

    ' Add the size of the headers to the size of the bitmap to get the total file size
    dwSizeofDIB = dwBmpSize + SIZEOF(BITMAPFILEHEADER) + SIZEOF(BITMAPINFOHEADER)

    ' Offset to where the actual bitmap bits start.
    bmfHeader.bfOffBits = CAST(DWORD, SIZEOF(BITMAPFILEHEADER)) + CAST(DWORD, SIZEOF(BITMAPINFOHEADER))
    bmfHeader.bfSize = dwSizeofDIB                                                      ' Size of the file
    bmfHeader.bfType = &h4D42                                                           ' "BM" identifier

    DIM AS integer hFile = FreeFile()                                                   ' Get a file handle
    OPEN OutFileName FOR Binary Access Write AS #hFile
    DIM AS BYTE PTR lpFptr
    lpFptr=CAST(BYTE PTR, @bmfHeader)
    PUT #hFile, , lpFptr[0], SIZEOF(BITMAPFILEHEADER)                                   ' BMP File header
    lpFptr=CAST(BYTE PTR, @bi)
    PUT #hFile, , lpFptr[0], SIZEOF(BITMAPINFOHEADER)                                   ' BMP Info header
    lpFptr=CAST(BYTE PTR, pDIB)
    PUT #hFile, , lpFptr[0], dwBmpSize                                                  ' BMP data
    CLOSE #hFile                                                                        ' Close the handle

    DeAllocate(pDIB)
END SUB

' Capture QBitmap to file
FUNCTION rqBMPToFile(srcDC AS HDC, Widf AS integer, Height AS integer, FileName AS string) AS integer
DIM AS HBITMAP hBmp
DIM AS HDC memDC=CreateCompatibleDC(srcDC)

    hBmp=CreateCompatibleBitmap(srcDC, Widf, Height)
    SelectObject(memDC, hBmp)
    BitBlt(memDC, 0, 0, Widf, Height, srcDC, 0, 0, SRCCOPY)                             ' Copy BITMAP into memDC

    rqWriteFile(memDC, hBmp, Widf, Height, FileName)

    DeleteObject(hBmp)
    DeleteObject(memDC)
    RETURN True
END FUNCTION

' Screen Function: Capture (part of) screen into a bmp file
FUNCTION rqScreenToFile(lpRect AS RECT PTR, OutFileName AS string) AS integer
DIM AS HDC memDC, hdcScreen=GetDC(NULL)
DIM AS HBITMAP hBmp
DIM AS integer W, H

    W=lpRect->Right-lpRect->Left: H=lpRect->Bottom-lpRect->Top
    hBmp=CreateCompatibleBitmap(hdcScreen, W, H)
    memDC=CreateCompatibleDC(hdcScreen)
    SelectObject(memDC, hBmp)
    BitBlt(memDC, 0, 0, W, H, hdcScreen, lpRect->Left, lpRect->Top, SRCCOPY)            ' Copy (part of) screen into memDC

    rqWriteFile(memDC, hBmp, W, H, OutFileName)

    DeleteObject(hBmp)
    DeleteObject(memDC)
    ReleaseDC(NULL, hdcScreen)
    RETURN True
END FUNCTION

' This is an added function for FB only - pf32bit ONLY
' Captures a window client area (QForm, QCanvas, QImage etc) & saves to a bmp file
FUNCTION rqCaptureToFile(hWnd AS HWND, FileName AS string) AS integer
DIM AS HDC hdcWindow, memDC
DIM AS HBITMAP hBmp
DIM AS RECT rct
DIM AS integer W,H

    GetClientRect(hWnd, @rct)
    W=rct.right-rct.left: H=rct.bottom-rct.top
    hdcWindow=GetDC(hWnd)
    hBmp=CreateCompatibleBitmap(hdcWindow, W, H)                                        ' Create a compatible bitmap
    memDC = CreateCompatibleDC(hdcWindow)                                               ' Create a compatible DC
    SelectObject(memDC, hBmp)                                                           ' Select the bitmap into the memDC
    BitBlt(memDC, 0, 0, W, H, hdcWindow, 0, 0, SRCCOPY)                                 ' Block transfer into the memDC

    rqWriteFile(memDC, hBmp, W, H, FileName)

    DeleteObject(hBmp)
    DeleteObject(memDC)
    ReleaseDC(hWnd, hdcWindow)
    RETURN True
END FUNCTION

'-------------------------------------------------------------------------------------------------------------
' Callbacks Richedit & Edit objects
'-------------------------------------------------------------------------------------------------------------
#IFDEF __QEDIT
#DEFINE STREAM_CALLBACKS
#ENDIF
#IFDEF __QRICHEDIT
#DEFINE STREAM_CALLBACKS
#ENDIF

#IFDEF STREAM_CALLBACKS
' Ref: http://msdn.microsoft.com/en-us/library/windows/desktop/hh270405%28v=vs.85%29.aspx
' Load RTF file using the StreamIn function of RichEdit component
FUNCTION ReadStreamCallback(dwCookie AS DWORD PTR, lpBuff AS BYTE PTR, cb AS long, lpcb AS long PTR) AS DWORD
DIM AS HANDLE hFile = CAST(HANDLE, dwCookie)
    IF (ReadFile(hFile, lpBuff, cb, lpcb, NULL)) THEN
        RETURN False
    END IF
    RETURN True
END FUNCTION
FUNCTION FillRichEditFromFile(hWnd AS HWND, BYVAL pszFile AS LPCTSTR) AS integer
DIM AS integer fSuccess=FALSE
DIM AS HANDLE hFile=CreateFile(pszFile, GENERIC_READ, FILE_SHARE_READ, 0, _
                                                OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL)
    IF hFile <> INVALID_HANDLE_VALUE THEN
        DIM AS EDITSTREAM es
        es.pfnCallback = CAST(EDITSTREAMCALLBACK, @ReadStreamCallback)
        es.dwCookie = CAST(DWORD, hFile)
        IF (SendMessage(hwnd, EM_STREAMIN, SF_RTF, CAST(LPARAM, @es)) _
                                                AND (es.dwError = 0)) THEN fSuccess = TRUE
        CloseHandle(hFile)
    END IF
    RETURN fSuccess
END FUNCTION
' Save to RTF file using the StreamOut function of RichEdit
FUNCTION WriteStreamCallback(dwCookie AS DWORD PTR, lpBuff AS BYTE PTR, cb AS long, lpcb AS long PTR) AS DWORD
DIM AS HANDLE hFile = CAST(HANDLE, dwCookie)
    IF (WriteFile(hFile, lpBuff, cb, lpcb, NULL)) THEN
        RETURN False
    END IF
    RETURN True
END FUNCTION
FUNCTION SaveRichEditToFile(hWnd AS HWND, FileName AS string) AS integer
DIM AS integer fSuccess=FALSE
DIM AS HANDLE hFile=CreateFile(FileName, GENERIC_WRITE, FILE_SHARE_WRITE, 0, _
                                                CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)
    IF hFile <> INVALID_HANDLE_VALUE THEN
        DIM AS EDITSTREAM es
        es.pfnCallback = CAST(EDITSTREAMCALLBACK, @WriteStreamCallback)
        es.dwCookie = CAST(DWORD, hFile)
        IF (SendMessage(hwnd, EM_STREAMOUT, SF_RTF, CAST(LPARAM, @es)) _
                                                AND (es.dwError = 0)) THEN fSuccess = TRUE
        CloseHandle(hFile)
    END IF
    RETURN fSuccess
END FUNCTION
#ENDIF              ' #IFDEF STREAM_CALLBACKS

'-------------------------------------------------------------------------------------------------------------
' GP system code
'-------------------------------------------------------------------------------------------------------------
' Add or remove window styles
SUB rqUpdateStyle(Handle AS HWND, Style AS UINT, AddYesNo AS integer)
DIM AS UINT oldStyle=GetWindowLong(Handle, GWL_STYLE)
    IF AddYesNo THEN oldStyle OR= Style: ELSE: oldStyle AND= NOT(Style): END IF
    SetWindowLong(Handle, GWL_STYLE, oldStyle)
END SUB

'
' Default Font for the Application (values copied from RQ default font)
'
FUNCTION CreateDefaultFont() AS HFONT
Application.Font._Size=8
Application.Font.Name = "MS Sans Serif"
WITH Application.Font.lFontA
    .lfHeight = -11
    .lfWidth = 0
    .lfEscapement = 0
    .lfOrientation = 0
    .lfWeight = FW_NORMAL
    .lfItalic = 0
    .lfUnderline = 0
    .lfStrikeOut = 0
    .lfCharSet = ANSI_CHARSET
    .lfOutPrecision = OUT_STRING_PRECIS
    .lfClipPrecision = CLIP_STROKE_PRECIS
    .lfQuality = 1
    .lfPitchAndFamily = 34
    .lfFaceName = "MS Sans Serif"
END WITH
    RETURN CreateFontIndirect(@Application.Font.lFontA)
END FUNCTION

SUB InitialiseFont(lpFont AS QFONT PTR)
    IF lpFont->Name="" THEN lpFont->Name=Application.Font.Name
    IF lpFont->Size=0 THEN lpFont->Size=Application.Font.Size
    SendMessage(lpFont->Owner,WM_SETFONT,CAST(WPARAM,lpFont->Handle),1)    ' Set the font for this component
END SUB

FUNCTION UpDateFont(Parent AS HWND, lpLogFont AS LOGFONTA PTR) AS HFONT
DIM AS HFONT hFont=CreateFontIndirect(lpLogFont)
    SendMessage(Parent,WM_SETFONT,CAST(WPARAM,hFont),True)               ' Set & redraw
    RETURN hFont
END FUNCTION

SUB DoEvents()
DIM AS MSG uMsg

    WHILE PeekMessage(@uMsg, 0, 0, 0, PM_REMOVE)
        TranslateMessage(@uMsg)
        DispatchMessage(@uMsg)
    WEND
END SUB

'
' MouseHook stuff
'
FUNCTION MouseProc(nCode AS integer, wParam AS WPARAM, lParam AS LPARAM) AS UINT
DIM AS POINT PTR lpPoint = CAST(POINT PTR, lParam)

    IF nCode >= 0 THEN                                          ' If < 0 no processing required
        Screen.MouseX=lpPoint->x
        Screen.MouseY=lpPoint->y
        SELECT CASE LOWORD(wParam)
            CASE WM_LBUTTONDOWN: Screen.MouseBtns OR= MK_LBUTTON        '| Over window client area
            CASE WM_LBUTTONUP: Screen.MouseBtns AND= NOT(MK_LBUTTON)    '|
            CASE WM_RBUTTONDOWN: Screen.MouseBtns OR= MK_RBUTTON        '| (Popup Menu "steals" this!)
            CASE WM_RBUTTONUP: Screen.MouseBtns AND= NOT(MK_RBUTTON)    '|
            CASE WM_MBUTTONDOWN: Screen.MouseBtns OR= MK_MBUTTON        '|
            CASE WM_MBUTTONUP: Screen.MouseBtns AND= NOT(MK_MBUTTON)    '|

            CASE WM_NCLBUTTONDOWN: Screen.MouseBtns OR= MK_LBUTTON      '| Over window titlebar
            CASE WM_NCLBUTTONUP: Screen.MouseBtns AND= NOT(MK_LBUTTON)  '|
            CASE WM_NCRBUTTONDOWN: Screen.MouseBtns OR= MK_RBUTTON      '| (Popup Menu "steals" this)
            CASE WM_NCRBUTTONUP: Screen.MouseBtns AND= NOT(MK_RBUTTON)  '|
            CASE WM_NCMBUTTONDOWN: Screen.MouseBtns OR= MK_MBUTTON      '|
            CASE WM_NCMBUTTONUP: Screen.MouseBtns AND= NOT(MK_MBUTTON)  '|
        END SELECT
    END IF
    RETURN CallNextHookEx(MouseHook, nCode, wParam, lParam)     ' Call the next hook
END FUNCTION

SUB HookTheMouse
DIM AS HOOKPROC lpHookProc = CAST(HOOKPROC, @MouseProc)         ' Hook mouse
DIM AS HMODULE ModuleID = GetModuleHandle(0)

    MouseHook = SetWindowsHookEx(WH_MOUSE_LL, lpHookProc, ModuleID, 0)
END SUB

SUB UnHookTheMouse
    UnhookWindowsHookEx(MouseHook)                              ' Remove our windows mouse hook
END SUB

'
' Main System timer - currently used for ShowHint
'
SUB InitSystemTimers(Parent AS Handle)
    App_Timer.ObjIndex = SYS_TIMER_IDX
    App_Timer.Parent = Parent
    App_Timer.Interval = Application.HintPause
    App_Timer.Enabled = True
    SetTimer(Parent, SYS_TIMER_IDX, Application.HintPause, 0)
END SUB

#DEFINE MAX_VALUE_NAME 16383
FUNCTION GetSysDateFormat() AS string
DIM AS HKEY TestKey
DIM AS DWORD retCode, cValues

    IF RegOpenKeyEx(HKEY_CURRENT_USER, STRPTR("Control Panel\\International"), _
                                                0, KEY_READ, @TestKey) = ERROR_SUCCESS THEN
        ' Get key value count for this key/subkey
        retCode = RegQueryInfoKey(TestKey,0,0,0,0,0,0,@cValues,0,0,0,0)
        IF retCode<>ERROR_SUCCESS THEN
            DBG("Internal error: RegQueryInfoKey() Failed!")
            RegCloseKey(TestKey)
            RETURN ""
        END IF
        ' Enumerate the key values
        IF cValues THEN
            DIM AS string achValue, strValue
            DIM AS DWORD cchValue, cstrValue, valType
            FOR i AS integer = 0 TO cValues-1
                cchValue = MAX_VALUE_NAME: cstrValue = 256
                achValue = STRING(MAX_VALUE_NAME,0): strValue=STRING(256,0)
                retCode = RegEnumValue(TestKey, i, STRPTR(achValue), @cchValue, 0, _
                                                        @valType, STRPTR(strValue), @cstrValue)
                IF (retCode = ERROR_SUCCESS) THEN
                    IF LEFT(UCASE(achValue), cchValue) = "SSHORTDATE" THEN
                        RegCloseKey(TestKey)
                        RETURN LEFT(strValue,cstrValue)
                    END IF
                END IF
            NEXT i
        END IF
        RegCloseKey(TestKey)
        RETURN ""
    ELSE
        DBG("Internal error: RegOpenKeyEx() failed!")
        RETURN ""
    END IF
END FUNCTION
'-------------------------------------------------------------------------------------------------------------
' Common string functions
'-------------------------------------------------------------------------------------------------------------
' RapidQ FIELD$()
FUNCTION rqFIELDSTR(srcString AS string, sepField AS string, numField AS integer) AS string
DIM AS integer i, j, start, cnt
DIM AS string tstr

    IF (LEN(srcString)=0) OR (LEN(sepField)=0) OR (numField<1) OR _
                                    (INSTR(srcString,sepField)=0) THEN
        RETURN srcString                                        ' No change
    END IF

    start=1: cnt=LEN(srcString)
    IF numField>1 THEN
        FOR i=2 TO numField
            j=INSTR(start,srcString,sepField)
            start = j + LEN(sepField)                           ' Move start pt along input string
        NEXT
    END IF
    i = cnt-start+1
    tstr=RIGHT(srcString,i)
    i=INSTR(tstr,sepField)
    IF i>0 THEN
        tstr=LEFT(tstr,i-1)
    END IF
    RETURN tstr
END FUNCTION

' RapidQ TALLY()
FUNCTION rqTALLY(srcString AS string, srchString AS string) AS integer
DIM AS integer i, j, cnt, retVal

    retVal=0: cnt=LEN(srchString)
    IF (LEN(srcString)>0) AND (cnt>0) THEN
        FOR i=1 TO LEN(srcString)
            j=INSTR(i,srcString,srchString)
            IF j=0 THEN
                EXIT FOR
            ELSE
                retVal += 1
                i = j + cnt - 1
            END IF
        NEXT
    END IF
    RETURN retVal
END FUNCTION

' RapidQ REVERSE$()
FUNCTION rqREVERSESTR(srcString AS string) AS string
DIM AS integer idx
DIM AS string retStr=""

    idx = LEN(srcString) - 1
    WHILE(idx >= 0)
        retStr += CHR(srcString[idx])
        idx -= 1
    WEND
    RETURN retStr
END FUNCTION

' RapidQ REPLACESUBSTR$() IF newToken="" REMOVE (all) occurences of ..
FUNCTION rqREPLACESUBSTR(srcString AS string, oldToken AS string, newToken AS string) AS string
DIM AS integer i, cnt
DIM AS string tstr, tok

    IF (LEN(srcString)=0) OR (LEN(oldToken)=0) THEN
        RETURN srcString
    END IF
    cnt=rqTALLY(srcString,oldToken)
    IF cnt>0 THEN
        tstr=""
        FOR i=1 TO cnt
            tok=rqFIELDSTR(srcString,oldToken,i)
            tstr += tok
            IF newToken<>"" THEN                                ' IF "" then remove oldToken
                tstr += newToken                                ' ELSE Replace oldToken
            END IF
        NEXT
        tok=rqFIELDSTR(srcString,oldToken,i)                    ' Add the remainder of the line
        tstr += tok
    ELSE
        tstr=srcString
    END IF
    RETURN tstr
END FUNCTION

'<END>